diff -pruN 2.25.0-2/api-ref/source/conf.py 2.25.1~git2020070613.2e001431f-0ubuntu1/api-ref/source/conf.py
--- 2.25.0-2/api-ref/source/conf.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/api-ref/source/conf.py	2020-07-06 17:03:50.000000000 +0000
@@ -25,21 +25,18 @@
 
 import datetime
 import os
-from swift import __version__
-import subprocess
 import sys
 import warnings
 
-import openstackdocstheme
 
 html_theme = 'openstackdocs'
-html_theme_path = [openstackdocstheme.get_html_theme_path()]
 html_theme_options = {
     "sidebar_mode": "toc",
 }
 
 extensions = [
     'os_api_ref',
+    'openstackdocstheme'
 ]
 
 # If extensions (or modules to document with autodoc) are in another directory,
@@ -68,19 +65,6 @@ master_doc = 'index'
 project = u'Object Storage API Reference'
 copyright = u'2010-present, OpenStack Foundation'
 
-# The version info for the project you're documenting, acts as replacement for
-# |version| and |release|, also used in various other places throughout the
-# built documents.
-#
-# The short X.Y version.
-version = __version__.rsplit('.', 1)[0]
-# The full version, including alpha/beta/rc tags.
-release = __version__
-
-# html_context allows us to pass arbitrary values into the html template
-html_context = {'bug_tag': 'api-ref',
-                'bug_project': 'swift'}
-
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
 #
@@ -108,7 +92,12 @@ add_module_names = False
 show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = 'native'
+
+# openstackdocstheme options
+openstackdocs_repo_name = 'openstack/swift'
+openstackdocs_bug_project = 'swift'
+openstackdocs_bug_tag = 'api-ref'
 
 # -- Options for man page output ----------------------------------------------
 
@@ -152,25 +141,6 @@ pygments_style = 'sphinx'
 # so a file named "default.css" will overwrite the builtin "default.css".
 # html_static_path = ['_static']
 
-# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
-# using the given strftime format.
-# html_last_updated_fmt = '%b %d, %Y'
-if 'SOURCE_DATE_EPOCH' in os.environ:
-    now = float(os.environ.get('SOURCE_DATE_EPOCH'))
-    html_last_updated_fmt = datetime.datetime.utcfromtimestamp(now).isoformat()
-else:
-    git_cmd = ["git", "log", "--pretty=format:'%ad, commit %h'",
-               "--date=local", "-n1"]
-    try:
-        html_last_updated_fmt = subprocess.Popen(
-            git_cmd, stdout=subprocess.PIPE).communicate()[0]
-    except OSError:
-        warnings.warn('Cannot get last updated time from git repository. '
-                      'Not setting "html_last_updated_fmt".')
-    else:
-        if not isinstance(html_last_updated_fmt, str):
-            # for py3
-            html_last_updated_fmt = html_last_updated_fmt.decode('ascii')
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
 # html_use_smartypants = True
diff -pruN 2.25.0-2/bin/swift-get-nodes 2.25.1~git2020070613.2e001431f-0ubuntu1/bin/swift-get-nodes
--- 2.25.0-2/bin/swift-get-nodes	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/bin/swift-get-nodes	2020-07-06 17:03:50.000000000 +0000
@@ -52,6 +52,8 @@ if __name__ == '__main__':
                       help='Specify which policy to use')
     parser.add_option('-d', '--swift-dir', default='/etc/swift',
                       dest='swift_dir', help='Path to swift directory')
+    parser.add_option('-Q', '--quoted', action='store_true',
+                      help='Assume swift paths are quoted')
     options, args = parser.parse_args()
 
     if set_swift_dir(options.swift_dir):
diff -pruN 2.25.0-2/bin/swift-object-relinker 2.25.1~git2020070613.2e001431f-0ubuntu1/bin/swift-object-relinker
--- 2.25.0-2/bin/swift-object-relinker	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/bin/swift-object-relinker	2020-07-06 17:03:50.000000000 +0000
@@ -28,6 +28,8 @@ if __name__ == '__main__':
                         dest='swift_dir', help='Path to swift directory')
     parser.add_argument('--devices', default='/srv/node',
                         dest='devices', help='Path to swift device directory')
+    parser.add_argument('--device', default=None, dest='device',
+                        help='Device name to relink (default: all)')
     parser.add_argument('--skip-mount-check', default=False,
                         help='Don\'t test if disk is mounted',
                         action="store_true", dest='skip_mount_check')
diff -pruN 2.25.0-2/CHANGELOG 2.25.1~git2020070613.2e001431f-0ubuntu1/CHANGELOG
--- 2.25.0-2/CHANGELOG	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/CHANGELOG	2020-07-06 17:03:50.000000000 +0000
@@ -2,12 +2,6 @@ swift (2.25.0, OpenStack Ussuri)
 
     * WSGI server processes can now notify systemd when they are ready.
 
-    * Added a new middleware that allows users and operators to configure
-      accounts and containers to use RFC-compliant (i.e., double-quoted)
-      ETags. This may be useful when using Swift as an origin for some
-      content delivery networks. For more information, see
-      https://docs.openstack.org/swift/latest/middleware.html#etag-quoter
-
     * Added `ttfb` (Time to First Byte) and `pid` (Process ID) to the set
       of available proxy-server log fields. For more information, see
       https://docs.openstack.org/swift/latest/logs.html
@@ -58,8 +52,9 @@ swift (2.24.0)
     * Added support for S3 versioning using the above new mode.
 
     * Added a new middleware to allow accounts and containers to opt-in to
-      RFC-compliant ETags. For more information, see the documentation at
-      https://docs.openstack.org/swift/latest/middleware.html#module-swift.common.middleware.etag_quoter
+      RFC-compliant ETags. This may be useful when using Swift as an origin
+      for some content delivery networks. For more information, see the
+      documentation at https://docs.openstack.org/swift/latest/middleware.html#module-swift.common.middleware.etag_quoter
       Clients should be aware of the fact that ETags may be quoted for RFC
       compliance; this may become the default behavior in some future release.
 
diff -pruN 2.25.0-2/CONTRIBUTING.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/CONTRIBUTING.rst
--- 2.25.0-2/CONTRIBUTING.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/CONTRIBUTING.rst	2020-07-06 17:03:50.000000000 +0000
@@ -21,6 +21,16 @@ Swift is nothing without the community b
 our community. Come find us in #openstack-swift on freenode IRC or on the
 OpenStack dev mailing list.
 
+For general information on contributing to OpenStack, please check out the
+`contributor guide <https://docs.openstack.org/contributors/>`_ to get started.
+It covers all the basics that are common to all OpenStack projects: the accounts
+you need, the basics of interacting with our Gerrit review system, how we
+communicate as a community, etc.
+
+If you want more Swift related project documentation make sure you checkout
+the Swift developer (contributor) documentation at
+https://docs.openstack.org/swift/latest/
+
 Filing a Bug
 ~~~~~~~~~~~~
 
diff -pruN 2.25.0-2/debian/account-server.conf 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/account-server.conf
--- 2.25.0-2/debian/account-server.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/account-server.conf	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,16 @@
+[DEFAULT]
+bind_ip = 0.0.0.0
+bind_port = 6002
+workers = 2
+
+[pipeline:main]
+pipeline = account-server
+
+[app:account-server]
+use = egg:swift#account
+
+[account-replicator]
+
+[account-auditor]
+
+[account-reaper]
diff -pruN 2.25.0-2/debian/changelog 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/changelog
--- 2.25.0-2/debian/changelog	2020-06-12 12:22:55.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/changelog	2020-07-06 17:04:33.000000000 +0000
@@ -1,898 +1,1002 @@
-swift (2.25.0-2) unstable; urgency=medium
+swift (2.25.1~git2020070613.2e001431f-0ubuntu1) groovy; urgency=medium
 
-  * Uploading to unstable.
+  * New upstream snapshot for OpenStack Victoria.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/p/drop-ipaddress-requirement.patch: Dropped. No longer needed as package
+    is Python3-only.
+  * d/control, d/compat: Switch to debhelper compat 12.
+  * d/control: Update Standards-Version to 4.5.0.
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 12 Jun 2020 14:22:55 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 06 Jul 2020 13:04:33 -0400
 
-swift (2.25.0-1) experimental; urgency=medium
+swift (2.25.0-0ubuntu3) groovy; urgency=medium
 
-  * New upstream release.
-  * Rebase patches.
+  * d/t/swift-daemons: Update to give systemd units time to restart.
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 21 Apr 2020 10:38:46 +0200
+ -- Chris MacNaughton <chris.macnaughton@canonical.com>  Thu, 25 Jun 2020 11:30:03 +0000
 
-swift (2.24.0-1) experimental; urgency=medium
+swift (2.25.0-0ubuntu2) groovy; urgency=medium
 
-  * New upstream release.
-  * d/patches: Rebased.
-  * Bump Standards-Version to 4.5.0.
-  * Rules-Requires-Root: no.
-  * Disable sphinxcontrib.rsvgconverter extension.
-  * d/patches/py38_cgi_lost_some_names.patch:
-    Drop, applied upstream.
-  * d/rules: Remove not needed override_dh_systemd_enable target.
+  [ Chris MacNaughton ]
+  * Update to use Systemd unit files (LP: #1827340, LP: #1800676)
+    * d/*.init.in: Import init script (systemd) generation from Debian.
+    * d/*.upstart: Removed.
+    * d/*.init: Removed
+    * d/*.generator: Import from Debian.
+    * d/*.install: Added reference to generator files
+    * d/gen-init: Import from Debian. Remove WorkingDirectory.
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 13 Mar 2020 16:46:42 +0100
+  [ James Page ]
+  * d/control: Add sphinxdoc:Depends to swift-doc.
+  * d/*: wrap-and-sort -bast.
 
-swift (2.23.1-2) unstable; urgency=medium
+ -- Chris MacNaughton <chris.macnaughton@canonical.com>  Wed, 24 Jun 2020 09:59:02 +0100
 
-  * Add upstream patch: py38_cgi_lost_some_names.patch. (Closes: #951987).
+swift (2.25.0-0ubuntu1) groovy; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 25 Feb 2020 11:55:02 +0100
+  * New upstream release for OpenStack Ussuri (LP: #1877642).
 
-swift (2.23.1-1) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 14 May 2020 14:47:36 -0400
 
-  * New upstream release.
-  * Remove one more not needed
-    package-supports-alternative-init-but-no-init.d-script
-    lintian override.
-  * Drop Python 3 patches, applied upstream.
+swift (2.24.1~git2020041316.a495f1e32-0ubuntu1) focal; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 23 Oct 2019 14:26:27 +0200
+  * d/watch: Update tarball URL to opendev.org.
+  * New upstream snapshot for OpenStack Ussuri.
 
-swift (2.23.0-6) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 13 Apr 2020 16:25:31 -0400
 
-  * Uploading to unstable.
-  * Bump Standards-Version to 4.4.1.
-  * Remove not needed package-supports-alternative-init-but-no-init.d-script
-    lintian overrides.
+swift (2.24.1~git2020032711.712bf3c9f-0ubuntu2) focal; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 21 Oct 2019 12:33:00 +0200
+  * d/control, d/rules: Move installation of /etc/swift/ files to
+    python3-swift package.
 
-swift (2.23.0-5) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 30 Mar 2020 08:26:09 -0400
 
-  * Add a number of Py3 fixes:
-    - py3_Fix_swift-drive-audit.patch
-    - py3_Fix_swift-recon.patch
-    - py3_fix_swift-dispersion-populate.patch
-    - py3_fix_swift-account-audit.patch
+swift (2.24.1~git2020032711.712bf3c9f-0ubuntu1) focal; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 15 Oct 2019 16:53:21 +0200
+  * New upstream snapshot for OpenStack Ussuri.
+  * d/glance-common.postinst: Set default ownership and permissions for
+    /etc/<pkg> (LP: #1859422).
 
-swift (2.23.0-4) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 27 Mar 2020 11:39:24 -0400
 
-  * Replace my old patch Fix_on-disk_encryption_under_Python_3.patch by the new
-    upstream one: Fix_kms_keymaster_under_Python_3.patch.
+swift (2.24.0-0ubuntu1) focal; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 15 Oct 2019 03:16:37 +0200
+  * New upstream release for OpenStack Ussuri.
 
-swift (2.23.0-3) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 13 Feb 2020 14:01:08 -0500
 
-  * Add Fix_on-disk_encryption_under_Python_3.patch.
+swift (2.24.0~git2019121715.e890b0f0f-0ubuntu1) focal; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 11 Oct 2019 14:16:53 +0200
+  * New upstream snapshot for OpenStack Ussuri.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/rules: Switch pybuild.
+  * d/rules: Update PBR_VERSION to handle ~git versioning.
+  * d/p/skip-test-local-py36.patch: Update to skip for all Py3 versions.
 
-swift (2.23.0-2) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 17 Dec 2019 15:16:47 -0500
 
-  * Do not use --processes=-1 when running tests, as this seems to fail on
-    buildds.
+swift (2.23.1-0ubuntu1) focal; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 07 Oct 2019 16:31:24 +0200
+  * New stable point release for OpenStack Train (LP: #1853311).
 
-swift (2.23.0-1) experimental; urgency=medium
+ -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Mon, 02 Dec 2019 15:19:23 +0100
 
-  * New upstream release.
-  * Fixed version of eventlet in (b-)d for this release.
-  * Add  python3-barbicanclient and python3-castellan as recommends in
-    swift-proxy, as they are needed for on-disk encryption.
-  * Removed patches applied upstream:
-    - sphinx_reproducible_build.patch
-    - fix-xattr_supported_check.patch
-  * Run tests with --processes=-1 to run them in parallel.
+swift (2.23.0-0ubuntu1) eoan; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 04 Oct 2019 15:59:04 +0200
+  * New upstream release for OpenStack Train.
 
-swift (2.22.0-2) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 16 Oct 2019 11:26:04 -0400
 
-  * Remove swauth from Recommends.
+swift (2.22.0-0ubuntu2) eoan; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 13 Aug 2019 10:37:49 +0200
+  * d/control: Add Breaks/Replaces on python-swift to ensure that
+    upgrades from py2->py3 are handled correctly (LP: #1847576).
 
-swift (2.22.0-1) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Thu, 10 Oct 2019 12:04:12 +0100
 
-  * New upstream release.
-  * Bump Standards-Version to 4.4.0.
-  * Remove prerm/preinst scripts for upgrading from version 2.6.0-2.
-  * Add lintian overrides for
-    package-supports-alternative-init-but-no-init.d-script
-  * python3-swift.lintian-overrides: Fix wrong binary package name
-  * Use pybuild to build package.
-  * Clean using d/clean file instead of override_dh_auto_clean target.
-  * Bump debhelper compat level to 12.
-  * Cleanup systemd and init scripts generator.
+swift (2.22.0-0ubuntu1) eoan; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 05 Aug 2019 19:12:51 +0200
+  * New upstream release for OpenStack Train.
 
-swift (2.21.10+2019.07.13+git.4643412bd1-3) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Thu, 26 Sep 2019 15:15:04 +0100
 
-  [ Ondřej Nový ]
-  * Running wrap-and-sort -bast.
-  * Use debhelper-compat instead of debian/compat.
+swift (2.22.0~b2~git2019073018.d33e569be-0ubuntu1) eoan; urgency=medium
 
-  [ Thomas Goirand ]
-  * Fixed python3-os-api-ref-common -> python-os-api-ref-common depends for
-    swift-doc, which was a mistake when converting to Python 3.
+  * New upstream snapshot for OpenStack Train.
+  * d/control: Align (Build-)Depends with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 23 Jul 2019 18:41:54 +0200
+ -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Tue, 30 Jul 2019 18:52:11 +0200
 
-swift (2.21.10+2019.07.13+git.4643412bd1-2) unstable; urgency=medium
+swift (2.22.0~b1~git2019071110.e62f07d98-0ubuntu3) eoan; urgency=medium
 
-  * Uploading to unstable.
+  * d/rules: Use pkgos-dh_auto_install to install Python 3 modules.
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 17 Jul 2019 19:51:53 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 18 Jul 2019 11:48:40 -0400
 
-swift (2.21.10+2019.07.13+git.4643412bd1-1) experimental; urgency=medium
+swift (2.22.0~b1~git2019071110.e62f07d98-0ubuntu2) eoan; urgency=medium
 
-  * New upstream release.
-  * Switch swift to Python 3.
-  * Rebased patches.
-  * Added usr/bin/swift-container-deleter to the swift-container package.
+  * d/control: Restore python-setuptools BDI for UCA backport.
+  * d/p/skip-test-local-py36.patch, d/control: Skip locale test for Python
+    3.6 as locale is not available by default in build environment.
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 15 Jul 2019 15:09:23 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 11 Jul 2019 14:05:49 -0400
 
-swift (2.21.0-1) experimental; urgency=medium
+swift (2.22.0~b1~git2019071110.e62f07d98-0ubuntu1) eoan; urgency=medium
 
-  [ Michal Arbet ]
-  * d/control:
-      - Bump openstack-pkg-tools to version 99
-      - Add me to uploaders field
-  * d/copyright: Add me to copyright file
-  * New upstream version
+  * New upstream snapshot for OpenStack Train.
+  * d/control, d/rules, d/python(3)-swift*: Add support for Python 3
+    and remove support for Python 2.
+  * d/p/drop-ipaddress-requirement.patch: Drop ipaddress from requirements.txt.
 
-  [ Ondřej Nový ]
-  * d/p/fix-decryption-of-object-if-metadata-is-missing.patch:
-    Remove, applied upstream
-  * Rebased patches
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 11 Jul 2019 10:14:31 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 13 May 2019 12:06:24 +0200
+swift (2.22.0~b1~git2019061305.aa2f1db1b-0ubuntu1) eoan; urgency=medium
 
-swift (2.19.1-1) unstable; urgency=medium
+  * New upstream snapshot for OpenStack Train.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/swift-container.install: Wildcard install of swift-container-*
+    binaries.
 
-  * New upstream bugfix release
+ -- James Page <james.page@ubuntu.com>  Thu, 13 Jun 2019 15:13:13 +0100
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 26 Feb 2019 11:53:35 +0100
+swift (2.21.0-0ubuntu1) disco; urgency=medium
 
-swift (2.19.0-6) unstable; urgency=medium
+  * New upstream release for OpenStack Stein.
 
-  * Object decryption fix patch:
-    - Add a warning in the logs if path is different in
-      put_crypto_meta['key_id']['path'] and put_keys['id']['path']).
+ -- James Page <james.page@ubuntu.com>  Mon, 08 Apr 2019 09:13:45 +0100
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 01 Feb 2019 13:38:08 +0100
+swift (2.20.0-0ubuntu2) disco; urgency=medium
 
-swift (2.19.0-5) unstable; urgency=medium
+  * d/control: Add python-keystonemiddleware to Depends (LP: #1815093).
 
-  * Fix decryption of objects that sometimes is wrong.
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 07 Feb 2019 15:05:35 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 24 Jan 2019 20:48:22 +0100
+swift (2.20.0-0ubuntu1) disco; urgency=medium
 
-swift (2.19.0-3) unstable; urgency=medium
+  * New upstream release for OpenStack Stein.
+  * d/control: Align (Build-)Depends with upstream.
 
-  * Add Breaks of older systemd without CacheDirectory support
-  * Rename d/tests/control.autodep8 to d/tests/control.
-  * d/copyright: Bump my copyright year.
-  * Bump Standards-Version to 4.3.0 (no changes)
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 31 Jan 2019 12:43:00 -0500
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 22 Jan 2019 17:41:50 +0100
+swift (2.19.0-0ubuntu1) cosmic; urgency=medium
 
-swift (2.19.0-2) unstable; urgency=medium
+  * New upstream release.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/swift.install: Install binary for new CLI client swift-ring-composer.
 
-  * Uploading to unstable
-  * Bump Standards-Version to 4.2.1
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 30 Aug 2018 10:33:03 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 05 Sep 2018 12:24:08 +0200
+swift (2.18.0-0ubuntu1) cosmic; urgency=medium
 
-swift (2.19.0-1) experimental; urgency=medium
+  * New upstream release.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/swift-container.install, d/swift.install,
+    swift-container.swift-container-sharder.init: Install
+    usr/bin/swift-container-sharder and usr/bin/swift-manage-shard-ranges and
+    add init file for swift-container-sharder.
+  * d/control: Update Standards-Version to 4.1.4.
+  * d/control, d/tests/*: Drop obsolete autopkgtest header and enable
+    autopkgtest-pkg-python testsuite.
+  * d/control, d/watch: Use https URLs.
 
-  * New upstream release
-  * d/p/syslog_log_name.patch: Rebased
-  * Add python-ipaddress to B-D and D
-  * Add swift-ring-composer CLI
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 13 Jun 2018 15:14:00 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 22 Aug 2018 14:30:40 +0200
+swift (2.17.0-0ubuntu1) bionic; urgency=medium
 
-swift (2.18.0-1) experimental; urgency=medium
+  [ James Page ]
+  * d/p/*: Rebase.
 
-  * New upstream release
-  * d/p/Fix_tests_using_O_TMPFILE.patch: Drop, applied upstream
-  * d/p/syslog_log_name.patch: Rebased
-  * Fix B-D for new upstream release
-  * Add swift-object-relinker manpage
-  * Add swift-container-sharder daemon and swift-manage-shard-ranges CLI
-  * Enable autopkgtest-pkg-python testsuite
+  [ Corey Bryant ]
+  * New upstream release candidate for OpenStack Queens.
+  * d/*: wrap-and-sort -bast.
+  * d/control: Update Standards-Version to 4.1.2.
+  * d/control: Bump debhelper compat to 10.
+  * d/control: Align (Build-)Depends with upstream.
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 20 Aug 2018 15:32:05 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 14 Feb 2018 09:24:36 -0500
 
-swift (2.17.0-5) unstable; urgency=medium
+swift (2.16.0-0ubuntu2) bionic; urgency=medium
 
-  * d/tests: Use AUTOPKGTEST_TMP instead of ADTTMP
-  * d/control: Use team+openstack@tracker.debian.org as maintainer
-  * Don't use has_key, which is deprecated (Closes: #906413)
-  * Really build docs with Python 3
-  * Use LC_ALL=C.UTF-8 when building docs
-  * Use SOURCE_DATE_EPOCH in docs to make build reproducible (again)
-  * Bump standards version to 4.2.0 (no changes)
-  * Add upstream metadata
+  * d/rules, d/swift-doc.docs: Adjust sphinx-build command and drop
+    swift-doc.docs as the sphinx-build command already installs the files in
+    the temp directory.
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 20 Aug 2018 11:49:41 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 22 Nov 2017 14:07:55 -0500
 
-swift (2.17.0-4) unstable; urgency=medium
+swift (2.16.0-0ubuntu1) bionic; urgency=medium
 
-  * Remove python-keystonemiddleware as runtime depends
-  * Add python-keystonemiddleware | swauth as recommends for swift-proxy
-  * d/p/Fix_tests_using_O_TMPFILE.patch: Refresh from current upstream review
+  * New upstream release.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/p/*: Rebase, drop patches accepted upstrea or no longer needed.
+  * d/compat: Bump to 9, inline with BD.
+  * d/swift.install: Drop swift-temp-url, no long shipped.
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 13 Mar 2018 13:07:06 +0100
+ -- James Page <james.page@ubuntu.com>  Fri, 17 Nov 2017 10:40:50 +0000
 
-swift (2.17.0-3) unstable; urgency=medium
+swift (2.15.1-0ubuntu3) artful; urgency=medium
 
-  * Add python-keystonemiddleware as runtime depends.
-  * Removed versions when satisfied in Stretch.
-  * Removed breaks/replaces when transition is already done in Stretch.
-  * Refreshed patches.
-  * Add Fix_tests_using_O_TMPFILE.patch.
+  * d/p/update-test-drop-privs.patch: Drop group comparison from
+    drop_privileges test as it does not appear to be valid (LP: #1724342).
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 12 Mar 2018 08:58:19 +0000
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 17 Oct 2017 15:01:59 -0400
 
-swift (2.17.0-2) unstable; urgency=medium
+swift (2.15.1-0ubuntu2) artful; urgency=medium
 
-  * Uploading to unstable
-  * d/control: Set Vcs-* to salsa.debian.org
-  * Running wrap-and-sort -bast
-  * d/copyright: Bump my copyright year
+  * d/p/fix-deployment-guide-header.patch: Extend deployment guide headers
+    to fix sphinx error for xenial-pike backport.
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 27 Feb 2018 12:49:44 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 25 Aug 2017 17:57:20 -0400
 
-swift (2.17.0-1) experimental; urgency=medium
+swift (2.15.1-0ubuntu1) artful; urgency=medium
 
-  * New upstream release
-  * Sync with unstable
-  * Standards-Version is 4.1.3 now (no change)
+  * New upstream point release for OpenStack Pike.
+  * d/p/*: Rebased.
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 09 Feb 2018 15:45:22 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 24 Aug 2017 12:29:58 -0400
 
-swift (2.16.0-1) experimental; urgency=medium
+swift (2.15.0-0ubuntu1) artful; urgency=medium
 
-  * New upstream release
-  * Bump required version of python-cryptography
-  * d/patches/Be_more_tolerant_of_exception_messages_from_sqlite.patch:
-    Remove, applied upstream
-  * Rebased all patches
-  * Remove bin/swift-temp-url
+  * d/control: Drop oslosphinx and update min version of openstackdocstheme.
+  * New upstream release for OpenStack Pike.
+  * d/p/drop-openstackdoctheme.patch: Temporarily drop openstackdocstheme
+    sphinx extension until sphinx>=1.6.2 is available.
+  * d/p/skip-online-test.patch: Skip test that is failing without network
+    access.
+  * d/swift-object.install: Install swift-object-relinker binary.
 
- -- Ondřej Nový <onovy@debian.org>  Sat, 09 Dec 2017 22:29:12 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 01 Aug 2017 09:20:37 -0400
 
-swift (2.15.1-7) unstable; urgency=medium
+swift (2.13.1-0ubuntu1) artful; urgency=medium
 
-  * Fix wrong logrotate file
-  * Standards-Version is 4.1.2 now (no change)
+  [ Chuck Short ]
+  * d/patches/use-pbr2.patch: Use pbr2 by default.
+  * d/patches/fix-doc-no-network.patch: Dropped not longer required.
 
- -- Ondřej Nový <onovy@debian.org>  Sun, 10 Dec 2017 10:35:18 +0100
+  [ James Page ]
+  * New upstream point release.
 
-swift (2.15.1-6) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 16 Jun 2017 11:45:54 +0100
 
-  * d/swift-container-generator: Remove container-reconciler
-  * Use dh_missing --fail-missing
+swift (2.13.0-0ubuntu1) zesty; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Sat, 09 Dec 2017 22:00:34 +0100
+  * New upstream release for OpenStack Ocata.
+  * d/control: Align (build-)depends with upstream.
+  * d/README.Source: Removed it still mentioned bzr to package swift.
 
-swift (2.15.1-5) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 16 Feb 2017 05:46:37 -0500
 
-  * Create /var/log/swift and /var/lib/swift only during postinst
-  * Change WorkingDirectory to ~
-  * Use pkgos_var_user_group instead of pkgos_adduser in postinst
-  * Create /var/cache/swift in SysV init script
+swift (2.12.0-0ubuntu1) zesty; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Sat, 02 Dec 2017 19:45:07 +0100
+  * New upstream version.
+  * d/p/avoid-infinite-loop-while-placing-parts.patch: Dropped. Included in
+    new upstream version.
+  * New upstream release for OpenStack Ocata.
 
-swift (2.15.1-4) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 19 Dec 2016 09:18:26 -0500
 
-  * Use tmpfiles.d, CacheDirectory and RuntimeDirectory instead of
-    ExecStartPre
-  * Set owner of /var/log/swift to root
-  * d/tests/daemon: Require isolation-container
+swift (2.11.0-0ubuntu2) zesty; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Sat, 02 Dec 2017 15:04:11 +0100
+  * d/p/avoid-infinite-loop-while-placing-parts.patch: Cherry-picked from
+    upstream master branch to avoid infinite loop while placing parts
+    (LP: #1642538).
 
-swift (2.15.1-3) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 09 Dec 2016 09:05:26 -0500
 
-  * d/copyright: Add missing copyright holders
+swift (2.11.0-0ubuntu1) zesty; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 06 Nov 2017 09:15:02 +0100
+  [ Corey Bryant ]
+  * d/control: Align python-pyeclib with upstream.
 
-swift (2.15.1-2) unstable; urgency=medium
+  [ David Della Vecchia ]
+  * New upstream release for OpenStack Ocata.
+  * d/control: Align (build-)depends with upstream.
 
-  * Uploading to unstable
+ -- David Della Vecchia <ddv@canonical.com>  Mon, 21 Nov 2016 09:18:15 -0500
 
- -- Ondřej Nový <onovy@debian.org>  Sun, 05 Nov 2017 21:12:27 +0100
+swift (2.10.0-0ubuntu1) yakkety; urgency=medium
 
-swift (2.15.1-1) experimental; urgency=medium
+  * New upstream release for OpenStack Newton.
+  * d/control: Align (build-)depends with upstream.
 
-  [ Ondřej Nový ]
-  * New upstream release
-  * Bump required version of (build-)depends for new upstream release
-  * d/p/syslog_log_name.patch: rebase
-  * d/p/Be_more_tolerant_of_exception_messages_from_sqlite.patch:
-    fix sqlite error (Closes: #877298)
-  * Don't restart rsyslog in postrm/postinst, it's done by trigger
-  * d/copyright: Bump copyright years
-  * Install swift-object-relinker
-  * Install guide is now part of main docs
-  * d/control
-    - Don't depend on dh-systemd, it's not needed in new debhelper
-    - Remove deprecated ${python:Provides}
-  * Use python3-sphinx for building docs
-  * d/tests/help: Add swift-object-relinker
-  * Updating standards version to 4.1.1.
-
-  [ Daniel Baumann ]
-  * Updating vcs fields.
-  * Updating copyright format url.
-  * Updating maintainer field.
-  * Running wrap-and-sort -bast.
-  * Removing gbp.conf, not used anymore or should be specified in the
-    developers dotfiles.
-  * Correcting permissions in debian packaging files.
-
- -- Ondřej Nový <onovy@debian.org>  Tue, 31 Oct 2017 14:43:03 +0100
-
-swift (2.10.2-1) unstable; urgency=medium
-
-  * New upstream stable release
-  * Removed patches applied upstream:
-    - Quarantine_malformed_database_schema_SQLite_errors.patch
-    - For_any_part_only_one_replica_can_move_in_a_rebalance.patch
-    - FTBFS_i386.patch
-
- -- Ondřej Nový <onovy@debian.org>  Sat, 03 Jun 2017 13:35:44 +0200
-
-swift (2.10.1-3) unstable; urgency=medium
-
-  * d/patches/FTBFS_i386.patch: Fix FTBFS on i386 (Closes: #860638)
-
- -- Ondřej Nový <onovy@debian.org>  Thu, 20 Apr 2017 22:51:28 +0200
-
-swift (2.10.1-2) unstable; urgency=medium
-
-  * Don't start rsyslog during postinst/postrm if it's stopped
-  * d/tests
-    - Added Python module import test
-    - Added daemons test
-  * Added patches from upstream master:
-    - For any part only one replica can move in a rebalance
-    - Quarantine malformed database schema SQLite errors
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 28 Sep 2016 14:06:46 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 13 Jan 2017 10:05:12 +0100
+swift (2.9.0-0ubuntu1) yakkety; urgency=medium
 
-swift (2.10.1-1) unstable; urgency=medium
+  * New upstream release for OpenStack Newton.
+  * d/control: Align (build-)depends with upstream.
 
-  * New upstream release
-  * Bumped debhelper version to 10
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 15 Jul 2016 08:32:18 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Thu, 15 Dec 2016 16:11:51 +0100
+swift (2.8.0-0ubuntu1) yakkety; urgency=medium
 
-swift (2.10.0-3) unstable; urgency=medium
+  * New upstream version.
+  * d/p/drop-sphinx-git.patch: Dropped, no longer required.
+  * d/control: Bumped Standards-Version, no changes.
+  * d/swift-container.docs: Install container-sync-realms.conf sample
+    configuration file (LP: #1586483).
+  * d/swift-object.swift-object-reconstructor.{init|upstart},rules:
+    Add init and upstart configuration files for swift-object-reconstructor
+    (LP: #1522448).
 
-  * Run swift-drive-audit cron by root
-    (needed for /var/log/kern.log reading and umount command)
+ -- James Page <james.page@ubuntu.com>  Fri, 10 Jun 2016 11:34:52 +0100
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 17 Oct 2016 14:40:10 +0200
+swift (2.7.0-0ubuntu2) xenial; urgency=medium
 
-swift (2.10.0-2) unstable; urgency=medium
+  * d/tests/swift-daemons: Set replica count for each ring to 1, resolving
+    autopkgtest failure during rebalance operations.
 
-  * Uploading to unstable
+ -- James Page <james.page@ubuntu.com>  Mon, 11 Apr 2016 12:21:44 +0100
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 07 Oct 2016 10:33:11 +0200
+swift (2.7.0-0ubuntu1) xenial; urgency=medium
 
-swift (2.10.0-1) experimental; urgency=medium
+  * New upstream release for OpenStack Mitaka.
+  * d/p/drop-sphinx-git.patch: Rebased.
+  * d/p/fix-doc-no-network.patch: Rebased.
 
-  * New upstream release
-  * d/s/options: extend-diff-ignore of .gitreview
-  * d/control: Using OpenStack's Gerrit as VCS URLs.
-  * Bump required version of dnspython to 1.14.0
-  * Added missing manpages from upstream
+ -- David Della Vecchia <ddv@canonical.com>  Fri, 08 Apr 2016 09:02:57 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Thu, 29 Sep 2016 09:43:09 +0200
+swift (2.6.0-0ubuntu1) xenial; urgency=medium
 
-swift (2.9.0-2) experimental; urgency=medium
+  [ David Della Vecchia ]
+  * New upstream release for OpenStack Mitaka.
+  * d/control: Align (build-)depends with upstream.
+  * d/p/pyeclib-version.patch: Removed, fixed in upstream.
+  * d/p/sphinx.patch: Remove git command to prevent build errors.
 
-  * Rebased on 2.7.0-10
-  * Removed doctrees from doc to make build reproducible
-  * Moved swift-recon and swift-object-expirer manpages to correct binary
-    packages
-  * Moved swift-config cli to swift binary package
+  [ Corey Bryant ]
+  * d/p/sphinx.patch: Dropped in favor of adding git to BD's.
+  * d/control: Add git to build-depends for sphinx-build.
+  * d/control: Add python-cffi to BDs to fix failing tests.
+  * d/p/drop-sphinx-git.patch, d/control: Drop use of git from sphinx config.
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 21 Sep 2016 20:57:37 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 10 Mar 2016 13:34:13 -0500
 
-swift (2.9.0-1) experimental; urgency=medium
+swift (2.5.0-0ubuntu1) wily; urgency=medium
 
-  * Rebased on 2.7.0-9
-  * New upstream release
-  * Changed (build) depends for new upstream release
-  * Build API ref and install guide documentation
-  * Added libjs-jquery, libjs-underscore and libjs-bootstrap dependency to
-    swift-doc
-  * Moved base documentation to "base" directory
+  * New upstream release for OpenStack Liberty.
+  * d/control,python-swift.postinst: Tidy lintian warning messages.
 
- -- Ondřej Nový <onovy@debian.org>  Sun, 17 Jul 2016 23:15:09 +0200
+ -- James Page <james.page@ubuntu.com>  Thu, 08 Oct 2015 06:16:59 -0700
 
-swift (2.8.0-2) experimental; urgency=medium
+swift (2.4.0-0ubuntu1) wily; urgency=medium
 
-  * Rebased on 2.7.0-7
+  * New upstream release:
+    - d/p/CVE-2015-1856.patch,
+      d/p/fix-tempauth-acl-checks.patch,
+      d/p/increase-httplib-maxheaders.patch,
+      d/p/x-auth-token-should-be-bytestring.patch:
+      Dropped, included upstream.
+  * Align (build-)depends with upstream, wrap-and-sort.
+  * d/p/pyeclib-version.patch: Specify minimum bound for pyeclib only.
+  * Install new swift-object-reconstructor and swift-ring-builder-analyzer
+    binaries.
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 06 Jul 2016 00:35:48 +0200
+ -- James Page <james.page@ubuntu.com>  Mon, 07 Sep 2015 13:00:03 +0100
 
-swift (2.8.0-1) experimental; urgency=medium
+swift (2.2.2-0ubuntu1.3) vivid-security; urgency=medium
 
-  * New upstream release
-  * Removed build depend on git, not needed anymore
-  * Added missed example configs to docs
-  * Use dh_installdocs -A for installing AUTHORS file
+  [ Marc Deslauriers ]
+  * SECURITY UPDATE: object deletion via x-versions-location container
+    - debian/patches/CVE-2015-1856.patch: prevent unauthorized delete in
+      swift/proxy/controllers/obj.py, added tests to
+      test/functional/tests.py.
+    - CVE-2015-1856
 
- -- Ondřej Nový <novy@ondrej.org>  Tue, 14 Jun 2016 20:23:21 +0200
+  [ Jamie Strandboge ]
+  * debian/patches/x-auth-token-should-be-bytestring.patch: update for
+    functional test suite
+  * debian/patches/fix-tempauth-acl-checks.patch: fix tempauth acl checks when
+    simplejson has no speedups
+  * debian/patches/increase-httplib-maxheaders.patch: fix testuite and
+    increase httplib._MAXHEADERS
 
-swift (2.7.0-10) unstable; urgency=medium
+ -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 30 Jul 2015 12:24:47 -0500
 
-  * Stop services first when upgrading from < 2.6.0-2 version
+swift (2.2.2-0ubuntu1) vivid; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 21 Sep 2016 19:34:00 +0200
+  * New upstream release. 
+  * debian/patches/fixup-32bit-max-file-size.patch: Dropped no longer needed.
 
-swift (2.7.0-9) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 09 Feb 2015 13:40:34 -0500
 
-  * Ignore errors when trying to restart rsyslog service in postrm too
-    (Closes: #830586)
+swift (2.2.1-0ubuntu2) vivid; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 11 Jul 2016 09:14:29 +0200
+  * Systemd enablement:
+    - d/*.init: Re-instate and re-write original init scripts. 
+    - d/*: Tidy incorrectly named init script files.
 
-swift (2.7.0-8) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Mon, 12 Jan 2015 10:42:51 +0000
 
-  * Ignore errors when trying to restart rsyslog service and be more robust
+swift (2.2.1-0ubuntu1) vivid; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Thu, 07 Jul 2016 16:06:46 +0200
+  [ Chuck Short ]
+  * Open for Vivid.
+  * d/control: Update branch locations.
 
-swift (2.7.0-7) unstable; urgency=medium
+  [ James Page ]
+  * New upstream release:
+    - d/p/*: Refresh.
+  * d/control: Bumped Standards-Version 3.9.6, no changes.
 
-  * Check for ring files before starting service (Closes: #829375)
-  * Remove all swift directories on purge
-  * Added missed example configs to docs
-  * Use dh_installdocs -A for installing AUTHORS file
-  * Added support for nodocs in DEB_BUILD_OPTIONS
-  * Use dh-exec for installing configs
-  * Use adm group for log directory
-  * Log to /var/log/swift and not to generic logfile
+ -- James Page <james.page@ubuntu.com>  Fri, 19 Dec 2014 14:33:19 +0000
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 05 Jul 2016 23:24:04 +0200
+swift (2.2.0-0ubuntu1) utopic; urgency=medium
 
-swift (2.7.0-6) unstable; urgency=medium
+  [ Corey Bryant ]
+  * New upstream release.
 
-  * Don't add user swift to adm group
-  * d/{control,copyright}: Use my @debian.org email address
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 16 Oct 2014 15:47:13 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 21 Jun 2016 17:41:38 +0200
+swift (2.2.0~rc1-0ubuntu3) utopic; urgency=medium
 
-swift (2.7.0-5) unstable; urgency=medium
+  * Fix autopkg tests due to upstream mandatory configuration changes:
+    - d/tests/swift-daemons,proxy-server.conf: Switch to using upstream
+      provided sample proxy server configuration, drop test specific
+      configuration.
+    - d/*.conf: Set default bind_port values inline with upstream.
 
-  * Bumped required version of python-setuptools to 20.6.8
-  * Use OSLO_PACKAGE_VERSION from openstack-pkg-tools
+ -- James Page <james.page@ubuntu.com>  Thu, 09 Oct 2014 11:51:59 +0100
 
- -- Ondřej Nový <novy@ondrej.org>  Tue, 14 Jun 2016 16:59:08 +0200
+swift (2.2.0~rc1-0ubuntu2) utopic; urgency=medium
 
-swift (2.7.0-4) unstable; urgency=medium
+  * d/p/fixup-32bit-max-file-size.patch: Limit MAX_FILE_SIZE on 32bit
+    architectures during testing, fixing FTBFS on i386 builders
+    (LP: #1378810).
+  * d/p/fix-ubuntu-tests.patch: Drop, superceeded by above.
 
-  * Bump required openstack-pkg-tools version to 45
-  * Removed run depends on python-setuptools
-  * Removed (build-)depends on python-paste, it's satisfied by
-    python-pastedeploy
-  * Added python-keystoneclient to Build-Depends-Indep
+ -- James Page <james.page@ubuntu.com>  Thu, 09 Oct 2014 09:57:04 +0100
 
- -- Ondřej Nový <novy@ondrej.org>  Thu, 09 Jun 2016 08:40:52 +0200
+swift (2.2.0~rc1-0ubuntu1) utopic; urgency=medium
 
-swift (2.7.0-3) unstable; urgency=medium
+  * New upstream release candidate for OpenStack Juno:
+    - d/p/*: Refreshed.
 
-  * Standards-Version is 3.9.8 now (no change)
-  * Fix copyright year in documentation to make build reproducible
-  * Use pkgos includes inside postinst
-  * Sort inputs in d/rules to make build reproducible
-  * Override false-positive Lintian: spelling-error-in-copyright Thier Their
-  * Removed d/source/include-binaries, not needed anymore
-  * Change directory to $ADTTMP before running Debian tests
-  * wrap-and-sort -t -a
-  * Added Documentation to systemd units
+ -- James Page <james.page@ubuntu.com>  Mon, 06 Oct 2014 15:05:01 +0100
 
- -- Ondřej Nový <novy@ondrej.org>  Thu, 28 Apr 2016 21:33:07 +0200
+swift (2.1.0-0ubuntu1) utopic; urgency=medium
 
-swift (2.7.0-2) unstable; urgency=medium
+  [ Chuck Short ]
+  * debian/patches/fix-doc-no-network.patch: Refreshed.
+  * debian/control: Add python-oslosphinx as a build dependency.
 
-  * Uploading to unstable
-  * Ignore errors when starting daemons during package install
+  [ James Page ]
+  * New upstream release for OpenStack Juno.
+  * d/copyright: Add linebreaks to fixup file-without-copyright-
+    information warning.
 
- -- Ondřej Nový <novy@ondrej.org>  Mon, 04 Apr 2016 10:53:24 +0200
+ -- James Page <james.page@ubuntu.com>  Mon, 06 Oct 2014 10:06:11 +0100
 
-swift (2.7.0-1) experimental; urgency=medium
+swift (2.0.0-0ubuntu2) utopic; urgency=medium
 
-  * New upstream release
-  * Support of multiple conf files in /etc/swift/*-server/ directories
-  * Added dh-python build-depends
-  * Bumped python-pyeclib required version
-  * Enabled autostarting of all daemons
-
- -- Ondřej Nový <novy@ondrej.org>  Sun, 27 Mar 2016 23:24:34 +0200
-
-swift (2.6.0-2) experimental; urgency=medium
-
-  [ Ondřej Nový ]
-  * Added Debian tests.
-  * Removed swift-init.
-  * Systemd support.
-  * Added container-sync config files.
-  * Changed all dependencies to same version of swift package.
-  * Changed shell of "swift" user to /bin/false.
-  * Add user "swift" to group "adm", not replace group list.
-  * Standards-Version is 3.9.7 now (no change).
-  * Fixed Vcs URL.
+  * Do not compress conf-sample files in the doc directories (used in
+    the autopkg tests).
 
-  [ Thomas Goirand ]
-  * Added a backups folder in /etc/swift/backups which links back to
-    /var/backups/swift.
+ -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Aug 2014 12:26:45 +0200
 
- -- Ondřej Nový <novy@ondrej.org>  Wed, 02 Mar 2016 16:42:53 +0100
+swift (2.0.0-0ubuntu1) utopic; urgency=medium
 
-swift (2.6.0-1) experimental; urgency=medium
+  * New upstream release.
+  * debian/control: Open up juno release
+  * debian/patches/ring-perms.patch: Dropped no longer needed.
+  * debian/switf-container.install: Add swift-reconciler-enqueue
+    and swift-container-reconciler.
 
-  [ Ondřej Nový ]
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 08 Jul 2014 10:31:47 -0400
 
-  * New upstream release.
-  * Removed useless shlibs dependency.
-  * Watch file fixed.
-  * Removed PyEClib requirements patching.
-  * Removed simplejson dependency.
-  * Bumbed eventlet and dnspython dependency to new versions.
-  * Added python-os-testr build dependency.
-  * Added git build dependency.
-  * wrap-and-sort -t -a
-  * Removed wrong systemd unit files.
-  * Removed libjerasure2 build dependency.
+swift (1.13.1-0ubuntu1) trusty; urgency=medium
 
-  [ Ivan Udovichenko ]
+  * New upstream release (LP: #1299055). 
 
-  * d/rules: Fix config location for swift-object-expirer service.
-  * d/control: Add Breaks field to swift-object-expirer package.
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 17 Apr 2014 04:52:50 -0400
 
- -- Ondřej Nový <novy@ondrej.org>  Wed, 20 Jan 2016 05:31:21 -0500
+swift (1.13.1~rc2-0ubuntu1) trusty; urgency=medium
 
-swift (2.5.0-2) unstable; urgency=medium
+  [ Chuck Short ]
+  * New upstream release candidate (LP: #1299055).
 
-  [ Ondřej Nový ]
-  * Added cron job for drive audit.
-  * Removed python-swiftclient dependency.
-  * Added libjerasure2 build dependency.
-  * Added myself to copyright file.
-  * Fixed debian/copyright.
-  * Fixed typo in swift-container-sync upstart job.
+  [ James Page ]
+  * d/control: Add appropriate Breaks/Replaces to support move of man pages
+    between binary packages in 1.13.1~rc1-0ubuntu1 (LP: #1306241).
 
-  [ Marek Kaleta ]
-  * Moved drive audit to new package swift-drive-audit.
-  * Added myself to copyright file.
+ -- James Page <james.page@ubuntu.com>  Mon, 14 Apr 2014 11:03:23 +0100
 
- -- Ondřej Nový <novy@ondrej.org>  Sat, 16 Jan 2016 05:05:21 -0500
+swift (1.13.1~rc1-0ubuntu2) trusty; urgency=medium
 
-swift (2.5.0-1) unstable; urgency=medium
+  * d/p/ring-perms.patch: Ensure that generated rings can be read by
+    the swift user, fixing autopkgtest failure (LP: #1302700). 
 
-  [ Ondřej Nový ]
-  * New upstream release.
-  * Workaround swift-init bug and send SIGKILL if SIGTERM is not successful.
-    Thanks to Petr Kuběna <petr.kubena@firma.seznam.cz>
-  * Moved same parts of init scripts to template.
-  * Allows one to change kill-interval in swift-init.
-  * man pages cleanup.
+ -- James Page <james.page@ubuntu.com>  Sun, 06 Apr 2014 21:10:51 +0100
 
-  [ Thomas Goirand ]
-  * Removed Pre-Depends on dpkg.
-  * Removed Breaks+Replaces now obsolete after the release of Jessie.
+swift (1.13.1~rc1-0ubuntu1) trusty; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 22 Oct 2015 20:54:44 +0000
+  [ Chuck Short ]
+  * Add new binaries:
+    - d/swift-container.install: Add swift-container-info binary.
+    - d/swift-account.install: Add swift-account-info binary.
 
-swift (2.4.0-1) unstable; urgency=medium
+  [ James Page ]
+  * New upstream release candidate (LP: #1299055). 
+  * d/rules: Tidy dh_clean override.
+  * d/rules,swift-doc.docs: Re-enable documentation build.
+  * d/*.manpages: Rejig manpage installs into correct packages.
+  * d/container-server.conf: Add missing container-sync section
+    (LP: #1290813).
+  * d/*: Wrap-and-sort.
 
-  [ Ondřej Nový ]
+ -- James Page <james.page@ubuntu.com>  Fri, 04 Apr 2014 10:57:51 +0100
+
+swift (1.13.0-0ubuntu1) trusty; urgency=medium
+
+  [ Chuck Short ]
   * New upstream release.
-  * swift-object-reconstructor init script is correctly installed now.
-  * Fixed service name of object-expirer.
-  * Added container-sync init script.
-  * All init scripts is using swift-init.
-  * Added myself as uploader.
 
-  [ Thomas Goirand ]
-  * Adds patch-requirements.txt-to-allow-pyeclib-versions.patch.
+  [ James Page ]
+  * Add object-expirer package and associated configuration (LP: #1235495):
+    - d/control: Add swift-object-expirer package, break/replace swift-object
+      from earlier versions.
+    - d/swift-object.install: Drop install of swift-object-expirer.
+    - d/swift-object-expirer.{install,upstart}: Install swift-object-expirer
+      and associated upstart configuration.
+    - d/rules,object-expirer.conf: Provide basic object-expirer configuration.
+    - debian/swift-object-expirer.docs: Add full example configuration to docs.
+  * d/rules,swift-container.swift-container-sync.upstart: Add upstart
+    configuration for swift-container-sync process (LP: #1250171).
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 14 Sep 2015 13:21:00 +0000
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 06 Mar 2014 12:29:10 -0500
 
-swift (2.3.0-1) unstable; urgency=medium
+swift (1.12.0-0ubuntu1) trusty; urgency=medium
 
   * New upstream release.
-  * Added python-pyeclib as (build-)depends, bumped eventlet required version
-    to 0.16.1, and removed a few versions already provided by Jessie.
-  * Standards-Version is now 3.9.6.
-  * Removed applied upstream patch:
-    - CVE-2015-1856_Prevent-unauthorized-delete-in-versioned-container.patch
-  * Added usr/bin/swift-object-reconstructor to swift-object.
-  * Added startup scripts for swift-container-reconciler and
-    swift-object-reconstructor. Thanks to <ondrej.novy@firma.seznam.cz> for the
-    bug report and patch (Closes: #788450).
+  * debian/patches/fix-ubuntu-tests.patch: Rediffed.
+  * debian/rules: Add pythonpath for tests.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 04 Jun 2015 09:49:04 +0200
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 29 Jan 2014 09:14:25 -0500
 
-swift (2.2.0-3) unstable; urgency=medium
+swift (1.11.0-0ubuntu2) trusty; urgency=low
 
-  * Fixed swift user creation (standardized on pkgos way).
+  * d/tests/swift-daemons: Use service command to restart daemons instead
+    of directly using non-existent scripts in /etc/init.d.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 30 Jun 2015 17:03:05 +0200
+ -- James Page <james.page@ubuntu.com>  Fri, 13 Dec 2013 09:14:19 +0000
 
-swift (2.2.0-2) unstable; urgency=high
+swift (1.11.0-0ubuntu1) trusty; urgency=low
 
-  * CVE-2015-1856 & OSSA 2015-006: Unauthorized delete of versioned Swift
-    object. Applied upstream patch: Prevent unauthorized delete in versioned
-    container (Closes: #783163).
+  [ Chuck Short ]
+  * debian/control: open icehouse release.
+  * debian/rules:
+    - Fix doc installation.
+    - Removed debian distribution checking.
+  * Removed init scripts, they dont get installed anyways.
+  * Renamed upstart.in to regular upstart jobs.
+  * debian/swift-doc.docs: Drop doc/build/html.
+  * debian/swift.install: Remove swift-bench and swift-bench-client, it has
+    moved into its own project.
+  * debian/control: Suggest swift-bench.
+  * debian/fix-ubuntu-tests.patch: Disable tests that fail on buildds.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 23 Apr 2015 09:42:47 +0200
+  [ James Page ]
+  * d/rules: Don't clean debian/*.upstart; we need those now! 
 
-swift (2.2.0-1) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 12 Dec 2013 10:50:46 -0500
 
-  * New upstream release.
-  * Removed the no intersphinx patch.
+swift (1.10.0-0ubuntu1) saucy; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 16 Oct 2014 12:44:38 +0000
+  * New upstream release (LP: #1236462).
 
-swift (2.2.0~rc1-1) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 17 Oct 2013 10:26:18 -0400
 
-  * New upstream release.
+swift (1.10.0~rc1-0ubuntu1) saucy; urgency=low
+
+  * New upstream release candidate.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 09 Oct 2013 15:05:24 -0400
+
+swift (1.9.1-0ubuntu3) saucy; urgency=low
+
+  * d/python-swift.postinst: Allow swift user to write to /var/cache/swift,
+    resolving repeated errors in swift syslog (LP: #1234657).
+
+ -- James Page <james.page@ubuntu.com>  Fri, 04 Oct 2013 16:21:14 +0100
+
+swift (1.9.1-0ubuntu2) saucy; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 08 Oct 2014 22:29:36 +0800
+  * d/control: Add missing dependency on python-dnspython >= 1.10.0.
+  * d/control: Wrap and sort.
 
-swift (2.1.0-1) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Wed, 25 Sep 2013 16:08:35 +0100
 
+swift (1.9.1-0ubuntu1) saucy; urgency=low
+
+  [ James Page ]
+  * d/control: Update VCS fields for new branch locations.
+
+  [ Chuck Short ]
   * New upstream release.
-  * Removed CVE-2014-3497_properly_quote_www-authenticate_header_value.patch
-    applied upstream.
-  * Added new command lines into packages:
-    - usr/bin/swift-container-info
-    - usr/bin/swift-container-reconciler
-    - usr/bin/swift-reconciler-enqueue
-    - usr/bin/swift-account-info
-  * Added new package (+init script): swift-account-expirer (Closes: #760363).
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 01 Jul 2014 19:31:22 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 13 Aug 2013 10:37:13 -0400
 
-swift (1.13.1-1) unstable; urgency=high
+swift (1.9.0-0ubuntu1) saucy; urgency=low
 
+  [ Chuck Short ]
   * New upstream release.
-  * CVE-2014-3497: XSS in Swift requests through WWW-Authenticate header.
-    Appilied upstream patch properly_quote_www-authenticate_header_value.patch
-    (Closes: #752087).
+  * debian/swift.install: Add swift-config.
+  * debian/control: Nump standards version to 3.9.4
+ 
+  [ Yolanda Robla ]
+  * debian/tests: added autopkg tests
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 12 Apr 2014 11:19:56 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 02 Jul 2013 10:26:07 -0500
 
-swift (1.12.0-1) unstable; urgency=medium
+swift (1.8.0-0ubuntu1) raring; urgency=low
 
-  * New upstream release (Closes: #737638).
-  * Added new (build-)dependency: python-dnspython.
-  * Removed CVE-2014-0006 patch, applied upstream.
-  * Added PYTHONPATH=. when running unit tests.
+  * New upstream release. 
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 04 Feb 2014 23:21:54 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 04 Apr 2013 10:38:18 -0500
 
-swift (1.11.0-2) unstable; urgency=high
+swift (1.8.0~rc2-0ubuntu1) raring; urgency=low
 
-  * CVE-2014-0006: Use constant time comparison in tempURL. Applied upstream
-    patch (Closes: #735582).
-  * Fix sphinx doc building.
+  * New usptream release candidate for grizzly.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 17 Jan 2014 00:31:56 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 02 Apr 2013 09:06:48 -0500
 
-swift (1.11.0-1) unstable; urgency=medium
+swift (1.8.0~rc1-0ubuntu1) raring; urgency=low
 
-  * New upstream relase.
-  * Removed swift-bench things, since that's gone from upstream project (it's
-    moved as a separate project at https://github.com/openstack/swift-bench).
+  * New upstream release candidate for grizzly. 
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 13 Dec 2013 17:21:20 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 20 Mar 2013 08:19:17 -0500
 
-swift (1.10.0-1) unstable; urgency=low
+swift (1.7.6-0ubuntu1) raring; urgency=low
 
-  * New upstream release.
-  * Uploading to unstable.
+  *  New upstream release.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 18 Oct 2013 01:08:31 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 28 Jan 2013 09:44:34 -0600
 
-swift (1.10.0~rc1-1) experimental; urgency=low
+swift (1.7.5-0ubuntu1) raring; urgency=low
 
   * New upstream release.
-  * Removed applied upstream patches.
+  * debian/control: Dropped python-webob.
+  * debian/swift.install: Add swift-bench-client.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 10 Oct 2013 11:59:08 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 14 Nov 2012 12:11:47 -0600
 
-swift (1.8.0-7) unstable; urgency=low
+swift (1.7.4-0ubuntu2) quantal; urgency=low
 
-  * Added "Account Quota Correction" patch.
+  * debian/control: Conflicts/Breaks on swift 1.6.0-ubuntu1 when upgrading 
+    from precise, since the swift client has been moved to python-swiftclient.
+    (LP: #1061064)
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 26 Sep 2013 16:03:31 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 11 Oct 2012 09:06:02 -0500
 
-swift (1.8.0-6) unstable; urgency=low
+swift (1.7.4-0ubuntu1) quantal; urgency=low
 
-  [ Thomas Goirand ]
-  * Renamed all init script with .init extension in the debian folder, so it is
-    more easy to list them with ls.
-  * Added upstart scripts.
-  * Added myself and Julien in debian/copyright for the packaging, plus
-    Canonical for the upstart jobs.
-  * Removes unwanted python-webob (build-)depends (Closes: #715452).
-  * CVE-2013-4155: DoS using superfluous object tombstones. Upstream patch
-    fixes handling of DELETE obj reqs with old timestamp (Closes: #719008).
+  * New upstream release. 
+  * debian/rules: Fail to build the packages if testsuite fails.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 26 Sep 2012 09:19:43 -0500
+
+swift (1.7.2-0ubuntu1) quantal; urgency=low
+
+  * New upstream release, this release fixes a major 
+    regression introduced in the last release.
 
-  [ Julien Cristau ]
-  * CVE-2013-2161: Check user input in XML responses (closes: #712202)
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 20 Sep 2012 08:42:59 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 28 Jun 2013 15:33:19 +0800
+swift (1.7.0-0ubuntu1) quantal; urgency=low
 
-swift (1.8.0-5) unstable; urgency=low
+  [ Soren Hansen ]
+  * Update debian/watch to account for symbolically named tarballs and
+    use newer URL.
+  * Run unit tests at build time.
+  * Fix Launchpad URLs in debian/watch.
 
-  * swift-account should be Breaks+Replaces: swift (<< 1.8.0-4~) to allow to
-    do backports.
-  * Added Fix-formpost-with-queries-without-user_agent.patch.
+  [ Chuck Short ]
+  * New upstream release
+  * debian/control: Add python-mock as a build dep
+  * debian/rules: Dont fail if testsuite fails.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 07 Sep 2012 19:02:36 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 17 Jun 2013 15:14:15 +0800
+swift (1.6.0-0ubuntu1) quantal; urgency=low
 
-swift (1.8.0-4) unstable; urgency=low
+  [ Adam Gandelman ]
+  * debian/patches/fix-ubuntu-unitteests.patch: Refreshed against tarball
+    generated by sdist.
+  * debian/control: Add python-swiftclient to Build-Depends.
+  * debian/swift.install: Remove swift CLI client, moved to
+    python-swiftclient.
+  * debian/patches/fix-ubuntu-unittests.patch: Dropped. Similar upstream
+    commit ensures logging exceptions are properly handled.
+  * debian/rules: *Temporarily* disable test suite.
 
-  * Corrects a mistake with the location of the account-server.conf, which
-    should have been in swift-account and not the swift package. As a
-    consequence, adds Breaks+Replaces: swift (<< 1.8.0-4) (Closes: #710916).
+  [ Chuck Short ]
+  * New upstream version.
+  * python-swift.dirs: Add /var/cache/swift
+  * debian/man/*: Removed used upstream man pages and replaced
+    with upstream manpages. (LP: #1006671)
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 04 Jun 2013 00:04:35 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 07 Aug 2012 09:31:35 -0500
 
-swift (1.8.0-3) unstable; urgency=low
+swift (1.5.0-0ubuntu1) quantal; urgency=low
 
-  * Ran wrap-and-sort.
-  * Installs a default configuration file for swift-dispersion-report
-    (Closes: #668775), thanks to Loic Dachary <loic@dachary.org> for reporting.
-  * Now using upstream manpages when available.
-  * Now using upstream configuration files as default in /etc/swift
-    (Closes: #661811)
+  * New upstream version
+  * debian/patches/fix-ubuntu-unittests.patch: Refreshed
+  * debian/patches/fix-doc-no-network.patch: Refreshed
+  * swift.docs: Add changelog
+  * swift.install: Remove missing binaries.
+  * debian/control: Bump to version 3.9.3
+  * debian/swift.install: Add swift-temp-url and swift-form-signature.
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 01 Jun 2013 19:55:10 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 18 Jun 2012 09:30:05 -0400
 
-swift (1.8.0-2) unstable; urgency=low
+swift (1.4.8-0ubuntu2) precise; urgency=low
 
-  * Upload to unstable.
-  * Updates the Allow-all-headers-requested-for-CORS.patch.
+  * debian/patches/fix-ubuntu-unittests.patch: Refreshed
+    to fix testsuite failures.
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 15 May 2013 22:32:52 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 12 Apr 2012 12:05:29 -0400
 
-swift (1.8.0-1) experimental; urgency=low
+swift (1.4.8-0ubuntu1) precise; urgency=low
 
   * New upstream release.
+  * debian/patches/fix-ubuntu-unittests.patch: Refreshed.
+  * debian/patches/fix-doc-no-network.patch: Dont access network when
+    trying to build docs.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 10 Apr 2012 09:23:54 -0400
+
+swift (1.4.7-0ubuntu3) precise; urgency=low
+
+  * debian/rules: Make the build fail if the testsuite doesnt pass.
+  * debian/patches/fix-ubuntu-unittests.patch: Various fixes to build
+    swift in the buildds. (LP: #961871)
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 26 Mar 2012 12:11:25 -0400
+
+swift (1.4.7-0ubuntu2) precise; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 03 Apr 2013 20:30:31 +0800
+  * Fixup upstart configurations (LP: #954477):
+    - d/rules: Correctly generate ALL upstart configurations when
+      building for Ubuntu.
+    - d/*.upstart.in: Update upstart config's to use new conf file locations.
 
-swift (1.7.5-3) experimental; urgency=low
+ -- James Page <james.page@ubuntu.com>  Thu, 15 Mar 2012 15:34:19 +0000
 
+swift (1.4.7-0ubuntu1) precise; urgency=low
+
+  [ Chuck Short ]
   * New upstream release.
-  * Fixed typoe dependency to python-swiftclient (and not python-swift-client).
-  * Removed patches now applied upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 03 Apr 2013 20:31:31 +0800
+  [ Thierry Carrez (ttx) ]
+  * Remove swift-stats-populate, swift-stats-report and stats.conf-sample to
+    match Swift 1.4.7 contents
 
-swift (1.7.5-2) experimental; urgency=low
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 09 Mar 2012 13:26:07 -0500
 
-  * Added missing python-swiftclient dependency in swift-account. Thanks to
-    Viktor Křivák for reporting (Closes: #703623).
-  * Adds adds Add-handler-for-CORS-actual-requests.patch.
+swift (1.4.7~20120302.1721-0ubuntu1) precise; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 22 Mar 2013 01:01:47 +0800
+  * New upstream release.
 
-swift (1.7.5-1) experimental; urgency=low
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 02 Mar 2012 13:27:27 -0500
 
-  [ Mehdi Abaakouk ]
-  * New upstream release
-  * Fixed -x switch issue in swift-bench
+swift (1.4.7~20120224.1690-0ubuntu1) precise; urgency=low
 
-  [ Thomas Goirand ]
-  * Fixed wrong format URL in debian/copyright.
-  * Added missing AUTHORS file in all packages.
-  * Removed useless X-Python-Version: >= 2.6 in control, since we already
-  Build-Depends: on python-all (>=2.6.6-3~).
-  * Removed \r from debian/copyright.
-  * Added missing Provides: ${python:Provides}, uses same short desc as in
-  Ubuntu, Break with versions << 1.6 (because of the python-swiftclient
-  package).
-  * Imported Ubuntu patch to stop accessing network when building docs.
-  * Fixes a log_daemon_msg typo present in most swift init scripts.
-  * Removes useless "swift is open source software" from long description.
+  [ Chuck Short ]
+  * New upstream release.
+
+  [ Chmouel Boudjnah ]
+  * Add more samples to packages (LP:#667935)
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 24 Feb 2012 09:10:12 -0500
 
-  [ Julien Danjou ]
-  * Add /var/cache/swift to use swift-recon
-  * Add configuration and cron job for swift-recon
-  * Move swift-recon-cron to swift-object
+swift (1.4.7~20120210.1686-0ubuntu1) precise; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 17 Dec 2012 15:34:54 +0000
+  * New upstream release.
+  * debian/control: Add python-paste.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 10 Feb 2012 09:41:51 -0500
+
+swift (1.4.6~20120202.1676-0ubuntu1) precise; urgency=low
+
+  * New upstream version.
 
-swift (1.4.8-2) unstable; urgency=high
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 03 Feb 2012 09:35:18 -0500
 
-  * CVE-2012-4406: Do not use pickle for serialization in memcache, but JSON
-  (Closes: #686812).
+swift (1.4.6~20120119.1666-0ubuntu2) precise; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 06 Sep 2012 08:40:18 +0000
+  * Update swift.install to reflect release.
 
-swift (1.4.8-1) unstable; urgency=low
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 26 Jan 2012 09:05:51 -0500
 
+swift (1.4.6~20120119.1666-0ubuntu1) precise; urgency=low
+
+  [Chuck Short]
   * New upstream release.
 
- -- Ghe Rivero <ghe.rivero@stackops.com>  Fri, 23 Mar 2012 08:09:54 +0100
+  [ Daniel T Chen ]
+  * debian/control: Fix Vcs entries.
+  * debian/swift.install: Add new scripts. Fixes FTBFS.
 
-swift (1.4.6-1) unstable; urgency=low
+  [ Marc Cluet ]
+  * Changed swift-proxy upstart script to watch /etc/swift/proxy-server.conf
+    (LP:#917893)
 
-  * New upstream release
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 20 Jan 2012 13:20:46 -0500
+
+swift (1.4.6~20120112.1660-0ubuntu1) precise; urgency=low
+
+  [Chuck Short]
+  * New upstream release.
+  * Merged changes from upstream packaging, thanks to Thierry Carrez.
+  * debian/rules:
+    + Remove egg-info on clean.
+
+  [Thierry Carrez (ttx)]
+  * Added usr/bin/swift-recon[-cron] to swift package.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 09 Jan 2012 11:26:25 -0500
+
+swift (1.4.5~20111202.1634-0ubuntu3) precise; urgency=low
+
+  * debian/swift.manpages: Remove swauth man pages.
+
+ -- Matthias Klose <doko@ubuntu.com>  Wed, 21 Dec 2011 18:29:35 +0100
+
+swift (1.4.5~20111202.1634-0ubuntu2) precise; urgency=low
 
- -- Ghe Rivero <ghe.rivero@stackops.com>  Mon, 13 Feb 2012 11:28:38 +0100
+  [ Chuck Short ]
+  * Drop swauth man pages. (LP: #900888)
+  * debian/control:
+    - Clean up build depends.
+    - Update VCS info to point to the right branches.
+  * debian/rules: Run the swift testsuite.
+  * debian/python-swift.postinst: Change user's shell to /bin/false.
+  * Fix some lintian warnings.
 
-swift (1.4.5-1) unstable; urgency=low
+  [ Thierry Carrez (ttx) ]
+  * Ship swift-oldies and swift-orphans in swift package
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 16 Dec 2011 09:45:28 -0500
+
+swift (1.4.5~20111202.1634-0ubuntu1) precise; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 02 Dec 2011 09:49:32 -0500
+
+swift (1.4.5~20111117.1632-0ubuntu1) precise; urgency=low
 
   * New upstream release.
+  * Convert init scripts to upstart.
 
- -- Ghe Rivero <ghe@debian.org>  Mon, 09 Jan 2012 16:18:17 +0100
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 18 Nov 2011 13:25:16 -0500
 
-swift (1.4.4+git145-g89ef1f4-1) experimental; urgency=low
+swift (1.4.4~20111108.1612-0ubuntu1) precise; urgency=low
+
+  * New upstream release.
+  * debian/rules: Add --fail-missing.
+  * Update .isntall files. (LP: #882679, #841853)
 
-  * New snapshot release.
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 11 Nov 2011 10:49:12 -0500
 
- -- Ghe Rivero <ghe@debian.org>  Wed, 04 Jan 2012 09:56:14 +0100
+swift (1.4.4~20111014.1599-0ubuntu1) precise; urgency=low
 
-swift (1.4.4+git135-g913cfcf-1) experimental; urgency=low
+  * New upstream verison.
+  * Dropped:
+    - debian/patches/backport-change-swift-ring-builder-exit-codes.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 21 Oct 2011 13:50:47 -0400
+
+swift (1.4.3-0ubuntu2) oneiric; urgency=low
+
+  [ Adam Gandelman ]
+  * debian/patches/backport-change-swift-ring-builder-exit-codes: Standardize
+    exit codes now to reduce hassles after future upgrades (LP: #836922)
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 30 Sep 2011 15:00:26 -0400
+
+swift (1.4.3-0ubuntu1) oneiric; urgency=low
+
+  [Chuck Short]
+  * New upstream release.
 
-  * New snapshot release.
+  [Monty Taylor]
+  * Work around dh_python2 for lucid. (LP: #848971)
 
- -- Ghe Rivero <ghe@debian.org>  Wed, 28 Dec 2011 08:35:37 +0100
+ -- Monty Taylor <mordred@inaugust.com>  Fri, 16 Sep 2011 15:40:19 -0400
 
-swift (1.4.4-2) unstable; urgency=low
+swift (1.4.3~20110902.354-0ubuntu1) oneiric; urgency=low
 
-  * Do not install test (Closes: #649908)
+  * New upstream release.
 
- -- Julien Danjou <acid@debian.org>  Mon, 19 Dec 2011 14:02:51 +0100
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 02 Sep 2011 14:10:27 -0400
 
-swift (1.4.4-1) unstable; urgency=low
+swift (1.4.3~20110823.347-0ubuntu1) oneiric; urgency=low
 
   * New upstream release.
-  * Remove useless provides in control.
 
- -- Julien Danjou <acid@debian.org>  Thu, 24 Nov 2011 17:17:46 +0100
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 26 Aug 2011 14:11:09 -0400
+
+swift (1.4.3~20110811.341-0ubuntu1) oneiric; urgency=low
 
-swift (1.4.3-1) unstable; urgency=low
+  * New upstream release.
 
-  * [984c1f2] Imported Upstream version 1.4.3
-     - Closes: #629998  no more st binary
-  * Some package cleanup and sync with ubuntu pkg
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 12 Aug 2011 05:33:16 -0400
 
- -- Ghe Rivero <ghe@debian.org>  Tue, 08 Nov 2011 08:25:40 +0100
+swift (1.4.3~20110728.333-0ubuntu1) UNRELEASED; urgency=low
 
-swift (1.3.0-1) unstable; urgency=low
+  [ Soren Hansen ]
+  * New upstream snapshot.
+  * Remove debian-changes patch file.
+  * Remove SOURCES.txt in clean target to avoid gettings its changes in
+    our diff.gz.
+  * Add "status" support to all init scripts.
+  * Use "shutdown" instead of "stop" as the action argument for swift-
+    init. This shuts down the services gracefully (letting live requests
+    finish).
+  * Add swift-dispersion-{report,populate} to swift.install.
 
+  [ Thomas Goirand ]
   * Added missing adduser and lsb-base dependency.
   * Made the long description longer (it was really minimalistic).
   * Reworked all Debian init.d scripts.
   * Added many missing manpages.
   * Added default container-server.conf & object-server.conf files.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 10 May 2011 09:24:33 +0000
+  [ James Page ]
+  * Added debian/python-swift.postrm:  Remove swift user when purging
+    package (LP: #825670).
+
+ -- James Page <james.page@ubuntu.com>  Tue, 16 Aug 2011 10:33:00 +0100
+
+swift (1.4.2-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release.
+  * debian/control:
+    - Update vcs infomration.
+    - Cleaned up build dependencies.
+    - Bump standards to version 3.9.2.
+  * debian/README.Source: Add doc to upload swift to the ubuntu archive.
+  * dh_python2 transition.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 28 Jul 2011 10:39:51 -0400
+
+swift (1.4.2~20110624.319-0ubuntu3) oneiric; urgency=low
+
+  * Clean up missing files.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 27 Jun 2011 06:30:51 -0400
+
+swift (1.4.2~20110624.319-0ubuntu2) oneiric; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 24 Jun 2011 14:00:18 -0400
+
+swift (1.4.1-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 20 Jun 2011 13:08:04 -0400
+
+swift (1.4.1~20110615.r304-0ubuntu1) oneiric; urgency=low
+
+  [ Gregory Holt ]
+  * Removed swauth references.
+
+  [ Soren Hansen ]
+  * st was renamed to swift.
+
+  [ Chuck Short ]
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 16 Jun 2011 09:25:37 -0400
+
+swift (1.4-dev+bzr300-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 31 May 2011 14:29:10 -0400
 
 swift (1.3.0-0ubuntu1) natty; urgency=low
 
diff -pruN 2.25.0-2/debian/clean 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/clean
--- 2.25.0-2/debian/clean	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/clean	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-debian/*.upstart
-debian/*.init
-debian/*.service
-debian/python3-swift.postinst
diff -pruN 2.25.0-2/debian/container-server.conf 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/container-server.conf
--- 2.25.0-2/debian/container-server.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/container-server.conf	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,18 @@
+[DEFAULT]
+bind_ip = 0.0.0.0
+bind_port = 6001
+workers = 2
+
+[pipeline:main]
+pipeline = container-server
+
+[app:container-server]
+use = egg:swift#container
+
+[container-replicator]
+
+[container-updater]
+
+[container-auditor]
+
+[container-sync]
diff -pruN 2.25.0-2/debian/control 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/control
--- 2.25.0-2/debian/control	2020-06-12 12:15:26.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/control	2020-07-06 17:04:33.000000000 +0000
@@ -1,90 +1,109 @@
 Source: swift
 Section: net
 Priority: optional
-Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Soren Hansen <soren@ubuntu.com>
 Uploaders:
+ Monty Taylor <mordred@inaugust.com>,
+ Greg Holt <gholt@rackspace.com>,
+ Jay Payne <letterj@racklabs.com>,
+ Michael Barton <michael.barton@rackspace.com>,
  Thomas Goirand <zigo@debian.org>,
- Michal Arbet <michal.arbet@ultimum.io>,
- Ondřej Nový <onovy@debian.org>,
+ David Della Vecchia <ddv@canonical.com>,
 Build-Depends:
  debhelper-compat (= 12),
- dh-exec,
  dh-python,
- openstack-pkg-tools (>= 99~),
+ openstack-pkg-tools,
  python3-all,
  python3-pbr,
  python3-setuptools,
- python3-sphinx (>= 1.6.2),
+ python3-sphinx (>= 2.0.0),
 Build-Depends-Indep:
- python3-boto,
- python3-boto3,
- python3-coverage,
- python3-cryptography,
- python3-dnspython,
+ libjerasure2,
+ python3-bandit (>= 1.1.0),
+ python3-boto (>= 2.32.1),
+ python3-boto3 (>= 1.9),
+ python3-botocore (>= 1.12),
+ python3-cffi,
+ python3-coverage (>= 3.6),
+ python3-cryptography (>= 2.0.2),
+ python3-dnspython (>= 1.15.0),
+ python3-docutils (>= 0.11),
  python3-eventlet (>= 0.25.0),
  python3-fixtures (>= 3.0.0),
- python3-greenlet,
- python3-keystoneclient,
+ python3-greenlet (>= 0.4.10),
+ python3-hacking (>= 0.11.0),
+ python3-keystoneclient (>= 1:2.0.0),
  python3-keystonemiddleware (>= 4.17.0),
- python3-lxml,
- python3-mock,
- python3-netifaces,
- python3-nose,
- python3-nose-exclude,
- python3-nosehtmloutput,
- python3-nosexcover,
- python3-openssl,
- python3-openstack.nose-plugin,
- python3-openstackclient,
- python3-openstackdocstheme (>= 1.11.0),
+ python3-lxml (>= 3.4.1),
+ python3-mock (>= 2.0),
+ python3-netifaces (>= 0.8),
+ python3-nose (>= 1.3.7),
+ python3-nosehtmloutput (>= 0.0.3),
+ python3-nosexcover (>= 1.0.10),
+ python3-openstackclient (>= 3.12.0),
+ python3-openstackdocstheme (>= 2.2.1),
  python3-os-api-ref (>= 1.0.0),
  python3-os-testr (>= 0.8.0),
- python3-oslosphinx,
- python3-pastedeploy,
- python3-pyeclib,
+ python3-pastedeploy (>= 1.3.3),
+ python3-pyeclib (>= 1.3.1),
  python3-requests (>= 2.14.2),
  python3-requests-mock (>= 1.2.0),
- python3-six,
- python3-swiftclient,
- python3-xattr,
+ python3-six (>= 1.10.0),
+ python3-sphinxcontrib.svg2pdfconverter (>= 0.1.0),
+ python3-swiftclient (>= 1:3.2.0),
+ python3-testtools,
+ python3-xattr (>= 0.4),
 Standards-Version: 4.5.0
-Vcs-Browser: https://salsa.debian.org/openstack-team/services/swift
-Vcs-Git: https://salsa.debian.org/openstack-team/services/swift.git
-Homepage: https://github.com/openstack/swift
+Homepage: https://launchpad.net/swift
+Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/swift
+Vcs-Git: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/swift
 Testsuite: autopkgtest-pkg-python
-Rules-Requires-Root: no
 
 Package: python3-swift
 Architecture: all
 Section: python
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
  adduser,
- python3-cryptography,
- python3-dnspython,
+ libjerasure2,
+ python3-cryptography (>= 2.0.2),
+ python3-dnspython (>= 1.15.0),
  python3-eventlet (>= 0.25.0),
- python3-greenlet,
- python3-netifaces,
- python3-openssl,
- python3-pastedeploy,
- python3-pyeclib,
- python3-six,
- python3-xattr,
+ python3-greenlet (>= 0.4.10),
+ python3-keystonemiddleware (>= 4.17.0),
+ python3-lxml (>= 3.4.1),
+ python3-netifaces (>= 0.8),
+ python3-pastedeploy (>= 1.3.3),
+ python3-pyeclib (>= 1.3.1),
+ python3-requests (>= 2.14.2),
+ python3-six (>= 1.10.0),
+ python3-xattr (>= 0.4),
  ${misc:Depends},
  ${python3:Depends},
+Provides:
+ ${python3:Provides},
 Breaks:
- systemd (<< 235~),
+ python-swift (<< 2.22.0~b1~git2019071110.e62f07d98-0ubuntu1~),
+ swift-account (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-container (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-object (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-object-expirer (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+Replaces:
+ python-swift (<< 2.22.0~b1~git2019071110.e62f07d98-0ubuntu1~),
+ swift-account (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-container (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-object (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-object-expirer (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
 Description: distributed virtual object store - Python 3 libraries
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -100,24 +119,25 @@ Description: distributed virtual object
 
 Package: swift
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- logrotate,
  python3-swift (=${binary:Version}),
- rsyslog,
  ${misc:Depends},
  ${python3:Depends},
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
+Suggests:
+ swift-bench,
 Description: distributed virtual object store - common files
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -132,27 +152,28 @@ Description: distributed virtual object
 
 Package: swift-account
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base,
  python3-swift (=${binary:Version}),
  rsync,
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- swift-drive-audit,
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
+Breaks:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
+Replaces:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
 Description: distributed virtual object store - account server
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -167,27 +188,28 @@ Description: distributed virtual object
 
 Package: swift-container
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base,
  python3-swift (=${binary:Version}),
  rsync,
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- swift-drive-audit,
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
+Breaks:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
+Replaces:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
 Description: distributed virtual object store - container server
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -203,25 +225,20 @@ Description: distributed virtual object
 Package: swift-doc
 Architecture: all
 Section: doc
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- libjs-bootstrap,
  libjs-jquery,
- libjs-underscore,
- python-os-api-ref-common,
  ${misc:Depends},
  ${sphinxdoc:Depends},
 Description: distributed virtual object store - documentation
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -234,60 +251,30 @@ Description: distributed virtual object
  .
  This package provides the Sphinx generated documentation for Swift.
 
-Package: swift-drive-audit
-Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
-Depends:
- python3-swift (=${binary:Version}),
- swift (=${binary:Version}),
- ${misc:Depends},
- ${python3:Depends},
-Description: distributed virtual object store - drive audit
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
- .
- Objects are written to multiple hardware devices in the data center, with
- the OpenStack software responsible for ensuring data replication and
- integrity across the cluster. Storage clusters can scale horizontally by
- adding new nodes. Should a node fail, OpenStack works to replicate its
- content from other active nodes. Because OpenStack uses software logic to
- ensure data replication and distribution across different devices,
- inexpensive commodity hard drives and servers can be used in lieu of more
- expensive equipment.
- .
- This package provides the swift drive audit tool.
-
 Package: swift-object
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base,
  python3-swift (=${binary:Version}),
  rsync,
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- swift-drive-audit,
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
+Breaks:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
+Replaces:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
 Description: distributed virtual object store - object server
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -302,25 +289,29 @@ Description: distributed virtual object
 
 Package: swift-object-expirer
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base (>= 3.0-6),
  python3-swift (=${binary:Version}),
- rsync,
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Description: distributed virtual object store - object-expirer
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
+Breaks:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
+ swift-object (<< 1.12.0-0ubuntu2),
+Replaces:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
+ swift-object (<< 1.12.0-0ubuntu2),
+Description: distributed virtual object store - object expirer
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -331,34 +322,32 @@ Description: distributed virtual object
  inexpensive commodity hard drives and servers can be used in lieu of more
  expensive equipment.
  .
- This package provides the swift object expirer daemon. Only a single instance
- of this daemon is needed for a given swift cluster, which is why it is
- packaged separately.
+ This package provides the object-expirer service that provides scheduled
+ deletion of objects in Swift.
 
 Package: swift-proxy
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base,
  python3-swift (=${binary:Version}),
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- python3-barbicanclient,
- python3-castellan,
- python3-keystonemiddleware,
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
+Breaks:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
+Replaces:
+ swift (<< 1.13.1~rc1-0ubuntu1~),
 Description: distributed virtual object store - proxy server
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
diff -pruN 2.25.0-2/debian/copyright 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/copyright
--- 2.25.0-2/debian/copyright	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/copyright	2020-07-06 17:04:33.000000000 +0000
@@ -1,72 +1,9 @@
-Format: https://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+Format: http://dep.debian.net/deps/dep5
 Upstream-Name: swift
 Source: https://code.launchpad.net/swift
 
 Files: *
-Copyright: (c) 2010-2017, See AUTHORS file
-           (c) 2013 Hewlett-Packard Development Company, L.P.
-           (c) 2010-2017 OpenStack Foundation
-License: Apache-2
-
-Files: debian/*
-Copyright: (c) 2010-2017, Thomas Goirand <zigo@debian.org>
-           (c) 2010-2012, Julien Danjou <acid@debian.org>
-           (c) 2015-2019, Ondřej Nový <onovy@debian.org>
-           (c) 2016, Marek Kaleta <marek.kaleta@firma.seznam.cz>
-           (c) 2019, Michal Arbet <michal.arbet@ultimum.io>
-License: Apache-2
-
-Files: swift/common/middleware/tempurl.py
-Copyright: (c) 2011-2014 Greg Holt
-           (c) 2012-2013 John Dickinson
-           (c) 2012 Felipe Reyes
-           (c) 2012 Peter Portante
-           (c) 2012 Victor Rodionov
-           (c) 2013-2014 Samuel Merritt
-           (c) 2013 Chuck Thier
-           (c) 2013 David Goetz
-           (c) 2013 Dirk Mueller
-           (c) 2013 Donagh McCabe
-           (c) 2013 Fabien Boucher
-           (c) 2013 Greg Lange
-           (c) 2013 Kun Huang
-           (c) 2013 Richard Hawkins
-           (c) 2013 Tong Li
-           (c) 2013 ZhiQiang Fan
-License: Apache-2
-
-Files: test/unit/common/middleware/test_tempurl.py
-Copyright: (c) 2011-2014 Greg Holt
-           (c) 2012-2013 Peter Portante
-           (c) 2012 Iryoung Jeong
-           (c) 2012 Michael Barton
-           (c) 2013 Alex Gaynor
-           (c) 2013 Chuck Thier
-           (c) 2013 David Goetz
-           (c) 2015 Donagh McCabe
-           (c) 2013 Greg Lange
-           (c) 2013 John Dickinson
-           (c) 2013 Kun Huang
-           (c) 2013 Richard Hawkins
-           (c) 2013 Samuel Merritt
-           (c) 2013 Shri Javadekar
-           (c) 2013 Tong Li
-           (c) 2013 ZhiQiang Fan
-License: Apache-2
-
-Files: bin/swift-ring-builder
-       bin/swift-recon
-       test/unit/cli/test_ringbuilder.py
-       test/unit/cli/test_recon.py
-Copyright: (c) 2013-2014 Christian Schwede <christian.schwede@enovance.com>
-License: Apache-2
-
-Files: bin/swift-ring-builder-analyzer
-       test/unit/cli/test_ring_builder_analyzer.py
-       test/unit/cli/test_form_signature.py
-Copyright: (c) 2014-2015 Samuel Merritt <sam@swiftstack.com>
-License: Apache-2
-
+Copyright: 2010 OpenStack, LLC.
 License: Apache-2
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
diff -pruN 2.25.0-2/debian/gbp.conf 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/gbp.conf
--- 2.25.0-2/debian/gbp.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/gbp.conf	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,7 @@
+[DEFAULT]
+debian-branch = master
+upstream-tag = %(version)s
+pristine-tar = True
+
+[buildpackage]
+export-dir = ../build-area
diff -pruN 2.25.0-2/debian/gen-init 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/gen-init
--- 2.25.0-2/debian/gen-init	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/gen-init	2020-07-06 17:04:33.000000000 +0000
@@ -46,7 +46,6 @@ $AFTER
 [Service]
 User=${SYSTEM_USER}
 Group=${SYSTEM_GROUP}
-WorkingDirectory=~
 CacheDirectory=${PROJECT_NAME}
 RuntimeDirectory=${PROJECT_NAME} lock/${PROJECT_NAME}
 ExecStart=/usr/bin/${NAME} /etc/${PROJECT_NAME}/${CONFIG}.conf
diff -pruN 2.25.0-2/debian/object-expirer.conf 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/object-expirer.conf
--- 2.25.0-2/debian/object-expirer.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/object-expirer.conf	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,18 @@
+[DEFAULT]
+
+[object-expirer]
+interval = 300
+
+[pipeline:main]
+pipeline = catch_errors cache proxy-server
+
+[app:proxy-server]
+use = egg:swift#proxy
+
+[filter:cache]
+use = egg:swift#memcache
+
+[filter:catch_errors]
+use = egg:swift#catch_errors
+
+# See object-expirer.conf-sample for options
diff -pruN 2.25.0-2/debian/object-server.conf 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/object-server.conf
--- 2.25.0-2/debian/object-server.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/object-server.conf	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,16 @@
+[DEFAULT]
+bind_ip = 0.0.0.0
+bind_port = 6000
+workers = 2
+
+[pipeline:main]
+pipeline = object-server
+
+[app:object-server]
+use = egg:swift#object
+
+[object-replicator]
+
+[object-updater]
+
+[object-auditor]
diff -pruN 2.25.0-2/debian/patches/disable_sphinxcontrib_rsvgconverter.patch 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/disable_sphinxcontrib_rsvgconverter.patch
--- 2.25.0-2/debian/patches/disable_sphinxcontrib_rsvgconverter.patch	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/disable_sphinxcontrib_rsvgconverter.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-Description: Disable sphinxcontrib.rsvgconverter extension
-Author: Ondřej Nový <novy@ondrej.org>
-Forwarded: not-needed
-Last-Update: 2020-02-12
-
---- a/doc/source/conf.py
-+++ b/doc/source/conf.py
-@@ -55,8 +55,7 @@
-               'sphinx.ext.todo',
-               'sphinx.ext.coverage',
-               'sphinx.ext.ifconfig',
--              'openstackdocstheme',
--              'sphinxcontrib.rsvgconverter']
-+              'openstackdocstheme']
- todo_include_todos = True
- 
- # Add any paths that contain templates here, relative to this directory.
diff -pruN 2.25.0-2/debian/patches/fix-deployment-guide-header.patch 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/fix-deployment-guide-header.patch
--- 2.25.0-2/debian/patches/fix-deployment-guide-header.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/fix-deployment-guide-header.patch	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,32 @@
+Description: Extend headers to prevent the following sphinx error:
+  sphinx.errors.SphinxWarning: /<<PKGBUILDDIR>>/doc/source/deployment_guide.rst:815: ERROR: Malformed table.
+  Column span alignment problem in table line 13.
+  This is required when building swift with the older version of python-docutils
+  that the Xenial-Pike cloud-archive picks up.
+Author: Corey Bryant <corey.bryant@canonical.com>
+Forwarded: no
+Last-Updated: 2017-08-25
+
+--- a/doc/source/deployment_guide.rst
++++ b/doc/source/deployment_guide.rst
+@@ -800,9 +800,9 @@ ionice_priority              None
+ [object-reconstructor]
+ **********************
+ 
+-===========================  ========================  ================================
++===========================  ========================  ======================================
+ Option                       Default                   Description
+----------------------------  ------------------------  --------------------------------
++---------------------------  ------------------------  --------------------------------------
+ log_name                     object-reconstructor      Label used when logging
+ log_facility                 LOG_LOCAL0                Syslog log facility
+ log_level                    INFO                      Logging level
+@@ -885,7 +885,7 @@ ionice_priority              None
+                                                        Work only with ionice_class.
+                                                        Ignored if IOPRIO_CLASS_IDLE
+                                                        is set.
+-===========================  ========================  ================================
++===========================  ========================  ======================================
+ 
+ ****************
+ [object-updater]
diff -pruN 2.25.0-2/debian/patches/series 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/series
--- 2.25.0-2/debian/patches/series	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/series	2020-07-06 17:04:33.000000000 +0000
@@ -1,2 +1,3 @@
-syslog_log_name.patch
-disable_sphinxcontrib_rsvgconverter.patch
+skip-test-local-py36.patch
+fix-deployment-guide-header.patch
+skip-online-test.patch
diff -pruN 2.25.0-2/debian/patches/skip-online-test.patch 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/skip-online-test.patch
--- 2.25.0-2/debian/patches/skip-online-test.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/skip-online-test.patch	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,25 @@
+Description: Skip test that is erroring with "gaierror:
+  [Errno -2] Name or service not known" as LP builds don't
+  have network access.
+Author: Corey Bryant <corey.bryant@canonical.com>
+Forwarded: no
+Last-Update: 2017-08-01
+
+--- a/test/unit/common/test_utils.py
++++ b/test/unit/common/test_utils.py
+@@ -47,6 +47,7 @@ from six.moves import range
+ from textwrap import dedent
+ 
+ import tempfile
++import testtools
+ import time
+ import unittest
+ import fcntl
+@@ -1530,6 +1531,7 @@ class TestUtils(unittest.TestCase):
+         self.assertEqual(sio.getvalue(),
+                          'test1\ntest3\ntest4\ntest6\n')
+ 
++    @testtools.skip("Skipped by Ubuntu")
+     def test_get_logger_sysloghandler_plumbing(self):
+         orig_sysloghandler = utils.ThreadSafeSysLogHandler
+         syslog_handler_args = []
diff -pruN 2.25.0-2/debian/patches/skip-test-local-py36.patch 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/skip-test-local-py36.patch
--- 2.25.0-2/debian/patches/skip-test-local-py36.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/skip-test-local-py36.patch	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,22 @@
+Description: Skip this test for Python 3 as it expects en_US.UTF-8
+  locale to be installed.
+Author: Corey Bryant <corey.bryant@canonical.com>
+Forwarded: not-needed
+
+--- a/test/unit/test_locale/test_locale.py
++++ b/test/unit/test_locale/test_locale.py
+@@ -17,11 +17,14 @@
+ import os
+ import unittest
+ import sys
++import testtools
+ 
+ from subprocess import check_output
+ 
+ 
+ class TestTranslations(unittest.TestCase):
++    @testtools.skipIf(sys.version_info >= (3, 6),
++                      "Skipped by Ubuntu, build chroot doesn't include en_US.UTF-8 by default")
+     def test_translations(self):
+         translated_message = check_output([sys.executable, __file__], env={
+             # Need to set this so py36 can do UTF-8, but we override later
diff -pruN 2.25.0-2/debian/patches/syslog_log_name.patch 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/syslog_log_name.patch
--- 2.25.0-2/debian/patches/syslog_log_name.patch	2020-04-21 08:30:49.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/patches/syslog_log_name.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,320 +0,0 @@
-Description: Set log_name for Swift services in default configs
-Author: Ondřej Nový <novy@ondrej.org>
-Forwarded: not-needed
-Last-Update: 2016-07-05
-
---- a/etc/account-server.conf-sample
-+++ b/etc/account-server.conf-sample
-@@ -18,7 +18,7 @@
- # max_clients = 1024
- #
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-account
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -85,7 +85,7 @@
- [app:account-server]
- use = egg:swift#account
- # You can override the default log routing for this app here:
--# set log_name = account-server
-+set log_name = swift-account-server
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_requests = true
-@@ -130,7 +130,7 @@
- 
- [account-replicator]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = account-replicator
-+log_name = swift-account-replicator
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -208,7 +208,7 @@
- 
- [account-auditor]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = account-auditor
-+log_name = swift-account-auditor
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -233,7 +233,7 @@
- 
- [account-reaper]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = account-reaper
-+log_name = swift-account-reaper
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/container-reconciler.conf-sample
-+++ b/etc/container-reconciler.conf-sample
-@@ -2,7 +2,7 @@
- # swift_dir = /etc/swift
- # user = swift
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-container-reconciler
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/container-server.conf-sample
-+++ b/etc/container-server.conf-sample
-@@ -24,7 +24,7 @@
- # allowed_sync_hosts = 127.0.0.1
- #
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-container
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -91,7 +91,7 @@
- [app:container-server]
- use = egg:swift#container
- # You can override the default log routing for this app here:
--# set log_name = container-server
-+set log_name = swift-container-server
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_requests = true
-@@ -140,7 +140,7 @@
- 
- [container-replicator]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = container-replicator
-+log_name = swift-container-replicator
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -218,7 +218,7 @@
- 
- [container-updater]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = container-updater
-+log_name = swift-container-updater
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -254,7 +254,7 @@
- 
- [container-auditor]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = container-auditor
-+log_name = swift-container-auditor
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -279,7 +279,7 @@
- 
- [container-sync]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = container-sync
-+log_name = swift-container-sync
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/drive-audit.conf-sample
-+++ b/etc/drive-audit.conf-sample
-@@ -5,7 +5,7 @@
- # device_dir = /srv/node
- #
- # You can specify default log routing here if you want:
--# log_name = drive-audit
-+log_name = swift-drive-audit
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/internal-client.conf-sample
-+++ b/etc/internal-client.conf-sample
-@@ -2,7 +2,7 @@
- # swift_dir = /etc/swift
- # user = swift
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-internal-client
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/object-expirer.conf-sample
-+++ b/etc/object-expirer.conf-sample
-@@ -2,7 +2,7 @@
- # swift_dir = /etc/swift
- # user = swift
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-object-expirer
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/object-server.conf-sample
-+++ b/etc/object-server.conf-sample
-@@ -26,7 +26,7 @@
- # max_clients = 1024
- #
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-object
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -105,7 +105,7 @@
- [app:object-server]
- use = egg:swift#object
- # You can override the default log routing for this app here:
--# set log_name = object-server
-+set log_name = swift-object-server
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_requests = true
-@@ -222,7 +222,7 @@
- 
- [object-replicator]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = object-replicator
-+log_name = swift-object-replicator
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -321,7 +321,7 @@
- # in the [object-replicator] section, however these settings apply to the EC
- # reconstructor
- #
--# log_name = object-reconstructor
-+log_name = swift-object-reconstructor
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -383,7 +383,7 @@
- 
- [object-updater]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = object-updater
-+log_name = swift-object-updater
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -428,7 +428,7 @@
- 
- [object-auditor]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = object-auditor
-+log_name = swift-object-auditor
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/proxy-server.conf-sample
-+++ b/etc/proxy-server.conf-sample
-@@ -41,7 +41,7 @@
- # expiring_objects_account_name = expiring_objects
- #
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-proxy
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_headers = false
-@@ -113,7 +113,7 @@
- [app:proxy-server]
- use = egg:swift#proxy
- # You can override the default log routing for this app here:
--# set log_name = proxy-server
-+set log_name = swift-proxy-server
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_address = /dev/log
-@@ -302,7 +302,7 @@
- [filter:tempauth]
- use = egg:swift#tempauth
- # You can override the default log routing for this filter here:
--# set log_name = tempauth
-+set log_name = swift-proxy-tempauth
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -643,7 +643,7 @@
- [filter:cache]
- use = egg:swift#memcache
- # You can override the default log routing for this filter here:
--# set log_name = cache
-+set log_name = swift-proxy-cache
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -676,7 +676,7 @@
- [filter:ratelimit]
- use = egg:swift#ratelimit
- # You can override the default log routing for this filter here:
--# set log_name = ratelimit
-+set log_name = swift-proxy-ratelimit
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -733,7 +733,7 @@
- [filter:domain_remap]
- use = egg:swift#domain_remap
- # You can override the default log routing for this filter here:
--# set log_name = domain_remap
-+set log_name = swift-proxy-domain_remap
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -768,7 +768,7 @@
- [filter:catch_errors]
- use = egg:swift#catch_errors
- # You can override the default log routing for this filter here:
--# set log_name = catch_errors
-+set log_name = swift-proxy-catch_errors
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -778,7 +778,7 @@
- # Note: this middleware requires python-dnspython
- use = egg:swift#cname_lookup
- # You can override the default log routing for this filter here:
--# set log_name = cname_lookup
-+set log_name = swift-proxy-cname_lookup
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -800,7 +800,7 @@
- [filter:staticweb]
- use = egg:swift#staticweb
- # You can override the default log routing for this filter here:
--# set log_name = staticweb
-+set log_name = swift-proxy-staticweb
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -879,7 +879,7 @@
- [filter:proxy-logging]
- use = egg:swift#proxy_logging
- # If not set, logging directives from [DEFAULT] without "access_" will be used
--# access_log_name = swift
-+access_log_name = swift-proxy-proxy-logging
- # access_log_facility = LOG_LOCAL0
- # access_log_level = INFO
- # access_log_address = /dev/log
-@@ -1034,7 +1034,7 @@
- # allow_reserved_names_header = false
- #
- # You can override the default log routing for this filter here:
--# set log_name = gatekeeper
-+set log_name = swift-proxy-gatekeeper
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
---- a/swift/container/sync.py
-+++ b/swift/container/sync.py
-@@ -55,7 +55,7 @@
- # swift_dir = /etc/swift
- # user = swift
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-internal-client
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
diff -pruN 2.25.0-2/debian/pybuild.testfiles 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/pybuild.testfiles
--- 2.25.0-2/debian/pybuild.testfiles	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/pybuild.testfiles	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-etc
-test
-swift.egg-info
diff -pruN 2.25.0-2/debian/python3-swift.dirs 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.dirs
--- 2.25.0-2/debian/python3-swift.dirs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.dirs	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1 @@
+var/cache/swift
diff -pruN 2.25.0-2/debian/python3-swift.docs 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.docs
--- 2.25.0-2/debian/python3-swift.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.docs	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 2.25.0-2/debian/python3-swift.install 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.install
--- 2.25.0-2/debian/python3-swift.install	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.install	2020-07-06 17:04:33.000000000 +0000
@@ -1 +1,3 @@
-usr/lib/python3*/dist-packages/*
+usr/bin/swift-drive-audit
+usr/bin/swift-init
+usr/lib/python*/dist-packages/*
diff -pruN 2.25.0-2/debian/python3-swift.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.lintian-overrides
--- 2.25.0-2/debian/python3-swift.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-python3-swift binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/python3-swift.manpages 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.manpages
--- 2.25.0-2/debian/python3-swift.manpages	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.manpages	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1 @@
+doc/manpages/swift-init.1
diff -pruN 2.25.0-2/debian/python3-swift.postinst 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.postinst
--- 2.25.0-2/debian/python3-swift.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.postinst	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,22 @@
+#!/bin/sh -e
+
+#DEBHELPER#
+
+if ! getent passwd swift > /dev/null ; then
+  adduser --system --quiet --disabled-login --home /var/lib/swift \
+        --disabled-password --no-create-home --group \
+        --shell /bin/false swift
+fi
+
+usermod -G adm swift
+
+find /etc/swift -exec chown root:swift "{}" +
+find /etc/swift -type f -exec chmod 0640 "{}" + -o -type d -exec chmod 0750 "{}" +
+
+if [ -d /var/cache/swift ] ; then
+  # Allow swift user to write to cache directory
+  chown root:swift /var/cache/swift
+  chmod 0775 /var/cache/swift
+fi
+
+exit 0
diff -pruN 2.25.0-2/debian/python3-swift.postinst.in 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.postinst.in
--- 2.25.0-2/debian/python3-swift.postinst.in	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.postinst.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-#!/bin/sh
-
-set -e
-
-#PKGOS-INCLUDE#
-
-if [ "$1" = "configure" ] || [ "$1" = "reconfigure" ] ; then
-	pkgos_var_user_group swift
-
-	mkdir -p /var/backups/swift
-	chown swift:swift /var/backups/swift
-	chmod 2770 /var/backups/swift
-fi
-
-#DEBHELPER#
-
-exit 0
diff -pruN 2.25.0-2/debian/python3-swift.postrm 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.postrm
--- 2.25.0-2/debian/python3-swift.postrm	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/python3-swift.postrm	2020-07-06 17:04:33.000000000 +0000
@@ -2,13 +2,20 @@
 
 set -e
 
-if [ "${1}" = "purge" ] ; then
-	for i in lock log run lib cache backups ; do
-		rm -rf /var/$i/swift
-	done
-	rm -rf /etc/swift
-fi
+case "$1" in
+    purge)
+        # Remove swift user if possible
+        userdel swift || true
+    ;;
+    remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
+    ;;
+    *)
+        echo "postrm called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
 
 #DEBHELPER#
 
 exit 0
+
diff -pruN 2.25.0-2/debian/rules 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/rules
--- 2.25.0-2/debian/rules	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/rules	2020-07-06 17:04:33.000000000 +0000
@@ -1,31 +1,56 @@
 #!/usr/bin/make -f
 
--include /usr/share/openstack-pkg-tools/pkgos.make
+# Verbose mode
+#export DH_VERBOSE=1
 
-export SWIFT_TEST_CONFIG_FILE=$(CURDIR)/debian/swift-test.conf
+export PYBUILD_NAME=swift
 
-export PYBUILD_TEST_ARGS=\
-	test/unit \
-	--exclude-test=test.unit.common.test_utils.TestUtils.test_get_logger_sysloghandler_plumbing
-	# --processes=-1
+SHELL := /bin/sh -e
+
+DEBVERS ?= $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
+VERSION ?= $(shell echo '$(DEBVERS)' | sed -e 's/^[[:digit:]]*://' -e 's/[-].*//' -e 's/[+].*//' -e 's/~git.*//g' -e 's/~/./g')
+export PBR_VERSION=$(VERSION)
 
 %:
-	dh $@ --buildsystem=pybuild --with python3,sphinxdoc
+	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
 
-override_dh_auto_build:
-	dh_auto_build
+# clean sphinx build output
+override_dh_clean:
+	dh_clean
+	rm -rf doc/build
+
+# build with sphinx documentation
+ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
+override_dh_sphinxdoc:
+	PYTHONPATH=. sphinx-build -b html doc/source $(CURDIR)/debian/swift-doc/usr/share/doc/swift-doc/html
+	dh_sphinxdoc
+endif
 
-	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func python3-swift.postinst
+ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
+override_dh_auto_test:
+	PYTHONPATH=. nosetests3 test/unit
+endif
+
+get-orig-source:
+	uscan --verbose --force-download --rename --destdir=../build-area
 
+override_dh_auto_build:
+	dh_auto_build
 	set -e ; set -x ; \
 	for i in $(sort $(wildcard debian/*.init.in)) ; do \
 		debian/gen-init $$i ; \
 	done
 
 override_dh_auto_install:
-	dh_auto_install
+	pkgos-dh_auto_install --no-py2 --in-tmp
 
-	rm debian/tmp/usr/bin/swift-init
+override_dh_install:
+	dh_install --sourcedir=debian/tmp -Xdebian/swift-account-generator -Xdebian/swift-object-generator -Xdebian/swift-container-generator
+	dh_missing --fail-missing
+	install -D -m 0640 $(CURDIR)/debian/account-server.conf $(CURDIR)/debian/python3-swift/etc/swift/account-server.conf
+	install -D -m 0640 $(CURDIR)/debian/container-server.conf $(CURDIR)/debian/python3-swift/etc/swift/container-server.conf
+	install -D -m 0640 $(CURDIR)/debian/object-server.conf $(CURDIR)/debian/python3-swift/etc/swift/object-server.conf
+	install -D -m 0640 $(CURDIR)/debian/object-expirer.conf $(CURDIR)/debian/python3-swift/etc/swift/object-expirer.conf
 
 override_dh_installinit:
 	set -e ; set -x ; \
@@ -43,21 +68,5 @@ override_dh_installsystemd:
 		dh_installsystemd -p$$PKG --name=$$NAME ;\
 	done
 
-gen-init-configurations:
-	echo "Do nothing"
-
-# build with sphinx documentation
-override_dh_sphinxdoc:
-ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
-	LC_ALL=C.UTF-8 PYTHONPATH=. python3 -m sphinx doc/source $(CURDIR)/debian/swift-doc/usr/share/doc/swift-doc/base
-	LC_ALL=C.UTF-8 PYTHONPATH=. python3 -m sphinx api-ref/source $(CURDIR)/debian/swift-doc/usr/share/doc/swift-doc/api-ref
-	dh_sphinxdoc
-endif
-
-override_dh_installdocs:
-	dh_installdocs
-
-	dh_installdocs -A AUTHORS
-
-override_dh_missing:
-	dh_missing --fail-missing
+override_dh_compress:
+	dh_compress -Xconf-sample
diff -pruN 2.25.0-2/debian/source/include-binaries 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/source/include-binaries
--- 2.25.0-2/debian/source/include-binaries	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/source/include-binaries	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1 @@
+doc/source/howto_cyberduck_config.png
diff -pruN 2.25.0-2/debian/source/options 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/source/options
--- 2.25.0-2/debian/source/options	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/source/options	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-extend-diff-ignore = "^[^/]*[.]egg-info/"
-extend-diff-ignore = "^[.]gitreview$"
diff -pruN 2.25.0-2/debian/swift-account.docs 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.docs
--- 2.25.0-2/debian/swift-account.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.docs	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1 @@
+etc/account-server.conf-sample
diff -pruN 2.25.0-2/debian/swift-account.install 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.install
--- 2.25.0-2/debian/swift-account.install	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.install	2020-07-06 17:04:33.000000000 +0000
@@ -1,7 +1,5 @@
 #! /usr/bin/dh-exec --with=install
 debian/swift-account-generator /lib/systemd/system-generators
-etc/account-server.conf-sample => /etc/swift/account-server.conf
-etc/account-server.conf-sample => /usr/share/doc/swift-account/examples/account-server.conf
 usr/bin/swift-account-audit
 usr/bin/swift-account-auditor
 usr/bin/swift-account-info
diff -pruN 2.25.0-2/debian/swift-account.links 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.links
--- 2.25.0-2/debian/swift-account.links	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.links	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/share/doc/swift-account/examples/account-server.conf usr/share/doc/swift/examples/account-server.conf
diff -pruN 2.25.0-2/debian/swift-account.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.lintian-overrides
--- 2.25.0-2/debian/swift-account.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-account binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/swift-account.manpages 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.manpages
--- 2.25.0-2/debian/swift-account.manpages	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-account.manpages	2020-07-06 17:04:33.000000000 +0000
@@ -1,7 +1,2 @@
-doc/manpages/account-server.conf.5
-doc/manpages/swift-account-audit.1
-doc/manpages/swift-account-auditor.1
-doc/manpages/swift-account-info.1
-doc/manpages/swift-account-reaper.1
-doc/manpages/swift-account-replicator.1
-doc/manpages/swift-account-server.1
+doc/manpages/account*
+doc/manpages/swift-account*
diff -pruN 2.25.0-2/debian/swift-container.docs 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.docs
--- 2.25.0-2/debian/swift-container.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.docs	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,2 @@
+etc/container-server.conf-sample
+etc/container-sync-realms.conf-sample
diff -pruN 2.25.0-2/debian/swift-container.install 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.install
--- 2.25.0-2/debian/swift-container.install	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.install	2020-07-06 17:04:33.000000000 +0000
@@ -1,18 +1,5 @@
 #! /usr/bin/dh-exec --with=install
-etc/container-reconciler.conf-sample => /etc/swift/container-reconciler.conf
-etc/container-reconciler.conf-sample => /usr/share/doc/swift-container/examples/container-reconciler.conf
-etc/container-server.conf-sample => /etc/swift/container-server.conf
-etc/container-server.conf-sample => /usr/share/doc/swift-container/examples/container-server.conf
-etc/internal-client.conf-sample => /etc/swift/internal-client.conf
-etc/internal-client.conf-sample => /usr/share/doc/swift-container/examples/internal-client.conf
 debian/swift-container-generator /lib/systemd/system-generators
-usr/bin/swift-container-auditor
-usr/bin/swift-container-info
-usr/bin/swift-container-reconciler
-usr/bin/swift-container-replicator
-usr/bin/swift-container-server
-usr/bin/swift-container-sharder
-usr/bin/swift-container-sync
-usr/bin/swift-container-updater
+usr/bin/swift-container-*
 usr/bin/swift-manage-shard-ranges
 usr/bin/swift-reconciler-enqueue
diff -pruN 2.25.0-2/debian/swift-container.links 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.links
--- 2.25.0-2/debian/swift-container.links	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.links	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-usr/share/doc/swift-container/examples/container-reconciler.conf usr/share/doc/swift/examples/container-reconciler.conf
-usr/share/doc/swift-container/examples/container-server.conf usr/share/doc/swift/examples/container-server.conf
-usr/share/doc/swift-container/examples/internal-client.conf usr/share/doc/swift/examples/internal-client.conf
diff -pruN 2.25.0-2/debian/swift-container.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.lintian-overrides
--- 2.25.0-2/debian/swift-container.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-container binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/swift-container.manpages 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.manpages
--- 2.25.0-2/debian/swift-container.manpages	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-container.manpages	2020-07-06 17:04:33.000000000 +0000
@@ -1,9 +1,2 @@
-doc/manpages/container-server.conf.5
-doc/manpages/swift-container-auditor.1
-doc/manpages/swift-container-info.1
-doc/manpages/swift-container-reconciler.1
-doc/manpages/swift-container-replicator.1
-doc/manpages/swift-container-server.1
-doc/manpages/swift-container-sync.1
-doc/manpages/swift-container-updater.1
-doc/manpages/swift-reconciler-enqueue.1
+doc/manpages/container*
+doc/manpages/swift-container*
diff -pruN 2.25.0-2/debian/swift-doc.doc-base 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-doc.doc-base
--- 2.25.0-2/debian/swift-doc.doc-base	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-doc.doc-base	2020-07-06 17:04:33.000000000 +0000
@@ -5,5 +5,5 @@ Abstract: Sphinx documentation for Swift
 Section: Network/File Transfer
 
 Format: HTML
-Index: /usr/share/doc/swift-doc/base/index.html
-Files: /usr/share/doc/swift-doc/base/*
+Index: /usr/share/doc/swift-doc/html/index.html
+Files: /usr/share/doc/swift-doc/html/*
diff -pruN 2.25.0-2/debian/swift-doc.links 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-doc.links
--- 2.25.0-2/debian/swift-doc.links	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-doc.links	2020-07-06 17:04:33.000000000 +0000
@@ -1,7 +1,3 @@
-usr/share/doc/swift-doc/api-ref usr/share/doc/swift/api-ref
-usr/share/doc/swift-doc/base usr/share/doc/swift/base
-usr/share/doc/swift-doc/install-guide usr/share/doc/swift/install-guide
-usr/share/javascript/bootstrap/css/bootstrap.min.css usr/share/doc/swift-doc/install-guide/_static/css/bootstrap.min.css
-usr/share/javascript/bootstrap/js/bootstrap.min.js usr/share/doc/swift-doc/install-guide/_static/js/bootstrap.min.js
-usr/share/javascript/jquery/jquery.min.js usr/share/doc/swift-doc/install-guide/_static/jquery.js
-usr/share/javascript/underscore/underscore.min.js usr/share/doc/swift-doc/install-guide/_static/underscore.js
+# Overwrite jquery.js  from upstream tarball with a  link to jquery.js
+# provided by jQuery Debian package
+/usr/share/javascript/jquery/jquery.js usr/share/doc/swift-doc/html/_static/jquery.js
diff -pruN 2.25.0-2/debian/swift-doc.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-doc.lintian-overrides
--- 2.25.0-2/debian/swift-doc.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-doc.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-doc binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/swift.docs 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.docs
--- 2.25.0-2/debian/swift.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.docs	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,4 @@
+CHANGELOG
+etc/dispersion.conf-sample
+etc/drive-audit.conf-sample
+etc/swift.conf-sample
diff -pruN 2.25.0-2/debian/swift-drive-audit.cron.d 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.cron.d
--- 2.25.0-2/debian/swift-drive-audit.cron.d	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.cron.d	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-*/5 * * * *     root   test -x /usr/bin/swift-drive-audit && test -r /etc/swift/drive-audit.conf && /usr/bin/swift-drive-audit /etc/swift/drive-audit.conf
diff -pruN 2.25.0-2/debian/swift-drive-audit.install 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.install
--- 2.25.0-2/debian/swift-drive-audit.install	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-#! /usr/bin/dh-exec --with=install
-etc/drive-audit.conf-sample => /etc/swift/drive-audit.conf
-etc/drive-audit.conf-sample => /usr/share/doc/swift-drive-audit/examples/drive-audit.conf
-usr/bin/swift-drive-audit
diff -pruN 2.25.0-2/debian/swift-drive-audit.links 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.links
--- 2.25.0-2/debian/swift-drive-audit.links	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.links	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/share/doc/swift-drive-audit/examples/drive-audit.conf usr/share/doc/swift/examples/drive-audit.conf
diff -pruN 2.25.0-2/debian/swift-drive-audit.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.lintian-overrides
--- 2.25.0-2/debian/swift-drive-audit.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-drive-audit binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/swift-drive-audit.manpages 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.manpages
--- 2.25.0-2/debian/swift-drive-audit.manpages	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-drive-audit.manpages	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-doc/manpages/swift-drive-audit.1
diff -pruN 2.25.0-2/debian/swift.install 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.install
--- 2.25.0-2/debian/swift.install	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.install	2020-07-06 17:04:33.000000000 +0000
@@ -1,13 +1,4 @@
-#! /usr/bin/dh-exec --with=install
-debian/swift.rsyslog => /etc/rsyslog.d/swift.conf
-etc/container-sync-realms.conf-sample => /etc/swift/container-sync-realms.conf
-etc/container-sync-realms.conf-sample => /usr/share/doc/swift/examples/container-sync-realms.conf
-etc/dispersion.conf-sample => /etc/swift/dispersion.conf
-etc/dispersion.conf-sample => /usr/share/doc/swift/examples/dispersion.conf
-etc/swift.conf-sample => /etc/swift/swift.conf
-etc/swift.conf-sample => /usr/share/doc/swift/examples/swift.conf
 usr/bin/swift-config
-usr/bin/swift-container-deleter
 usr/bin/swift-dispersion-populate
 usr/bin/swift-dispersion-report
 usr/bin/swift-form-signature
@@ -15,6 +6,9 @@ usr/bin/swift-get-nodes
 usr/bin/swift-oldies
 usr/bin/swift-orphans
 usr/bin/swift-recon
+usr/bin/swift-recon
+usr/bin/swift-recon-cron
+usr/bin/swift-recon-cron
 usr/bin/swift-ring-builder
 usr/bin/swift-ring-builder-analyzer
 usr/bin/swift-ring-composer
diff -pruN 2.25.0-2/debian/swift.links 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.links
--- 2.25.0-2/debian/swift.links	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.links	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-/var/backups/swift	/etc/swift/backups
diff -pruN 2.25.0-2/debian/swift.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.lintian-overrides
--- 2.25.0-2/debian/swift.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/swift.logrotate 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.logrotate
--- 2.25.0-2/debian/swift.logrotate	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.logrotate	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-/var/log/swift/*.log {
-	rotate 7
-	daily
-	missingok
-	notifempty
-	delaycompress
-	compress
-	sharedscripts
-	postrotate
-		invoke-rc.d rsyslog rotate > /dev/null
-	endscript
-}
diff -pruN 2.25.0-2/debian/swift.manpages 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.manpages
--- 2.25.0-2/debian/swift.manpages	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.manpages	2020-07-06 17:04:33.000000000 +0000
@@ -1,13 +1,7 @@
 doc/manpages/dispersion.conf.5
-doc/manpages/swift-config.1
 doc/manpages/swift-dispersion-populate.1
 doc/manpages/swift-dispersion-report.1
-doc/manpages/swift-form-signature.1
 doc/manpages/swift-get-nodes.1
-doc/manpages/swift-oldies.1
 doc/manpages/swift-orphans.1
 doc/manpages/swift-recon.1
-doc/manpages/swift-ring-builder-analyzer.1
 doc/manpages/swift-ring-builder.1
-doc/manpages/swift-ring-composer.1
-doc/manpages/swift.conf.5
diff -pruN 2.25.0-2/debian/swift-object.cron.d 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.cron.d
--- 2.25.0-2/debian/swift-object.cron.d	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.cron.d	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-*/5 * * * *     swift   test -x /usr/bin/swift-recon-cron && test -r /etc/swift/object-server.conf && /usr/bin/swift-recon-cron /etc/swift/object-server.conf
diff -pruN 2.25.0-2/debian/swift-object.docs 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.docs
--- 2.25.0-2/debian/swift-object.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.docs	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,3 @@
+etc/object-expirer.conf-sample
+etc/object-server.conf-sample
+etc/rsyncd.conf-sample
diff -pruN 2.25.0-2/debian/swift-object-expirer.docs 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.docs
--- 2.25.0-2/debian/swift-object-expirer.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.docs	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1 @@
+etc/object-expirer.conf-sample
diff -pruN 2.25.0-2/debian/swift-object-expirer.install 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.install
--- 2.25.0-2/debian/swift-object-expirer.install	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.install	2020-07-06 17:04:33.000000000 +0000
@@ -1,4 +1 @@
-#! /usr/bin/dh-exec --with=install
-etc/object-expirer.conf-sample => /etc/swift/object-expirer.conf
-etc/object-expirer.conf-sample => /usr/share/doc/swift-object-expirer/examples/object-expirer.conf
 usr/bin/swift-object-expirer
diff -pruN 2.25.0-2/debian/swift-object-expirer.links 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.links
--- 2.25.0-2/debian/swift-object-expirer.links	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.links	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/share/doc/swift-object-expirer/examples/object-expirer.conf usr/share/doc/swift/examples/object-expirer.conf
diff -pruN 2.25.0-2/debian/swift-object-expirer.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.lintian-overrides
--- 2.25.0-2/debian/swift-object-expirer.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-object-expirer binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/swift-object-expirer.manpages 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.manpages
--- 2.25.0-2/debian/swift-object-expirer.manpages	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object-expirer.manpages	2020-07-06 17:04:33.000000000 +0000
@@ -1 +1,2 @@
+doc/manpages/object-expirer.conf.5
 doc/manpages/swift-object-expirer.1
diff -pruN 2.25.0-2/debian/swift-object.install 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.install
--- 2.25.0-2/debian/swift-object.install	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.install	2020-07-06 17:04:33.000000000 +0000
@@ -1,8 +1,5 @@
 #! /usr/bin/dh-exec --with=install
 debian/swift-object-generator /lib/systemd/system-generators
-etc/object-server.conf-sample => /etc/swift/object-server.conf
-etc/object-server.conf-sample => /usr/share/doc/swift-object/examples/object-server.conf
-etc/rsyncd.conf-sample => /usr/share/doc/swift-object/examples/rsyncd.conf
 usr/bin/swift-object-auditor
 usr/bin/swift-object-info
 usr/bin/swift-object-reconstructor
@@ -10,4 +7,3 @@ usr/bin/swift-object-relinker
 usr/bin/swift-object-replicator
 usr/bin/swift-object-server
 usr/bin/swift-object-updater
-usr/bin/swift-recon-cron
diff -pruN 2.25.0-2/debian/swift-object.links 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.links
--- 2.25.0-2/debian/swift-object.links	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.links	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-usr/share/doc/swift-object/examples/object-server.conf usr/share/doc/swift/examples/object-server.conf
-usr/share/doc/swift-object/examples/rsyncd.conf usr/share/doc/swift/examples/rsyncd.conf
diff -pruN 2.25.0-2/debian/swift-object.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.lintian-overrides
--- 2.25.0-2/debian/swift-object.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-object binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/swift-object.manpages 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.manpages
--- 2.25.0-2/debian/swift-object.manpages	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-object.manpages	2020-07-06 17:04:33.000000000 +0000
@@ -1,10 +1,6 @@
-doc/manpages/object-expirer.conf.5
 doc/manpages/object-server.conf.5
 doc/manpages/swift-object-auditor.1
 doc/manpages/swift-object-info.1
-doc/manpages/swift-object-reconstructor.1
-doc/manpages/swift-object-relinker.1
 doc/manpages/swift-object-replicator.1
 doc/manpages/swift-object-server.1
 doc/manpages/swift-object-updater.1
-doc/manpages/swift-recon-cron.1
diff -pruN 2.25.0-2/debian/swift-proxy.docs 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-proxy.docs
--- 2.25.0-2/debian/swift-proxy.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-proxy.docs	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,3 @@
+etc/memcache.conf-sample
+etc/mime.types-sample
+etc/proxy-server.conf-sample
diff -pruN 2.25.0-2/debian/swift-proxy.install 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-proxy.install
--- 2.25.0-2/debian/swift-proxy.install	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-proxy.install	2020-07-06 17:04:33.000000000 +0000
@@ -1,8 +1 @@
-#! /usr/bin/dh-exec --with=install
-etc/memcache.conf-sample => /etc/swift/memcache.conf
-etc/memcache.conf-sample => /usr/share/doc/swift-proxy/examples/memcache.conf
-etc/mime.types-sample => /etc/swift/mime.types
-etc/mime.types-sample => /usr/share/doc/swift-proxy/examples/mime.types
-etc/proxy-server.conf-sample => /etc/swift/proxy-server.conf
-etc/proxy-server.conf-sample => /usr/share/doc/swift-proxy/examples/proxy-server.conf
 usr/bin/swift-proxy-server
diff -pruN 2.25.0-2/debian/swift-proxy.links 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-proxy.links
--- 2.25.0-2/debian/swift-proxy.links	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-proxy.links	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-usr/share/doc/swift-proxy/examples/memcache.conf usr/share/doc/swift/examples/memcache.conf
-usr/share/doc/swift-proxy/examples/mime.types usr/share/doc/swift/examples/mime.types
-usr/share/doc/swift-proxy/examples/proxy-server.conf usr/share/doc/swift/examples/proxy-server.conf
diff -pruN 2.25.0-2/debian/swift-proxy.lintian-overrides 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-proxy.lintian-overrides
--- 2.25.0-2/debian/swift-proxy.lintian-overrides	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-proxy.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-proxy binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-2/debian/swift.rsyslog 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.rsyslog
--- 2.25.0-2/debian/swift.rsyslog	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift.rsyslog	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-if $programname startswith 'swift-account' then /var/log/swift/account.log
-if $programname startswith 'swift-account' then stop
-if $programname startswith 'swift-container' then /var/log/swift/container.log
-if $programname startswith 'swift-container' then stop
-if $programname startswith 'swift-object' then /var/log/swift/object.log
-if $programname startswith 'swift-object' then stop
-if $programname startswith 'swift-proxy' then /var/log/swift/proxy.log
-if $programname startswith 'swift-proxy' then stop
-if $programname startswith 'swift-drive-audit' then /var/log/swift/drive-audit.log
-if $programname startswith 'swift-drive-audit' then stop
-if $programname startswith 'swift' then /var/log/swift/swift.log
-if $programname startswith 'swift' then stop
diff -pruN 2.25.0-2/debian/swift-test.conf 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-test.conf
--- 2.25.0-2/debian/swift-test.conf	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/swift-test.conf	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-[unit_test]
-fake_syslog = True
diff -pruN 2.25.0-2/debian/tests/control 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/tests/control
--- 2.25.0-2/debian/tests/control	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/tests/control	2020-07-06 17:04:33.000000000 +0000
@@ -1,18 +1,8 @@
-Tests: help
+Tests: swift-daemons
 Depends:
+ swift,
  swift-account,
  swift-container,
- swift-drive-audit,
  swift-object,
- swift-object-expirer,
  swift-proxy,
-
-Tests: daemons
-Depends:
- swift-account,
- swift-container,
- swift-object,
- swift-object-expirer,
- swift-proxy,
- wget,
-Restrictions: needs-root, isolation-container
+Restrictions: needs-root
diff -pruN 2.25.0-2/debian/tests/daemons 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/tests/daemons
--- 2.25.0-2/debian/tests/daemons	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/tests/daemons	1970-01-01 00:00:00.000000000 +0000
@@ -1,89 +0,0 @@
-#!/bin/bash
-#----------------
-# Testing daemons
-#----------------
-
-set -e
-
-export SYSTEMD_PAGER=
-
-# Daemons to test
-DAEMONS=(
-    swift-account
-    swift-account-auditor
-    swift-account-reaper
-    swift-account-replicator
-    swift-container
-    swift-container-auditor
-    swift-container-reconciler
-    swift-container-replicator
-    swift-container-sharder
-    swift-container-sync
-    swift-container-updater
-    swift-object
-    swift-object-auditor
-    swift-object-expirer
-    swift-object-reconstructor
-    swift-object-replicator
-    swift-object-updater
-    swift-proxy
-)
-
-
-echo "##### Create rings #####"
-mkdir -p /srv/node/sda1
-chown swift:swift /srv/node/sda1
-cd /etc/swift
-
-swift-ring-builder account.builder create 4 1 1
-swift-ring-builder object.builder create 4 1 1
-swift-ring-builder container.builder create 4 1 1
-
-swift-ring-builder account.builder add r1z1-127.0.0.1:6202/sda1 1
-swift-ring-builder container.builder add r1z1-127.0.0.1:6201/sda1 1
-swift-ring-builder object.builder add r1z1-127.0.0.1:6200/sda1 1
-
-swift-ring-builder account.builder rebalance
-swift-ring-builder container.builder rebalance
-swift-ring-builder object.builder rebalance
-
-echo "##### Start all daemons #####"
-for DAEMON in "${DAEMONS[@]}"; do
-    service "$DAEMON" restart
-done
-
-echo "##### Waiting for start #####"
-# Swift daemons sometimes crash after couple of seconds from start
-sleep 10
-
-echo "##### HTTP GET #####"
-echo -n "Object: "
-wget --no-verbose -t 5 --retry-connrefused --no-proxy -O - \
-    http://127.0.0.1:6200/recon/version 2>&1
-echo ""
-echo -n "Container: "
-wget --no-verbose -t 5 --retry-connrefused --no-proxy -O - \
-    http://127.0.0.1:6201/recon/version 2>&1
-echo ""
-echo -n "Account: "
-wget --no-verbose -t 5 --retry-connrefused --no-proxy -O - \
-    http://127.0.0.1:6202/recon/version 2>&1
-echo ""
-echo -n "Proxy: "
-wget --no-verbose -t 5 --retry-connrefused --no-proxy -O - \
-    http://127.0.0.1:8080/info 2>&1
-echo ""
-
-echo "##### Check all daemons #####"
-for DAEMON in "${DAEMONS[@]}"; do
-    service "$DAEMON" status </dev/null
-done
-
-echo "##### Stop all daemons #####"
-for DAEMON in "${DAEMONS[@]}"; do
-    service "$DAEMON" stop
-done
-
-echo "##### ALL DONE #####"
-
-exit 0
diff -pruN 2.25.0-2/debian/tests/help 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/tests/help
--- 2.25.0-2/debian/tests/help	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/tests/help	1970-01-01 00:00:00.000000000 +0000
@@ -1,38 +0,0 @@
-#!/bin/bash
-#-----------------------
-# Testing utilities help
-#-----------------------
-set -e
-
-cd "$AUTOPKGTEST_TMP"
-
-# Not working
-#  swift-account-audit
-#  swift-drive-audit
-#  swift-form-signature
-#  swift-recon-cron
-#  swift-ring-builder
-#  swift-temp-url
-
-CMDS=(
- 'swift-account-auditor' 'swift-account-info' 'swift-account-reaper'
- 'swift-account-replicator' 'swift-account-server' 'swift-config'
- 'swift-container-auditor' 'swift-container-info' 'swift-container-reconciler'
- 'swift-container-replicator' 'swift-container-server' 'swift-container-sharder'
- 'swift-container-sync' 'swift-container-updater' 'swift-dispersion-populate'
- 'swift-dispersion-report' 'swift-get-nodes'
- 'swift-object-auditor' 'swift-object-expirer' 'swift-object-info'
- 'swift-object-reconstructor' 'swift-object-replicator' 'swift-object-server'
- 'swift-object-updater' 'swift-oldies' 'swift-orphans' 'swift-proxy-server'
- 'swift-recon' 'swift-reconciler-enqueue' 'swift-ring-builder-analyzer'
- 'swift-ring-composer' 'swift-manage-shard-ranges' 'swift-object-relinker'
-)
-for cmd in "${CMDS[@]}"; do
-    if ! $cmd -h 2>&1 > /dev/null; then
-        echo "ERROR, ${cmd} is not running"
-        exit 1
-    else
-        echo "OK: ${cmd} is running"
-    fi
-done
-exit 0
diff -pruN 2.25.0-2/debian/tests/swift-daemons 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/tests/swift-daemons
--- 2.25.0-2/debian/tests/swift-daemons	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/tests/swift-daemons	2020-07-06 17:04:33.000000000 +0000
@@ -0,0 +1,56 @@
+#!/bin/bash
+#--------------------
+# Testing swift-proxy
+#--------------------
+set -e
+failure=false
+
+# copy config files
+mkdir -p /etc/swift 2>&1 > /dev/null
+cp /usr/share/doc/swift/swift.conf-sample /etc/swift/swift.conf 2>&1 > /dev/null
+cp /usr/share/doc/swift-proxy/proxy-server.conf-sample /etc/swift/proxy-server.conf 2>&1 > /dev/null
+
+# create rings
+cd /etc/swift 2>&1 > /dev/null
+swift-ring-builder account.builder create 18 1 1 2>&1 > /dev/null
+swift-ring-builder container.builder create 18 1 1 2>&1 > /dev/null
+swift-ring-builder object.builder create 18 1 1 2>&1 > /dev/null
+
+swift-ring-builder account.builder add z1-127.0.0.1:6002/sda1 100 2>&1 > /dev/null
+swift-ring-builder container.builder add z1-127.0.0.1:6001/sda1 100 2>&1 > /dev/null
+swift-ring-builder object.builder add z1-127.0.0.1:6000/sda1 100 2>&1 > /dev/null
+
+swift-ring-builder account.builder rebalance 2>&1 > /dev/null
+swift-ring-builder container.builder rebalance 2>&1 > /dev/null
+swift-ring-builder object.builder rebalance 2>&1 > /dev/null
+
+DAEMONS=('swift-proxy' 'swift-object' 'swift-container' 'swift-account')
+
+for daemon in "${DAEMONS[@]}"; do
+    systemctl restart $daemon
+done
+
+for daemon in "${DAEMONS[@]}"; do
+    TIMEOUT=50
+    while [ "$TIMEOUT" -gt 0 ]; do
+        if pidof -x ${daemon}-server > /dev/null; then
+            echo "OK"
+            break
+        fi
+        TIMEOUT=$((TIMEOUT - 1))
+        sleep 0.1
+    done
+
+    if [ "$TIMEOUT" -le 0 ]; then
+        echo "ERROR: ${daemon}-server IS NOT RUNNING"
+        failure=true
+    else
+        echo "${daemon}-server IS RUNNING"
+    fi
+done
+
+if [ "$failure" = true ]; then
+    exit 1
+fi
+
+exit 0
diff -pruN 2.25.0-2/debian/upstream/metadata 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/upstream/metadata
--- 2.25.0-2/debian/upstream/metadata	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/upstream/metadata	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-Bug-Database: https://bugs.launchpad.net/swift
-Bug-Submit: https://bugs.launchpad.net/swift/+filebug
-Name: Swift
-Repository: https://github.com/openstack/swift.git
-Repository-Browse: https://github.com/openstack/swift
diff -pruN 2.25.0-2/debian/watch 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/watch
--- 2.25.0-2/debian/watch	2020-04-21 08:26:16.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/debian/watch	2020-07-06 17:04:33.000000000 +0000
@@ -1,3 +1,3 @@
 version=3
-https://github.com/openstack/swift/tags .*/(\d[\d\.]+.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
-https://tarballs.openstack.org/swift/ swift-(\d[\d\.]+.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
+opts="uversionmangle=s/rc/~rc/" \
+ https://tarballs.opendev.org/openstack/swift/ swift-(\d.*).tar.gz
diff -pruN 2.25.0-2/doc/requirements.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/requirements.txt
--- 2.25.0-2/doc/requirements.txt	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/requirements.txt	2020-07-06 17:03:50.000000000 +0000
@@ -2,10 +2,9 @@
 # of appearance. Changing the order has an impact on the overall integration
 # process, which may cause wedges in the gate later.
 # this is required for the docs build jobs
-sphinx>=1.6.2,<2.0.0;python_version=='2.7' # BSD
-sphinx>=1.6.2;python_version>='3.4' # BSD
-openstackdocstheme>=1.30.0 # Apache-2.0
-reno>=1.8.0  # Apache-2.0
+sphinx>=2.0.0,!=2.1.0 # BSD
+openstackdocstheme>=2.2.1 # Apache-2.0
+reno>=3.1.0 # Apache-2.0
 os-api-ref>=1.0.0 # Apache-2.0
 python-keystoneclient!=2.1.0,>=2.0.0 # Apache-2.0
 sphinxcontrib-svg2pdfconverter>=0.1.0 # BSD
diff -pruN 2.25.0-2/doc/saio/swift/proxy-server.conf 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/saio/swift/proxy-server.conf
--- 2.25.0-2/doc/saio/swift/proxy-server.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/saio/swift/proxy-server.conf	2020-07-06 17:03:50.000000000 +0000
@@ -80,6 +80,9 @@ use = egg:swift#copy
 [filter:listing_formats]
 use = egg:swift#listing_formats
 
+[filter:domain_remap]
+use = egg:swift#domain_remap
+
 [filter:symlink]
 use = egg:swift#symlink
 
diff -pruN 2.25.0-2/doc/source/conf.py 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/conf.py
--- 2.25.0-2/doc/source/conf.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/conf.py	2020-07-06 17:03:50.000000000 +0000
@@ -29,7 +29,6 @@
 import datetime
 import logging
 import os
-from swift import __version__
 import sys
 
 # NOTE(amotoki): Our current doc build job uses an older version of
@@ -80,15 +79,6 @@ else:
     now = datetime.date.today()
 copyright = u'%d, OpenStack Foundation' % now.year
 
-# The version info for the project you're documenting, acts as replacement for
-# |version| and |release|, also used in various other places throughout the
-# built documents.
-#
-# The short X.Y version.
-version = __version__.rsplit('.', 1)[0]
-# The full version, including alpha/beta/rc tags.
-release = __version__
-
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
 # language = None
@@ -122,7 +112,7 @@ exclude_trees = []
 show_authors = True
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = 'native'
 
 # A list of ignored prefixes for module index sorting.
 modindex_common_prefix = ['swift.']
@@ -172,11 +162,6 @@ html_theme_options = {
 # robots.txt.
 html_extra_path = ['_extra']
 
-# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
-# using the given strftime format.
-# html_last_updated_fmt = '%b %d, %Y'
-html_last_updated_fmt = '%Y-%m-%d %H:%M'
-
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
 # html_use_smartypants = True
@@ -248,6 +233,8 @@ latex_documents = [
 latex_use_xindy = False
 
 # -- Options for openstackdocstheme -------------------------------------------
-repository_name = 'openstack/swift'
-bug_project = 'swift'
-bug_tag = ''
+openstackdocs_repo_name = 'openstack/swift'
+openstackdocs_pdf_link = True
+openstackdocs_auto_name = False
+openstackdocs_bug_project = 'swift'
+openstackdocs_bug_tag = ''
diff -pruN 2.25.0-2/doc/source/contributor/contributing.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/contributor/contributing.rst
--- 2.25.0-2/doc/source/contributor/contributing.rst	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/contributor/contributing.rst	2020-07-06 17:03:50.000000000 +0000
@@ -0,0 +1,79 @@
+.. include:: ../../../CONTRIBUTING.rst
+
+Community
+=========
+
+Communication
+-------------
+IRC
+    People working on the Swift project may be found in the
+    ``#openstack-swift`` channel on Freenode during working hours
+    in their timezone.  The channel is logged, so if you ask a question
+    when no one is around, you can check the log to see if it's been
+    answered: http://eavesdrop.openstack.org/irclogs/%23openstack-swift/
+
+weekly meeting
+    This is a Swift team meeting. The discussion in this meeting is about
+    all things related to the Swift project:
+
+- time: http://eavesdrop.openstack.org/#Swift_Team_Meeting
+- agenda: https://wiki.openstack.org/wiki/Meetings/Swift
+
+mailing list
+    We use the openstack-discuss@lists.openstack.org mailing list for
+    asynchronous discussions or to communicate with other OpenStack teams.
+    Use the prefix ``[swift]`` in your subject line (it's a high-volume
+    list, so most people use email filters).
+
+    More information about the mailing list, including how to subscribe
+    and read the archives, can be found at:
+    http://lists.openstack.org/cgi-bin/mailman/listinfo/openstack-discuss
+
+Contacting the Core Team
+------------------------
+
+The swift-core team is an active group of contributors who are responsible
+for directing and maintaining the Swift project.  As a new contributor, your
+interaction with this group will be mostly through code reviews, because
+only members of swift-core can approve a code change to be merged into the
+code repository. But the swift-core team also spend time on IRC so feel
+free to drop in to ask questions or just to meet us.
+
+.. note::
+   Although your contribution will require reviews by members of
+   swift-core, these aren't the only people whose reviews matter.
+   Anyone with a gerrit account can post reviews, so you can ask
+   other developers you know to review your code ... and you can
+   review theirs.  (A good way to learn your way around the codebase
+   is to review other people's patches.)
+
+   If you're thinking, "I'm new at this, how can I possibly provide
+   a helpful review?", take a look at `How to Review Changes the
+   OpenStack Way
+   <https://docs.openstack.org/project-team-guide/review-the-openstack-way.html>`_.
+
+   Or for more specifically in a Swift context read :doc:`review_guidelines`
+
+You can learn more about the role of core reviewers in the OpenStack
+governance documentation:
+https://docs.openstack.org/contributors/common/governance.html#core-reviewer
+
+The membership list of swift-core is maintained in gerrit:
+https://review.opendev.org/#/admin/groups/24,members
+
+You can also find the members of the swift-core team at the Swift weekly
+meetings.
+
+Getting Your Patch Merged
+-------------------------
+Understanding how reviewers review and what they look for will help getting
+your code merged. See `Swift Review Guidelines <contributor/review_guidelines>`_
+for how we review code.
+
+Keep in mind that reviewers are also human; if something feels stalled, then
+come and poke us on IRC or add it to our meeting agenda.
+
+Project Team Lead Duties
+------------------------
+All common PTL duties are enumerated in the `PTL guide
+<https://docs.openstack.org/project-team-guide/ptl.html>`_.
diff -pruN 2.25.0-2/doc/source/contributor/review_guidelines.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/contributor/review_guidelines.rst
--- 2.25.0-2/doc/source/contributor/review_guidelines.rst	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/contributor/review_guidelines.rst	2020-07-06 17:03:50.000000000 +0000
@@ -0,0 +1 @@
+.. include:: ../../../REVIEW_GUIDELINES.rst
diff -pruN 2.25.0-2/doc/source/deployment_guide.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/deployment_guide.rst
--- 2.25.0-2/doc/source/deployment_guide.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/deployment_guide.rst	2020-07-06 17:03:50.000000000 +0000
@@ -2331,7 +2331,7 @@ headroom.
 
 The following example mount options are recommended when using XFS::
 
-    mount -t xfs -o noatime,nodiratime,logbufs=8 -L D1 /srv/node/d1
+    mount -t xfs -o noatime -L D1 /srv/node/d1
 
 We do not recommend running Swift on RAID, but if you are using
 RAID it is also important to make sure that the proper sunit and swidth
diff -pruN 2.25.0-2/doc/source/development_saio.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/development_saio.rst
--- 2.25.0-2/doc/source/development_saio.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/development_saio.rst	2020-07-06 17:03:50.000000000 +0000
@@ -141,7 +141,7 @@ another device when creating the VM, and
 
 #. Edit ``/etc/fstab`` and add::
 
-      UUID="<UUID-from-output-above>" /mnt/sdb1 xfs noatime,nodiratime,logbufs=8 0 0
+      UUID="<UUID-from-output-above>" /mnt/sdb1 xfs noatime 0 0
 
 #. Create the Swift data mount point and test that mounting works::
 
@@ -169,7 +169,7 @@ these instructions:
 
 #. Edit `/etc/fstab` and add::
 
-      /srv/swift-disk /mnt/sdb1 xfs loop,noatime,nodiratime,logbufs=8 0 0
+      /srv/swift-disk /mnt/sdb1 xfs loop,noatime 0 0
 
 #. Create the Swift data mount point and test that mounting works::
 
@@ -258,23 +258,23 @@ environment variable.
 
 * To mount the tmp loopback device at ``/tmp``, do the following::
 
-      sudo mount -o loop,noatime,nodiratime /srv/swift-tmp /tmp
+      sudo mount -o loop,noatime /srv/swift-tmp /tmp
       sudo chmod -R 1777 /tmp
 
   * To persist this, edit and add the following to ``/etc/fstab``::
 
-        /srv/swift-tmp /tmp xfs rw,noatime,nodiratime,attr2,inode64,noquota 0 0
+        /srv/swift-tmp /tmp xfs rw,noatime,attr2,inode64,noquota 0 0
 
 * To mount the tmp loopback at an alternate location (for example, ``/mnt/tmp``),
   do the following::
 
       sudo mkdir -p /mnt/tmp
-      sudo mount -o loop,noatime,nodiratime /srv/swift-tmp /mnt/tmp
+      sudo mount -o loop,noatime /srv/swift-tmp /mnt/tmp
       sudo chown ${USER}:${USER} /mnt/tmp
 
   * To persist this, edit and add the following to ``/etc/fstab``::
 
-        /srv/swift-tmp /mnt/tmp xfs rw,noatime,nodiratime,attr2,inode64,noquota 0 0
+        /srv/swift-tmp /mnt/tmp xfs rw,noatime,attr2,inode64,noquota 0 0
 
   * Set your ``TMPDIR`` environment dir so that Swift looks in the right location::
 
diff -pruN 2.25.0-2/doc/source/index.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/index.rst
--- 2.25.0-2/doc/source/index.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/index.rst	2020-07-06 17:03:50.000000000 +0000
@@ -66,6 +66,15 @@ Overview and Concepts
     ring_partpower
     associated_projects
 
+Contributor Documentation
+=========================
+
+.. toctree::
+    :maxdepth: 2
+
+    contributor/contributing
+    contributor/review_guidelines
+
 Developer Documentation
 =======================
 
diff -pruN 2.25.0-2/doc/source/install/storage-install-obs.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/install/storage-install-obs.rst
--- 2.25.0-2/doc/source/install/storage-install-obs.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/install/storage-install-obs.rst	2020-07-06 17:03:50.000000000 +0000
@@ -59,8 +59,8 @@ storage nodes, you must prepare the stor
 
    .. code-block:: none
 
-      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime,nodiratime,logbufs=8 0 2
-      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime,nodiratime,logbufs=8 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime 0 2
 
 #. Mount the devices:
 
diff -pruN 2.25.0-2/doc/source/install/storage-install-rdo.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/install/storage-install-rdo.rst
--- 2.25.0-2/doc/source/install/storage-install-rdo.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/install/storage-install-rdo.rst	2020-07-06 17:03:50.000000000 +0000
@@ -58,8 +58,8 @@ storage nodes, you must prepare the stor
 
    .. code-block:: none
 
-      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime,nodiratime,logbufs=8 0 2
-      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime,nodiratime,logbufs=8 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime 0 2
 
 #. Mount the devices:
 
diff -pruN 2.25.0-2/doc/source/install/storage-install-ubuntu-debian.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/install/storage-install-ubuntu-debian.rst
--- 2.25.0-2/doc/source/install/storage-install-ubuntu-debian.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/install/storage-install-ubuntu-debian.rst	2020-07-06 17:03:50.000000000 +0000
@@ -58,8 +58,8 @@ storage nodes, you must prepare the stor
 
    .. code-block:: none
 
-      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime,nodiratime,logbufs=8 0 2
-      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime,nodiratime,logbufs=8 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime 0 2
 
 #. Mount the devices:
 
diff -pruN 2.25.0-2/doc/source/s3_compat.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/s3_compat.rst
--- 2.25.0-2/doc/source/s3_compat.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/doc/source/s3_compat.rst	2020-07-06 17:03:50.000000000 +0000
@@ -60,8 +60,6 @@ Amazon S3 operations
 +------------------------------------------------+------------------+--------------+
 | `PUT Bucket acl`_                              | Core-API         | Yes          |
 +------------------------------------------------+------------------+--------------+
-| `Object tagging`_                              | Core-API         | Yes          |
-+------------------------------------------------+------------------+--------------+
 | `Versioning`_                                  | Versioning       | Yes          |
 +------------------------------------------------+------------------+--------------+
 | `Bucket notification`_                         | Notifications    | No           |
@@ -78,6 +76,8 @@ Amazon S3 operations
 +------------------------------------------------+------------------+--------------+
 | `Delete Multiple Objects`_                     | Advanced Feature | Yes          |
 +------------------------------------------------+------------------+--------------+
+| `Object tagging`_                              | Advanced Feature | No           |
++------------------------------------------------+------------------+--------------+
 | `GET Object torrent`_                          | Advanced Feature | No           |
 +------------------------------------------------+------------------+--------------+
 | `Bucket inventory`_                            | Advanced Feature | No           |
diff -pruN 2.25.0-2/docker/rootfs/etc/swift_build/build_devices 2.25.1~git2020070613.2e001431f-0ubuntu1/docker/rootfs/etc/swift_build/build_devices
--- 2.25.0-2/docker/rootfs/etc/swift_build/build_devices	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/docker/rootfs/etc/swift_build/build_devices	2020-07-06 17:03:50.000000000 +0000
@@ -56,7 +56,7 @@ if [[ $MY_STORAGE_TYPE == "internal_devi
     # echo "created storage device /dev/swift-d$i of $DEV_SIZE";
     mkfs.xfs -f -L D$i -i size=512 /dev/$device;
     echo "  created XFS file system on device /dev/$device";
-    mount -t xfs -o noatime,nodiratime,logbufs=8 /dev/$device /srv/node/$device;
+    mount -t xfs -o noatime /dev/$device /srv/node/$device;
     echo "  mounted /dev/$device as /srv/node/$device";
   done
 fi
diff -pruN 2.25.0-2/etc/proxy-server.conf-sample 2.25.1~git2020070613.2e001431f-0ubuntu1/etc/proxy-server.conf-sample
--- 2.25.0-2/etc/proxy-server.conf-sample	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/etc/proxy-server.conf-sample	2020-07-06 17:03:50.000000000 +0000
@@ -470,7 +470,10 @@ use = egg:swift#s3api
 # With either tempauth or your custom auth:
 # - Put s3api just before your auth filter(s) in the pipeline
 # With keystone:
-# - Put s3api and s3token before keystoneauth in the pipeline
+# - Put s3api and s3token before keystoneauth in the pipeline, but after
+#   auth_token
+# If you have ratelimit enabled for Swift requests, you may want to place a
+# second copy after auth to also ratelimit S3 requests.
 #
 # Swift has no concept of the S3's resource owner; the resources
 # (i.e. containers and objects) created via the Swift API have no owner
diff -pruN 2.25.0-2/.gitignore 2.25.1~git2020070613.2e001431f-0ubuntu1/.gitignore
--- 2.25.0-2/.gitignore	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/.gitignore	1970-01-01 00:00:00.000000000 +0000
@@ -1,25 +0,0 @@
-*.py[co]
-*.sw?
-*~
-doc/build/*
-dist
-build
-cover
-ChangeLog
-.coverage
-*.egg
-*.egg-info
-.eggs/*
-.DS_Store
-.tox
-pycscope.*
-.idea
-MANIFEST
-
-.testrepository/*
-.stestr/*
-subunit.log
-test/probe/.noseids
-RELEASENOTES.rst
-releasenotes/notes/reno.cache
-/tools/playbooks/**/*.retry
diff -pruN 2.25.0-2/.gitreview 2.25.1~git2020070613.2e001431f-0ubuntu1/.gitreview
--- 2.25.0-2/.gitreview	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/.gitreview	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-[gerrit]
-host=review.opendev.org
-port=29418
-project=openstack/swift.git
diff -pruN 2.25.0-2/lower-constraints.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/lower-constraints.txt
--- 2.25.0-2/lower-constraints.txt	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/lower-constraints.txt	2020-07-06 17:03:50.000000000 +0000
@@ -44,8 +44,6 @@ netifaces==0.8
 nose==1.3.7
 nosehtmloutput==0.0.3
 nosexcover==1.0.10
-openstackdocstheme==1.30.0
-os-api-ref==1.0.0
 os-testr==0.8.0
 oslo.config==4.0.0
 oslo.i18n==3.20.0
@@ -68,15 +66,12 @@ python-swiftclient==3.2.0
 python-openstackclient==3.12.0
 pytz==2018.3
 PyYAML==3.12
-reno==1.8.0
 requests==2.14.2
 requests-mock==1.2.0
 rfc3986==1.1.0
 six==1.10.0
 smmap2==2.0.3
 snowballstemmer==1.2.1
-Sphinx==1.6.2
-sphinxcontrib-websupport==1.0.1
 stestr==2.0.0
 stevedore==1.28.0
 testtools==2.3.0
diff -pruN 2.25.0-2/PKG-INFO 2.25.1~git2020070613.2e001431f-0ubuntu1/PKG-INFO
--- 2.25.0-2/PKG-INFO	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/PKG-INFO	2020-07-06 17:03:53.862100400 +0000
@@ -0,0 +1,188 @@
+Metadata-Version: 2.1
+Name: swift
+Version: 2.26.0.dev120
+Summary: OpenStack Object Storage
+Home-page: https://docs.openstack.org/swift/latest/
+Author: OpenStack
+Author-email: openstack-discuss@lists.openstack.org
+License: UNKNOWN
+Description: ===============
+        OpenStack Swift
+        ===============
+        
+        .. image:: https://governance.openstack.org/tc/badges/swift.svg
+            :target: https://governance.openstack.org/tc/reference/tags/index.html
+        
+        .. Change things from this point on
+        
+        OpenStack Swift is a distributed object storage system designed to scale
+        from a single machine to thousands of servers. Swift is optimized for
+        multi-tenancy and high concurrency. Swift is ideal for backups, web and mobile
+        content, and any other unstructured data that can grow without bound.
+        
+        Swift provides a simple, REST-based API fully documented at
+        https://docs.openstack.org/swift/latest/.
+        
+        Swift was originally developed as the basis for Rackspace's Cloud Files
+        and was open-sourced in 2010 as part of the OpenStack project. It has
+        since grown to include contributions from many companies and has spawned
+        a thriving ecosystem of 3rd party tools. Swift's contributors are listed
+        in the AUTHORS file.
+        
+        Docs
+        ----
+        
+        To build documentation run::
+        
+            pip install -r requirements.txt -r doc/requirements.txt
+            sphinx-build -W -b html doc/source doc/build/html
+        
+        and then browse to doc/build/html/index.html. These docs are auto-generated
+        after every commit and available online at
+        https://docs.openstack.org/swift/latest/.
+        
+        For Developers
+        --------------
+        
+        Getting Started
+        ~~~~~~~~~~~~~~~
+        
+        Swift is part of OpenStack and follows the code contribution, review, and
+        testing processes common to all OpenStack projects.
+        
+        If you would like to start contributing, check out these
+        `notes <CONTRIBUTING.rst>`__ to help you get started.
+        
+        The best place to get started is the
+        `"SAIO - Swift All In One" <https://docs.openstack.org/swift/latest/development_saio.html>`__.
+        This document will walk you through setting up a development cluster of
+        Swift in a VM. The SAIO environment is ideal for running small-scale
+        tests against Swift and trying out new features and bug fixes.
+        
+        Tests
+        ~~~~~
+        
+        There are three types of tests included in Swift's source tree.
+        
+        #. Unit tests
+        #. Functional tests
+        #. Probe tests
+        
+        Unit tests check that small sections of the code behave properly. For example,
+        a unit test may test a single function to ensure that various input gives the
+        expected output. This validates that the code is correct and regressions are
+        not introduced.
+        
+        Functional tests check that the client API is working as expected. These can
+        be run against any endpoint claiming to support the Swift API (although some
+        tests require multiple accounts with different privilege levels). These are
+        "black box" tests that ensure that client apps written against Swift will
+        continue to work.
+        
+        Probe tests are "white box" tests that validate the internal workings of a
+        Swift cluster. They are written to work against the
+        `"SAIO - Swift All In One" <https://docs.openstack.org/swift/latest/development_saio.html>`__
+        dev environment. For example, a probe test may create an object, delete one
+        replica, and ensure that the background consistency processes find and correct
+        the error.
+        
+        You can run unit tests with ``.unittests``, functional tests with
+        ``.functests``, and probe tests with ``.probetests``. There is an
+        additional ``.alltests`` script that wraps the other three.
+        
+        To fully run the tests, the target environment must use a filesystem that
+        supports large xattrs. XFS is strongly recommended. For unit tests and in-
+        process functional tests, either mount ``/tmp`` with XFS or provide another
+        XFS filesystem via the ``TMPDIR`` environment variable. Without this setting,
+        tests should still pass, but a very large number will be skipped.
+        
+        Code Organization
+        ~~~~~~~~~~~~~~~~~
+        
+        -  bin/: Executable scripts that are the processes run by the deployer
+        -  doc/: Documentation
+        -  etc/: Sample config files
+        -  examples/: Config snippets used in the docs
+        -  swift/: Core code
+        
+           -  account/: account server
+           -  cli/: code that backs some of the CLI tools in bin/
+           -  common/: code shared by different modules
+        
+              -  middleware/: "standard", officially-supported middleware
+              -  ring/: code implementing Swift's ring
+        
+           -  container/: container server
+           -  locale/: internationalization (translation) data
+           -  obj/: object server
+           -  proxy/: proxy server
+        
+        -  test/: Unit, functional, and probe tests
+        
+        Data Flow
+        ~~~~~~~~~
+        
+        Swift is a WSGI application and uses eventlet's WSGI server. After the
+        processes are running, the entry point for new requests is the
+        ``Application`` class in ``swift/proxy/server.py``. From there, a
+        controller is chosen, and the request is processed. The proxy may choose
+        to forward the request to a back-end server. For example, the entry
+        point for requests to the object server is the ``ObjectController``
+        class in ``swift/obj/server.py``.
+        
+        For Deployers
+        -------------
+        
+        Deployer docs are also available at
+        https://docs.openstack.org/swift/latest/. A good starting point is at
+        https://docs.openstack.org/swift/latest/deployment_guide.html
+        There is an `ops runbook <https://docs.openstack.org/swift/latest/ops_runbook/index.html>`__
+        that gives information about how to diagnose and troubleshoot common issues
+        when running a Swift cluster.
+        
+        You can run functional tests against a Swift cluster with
+        ``.functests``. These functional tests require ``/etc/swift/test.conf``
+        to run. A sample config file can be found in this source tree in
+        ``test/sample.conf``.
+        
+        For Client Apps
+        ---------------
+        
+        For client applications, official Python language bindings are provided
+        at https://github.com/openstack/python-swiftclient.
+        
+        Complete API documentation at
+        https://docs.openstack.org/api-ref/object-store/
+        
+        There is a large ecosystem of applications and libraries that support and
+        work with OpenStack Swift. Several are listed on the
+        `associated projects <https://docs.openstack.org/swift/latest/associated_projects.html>`__
+        page.
+        
+        --------------
+        
+        For more information come hang out in #openstack-swift on freenode.
+        
+        Thanks,
+        
+        The Swift Development Team
+        
+        
+Platform: UNKNOWN
+Classifier: Development Status :: 5 - Production/Stable
+Classifier: Environment :: OpenStack
+Classifier: Intended Audience :: Information Technology
+Classifier: Intended Audience :: System Administrators
+Classifier: License :: OSI Approved :: Apache Software License
+Classifier: Operating System :: POSIX :: Linux
+Classifier: Programming Language :: Python
+Classifier: Programming Language :: Python :: 2
+Classifier: Programming Language :: Python :: 2.7
+Classifier: Programming Language :: Python :: 3
+Classifier: Programming Language :: Python :: 3.6
+Classifier: Programming Language :: Python :: 3.7
+Classifier: Programming Language :: Python :: 3.8
+Provides-Extra: keystone
+Provides-Extra: kmip_keymaster
+Provides-Extra: kms_keymaster
+Provides-Extra: test
diff -pruN 2.25.0-2/py2-constraints.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/py2-constraints.txt
--- 2.25.0-2/py2-constraints.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/py2-constraints.txt	2020-07-06 17:03:50.000000000 +0000
@@ -0,0 +1,72 @@
+voluptuous===0.11.7
+chardet===3.0.4
+enum-compat===0.0.3
+os-api-ref===1.6.2
+lxml===4.5.0
+certifi===2020.4.5.1
+alabaster===0.7.12
+pbr===5.4.5
+oslo.i18n===3.25.1
+fixtures===3.0.0
+nose===1.3.7
+nosehtmloutput===0.0.7
+sphinxcontrib-websupport===1.1.2
+ipaddress===1.0.23
+nosexcover===1.0.11
+debtcollector===1.22.0
+MarkupSafe===1.1.1
+netaddr===0.7.19
+prettytable===0.7.2
+traceback2===1.4.0
+eventlet===0.25.2
+extras===1.0.0
+reno===2.11.3
+imagesize===1.2.0
+urllib3===1.25.8
+mock===3.0.5
+PyYAML===5.3.1
+cryptography===2.9
+requests-mock===1.7.0
+unittest2===1.1.0
+Pygments===2.5.2
+requests===2.23.0
+snowballstemmer===2.0.0
+Jinja2===2.11.1
+cliff===2.18.0
+castellan===1.4.0
+coverage===5.0.4
+oslo.log===3.45.2
+docutils===0.15.2
+boto3===1.12.39
+stestr===2.6.0
+oslo.serialization===2.29.2
+testtools===2.4.0
+keystonemiddleware===9.0.0
+iso8601===0.1.12
+linecache2===1.0.0
+idna===2.9
+msgpack===0.6.2
+Sphinx===1.8.5
+oslo.config===7.0.0
+openstackdocstheme===1.31.2
+stevedore===1.32.0
+botocore===1.15.39
+cmd2===0.8.9
+os-testr===1.1.0
+xattr===0.9.7
+six===1.14.0
+dulwich===0.19.15
+GitPython===2.1.11
+wrapt===1.12.1
+rfc3986===1.4.0
+future===0.18.2
+boto===2.49.0
+monotonic===1.5
+netifaces===0.10.9
+keystoneauth1===4.0.0
+cffi===1.14.0
+Babel===2.8.0
+greenlet===0.4.15
+oslo.utils===3.42.1
+gitdb===0.6.4
+gitdb2===2.0.6
diff -pruN 2.25.0-2/releasenotes/source/conf.py 2.25.1~git2020070613.2e001431f-0ubuntu1/releasenotes/source/conf.py
--- 2.25.0-2/releasenotes/source/conf.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/releasenotes/source/conf.py	2020-07-06 17:03:50.000000000 +0000
@@ -116,7 +116,7 @@ exclude_patterns = ['_build', 'Thumbs.db
 # show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = 'native'
 
 # A list of ignored prefixes for module index sorting.
 # modindex_common_prefix = []
@@ -174,11 +174,6 @@ html_theme = 'openstackdocs'
 #
 # html_extra_path = []
 
-# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
-# using the given strftime format.
-# html_last_updated_fmt = '%b %d, %Y'
-html_last_updated_fmt = '%Y-%m-%d %H:%M'
-
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
 #
@@ -352,6 +347,7 @@ htmlhelp_basename = 'SwiftReleaseNotesdo
 locale_dirs = ['locale/']
 
 # -- Options for openstackdocstheme -------------------------------------------
-repository_name = 'openstack/swift'
-bug_project = 'swift'
-bug_tag = ''
+openstackdocs_repo_name = 'openstack/swift'
+openstackdocs_auto_name = False
+openstackdocs_bug_project = 'swift'
+openstackdocs_bug_tag = ''
diff -pruN 2.25.0-2/releasenotes/source/index.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/releasenotes/source/index.rst
--- 2.25.0-2/releasenotes/source/index.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/releasenotes/source/index.rst	2020-07-06 17:03:50.000000000 +0000
@@ -7,6 +7,8 @@
 
    current
 
+   ussuri
+
    train
 
    stein
diff -pruN 2.25.0-2/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po 2.25.1~git2020070613.2e001431f-0ubuntu1/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po
--- 2.25.0-2/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po	2020-07-06 17:03:50.000000000 +0000
@@ -5,11 +5,11 @@ msgid ""
 msgstr ""
 "Project-Id-Version: swift\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2020-04-14 13:23+0000\n"
+"POT-Creation-Date: 2020-05-27 04:38+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"PO-Revision-Date: 2020-04-16 12:48+0000\n"
+"PO-Revision-Date: 2020-05-26 11:24+0000\n"
 "Last-Translator: Andi Chandler <andi@gowling.com>\n"
 "Language-Team: English (United Kingdom)\n"
 "Language: en_GB\n"
@@ -112,6 +112,9 @@ msgstr "2.23.1"
 msgid "2.24.0"
 msgstr "2.24.0"
 
+msgid "2.25.0"
+msgstr "2.25.0"
+
 msgid ""
 "A PUT or POST to a container will now update the container's Last-Modified "
 "time, and that value will be included in a GET/HEAD response."
@@ -156,6 +159,9 @@ msgstr ""
 "Account and container replication stats logs now include ``remote_merges``, "
 "the number of times a whole database was sent to another node."
 
+msgid "Account quotas are now enforced even on empty accounts."
+msgstr "Account quotas are now enforced even on empty accounts."
+
 msgid "Add Composite Ring Functionality"
 msgstr "Add Composite Ring Functionality"
 
@@ -239,6 +245,19 @@ msgstr ""
 "setting to enable or disable this functionality."
 
 msgid ""
+"Add support for multiple root encryption secrets for the trivial and KMIP "
+"keymasters. This allows operators to rotate encryption keys over time "
+"without needing to re-encrypt all existing data in the cluster. Please see "
+"the included sample config files for instructions on how to multiple "
+"encryption keys."
+msgstr ""
+"Add support for multiple root encryption secrets for the trivial and KMIP "
+"keymasters. This allows operators to rotate encryption keys over time "
+"without needing to re-encrypt all existing data in the cluster. Please see "
+"the included sample config files for instructions on how to multiple "
+"encryption keys."
+
+msgid ""
 "Add support to increase object ring partition power transparently to end "
 "users and with no cluster downtime. Increasing the ring part power allows "
 "for incremental adjustment to the upper bound of the cluster size. Please "
@@ -261,6 +280,19 @@ msgstr ""
 "locations more quickly. This helps when adding capacity to a ring."
 
 msgid ""
+"Added \"static symlinks\", which perform some validation as they follow "
+"redirects and include more information about their target in container "
+"listings. For more information, see the `symlink middleware <https://docs."
+"openstack.org/swift/latest/middleware.html#symlink>`__ section of the "
+"documentation."
+msgstr ""
+"Added \"static symlinks\", which perform some validation as they follow "
+"redirects and include more information about their target in container "
+"listings. For more information, see the `symlink middleware <https://docs."
+"openstack.org/swift/latest/middleware.html#symlink>`__ section of the "
+"documentation."
+
+msgid ""
 "Added ``--swift-versions`` to ``swift-recon`` CLI to compare installed "
 "versions in the cluster."
 msgstr ""
@@ -271,6 +303,15 @@ msgid "Added ``-d <devs>`` and ``-p <par
 msgstr "Added ``-d <devs>`` and ``-p <partitions>`` command line options."
 
 msgid ""
+"Added ``ttfb`` (Time to First Byte) and ``pid`` (Process ID) to the set of "
+"available proxy-server log fields. For more information, see `the "
+"documentation <https://docs.openstack.org/swift/latest/logs.html>`__."
+msgstr ""
+"Added ``ttfb`` (Time to First Byte) and ``pid`` (Process ID) to the set of "
+"available proxy-server log fields. For more information, see `the "
+"documentation <https://docs.openstack.org/swift/latest/logs.html>`__."
+
+msgid ""
 "Added a \"user\" option to the drive-audit config file. Its value is used to "
 "set the owner of the drive-audit recon cache."
 msgstr ""
@@ -278,6 +319,13 @@ msgstr ""
 "set the owner of the drive-audit recon cache."
 
 msgid ""
+"Added a ``keep_idle`` config option to configure KEEPIDLE time for TCP "
+"sockets. The default value is the old constant of 600."
+msgstr ""
+"Added a ``keep_idle`` config option to configure KEEPIDLE time for TCP "
+"sockets. The default value is the old constant of 600."
+
+msgid ""
 "Added a configurable URL base to staticweb, fixing issues when the "
 "accessible endpoint isn't known to the Swift cluster (eg http vs https)."
 msgstr ""
@@ -291,6 +339,66 @@ msgid "Added a handoffs-only mode."
 msgstr "Added a handoffs-only mode."
 
 msgid ""
+"Added a new middleware that allows users and operators to configure accounts "
+"and containers to use RFC-compliant (i.e., double-quoted) ETags. This may be "
+"useful when using Swift as an origin for some content delivery networks. For "
+"more information, see `the middleware documentation <https://docs.openstack."
+"org/swift/latest/middleware.html#etag-quoter>`__."
+msgstr ""
+"Added a new middleware that allows users and operators to configure accounts "
+"and containers to use RFC-compliant (i.e., double-quoted) ETags. This may be "
+"useful when using Swift as an origin for some content delivery networks. For "
+"more information, see `the middleware documentation <https://docs.openstack."
+"org/swift/latest/middleware.html#etag-quoter>`__."
+
+msgid ""
+"Added a new middleware to allow accounts and containers to opt-in to RFC-"
+"compliant ETags. For more information, see `the documentation <https://docs."
+"openstack.org/swift/latest/middleware.html#module-swift.common.middleware."
+"etag_quoter>`__. Clients should be aware of the fact that ETags may be "
+"quoted for RFC compliance; this may become the default behavior in some "
+"future release."
+msgstr ""
+"Added a new middleware to allow accounts and containers to opt-in to RFC-"
+"compliant ETags. For more information, see `the documentation <https://docs."
+"openstack.org/swift/latest/middleware.html#module-swift.common.middleware."
+"etag_quoter>`__. Clients should be aware of the fact that ETags may be "
+"quoted for RFC compliance; this may become the default behaviour in some "
+"future release."
+
+msgid ""
+"Added a new object versioning mode, with APIs for querying and accessing old "
+"versions. For more information, see `the documentation <https://docs."
+"openstack.org/swift/latest/middleware.html#module-swift.common.middleware."
+"versioned_writes.object_versioning>`__."
+msgstr ""
+"Added a new object versioning mode, with APIs for querying and accessing old "
+"versions. For more information, see `the documentation <https://docs."
+"openstack.org/swift/latest/middleware.html#module-swift.common.middleware."
+"versioned_writes.object_versioning>`__."
+
+msgid ""
+"Added an experimental ``swift-ring-composer`` CLI tool to build composite "
+"rings."
+msgstr ""
+"Added an experimental ``swift-ring-composer`` CLI tool to build composite "
+"rings."
+
+msgid ""
+"Added an operator tool, ``swift-container-deleter``, to asynchronously "
+"delete some or all objects in a container using the object expirers."
+msgstr ""
+"Added an operator tool, ``swift-container-deleter``, to asynchronously "
+"delete some or all objects in a container using the object expirers."
+
+msgid ""
+"Added an optional ``read_only`` middleware to make an entire cluster or "
+"individual accounts read only."
+msgstr ""
+"Added an optional ``read_only`` middleware to make an entire cluster or "
+"individual accounts read only."
+
+msgid ""
 "Added container sharding, an operator controlled feature that may be used to "
 "shard very large container databases into a number of smaller shard "
 "containers. This mitigates the issues with one large DB by distributing the "
@@ -308,6 +416,12 @@ msgstr ""
 msgid "Added container/object listing with prefix to InternalClient."
 msgstr "Added container/object listing with prefix to InternalClient."
 
+msgid "Added support for Python 3.8."
+msgstr "Added support for Python 3.8."
+
+msgid "Added support for S3 versioning using the above new mode."
+msgstr "Added support for S3 versioning using the above new mode."
+
 msgid "Added support for inline data segments in SLO manifests."
 msgstr "Added support for inline data segments in SLO manifests."
 
@@ -347,19 +461,46 @@ msgstr ""
 "unsatisfied-range value. This allows the caller to know the valid range "
 "request value for an object."
 
+msgid "Allow ``fallocate_reserve`` to be specified as a percentage."
+msgstr "Allow ``fallocate_reserve`` to be specified as a percentage."
+
+msgid "Allow direct_client users to overwrite the ``X-Timestamp`` header."
+msgstr "Allow direct_client users to overwrite the ``X-Timestamp`` header."
+
 msgid "Allow the expirer to gracefully move past updating stale work items."
 msgstr "Allow the expirer to gracefully move past updating stale work items."
 
 msgid "Always set Swift processes to use UTC."
 msgstr "Always set Swift processes to use UTC."
 
+msgid "Background corruption-detection improvements"
+msgstr "Background corruption-detection improvements"
+
 msgid "Bug Fixes"
 msgstr "Bug Fixes"
 
+msgid "COPY now works with unicode account names."
+msgstr "COPY now works with Unicode account names."
+
 msgid "Cache all answers from nameservers in cname_lookup."
 msgstr "Cache all answers from nameservers in cname_lookup."
 
 msgid ""
+"Change the behavior of the EC reconstructor to perform a fragment rebuild to "
+"a handoff node when a primary peer responds with 507 to the REPLICATE "
+"request. This changes EC to match the existing behavior of replication when "
+"drives fail. After a rebalance of EC rings (potentially removing unmounted/"
+"failed devices), it's most IO efficient to run in handoffs_only mode to "
+"avoid unnecessary rebuilds."
+msgstr ""
+"Change the behaviour of the EC reconstructor to perform a fragment rebuild "
+"to a handoff node when a primary peer responds with 507 to the REPLICATE "
+"request. This changes EC to match the existing behaviour of replication when "
+"drives fail. After a rebalance of EC rings (potentially removing unmounted/"
+"failed devices), it's most IO efficient to run in handoffs_only mode to "
+"avoid unnecessary rebuilds."
+
+msgid ""
 "Changed where liberasurecode-devel for CentOS 7 is referenced and installed "
 "as a dependency."
 msgstr ""
@@ -395,6 +536,9 @@ msgstr ""
 "fragment metadata will now be validated when read and, if bad data is found, "
 "the fragment will be quarantined."
 
+msgid "CompleteMultipartUpload requests with a ``Content-MD5`` now work."
+msgstr "CompleteMultipartUpload requests with a ``Content-MD5`` now work."
+
 msgid ""
 "Composite rings can be used for explicit replica placement and \"replicated "
 "EC\" for global erasure codes policies."
@@ -414,6 +558,11 @@ msgstr ""
 "moved in multiple components."
 
 msgid ""
+"Container metadata related to sharding are now removed when no longer needed."
+msgstr ""
+"Container metadata related to sharding are now removed when no longer needed."
+
+msgid ""
 "Container sync can now copy SLOs more efficiently by allowing the manifest "
 "to be synced before all of the referenced segments. This fixes a bug where "
 "container sync would not copy SLO manifests."
@@ -422,6 +571,13 @@ msgstr ""
 "to be synced before all of the referenced segments. This fixes a bug where "
 "container sync would not copy SLO manifests."
 
+msgid ""
+"Container sync now synchronizes static symlinks in a way similar to static "
+"large objects."
+msgstr ""
+"Container sync now synchronizes static symlinks in a way similar to static "
+"large objects."
+
 msgid "Correctly handle deleted files with if-none-match requests."
 msgstr "Correctly handle deleted files with if-none-match requests."
 
@@ -432,9 +588,19 @@ msgstr ""
 "Correctly send 412 Precondition Failed if a user sends an invalid copy "
 "destination. Previously Swift would send a 500 Internal Server Error."
 
+msgid "Correctness improvements"
+msgstr "Correctness improvements"
+
 msgid "Critical Issues"
 msgstr "Critical Issues"
 
+msgid ""
+"Cross-account symlinks now store correct account information in container "
+"listings. This was previously fixed in 2.22.0."
+msgstr ""
+"Cross-account symlinks now store correct account information in container "
+"listings. This was previously fixed in 2.22.0."
+
 msgid "Current (Unreleased) Release Notes"
 msgstr "Current (Unreleased) Release Notes"
 
@@ -452,6 +618,9 @@ msgstr ""
 msgid "Daemons using InternalClient can now be properly killed with SIGTERM."
 msgstr "Daemons using InternalClient can now be properly killed with SIGTERM."
 
+msgid "Data encryption updates"
+msgstr "Data encryption updates"
+
 msgid ""
 "Deleting an expiring object will now cause less work in the system. The "
 "number of async pending files written has been reduced for all objects and "
@@ -464,6 +633,15 @@ msgstr ""
 "burden on container servers."
 
 msgid ""
+"Deployers with clusters that relied on the old implicit default location of "
+"\"US\" should explicitly set ``location = US`` in the ``[filter:s3api]`` "
+"section of proxy-server.conf before upgrading."
+msgstr ""
+"Deployers with clusters that relied on the old implicit default location of "
+"\"US\" should explicitly set ``location = US`` in the ``[filter:s3api]`` "
+"section of proxy-server.conf before upgrading."
+
+msgid ""
 "Deprecate swift-temp-url and call python-swiftclient's implementation "
 "instead. This adds python-swiftclient as an optional dependency of Swift."
 msgstr ""
@@ -473,9 +651,24 @@ msgstr ""
 msgid "Deprecation Notes"
 msgstr "Deprecation Notes"
 
+msgid "Detect and remove invalid entries from ``hashes.pkl``"
+msgstr "Detect and remove invalid entries from ``hashes.pkl``"
+
+msgid ""
+"Device region and zone can now be changed via ``swift-ring-builder``. Note "
+"that this may cause a lot of data movement on the next rebalance as the "
+"builder tries to reach full dispersion."
+msgstr ""
+"Device region and zone can now be changed via ``swift-ring-builder``. Note "
+"that this may cause a lot of data movement on the next rebalance as the "
+"builder tries to reach full dispersion."
+
 msgid "Disallow X-Delete-At header values equal to the X-Timestamp header."
 msgstr "Disallow X-Delete-At header values equal to the X-Timestamp header."
 
+msgid "Display crypto data/metadata details in swift-object-info."
+msgstr "Display crypto data/metadata details in swift-object-info."
+
 msgid "Display more info on empty rings."
 msgstr "Display more info on empty rings."
 
@@ -563,6 +756,15 @@ msgid "Fix SLO delete for accounts with
 msgstr "Fix SLO delete for accounts with non-ASCII names."
 
 msgid ""
+"Fixed 500 from cname_lookup middleware. Previously, if the looked-up domain "
+"was used by domain_remap to update the request path, the server would "
+"respond Internal Error."
+msgstr ""
+"Fixed 500 from cname_lookup middleware. Previously, if the looked-up domain "
+"was used by domain_remap to update the request path, the server would "
+"respond Internal Error."
+
+msgid ""
 "Fixed UnicodeDecodeError in the object reconstructor that would prevent "
 "objects with non-ascii names from being reconstructed and caused the "
 "reconstructor process to hang."
@@ -603,6 +805,13 @@ msgstr ""
 "only requested if the sync request was successful."
 
 msgid ""
+"Fixed a bug in the new object versioning API that would cause more than "
+"``limit`` results to be returned when listing."
+msgstr ""
+"Fixed a bug in the new object versioning API that would cause more than "
+"``limit`` results to be returned when listing."
+
+msgid ""
 "Fixed a bug introduced in 2.15.0 where the object reconstructor would exit "
 "with a traceback if no EC policy was configured."
 msgstr ""
@@ -627,6 +836,13 @@ msgstr ""
 "a 5xx series response."
 
 msgid ""
+"Fixed a bug where encryption would store the incorrect key metadata if the "
+"object name starts with a slash."
+msgstr ""
+"Fixed a bug where encryption would store the incorrect key metadata if the "
+"object name starts with a slash."
+
+msgid ""
 "Fixed a bug where some headers weren't being copied correctly in a COPY "
 "request."
 msgstr ""
@@ -643,6 +859,22 @@ msgstr ""
 "Fixed a bug where the ring builder would not allow removal of a device when "
 "min_part_seconds_left was greater than zero."
 
+msgid ""
+"Fixed a bug where zero-byte PUTs would not work properly with \"If-None-"
+"Match: \\*\" conditional requests."
+msgstr ""
+"Fixed a bug where zero-byte PUTs would not work properly with \"If-None-"
+"Match: \\*\" conditional requests."
+
+msgid ""
+"Fixed a cache invalidation issue related to GET and PUT requests to "
+"containers that would occasionally cause object PUTs to a container to 404 "
+"after the container had been successfully created."
+msgstr ""
+"Fixed a cache invalidation issue related to GET and PUT requests to "
+"containers that would occasionally cause object PUTs to a container to 404 "
+"after the container had been successfully created."
+
 msgid "Fixed a few areas where the ``swiftdir`` option was not respected."
 msgstr "Fixed a few areas where the ``swiftdir`` option was not respected."
 
@@ -668,16 +900,114 @@ msgid "Fixed a socket leak in copy middl
 msgstr "Fixed a socket leak in copy middleware when a large object was copied."
 
 msgid ""
+"Fixed an issue in COPY where concurrent requests may have copied the wrong "
+"data."
+msgstr ""
+"Fixed an issue in COPY where concurrent requests may have copied the wrong "
+"data."
+
+msgid ""
+"Fixed an issue that caused Delete Multiple Objects requests with large "
+"bodies to 400. This was previously fixed in 2.20.0."
+msgstr ""
+"Fixed an issue that caused Delete Multiple Objects requests with large "
+"bodies to 400. This was previously fixed in 2.20.0."
+
+msgid ""
+"Fixed an issue where S3 API v4 signatures would not be validated against the "
+"body of the request, allowing a replay attack if request headers were "
+"captured by a malicious third party."
+msgstr ""
+"Fixed an issue where S3 API v4 signatures would not be validated against the "
+"body of the request, allowing a replay attack if request headers were "
+"captured by a malicious third party."
+
+msgid ""
+"Fixed an issue where a failed drive could prevent the container sharder from "
+"making progress."
+msgstr ""
+"Fixed an issue where a failed drive could prevent the container sharder from "
+"making progress."
+
+msgid ""
+"Fixed an issue where an object server failure during a client download could "
+"leave an open socket between the proxy and client."
+msgstr ""
+"Fixed an issue where an object server failure during a client download could "
+"leave an open socket between the proxy and client."
+
+msgid ""
 "Fixed an issue where background consistency daemon child processes would "
 "deadlock waiting on the same file descriptor."
 msgstr ""
 "Fixed an issue where background consistency daemon child processes would "
 "deadlock waiting on the same file descriptor."
 
+msgid ""
+"Fixed an issue where deleted EC objects didn't have their on-disk "
+"directories cleaned up. This would cause extra resource usage on the object "
+"servers."
+msgstr ""
+"Fixed an issue where deleted EC objects didn't have their on-disk "
+"directories cleaned up. This would cause extra resource usage on the object "
+"servers."
+
+msgid ""
+"Fixed an issue where multipart uploads with the S3 API would sometimes "
+"report an error despite all segments being upload successfully."
+msgstr ""
+"Fixed an issue where multipart uploads with the S3 API would sometimes "
+"report an error despite all segments being upload successfully."
+
+msgid ""
+"Fixed an issue where non-ASCII Keystone EC2 credentials would not get mapped "
+"to the correct account. This was previously fixed in 2.20.0."
+msgstr ""
+"Fixed an issue where non-ASCII Keystone EC2 credentials would not get mapped "
+"to the correct account. This was previously fixed in 2.20.0."
+
+msgid ""
+"Fixed an issue where v4 signatures would not be validated against the body "
+"of the request, allowing a replay attack if request headers were captured by "
+"a malicious third party. Note that unsigned payloads still function normally."
+msgstr ""
+"Fixed an issue where v4 signatures would not be validated against the body "
+"of the request, allowing a replay attack if request headers were captured by "
+"a malicious third party. Note that unsigned payloads still function normally."
+
+msgid ""
+"Fixed an issue with SSYNC requests to ensure that only one request can be "
+"running on a partition at a time."
+msgstr ""
+"Fixed an issue with SSYNC requests to ensure that only one request can be "
+"running on a partition at a time."
+
+msgid ""
+"Fixed an issue with multi-region EC policies that caused the EC "
+"reconstructor to constantly attempt cross-region rebuild traffic."
+msgstr ""
+"Fixed an issue with multi-region EC policies that caused the EC "
+"reconstructor to constantly attempt cross-region rebuild traffic."
+
 msgid "Fixed deadlock when logging from a tpool thread."
 msgstr "Fixed deadlock when logging from a tpool thread."
 
 msgid ""
+"Fixed deadlock when logging from a tpool thread. The object server runs "
+"certain IO-intensive methods outside the main pthread for performance. "
+"Previously, if one of those methods tried to log, this can cause a crash "
+"that eventually leads to an object server with hundreds or thousands of "
+"greenthreads, all deadlocked. The fix is to use a mutex that works across "
+"different greenlets and different pthreads."
+msgstr ""
+"Fixed deadlock when logging from a tpool thread. The object server runs "
+"certain IO-intensive methods outside the main pthread for performance. "
+"Previously, if one of those methods tried to log, this can cause a crash "
+"that eventually leads to an object server with hundreds or thousands of "
+"greenthreads, all deadlocked. The fix is to use a mutex that works across "
+"different greenlets and different pthreads."
+
+msgid ""
 "Fixed encoding issue in ssync where a mix of ascii and non-ascii metadata "
 "values would cause an error."
 msgstr ""
@@ -696,6 +1026,19 @@ msgstr ""
 "drive space used and filling the cluster."
 
 msgid ""
+"Fixed issue where bulk requests using xml and expect 100-continue would "
+"return a malformed HTTP response."
+msgstr ""
+"Fixed issue where bulk requests using XML and expect 100-continue would "
+"return a malformed HTTP response."
+
+msgid "Fixed listings for sharded containers."
+msgstr "Fixed listings for sharded containers."
+
+msgid "Fixed non-ASCII account metadata handling."
+msgstr "Fixed non-ASCII account metadata handling."
+
+msgid ""
 "Fixed non-deterministic suffix updates in hashes.pkl where a partition may "
 "be updated much less often than expected."
 msgstr ""
@@ -730,17 +1073,26 @@ msgstr ""
 msgid "Fixed some minor test compatibility issues."
 msgstr "Fixed some minor test compatibility issues."
 
+msgid "Fixed some title-casing of headers."
+msgstr "Fixed some title-casing of headers."
+
 msgid "Fixed the KeyError message when auditor finds an expired object."
 msgstr "Fixed the KeyError message when auditor finds an expired object."
 
 msgid "Fixed the stats calculation in the erasure code reconstructor."
 msgstr "Fixed the stats calculation in the erasure code reconstructor."
 
+msgid "Fixed time skew when using X-Delete-After."
+msgstr "Fixed time skew when using X-Delete-After."
+
 msgid ""
 "Fixed using ``swift-ring-builder set_weight`` with more than one device."
 msgstr ""
 "Fixed using ``swift-ring-builder set_weight`` with more than one device."
 
+msgid "Fixed v1 listings that end with a non-ASCII object name."
+msgstr "Fixed v1 listings that end with a non-ASCII object name."
+
 msgid ""
 "For further information see the `docs <https://docs.openstack.org/swift/"
 "latest/overview_ring.html#module-swift.common.ring.composite_builder>`__"
@@ -748,6 +1100,23 @@ msgstr ""
 "For further information see the `docs <https://docs.openstack.org/swift/"
 "latest/overview_ring.html#module-swift.common.ring.composite_builder>`__"
 
+msgid ""
+"For new multipart-uploads via the S3 API, the ETag that is stored will be "
+"calculated in the same way that AWS uses. This ETag will be used in GET/HEAD "
+"responses, bucket listings, and conditional requests via the S3 API. "
+"Accessing the same object via the Swift API will use the SLO Etag; however, "
+"in JSON container listings the multipart upload etag will be exposed in a "
+"new \"s3_etag\" key. Previously, some S3 clients would complain about "
+"download corruption when the ETag did not have a '-'."
+msgstr ""
+"For new multipart-uploads via the S3 API, the ETag that is stored will be "
+"calculated in the same way that AWS uses. This ETag will be used in GET/HEAD "
+"responses, bucket listings, and conditional requests via the S3 API. "
+"Accessing the same object via the Swift API will use the SLO Etag; however, "
+"in JSON container listings the multipart upload etag will be exposed in a "
+"new \"s3_etag\" key. Previously, some S3 clients would complain about "
+"download corruption when the ETag did not have a '-'."
+
 msgid "Fractional replicas are no longer allowed for erasure code policies."
 msgstr "Fractional replicas are no longer allowed for erasure code policies."
 
@@ -764,6 +1133,15 @@ msgstr ""
 "forwarded to the referenced object. POST requests sent to a symlink will "
 "result in a 307 Temporary Redirect response."
 
+msgid ""
+"Getting an SLO manifest with ``?format=raw`` now responds with an ETag that "
+"matches the MD5 of the generated body rather than the MD5 of the manifest "
+"stored on disk."
+msgstr ""
+"Getting an SLO manifest with ``?format=raw`` now responds with an ETag that "
+"matches the MD5 of the generated body rather than the MD5 of the manifest "
+"stored on disk."
+
 msgid "I/O priority is now supported on AArch64 architecture."
 msgstr "I/O priority is now supported on AArch64 architecture."
 
@@ -776,6 +1154,9 @@ msgstr ""
 "create fails, it will now return a server error (500) instead of Not Found "
 "(404)."
 
+msgid "If running Swift under Python 3, ``eventlet`` must be at least 0.25.0."
+msgstr "If running Swift under Python 3, ``eventlet`` must be at least 0.25.0."
+
 msgid ""
 "If using erasure coding with ISA-L in rs_vand mode and 5 or more parity "
 "fragments, Swift will emit a warning. This is a configuration that is known "
@@ -793,12 +1174,28 @@ msgstr ""
 "be migrated as soon as possible. Please see https://bugs.launchpad.net/swift/"
 "+bug/1639691 for more information."
 
+msgid "If you have a config file like this::"
+msgstr "If you have a config file like this::"
+
 msgid "If you upgrade and roll back, you must delete all `hashes.pkl` files."
 msgstr "If you upgrade and roll back, you must delete all `hashes.pkl` files."
 
+msgid "If you want updates to be processed exactly as before, do this::"
+msgstr "If you want updates to be processed exactly as before, do this::"
+
+msgid ""
+"If you've been testing Swift on Python 3, upgrade at your earliest "
+"convenience."
+msgstr ""
+"If you've been testing Swift on Python 3, upgrade at your earliest "
+"convenience."
+
 msgid "Imported docs content from openstack-manuals project."
 msgstr "Imported docs content from openstack-manuals project."
 
+msgid "Improved S3 API compatibility."
+msgstr "Improved S3 API compatibility."
+
 msgid ""
 "Improved ``object-updater`` stats logging. It now tells you all of its stats "
 "(successes, failures, quarantines due to bad pickles, unlinks, and errors), "
@@ -811,11 +1208,35 @@ msgstr ""
 "end of a pass remains and has been expanded to also include all stats."
 
 msgid ""
+"Improved container-sync performance when data has already been deleted or "
+"overwritten."
+msgstr ""
+"Improved container-sync performance when data has already been deleted or "
+"overwritten."
+
+msgid ""
 "Improved performance by eliminating an unneeded directory structure hash."
 msgstr ""
 "Improved performance by eliminating an unneeded directory structure hash."
 
 msgid ""
+"Improved performance of sharded container listings when performing prefix "
+"listings."
+msgstr ""
+"Improved performance of sharded container listings when performing prefix "
+"listings."
+
+msgid ""
+"Improved proxy-server performance by reducing unnecessary locking, memory "
+"copies, and eventlet scheduling."
+msgstr ""
+"Improved proxy-server performance by reducing unnecessary locking, memory "
+"copies, and eventlet scheduling."
+
+msgid "Improved proxy-to-backend requests to be more RFC-compliant."
+msgstr "Improved proxy-to-backend requests to be more RFC-compliant."
+
+msgid ""
 "Improved the granularity of the ring dispersion metric so that small "
 "improvements after a rebalance can show changes in the dispersion number. "
 "Dispersion in existing and new rings can be recalculated using the new ``--"
@@ -878,6 +1299,9 @@ msgstr ""
 "the filename. This saves one inode for every EC .data file. Existing ."
 "durable files will not be removed, and they will continue to work just fine."
 
+msgid "Internal client no longer logs object DELETEs as status 499."
+msgstr "Internal client no longer logs object DELETEs as status 499."
+
 msgid ""
 "Let clients request heartbeats during SLO PUTs by including the query "
 "parameter ``heartbeat=on``."
@@ -896,6 +1320,13 @@ msgstr ""
 "exposes the value to offer consistency with the object listings on "
 "containers."
 
+msgid ""
+"Lock timeouts in the container updater are now logged at INFO level, not "
+"ERROR."
+msgstr ""
+"Lock timeouts in the container updater are now logged at INFO level, not "
+"ERROR."
+
 msgid "Log correct status code for conditional requests."
 msgstr "Log correct status code for conditional requests."
 
@@ -908,10 +1339,37 @@ msgstr ""
 "config. Configure the ``versioned_writes`` middleware in the proxy server "
 "instead. This option will be ignored in a future release."
 
+msgid ""
+"Log deprecation warnings for ``run_pause``. This setting was deprecated in "
+"Swift 2.4.0 and is replaced by ``interval``. It may be removed in a future "
+"release."
+msgstr ""
+"Log deprecation warnings for ``run_pause``. This setting was deprecated in "
+"Swift 2.4.0 and is replaced by ``interval``. It may be removed in a future "
+"release."
+
+msgid ""
+"Log formats are now more configurable and include support for anonymization. "
+"See the ``log_msg_template`` option in ``proxy-server.conf`` and `the Swift "
+"documentation <https://docs.openstack.org/swift/latest/logs.html#proxy-"
+"logs>`__ for more information."
+msgstr ""
+"Log formats are now more configurable and include support for anonymization. "
+"See the ``log_msg_template`` option in ``proxy-server.conf`` and `the Swift "
+"documentation <https://docs.openstack.org/swift/latest/logs.html#proxy-"
+"logs>`__ for more information."
+
 msgid "Log the correct request type of a subrequest downstream of copy."
 msgstr "Log the correct request type of a sub-request downstream of copy."
 
 msgid ""
+"Lower bounds of dependencies have been updated to reflect what is actually "
+"tested."
+msgstr ""
+"Lower bounds of dependencies have been updated to reflect what is actually "
+"tested."
+
+msgid ""
 "Make mount_check option usable in containerized environments by adding a "
 "check for an \".ismount\" file at the root directory of a device."
 msgstr ""
@@ -942,10 +1400,43 @@ msgstr ""
 "Moved other-requirements.txt to bindep.txt. bindep.txt lists non-Python "
 "dependencies of Swift."
 
+msgid ""
+"Multi-character strings may now be used as delimiters in account and "
+"container listings."
+msgstr ""
+"Multi-character strings may now be used as delimiters in account and "
+"container listings."
+
+msgid ""
+"Multipart object segments are now actually deleted when the multipart object "
+"is deleted via the S3 API."
+msgstr ""
+"Multipart object segments are now actually deleted when the multipart object "
+"is deleted via the S3 API."
+
+msgid "Multipart upload parts may now be copied from other multipart uploads."
+msgstr "Multipart upload parts may now be copied from other multipart uploads."
+
+msgid ""
+"Multiple keymaster middlewares are now supported. This allows migration from "
+"one key provider to another."
+msgstr ""
+"Multiple keymaster middlewares are now supported. This allows migration from "
+"one key provider to another."
+
 msgid "New Features"
 msgstr "New Features"
 
 msgid ""
+"New buckets created via the S3 API will now store multi-part upload data in "
+"the same storage policy as other data rather than the cluster's default "
+"storage policy."
+msgstr ""
+"New buckets created via the S3 API will now store multi-part upload data in "
+"the same storage policy as other data rather than the cluster's default "
+"storage policy."
+
+msgid ""
 "New config variables to change the schedule priority and I/O scheduling "
 "class. Servers and daemons now understand `nice_priority`, `ionice_class`, "
 "and `ionice_priority` to schedule their relative importance. Please read "
@@ -962,6 +1453,15 @@ msgid "Newton Series Release Notes"
 msgstr "Newton Series Release Notes"
 
 msgid ""
+"Note that ``secret_id`` values must remain unique across all keymasters in a "
+"given pipeline. If they are not unique, the right-most keymaster will take "
+"precedence."
+msgstr ""
+"Note that ``secret_id`` values must remain unique across all keymasters in a "
+"given pipeline. If they are not unique, the right-most keymaster will take "
+"precedence."
+
+msgid ""
 "Note that after writing EC data with Swift 2.11.0 or later, that data will "
 "not be accessible to earlier versions of Swift."
 msgstr ""
@@ -991,10 +1491,28 @@ msgstr ""
 msgid "Now ``swift-recon-cron`` works with conf.d configs."
 msgstr "Now ``swift-recon-cron`` works with conf.d configs."
 
+msgid ""
+"O_TMPFILE support is now detected by attempting to use it instead of looking "
+"at the kernel version. This allows older kernels with backported patches to "
+"take advantage of the O_TMPFILE functionality."
+msgstr ""
+"O_TMPFILE support is now detected by attempting to use it instead of looking "
+"at the kernel version. This allows older kernels with backported patches to "
+"take advantage of the O_TMPFILE functionality."
+
 msgid "Object expiry improvements"
 msgstr "Object expiry improvements"
 
 msgid ""
+"Object reconstructor logs are now prefixed with information about the "
+"specific worker process logging the message. This makes reading the logs and "
+"understanding the messages much simpler."
+msgstr ""
+"Object reconstructor logs are now prefixed with information about the "
+"specific worker process logging the message. This makes reading the logs and "
+"understanding the messages much simpler."
+
+msgid ""
 "Object versioning now supports a \"history\" mode in addition to the older "
 "\"stack\" mode. The difference is in how DELETE requests are handled. For "
 "full details, please read http://docs.openstack.org/developer/swift/"
@@ -1005,10 +1523,56 @@ msgstr ""
 "full details, please read http://docs.openstack.org/developer/swift/"
 "overview_object_versioning.html."
 
+msgid ""
+"Object writes to a container whose existence cannot be verified now 503 "
+"instead of 404."
+msgstr ""
+"Object writes to a container whose existence cannot be verified now 503 "
+"instead of 404."
+
+msgid ""
+"Objects with an ``X-Delete-At`` value in the far future no longer cause "
+"backend server errors."
+msgstr ""
+"Objects with an ``X-Delete-At`` value in the far future no longer cause "
+"backend server errors."
+
 msgid "Ocata Series Release Notes"
 msgstr "Ocata Series Release Notes"
 
 msgid ""
+"On Python 3, certain S3 API headers are now lower case as they would be "
+"coming from AWS."
+msgstr ""
+"On Python 3, certain S3 API headers are now lower case as they would be "
+"coming from AWS."
+
+msgid ""
+"On Python 3, fixed a RecursionError in swift-dispersion-report when using "
+"TLS."
+msgstr ""
+"On Python 3, fixed a RecursionError in swift-dispersion-report when using "
+"TLS."
+
+msgid ""
+"On Python 3, fixed an issue when reading or writing objects with a content "
+"type like ``message/*``. Previously, Swift would fail to respond."
+msgstr ""
+"On Python 3, fixed an issue when reading or writing objects with a content "
+"type like ``message/*``. Previously, Swift would fail to respond."
+
+msgid ""
+"On Python 3, the KMS keymaster now works with secrets stored in Barbican "
+"with a ``text/plain`` payload-content-type."
+msgstr ""
+"On Python 3, the KMS keymaster now works with secrets stored in Barbican "
+"with a ``text/plain`` payload-content-type."
+
+msgid "On Python 3, the formpost middleware now works with unicode file names."
+msgstr ""
+"On Python 3, the formpost middleware now works with Unicode file names."
+
+msgid ""
 "On newer kernels (3.15+ when using xfs), Swift will use the O_TMPFILE flag "
 "when opening a file instead of creating a temporary file and renaming it on "
 "commit. This makes the data path simpler and allows the filesystem to more "
@@ -1020,6 +1584,13 @@ msgstr ""
 "efficiently optimise the files on disk, resulting in better performance."
 
 msgid ""
+"On upgrade, a node configured with concurrency=N will still handle async "
+"updates N-at-a-time, but will do so using only one process instead of N."
+msgstr ""
+"On upgrade, a node configured with concurrency=N will still handle async "
+"updates N-at-a-time, but will do so using only one process instead of N."
+
+msgid ""
 "Optimize the Erasure Code reconstructor protocol to reduce IO load on "
 "servers."
 msgstr ""
@@ -1033,6 +1604,19 @@ msgstr ""
 "Optimised the common case for hashing filesystem trees, thus eliminating a "
 "lot of extraneous disk I/O."
 
+msgid ""
+"Ordinary objects in S3 use the MD5 of the object as the ETag, just like "
+"Swift. Multipart Uploads follow a different format, notably including a dash "
+"followed by the number of segments. To that end (and for S3 API requests "
+"*only*), SLO responses via the S3 API have a literal '-N' added on the end "
+"of the ETag."
+msgstr ""
+"Ordinary objects in S3 use the MD5 of the object as the ETag, just like "
+"Swift. Multipart Uploads follow a different format, notably including a dash "
+"followed by the number of segments. To that end (and for S3 API requests "
+"*only*), SLO responses via the S3 API have a literal '-N' added on the end "
+"of the ETag."
+
 msgid "Other Notes"
 msgstr "Other Notes"
 
@@ -1045,10 +1629,41 @@ msgstr ""
 "SSC (server-side copy) Swift source field. See https://docs.openstack.org/"
 "developer/swift/logs.html#swift-source for more information."
 
+msgid ""
+"Per-service ``auto_create_account_prefix`` settings are now deprecated and "
+"may be ignored in a future release; if you need to use this, please set it "
+"in the ``[swift-constraints]`` section of ``/etc/swift/swift.conf``."
+msgstr ""
+"Per-service ``auto_create_account_prefix`` settings are now deprecated and "
+"may be ignored in a future release; if you need to use this, please set it "
+"in the ``[swift-constraints]`` section of ``/etc/swift/swift.conf``."
+
 msgid "Pike Series Release Notes"
 msgstr "Pike Series Release Notes"
 
 msgid ""
+"Prevent PyKMIP's kmip_protocol logger from logging at DEBUG. Previously, "
+"some versions of PyKMIP would include all wire data when the root logger was "
+"configured to log at DEBUG; this could expose key material in logs. Only the "
+"``kmip_keymaster`` was affected."
+msgstr ""
+"Prevent PyKMIP's kmip_protocol logger from logging at DEBUG. Previously, "
+"some versions of PyKMIP would include all wire data when the root logger was "
+"configured to log at DEBUG; this could expose key material in logs. Only the "
+"``kmip_keymaster`` was affected."
+
+msgid ""
+"Prevent PyKMIP's kmip_protocol logger from logging at DEBUG. Previously, "
+"some versions of PyKMIP would include all wire data when the root logger was "
+"configured to log at DEBUG; this could expose key material in logs. Only the "
+"kmip_keymaster was affected."
+msgstr ""
+"Prevent PyKMIP's kmip_protocol logger from logging at DEBUG. Previously, "
+"some versions of PyKMIP would include all wire data when the root logger was "
+"configured to log at DEBUG; this could expose key material in logs. Only the "
+"kmip_keymaster was affected."
+
+msgid ""
 "Prevent logged traceback in object-server on client disconnect for chunked "
 "transfers to replicated policies."
 msgstr ""
@@ -1071,10 +1686,43 @@ msgstr ""
 "Provide an S3 API compatibility layer. The external \"swift3\" project has "
 "been imported into Swift's codebase as the \"s3api\" middleware."
 
+msgid ""
+"Provide useful status codes in logs for some versioning and symlink "
+"subrequests that were previously logged as 499."
+msgstr ""
+"Provide useful status codes in logs for some versioning and symlink "
+"subrequests that were previously logged as 499."
+
+msgid ""
+"Proxy, account, container, and object servers now support \"seamless reloads"
+"\" via ``SIGUSR1``. This is similar to the existing graceful restarts but "
+"keeps the server socket open the whole time, reducing service downtime."
+msgstr ""
+"Proxy, account, container, and object servers now support \"seamless reloads"
+"\" via ``SIGUSR1``. This is similar to the existing graceful restarts but "
+"keeps the server socket open the whole time, reducing service downtime."
+
+msgid "Python 3 fixes:"
+msgstr "Python 3 fixes:"
+
+msgid ""
+"Python 3.6 and 3.7 are now fully supported. If you've been testing Swift on "
+"Python 3, upgrade at your earliest convenience."
+msgstr ""
+"Python 3.6 and 3.7 are now fully supported. If you've been testing Swift on "
+"Python 3, upgrade at your earliest convenience."
+
 msgid "Queens Series Release Notes"
 msgstr "Queens Series Release Notes"
 
 msgid ""
+"Reduced object-replicator and object-reconstructor CPU usage by only "
+"checking that the device list is current when rings change."
+msgstr ""
+"Reduced object-replicator and object-reconstructor CPU usage by only "
+"checking that the device list is current when rings change."
+
+msgid ""
 "Remove ``swift-temp-url`` script. The functionality has been in swiftclient "
 "for a long time and this script has been deprecated since 2.10.0."
 msgstr ""
@@ -1100,6 +1748,11 @@ msgstr ""
 "Large-Object metadata."
 
 msgid ""
+"Removed a request-smuggling vector when running a mixed py2/py3 cluster."
+msgstr ""
+"Removed a request-smuggling vector when running a mixed py2/py3 cluster."
+
+msgid ""
 "Removed all ``post_as_copy`` related code and configs. The option has been "
 "deprecated since 2.13.0."
 msgstr ""
@@ -1124,6 +1777,13 @@ msgstr ""
 "deprecated, but continues to function for now. If both values are defined, "
 "the old ``replication_one_per_device`` is ignored."
 
+msgid ""
+"Requesting multiple ranges from a Dynamic Large Object now returns the "
+"entire object instead of incorrect data. This was previously fixed in 2.23.0."
+msgstr ""
+"Requesting multiple ranges from a Dynamic Large Object now returns the "
+"entire object instead of incorrect data. This was previously fixed in 2.23.0."
+
 msgid "Require that known-bad EC schemes be deprecated"
 msgstr "Require that known-bad EC schemes be deprecated"
 
@@ -1170,6 +1830,22 @@ msgstr ""
 msgid "Rocky Series Release Notes"
 msgstr "Rocky Series Release Notes"
 
+msgid "S3 API compatibility updates"
+msgstr "S3 API compatibility updates"
+
+msgid "S3 API improvements"
+msgstr "S3 API improvements"
+
+msgid ""
+"S3 API now translates ``503 Service Unavailable`` responses to a more S3-"
+"like response instead of raising an error."
+msgstr ""
+"S3 API now translates ``503 Service Unavailable`` responses to a more S3-"
+"like response instead of raising an error."
+
+msgid "S3 ETag for SLOs now include a '-'."
+msgstr "S3 ETag for SLOs now include a '-'."
+
 msgid ""
 "SLO manifest PUT requests can now be properly validated by sending an ETag "
 "header of the md5 sum of the concatenated md5 sums of the referenced "
@@ -1191,6 +1867,15 @@ msgstr ""
 "setting in the \"[filter:slo]\" section of the proxy server config."
 
 msgid ""
+"SSYNC replication mode now removes as much of the directory structure as "
+"possible as soon at it observes that the directory is empty. This reduces "
+"the work needed for subsequent replication passes."
+msgstr ""
+"SSYNC replication mode now removes as much of the directory structure as "
+"possible as soon at it observes that the directory is empty. This reduces "
+"the work needed for subsequent replication passes."
+
+msgid ""
 "Save the ring when dispersion improves, even if balance doesn't improve."
 msgstr ""
 "Save the ring when dispersion improves, even if balance doesn't improve."
@@ -1198,6 +1883,12 @@ msgstr ""
 msgid "Send ETag header in 206 Partial Content responses to SLO reads."
 msgstr "Send ETag header in 206 Partial Content responses to SLO reads."
 
+msgid "Several utility scripts now work better on Python 3:"
+msgstr "Several utility scripts now work better on Python 3:"
+
+msgid "Sharding improvements"
+msgstr "Sharding improvements"
+
 msgid ""
 "Significant improvements to the api-ref doc available at http://developer."
 "openstack.org/api-ref/object-storage/."
@@ -1212,6 +1903,13 @@ msgstr ""
 "Static Large Object (SLO) manifest may now (again) have zero-byte last "
 "segments."
 
+msgid ""
+"Static Large Object sizes in listings for versioned containers are now more "
+"accurate."
+msgstr ""
+"Static Large Object sizes in listings for versioned containers are now more "
+"accurate."
+
 msgid "Stein Series Release Notes"
 msgstr "Stein Series Release Notes"
 
@@ -1225,6 +1923,15 @@ msgstr ""
 msgid "Stopped logging tracebacks when receiving an unexpected response."
 msgstr "Stopped logging tracebacks when receiving an unexpected response."
 
+msgid ""
+"Storage policy definitions in swift.conf can now define the diskfile to use "
+"to access objects. See the included swift.conf-sample file for a description "
+"of usage."
+msgstr ""
+"Storage policy definitions in swift.conf can now define the diskfile to use "
+"to access objects. See the included swift.conf-sample file for a description "
+"of usage."
+
 msgid "Support multi-range GETs for static large objects."
 msgstr "Support multi-range GETs for static large objects."
 
@@ -1238,6 +1945,17 @@ msgid "Swift Release Notes"
 msgstr "Swift Release Notes"
 
 msgid ""
+"Swift can now cache the S3 secret from Keystone to use for subsequent "
+"requests. This functionality is disabled by default but can be enabled by "
+"setting the ``secret_cache_duration`` in the ``[filter:s3token]`` section of "
+"the proxy server config to a number greater than 0."
+msgstr ""
+"Swift can now cache the S3 secret from Keystone to use for subsequent "
+"requests. This functionality is disabled by default but can be enabled by "
+"setting the ``secret_cache_duration`` in the ``[filter:s3token]`` section of "
+"the proxy server config to a number greater than 0."
+
+msgid ""
 "Swift now returns a 503 (instead of a 500) when an account auto-create fails."
 msgstr ""
 "Swift now returns a 503 (instead of a 500) when an account auto-create fails."
@@ -1267,6 +1985,15 @@ msgstr ""
 "including the X-Symlink-Target-Account header."
 
 msgid ""
+"TempURLs now support IP range restrictions. Please see https://docs."
+"openstack.org/swift/latest/middleware.html#client-usage for more information "
+"on how to use this additional restriction."
+msgstr ""
+"TempURLs now support IP range restrictions. Please see https://docs."
+"openstack.org/swift/latest/middleware.html#client-usage for more information "
+"on how to use this additional restriction."
+
+msgid ""
 "TempURLs now support a validation against a common prefix. A prefix-based "
 "signature grants access to all objects which share the same prefix. This "
 "avoids the creation of a large amount of signatures, when a whole container "
@@ -1307,6 +2034,31 @@ msgstr ""
 "on servers with many drives."
 
 msgid ""
+"The EC reconstructor will now attempt to remove empty directories "
+"immediately, while the inodes are still cached, rather than waiting until "
+"the next run."
+msgstr ""
+"The EC reconstructor will now attempt to remove empty directories "
+"immediately, while the inodes are still cached, rather than waiting until "
+"the next run."
+
+msgid ""
+"The ``container-replicator`` now correctly enqueues ``container-reconciler`` "
+"work for sharded containers."
+msgstr ""
+"The ``container-replicator`` now correctly enqueues ``container-reconciler`` "
+"work for sharded containers."
+
+msgid ""
+"The ``container-replicator`` now only attempts to fetch shard ranges if the "
+"remote indicates that it has shard ranges. Further, it does so with a "
+"timeout to prevent the process from hanging in certain cases."
+msgstr ""
+"The ``container-replicator`` now only attempts to fetch shard ranges if the "
+"remote indicates that it has shard ranges. Further, it does so with a "
+"timeout to prevent the process from hanging in certain cases."
+
+msgid ""
 "The ``domain_remap`` middleware now supports the ``mangle_client_paths`` "
 "option. Its default \"false\" value changes ``domain_remap`` parsing to stop "
 "stripping the ``path_root`` value from URL paths. If users depend on this "
@@ -1320,6 +2072,67 @@ msgstr ""
 "before upgrading."
 
 msgid ""
+"The ``kmip_keymaster`` middleware can now be configured directly in the "
+"proxy-server config file. The existing behavior of using an external config "
+"file is still supported."
+msgstr ""
+"The ``kmip_keymaster`` middleware can now be configured directly in the "
+"proxy-server config file. The existing behaviour of using an external config "
+"file is still supported."
+
+msgid ""
+"The ``object-expirer`` may now be configured in ``object-server.conf``. This "
+"is in anticipation of a future change to allow the ``object-expirer`` to be "
+"deployed on all nodes that run the ``object-server``."
+msgstr ""
+"The ``object-expirer`` may now be configured in ``object-server.conf``. This "
+"is in anticipation of a future change to allow the ``object-expirer`` to be "
+"deployed on all nodes that run the ``object-server``."
+
+msgid ""
+"The ``proxy-server`` now caches 'updating' shards, improving write "
+"performance for sharded containers. A new config option, "
+"``recheck_updating_shard_ranges``, controls the cache time; set it to 0 to "
+"disable caching."
+msgstr ""
+"The ``proxy-server`` now caches 'updating' shards, improving write "
+"performance for sharded containers. A new config option, "
+"``recheck_updating_shard_ranges``, controls the cache time; set it to 0 to "
+"disable caching."
+
+msgid ""
+"The ``proxy-server`` now ignores 404 responses from handoffs that have no "
+"data when deciding on the correct response for object requests, similar to "
+"what it already does for account and container requests."
+msgstr ""
+"The ``proxy-server`` now ignores 404 responses from handoffs that have no "
+"data when deciding on the correct response for object requests, similar to "
+"what it already does for account and container requests."
+
+msgid ""
+"The ``proxy-server`` now ignores 404 responses from handoffs without "
+"databases when deciding on the correct response for account and container "
+"requests."
+msgstr ""
+"The ``proxy-server`` now ignores 404 responses from handoffs without "
+"databases when deciding on the correct response for account and container "
+"requests."
+
+msgid ""
+"The bulk extract middleware once again allows clients to specify metadata "
+"(including expiration timestamps) for all objects in the archive."
+msgstr ""
+"The bulk extract middleware once again allows clients to specify metadata "
+"(including expiration timestamps) for all objects in the archive."
+
+msgid ""
+"The container sharder can now handle containers with special characters in "
+"their names."
+msgstr ""
+"The container sharder can now handle containers with special characters in "
+"their names."
+
+msgid ""
 "The container-updater now reports zero objects and bytes used for child DBs "
 "in sharded containers. This prevents double-counting in utilization reports."
 msgstr ""
@@ -1532,6 +2345,9 @@ msgstr ""
 "write a manifest that an out-of-date proxy server will not be able to read. "
 "This will resolve itself once the upgrade completes on all nodes."
 
+msgid "Ussuri Series Release Notes"
+msgstr "Ussuri Series Release Notes"
+
 msgid "Various other minor bug fixes and improvements."
 msgstr "Various other minor bug fixes and improvements."
 
@@ -1546,6 +2362,9 @@ msgstr ""
 "using isa_l_rs_vand with more than 4 parity, please read https://bugs."
 "launchpad.net/swift/+bug/1639691 and take necessary action."
 
+msgid "WSGI server processes can now notify systemd when they are ready."
+msgstr "WSGI server processes can now notify systemd when they are ready."
+
 msgid ""
 "We do not yet have CLI tools for creating composite rings, but the "
 "functionality has been enabled in the ring modules to support this advanced "
@@ -1569,6 +2388,38 @@ msgstr ""
 "unaffected by this change."
 
 msgid ""
+"When looking for the active root secret, only the right-most keymaster is "
+"used."
+msgstr ""
+"When looking for the active root secret, only the right-most keymaster is "
+"used."
+
+msgid ""
+"When making backend requests, the ``proxy-server`` now ensures query "
+"parameters are always properly quoted. Previously, the proxy would encounter "
+"an error on Python 2.7.17 if the client included non-ASCII query parameters "
+"in object requests. This was previously fixed in 2.23.0."
+msgstr ""
+"When making backend requests, the ``proxy-server`` now ensures query "
+"parameters are always properly quoted. Previously, the proxy would encounter "
+"an error on Python 2.7.17 if the client included non-ASCII query parameters "
+"in object requests. This was previously fixed in 2.23.0."
+
+msgid ""
+"When object path is not a directory, just quarantine it, rather than the "
+"whole suffix."
+msgstr ""
+"When object path is not a directory, just quarantine it, rather than the "
+"whole suffix."
+
+msgid ""
+"When refetching Static Large Object manifests, non-manifest responses are "
+"now handled better."
+msgstr ""
+"When refetching Static Large Object manifests, non-manifest responses are "
+"now handled better."
+
+msgid ""
 "When requesting objects, return 404 if a tombstone is found and is newer "
 "than any data found. Previous behavior was to return stale data."
 msgstr ""
@@ -1618,10 +2469,37 @@ msgstr ""
 "X-Delete-At computation now uses X-Timestamp instead of system time. This "
 "prevents clock skew causing inconsistent expiry data."
 
+msgid "``Content-Type`` can now be updated when copying an object."
+msgstr "``Content-Type`` can now be updated when copying an object."
+
+msgid "``swift-account-audit``"
+msgstr "``swift-account-audit``"
+
+msgid "``swift-dispersion-populate``"
+msgstr "``swift-dispersion-populate``"
+
+msgid "``swift-drive-recon``"
+msgstr "``swift-drive-recon``"
+
+msgid "``swift-recon``"
+msgstr "``swift-recon``"
+
 msgid "``swift-ring-builder`` improvements"
 msgstr "``swift-ring-builder`` improvements"
 
 msgid ""
+"``swift_source`` is set for more sub-requests in the proxy-server. See `the "
+"documentation <https://docs.openstack.org/swift/latest/logs.html#swift-"
+"source>`__."
+msgstr ""
+"``swift_source`` is set for more sub-requests in the proxy-server. See `the "
+"documentation <https://docs.openstack.org/swift/latest/logs.html#swift-"
+"source>`__."
+
+msgid "and you want to take advantage of faster updates, then do this::"
+msgstr "and you want to take advantage of faster updates, then do this::"
+
+msgid ""
 "cname_lookup middleware now accepts a ``nameservers`` config variable that, "
 "if defined, will be used for DNS lookups instead of the system default."
 msgstr ""
diff -pruN 2.25.0-2/releasenotes/source/ussuri.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/releasenotes/source/ussuri.rst
--- 2.25.0-2/releasenotes/source/ussuri.rst	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/releasenotes/source/ussuri.rst	2020-07-06 17:03:50.000000000 +0000
@@ -0,0 +1,6 @@
+===========================
+Ussuri Series Release Notes
+===========================
+
+.. release-notes::
+   :branch: stable/ussuri
diff -pruN 2.25.0-2/requirements.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/requirements.txt
--- 2.25.0-2/requirements.txt	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/requirements.txt	2020-07-06 17:03:50.000000000 +0000
@@ -2,7 +2,6 @@
 # of appearance. Changing the order has an impact on the overall integration
 # process, which may cause wedges in the gate later.
 
-dnspython>=1.15.0;python_version=='2.7' # http://www.dnspython.org/LICENSE
 eventlet>=0.25.0                        # MIT
 greenlet>=0.3.2
 netifaces>=0.8,!=0.10.0,!=0.10.1
@@ -13,4 +12,12 @@ six>=1.10.0
 xattr>=0.4;sys_platform!='win32'        # MIT
 PyECLib>=1.3.1                          # BSD
 cryptography>=2.0.2                     # BSD/Apache-2.0
-ipaddress>=1.0.16;python_version<'3.3'  # PSF
+
+# For python 2.7, the following requirements are needed; they are not
+# included since the requirments-check check will fail otherwise since
+# global requirements do not support these anymore.
+# Fortunately, these packages come in as dependencies from others and
+# thus the py27 jobs still work.
+#
+# dnspython>=1.15.0;python_version=='2.7' # http://www.dnspython.org/LICENSE
+# ipaddress>=1.0.16;python_version<'3.3'  # PSF
diff -pruN 2.25.0-2/REVIEW_GUIDELINES.rst 2.25.1~git2020070613.2e001431f-0ubuntu1/REVIEW_GUIDELINES.rst
--- 2.25.0-2/REVIEW_GUIDELINES.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/REVIEW_GUIDELINES.rst	2020-07-06 17:03:50.000000000 +0000
@@ -369,7 +369,7 @@ Endeavor to leave a positive or negative
 Use your best judgment.
 
 A note on Swift Core Maintainers
-================================
+--------------------------------
 
 Swift Core maintainers may provide positive reviews scores that *look*
 different from your reviews - a "+2" instead of a "+1".
diff -pruN 2.25.0-2/roles/additional-keystone-users/tasks/main.yaml 2.25.1~git2020070613.2e001431f-0ubuntu1/roles/additional-keystone-users/tasks/main.yaml
--- 2.25.0-2/roles/additional-keystone-users/tasks/main.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/roles/additional-keystone-users/tasks/main.yaml	2020-07-06 17:03:50.000000000 +0000
@@ -0,0 +1,134 @@
+- name: Set S3 endpoint
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_storage_url
+    value: http://localhost:8080
+  become: true
+
+- name: Create primary S3 user
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    credential create --type ec2 --project swiftprojecttest1 swiftusertest1
+    '{"access": "s3-user1", "secret": "s3-secret1"}'
+- name: Add primary S3 user to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_access_key
+    value: s3-user1
+  become: true
+- name: Add primary S3 user secret to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_secret_key
+    value: s3-secret1
+  become: true
+
+- name: Clear secondary S3 user from test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_access_key2
+    value: ""
+  become: true
+
+- name: Create restricted S3 user
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    credential create --type ec2 --project swiftprojecttest1 swiftusertest3
+    '{"access": "s3-user3", "secret": "s3-secret3"}'
+- name: Add restricted S3 user to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_access_key3
+    value: s3-user3
+  become: true
+- name: Add restricted S3 user secret to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_secret_key3
+    value: s3-secret3
+  become: true
+
+- name: Create service role
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    role create swift_service
+- name: Create service project
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    project create swiftprojecttest5
+- name: Create service user
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    user create --project swiftprojecttest5 swiftusertest5 --password testing5
+- name: Assign service role
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    role add --project swiftprojecttest5 --user swiftusertest5 swift_service
+
+- name: Add service_roles to proxy-server.conf
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:keystoneauth
+    option: SERVICE_KEY_service_roles
+    value: swift_service
+  become: true
+- name: Update reseller prefixes in proxy-server.conf
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:keystoneauth
+    option: reseller_prefix
+    value: AUTH, SERVICE_KEY
+  become: true
+
+- name: Add service account to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: account5
+    value: swiftprojecttest5
+  become: true
+- name: Add service user to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: username5
+    value: swiftusertest5
+  become: true
+- name: Add service password to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: password5
+    value: testing5
+  become: true
+- name: Add service prefix to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: service_prefix
+    value: SERVICE_KEY
+  become: true
diff -pruN 2.25.0-2/roles/additional-tempauth-users/tasks/main.yaml 2.25.1~git2020070613.2e001431f-0ubuntu1/roles/additional-tempauth-users/tasks/main.yaml
--- 2.25.0-2/roles/additional-tempauth-users/tasks/main.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/roles/additional-tempauth-users/tasks/main.yaml	2020-07-06 17:03:50.000000000 +0000
@@ -0,0 +1,47 @@
+- name: Configure service auth prefix for tempauth tests
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:tempauth
+    option: reseller_prefix
+    value: TEMPAUTH, SERVICE_TA
+  become: true
+
+- name: Configure service group for tempauth tests
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:tempauth
+    option: SERVICE_TA_require_group
+    value: service
+  become: true
+
+- name: Configure service account for tempauth tests
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: account5
+    value: test5
+  become: true
+
+- name: Configure service username for tempauth tests
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: username5
+    value: tester5
+  become: true
+
+- name: Configure service user password for tempauth tests
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: password5
+    value: testing5
+  become: true
+
+- name: Configure service prefix for tempauth tests
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: service_prefix
+    value: SERVICE_TA
+  become: true
diff -pruN 2.25.0-2/roles/dsvm-additional-middlewares/tasks/main.yaml 2.25.1~git2020070613.2e001431f-0ubuntu1/roles/dsvm-additional-middlewares/tasks/main.yaml
--- 2.25.0-2/roles/dsvm-additional-middlewares/tasks/main.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/roles/dsvm-additional-middlewares/tasks/main.yaml	2020-07-06 17:03:50.000000000 +0000
@@ -0,0 +1,70 @@
+- name: Add domain_remap and etag-quoter to pipeline
+  replace:
+    path: "/etc/swift/proxy-server.conf"
+    regexp: "cache listing_formats"
+    replace: "cache domain_remap etag-quoter listing_formats"
+  become: true
+
+- name: Set domain_remap domain
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:domain_remap
+    option: storage_domain
+    value: example.com
+  become: true
+
+- name: Set storage_domain in test.conf (for Keystone tests)
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: storage_domain
+    value: example.com
+  become: true
+
+- name: Set storage_domain in test/sample.conf (for tempauth tests)
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: storage_domain
+    value: example.com
+  become: true
+
+- name: Enable object versioning
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:versioned_writes
+    option: allow_object_versioning
+    value: true
+  become: true
+
+- name: Configure s3api force_swift_request_proxy_log
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:s3api
+    option: force_swift_request_proxy_log
+    value: true
+  become: true
+
+- name: Copy ring for Policy-1
+  copy:
+    remote_src: true
+    src: /etc/swift/object.ring.gz
+    dest: /etc/swift/object-1.ring.gz
+  become: true
+
+- name: Add Policy-1 to swift.conf
+  ini_file:
+    path: /etc/swift/swift.conf
+    section: storage-policy:1
+    option: name
+    value: Policy-1
+  become: true
+
+- name: Restart service to pick up config changes
+  command: systemctl restart devstack@s-{{ item }}.service
+  become: true
+  with_items:
+    - proxy
+    - account
+    - container
+    - object
diff -pruN 2.25.0-2/setup.cfg 2.25.1~git2020070613.2e001431f-0ubuntu1/setup.cfg
--- 2.25.0-2/setup.cfg	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/setup.cfg	2020-07-06 17:03:53.866100500 +0000
@@ -1,139 +1,135 @@
 [metadata]
 name = swift
 summary = OpenStack Object Storage
-description-file =
-    README.rst
+description-file = 
+	README.rst
 author = OpenStack
 author-email = openstack-discuss@lists.openstack.org
 home-page = https://docs.openstack.org/swift/latest/
-classifier =
-    Development Status :: 5 - Production/Stable
-    Environment :: OpenStack
-    Intended Audience :: Information Technology
-    Intended Audience :: System Administrators
-    License :: OSI Approved :: Apache Software License
-    Operating System :: POSIX :: Linux
-    Programming Language :: Python
-    Programming Language :: Python :: 2
-    Programming Language :: Python :: 2.7
-    Programming Language :: Python :: 3
-    Programming Language :: Python :: 3.6
-    Programming Language :: Python :: 3.7
+classifier = 
+	Development Status :: 5 - Production/Stable
+	Environment :: OpenStack
+	Intended Audience :: Information Technology
+	Intended Audience :: System Administrators
+	License :: OSI Approved :: Apache Software License
+	Operating System :: POSIX :: Linux
+	Programming Language :: Python
+	Programming Language :: Python :: 2
+	Programming Language :: Python :: 2.7
+	Programming Language :: Python :: 3
+	Programming Language :: Python :: 3.6
+	Programming Language :: Python :: 3.7
+	Programming Language :: Python :: 3.8
 
 [pbr]
 skip_authors = True
 skip_changelog = True
 
 [files]
-packages =
-    swift
-scripts =
-    bin/swift-account-audit
-    bin/swift-account-auditor
-    bin/swift-account-info
-    bin/swift-account-reaper
-    bin/swift-account-replicator
-    bin/swift-account-server
-    bin/swift-config
-    bin/swift-container-auditor
-    bin/swift-container-info
-    bin/swift-container-replicator
-    bin/swift-container-server
-    bin/swift-container-sharder
-    bin/swift-container-sync
-    bin/swift-container-updater
-    bin/swift-container-reconciler
-    bin/swift-reconciler-enqueue
-    bin/swift-dispersion-populate
-    bin/swift-dispersion-report
-    bin/swift-drive-audit
-    bin/swift-form-signature
-    bin/swift-get-nodes
-    bin/swift-init
-    bin/swift-object-auditor
-    bin/swift-object-expirer
-    bin/swift-object-info
-    bin/swift-object-replicator
-    bin/swift-object-reconstructor
-    bin/swift-object-relinker
-    bin/swift-object-server
-    bin/swift-object-updater
-    bin/swift-oldies
-    bin/swift-orphans
-    bin/swift-proxy-server
-    bin/swift-recon
-    bin/swift-recon-cron
-    bin/swift-ring-builder
-    bin/swift-ring-builder-analyzer
-    bin/swift-ring-composer
+packages = 
+	swift
+scripts = 
+	bin/swift-account-audit
+	bin/swift-account-auditor
+	bin/swift-account-info
+	bin/swift-account-reaper
+	bin/swift-account-replicator
+	bin/swift-account-server
+	bin/swift-config
+	bin/swift-container-auditor
+	bin/swift-container-info
+	bin/swift-container-replicator
+	bin/swift-container-server
+	bin/swift-container-sharder
+	bin/swift-container-sync
+	bin/swift-container-updater
+	bin/swift-container-reconciler
+	bin/swift-reconciler-enqueue
+	bin/swift-dispersion-populate
+	bin/swift-dispersion-report
+	bin/swift-drive-audit
+	bin/swift-form-signature
+	bin/swift-get-nodes
+	bin/swift-init
+	bin/swift-object-auditor
+	bin/swift-object-expirer
+	bin/swift-object-info
+	bin/swift-object-replicator
+	bin/swift-object-reconstructor
+	bin/swift-object-relinker
+	bin/swift-object-server
+	bin/swift-object-updater
+	bin/swift-oldies
+	bin/swift-orphans
+	bin/swift-proxy-server
+	bin/swift-recon
+	bin/swift-recon-cron
+	bin/swift-ring-builder
+	bin/swift-ring-builder-analyzer
+	bin/swift-ring-composer
 
 [extras]
-kms_keymaster =
-    oslo.config>=4.0.0,!=4.3.0,!=4.4.0 # Apache-2.0
-    castellan>=0.13.0 # Apache-2.0
-
-kmip_keymaster =
-    pykmip>=0.7.0 # Apache-2.0
-
-keystone =
-    keystonemiddleware>=4.17.0
+kms_keymaster = 
+	oslo.config>=4.0.0,!=4.3.0,!=4.4.0 # Apache-2.0
+	castellan>=0.13.0 # Apache-2.0
+kmip_keymaster = 
+	pykmip>=0.7.0 # Apache-2.0
+keystone = 
+	keystonemiddleware>=4.17.0
 
 [entry_points]
-console_scripts =
-    swift-manage-shard-ranges = swift.cli.manage_shard_ranges:main
-    swift-container-deleter = swift.cli.container_deleter:main
-
-paste.app_factory =
-    proxy = swift.proxy.server:app_factory
-    object = swift.obj.server:app_factory
-    mem_object = swift.obj.mem_server:app_factory
-    container = swift.container.server:app_factory
-    account = swift.account.server:app_factory
-
-paste.filter_factory =
-    healthcheck = swift.common.middleware.healthcheck:filter_factory
-    crossdomain = swift.common.middleware.crossdomain:filter_factory
-    memcache = swift.common.middleware.memcache:filter_factory
-    read_only = swift.common.middleware.read_only:filter_factory
-    ratelimit = swift.common.middleware.ratelimit:filter_factory
-    cname_lookup = swift.common.middleware.cname_lookup:filter_factory
-    catch_errors = swift.common.middleware.catch_errors:filter_factory
-    domain_remap = swift.common.middleware.domain_remap:filter_factory
-    staticweb = swift.common.middleware.staticweb:filter_factory
-    tempauth = swift.common.middleware.tempauth:filter_factory
-    keystoneauth = swift.common.middleware.keystoneauth:filter_factory
-    recon = swift.common.middleware.recon:filter_factory
-    tempurl = swift.common.middleware.tempurl:filter_factory
-    formpost = swift.common.middleware.formpost:filter_factory
-    name_check = swift.common.middleware.name_check:filter_factory
-    bulk = swift.common.middleware.bulk:filter_factory
-    container_quotas = swift.common.middleware.container_quotas:filter_factory
-    account_quotas = swift.common.middleware.account_quotas:filter_factory
-    proxy_logging = swift.common.middleware.proxy_logging:filter_factory
-    dlo = swift.common.middleware.dlo:filter_factory
-    slo = swift.common.middleware.slo:filter_factory
-    list_endpoints = swift.common.middleware.list_endpoints:filter_factory
-    gatekeeper = swift.common.middleware.gatekeeper:filter_factory
-    container_sync = swift.common.middleware.container_sync:filter_factory
-    xprofile = swift.common.middleware.xprofile:filter_factory
-    versioned_writes = swift.common.middleware.versioned_writes:filter_factory
-    copy = swift.common.middleware.copy:filter_factory
-    keymaster = swift.common.middleware.crypto.keymaster:filter_factory
-    encryption = swift.common.middleware.crypto:filter_factory
-    kms_keymaster = swift.common.middleware.crypto.kms_keymaster:filter_factory
-    kmip_keymaster = swift.common.middleware.crypto.kmip_keymaster:filter_factory
-    listing_formats = swift.common.middleware.listing_formats:filter_factory
-    symlink = swift.common.middleware.symlink:filter_factory
-    s3api = swift.common.middleware.s3api.s3api:filter_factory
-    s3token = swift.common.middleware.s3api.s3token:filter_factory
-    etag_quoter = swift.common.middleware.etag_quoter:filter_factory
-
-swift.diskfile =
-    replication.fs = swift.obj.diskfile:DiskFileManager
-    erasure_coding.fs = swift.obj.diskfile:ECDiskFileManager
+console_scripts = 
+	swift-manage-shard-ranges = swift.cli.manage_shard_ranges:main
+	swift-container-deleter = swift.cli.container_deleter:main
+paste.app_factory = 
+	proxy = swift.proxy.server:app_factory
+	object = swift.obj.server:app_factory
+	mem_object = swift.obj.mem_server:app_factory
+	container = swift.container.server:app_factory
+	account = swift.account.server:app_factory
+paste.filter_factory = 
+	healthcheck = swift.common.middleware.healthcheck:filter_factory
+	crossdomain = swift.common.middleware.crossdomain:filter_factory
+	memcache = swift.common.middleware.memcache:filter_factory
+	read_only = swift.common.middleware.read_only:filter_factory
+	ratelimit = swift.common.middleware.ratelimit:filter_factory
+	cname_lookup = swift.common.middleware.cname_lookup:filter_factory
+	catch_errors = swift.common.middleware.catch_errors:filter_factory
+	domain_remap = swift.common.middleware.domain_remap:filter_factory
+	staticweb = swift.common.middleware.staticweb:filter_factory
+	tempauth = swift.common.middleware.tempauth:filter_factory
+	keystoneauth = swift.common.middleware.keystoneauth:filter_factory
+	recon = swift.common.middleware.recon:filter_factory
+	tempurl = swift.common.middleware.tempurl:filter_factory
+	formpost = swift.common.middleware.formpost:filter_factory
+	name_check = swift.common.middleware.name_check:filter_factory
+	bulk = swift.common.middleware.bulk:filter_factory
+	container_quotas = swift.common.middleware.container_quotas:filter_factory
+	account_quotas = swift.common.middleware.account_quotas:filter_factory
+	proxy_logging = swift.common.middleware.proxy_logging:filter_factory
+	dlo = swift.common.middleware.dlo:filter_factory
+	slo = swift.common.middleware.slo:filter_factory
+	list_endpoints = swift.common.middleware.list_endpoints:filter_factory
+	gatekeeper = swift.common.middleware.gatekeeper:filter_factory
+	container_sync = swift.common.middleware.container_sync:filter_factory
+	xprofile = swift.common.middleware.xprofile:filter_factory
+	versioned_writes = swift.common.middleware.versioned_writes:filter_factory
+	copy = swift.common.middleware.copy:filter_factory
+	keymaster = swift.common.middleware.crypto.keymaster:filter_factory
+	encryption = swift.common.middleware.crypto:filter_factory
+	kms_keymaster = swift.common.middleware.crypto.kms_keymaster:filter_factory
+	kmip_keymaster = swift.common.middleware.crypto.kmip_keymaster:filter_factory
+	listing_formats = swift.common.middleware.listing_formats:filter_factory
+	symlink = swift.common.middleware.symlink:filter_factory
+	s3api = swift.common.middleware.s3api.s3api:filter_factory
+	s3token = swift.common.middleware.s3api.s3token:filter_factory
+	etag_quoter = swift.common.middleware.etag_quoter:filter_factory
+swift.diskfile = 
+	replication.fs = swift.obj.diskfile:DiskFileManager
+	erasure_coding.fs = swift.obj.diskfile:ECDiskFileManager
 
 [egg_info]
-tag_build =
+tag_build = 
 tag_date = 0
 tag_svn_revision = 0
 
@@ -161,3 +157,4 @@ detailed-errors = 1
 cover-package = swift
 cover-html = true
 cover-erase = true
+
diff -pruN 2.25.0-2/swift/cli/info.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/cli/info.py
--- 2.25.0-2/swift/cli/info.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/cli/info.py	2020-07-06 17:03:50.000000000 +0000
@@ -57,6 +57,8 @@ def parse_get_node_args(options, args):
         else:
             raise InfoSystemExit('Ring file does not exist')
 
+    if options.quoted:
+        args = [urllib.parse.unquote(arg) for arg in args]
     if len(args) == 1:
         args = args[0].strip('/').split('/', 2)
 
@@ -90,7 +92,7 @@ def curl_head_command(ip, port, device,
     else:
         formatted_ip = ip
 
-    cmd = 'curl -g -I -XHEAD "http://%s:%s/%s/%s/%s"' % (
+    cmd = 'curl --path-as-is -g -I -XHEAD "http://%s:%s/%s/%s/%s"' % (
         formatted_ip, port, device, part, urllib.parse.quote(target))
     if policy_index is not None:
         cmd += ' -H "%s: %s"' % ('X-Backend-Storage-Policy-Index',
@@ -614,15 +616,15 @@ def print_item_locations(ring, ring_name
         ring = POLICIES.get_object_ring(policy_index, swift_dir)
         ring_name = (POLICIES.get_by_name(policy_name)).ring_name
 
-    if account is None and (container is not None or obj is not None):
+    if (container or obj) and not account:
         print('No account specified')
         raise InfoSystemExit()
 
-    if container is None and obj is not None:
+    if obj and not container:
         print('No container specified')
         raise InfoSystemExit()
 
-    if account is None and part is None:
+    if not account and not part:
         print('No target specified')
         raise InfoSystemExit()
 
@@ -654,8 +656,11 @@ def print_item_locations(ring, ring_name
                 print('Warning: account specified ' +
                       'but ring not named "account"')
 
-    print('\nAccount  \t%s' % account)
-    print('Container\t%s' % container)
-    print('Object   \t%s\n\n' % obj)
+    if account:
+        print('\nAccount  \t%s' % urllib.parse.quote(account))
+    if container:
+        print('Container\t%s' % urllib.parse.quote(container))
+    if obj:
+        print('Object   \t%s\n\n' % urllib.parse.quote(obj))
     print_ring_locations(ring, loc, account, container, obj, part, all_nodes,
                          policy_index=policy_index)
diff -pruN 2.25.0-2/swift/cli/manage_shard_ranges.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/cli/manage_shard_ranges.py
--- 2.25.0-2/swift/cli/manage_shard_ranges.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/cli/manage_shard_ranges.py	2020-07-06 17:03:50.000000000 +0000
@@ -343,7 +343,9 @@ def _replace_shard_ranges(broker, args,
 
     # Crank up the timeout in an effort to *make sure* this succeeds
     with broker.updated_timeout(max(timeout, args.replace_timeout)):
-        delete_shard_ranges(broker, args)
+        delete_status = delete_shard_ranges(broker, args)
+        if delete_status != 0:
+            return delete_status
         broker.merge_shard_ranges(shard_ranges)
 
     print('Injected %d shard ranges.' % len(shard_ranges))
diff -pruN 2.25.0-2/swift/cli/relinker.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/cli/relinker.py
--- 2.25.0-2/swift/cli/relinker.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/cli/relinker.py	2020-07-06 17:03:50.000000000 +0000
@@ -14,8 +14,12 @@
 # limitations under the License.
 
 
+import errno
+import fcntl
+import json
 import logging
 import os
+from functools import partial
 from swift.common.storage_policy import POLICIES
 from swift.common.exceptions import DiskFileDeleted, DiskFileNotExist, \
     DiskFileQuarantined
@@ -24,10 +28,126 @@ from swift.common.utils import replace_p
 from swift.obj import diskfile
 
 
+LOCK_FILE = '.relink.{datadir}.lock'
+STATE_FILE = 'relink.{datadir}.json'
+STATE_TMP_FILE = '.relink.{datadir}.json.tmp'
+STEP_RELINK = 'relink'
+STEP_CLEANUP = 'cleanup'
+
+
+def devices_filter(device, _, devices):
+    if device:
+        devices = [d for d in devices if d == device]
+
+    return set(devices)
+
+
+def hook_pre_device(locks, states, datadir, device_path):
+    lock_file = os.path.join(device_path, LOCK_FILE.format(datadir=datadir))
+
+    fd = os.open(lock_file, os.O_CREAT | os.O_WRONLY)
+    fcntl.flock(fd, fcntl.LOCK_EX)
+    locks[0] = fd
+
+    state_file = os.path.join(device_path, STATE_FILE.format(datadir=datadir))
+    states.clear()
+    try:
+        with open(state_file, 'rt') as f:
+            tmp = json.load(f)
+            states.update(tmp)
+    except ValueError:
+        # Invalid JSON: remove the file to restart from scratch
+        os.unlink(state_file)
+    except IOError as err:
+        # Ignore file not found error
+        if err.errno != errno.ENOENT:
+            raise
+
+
+def hook_post_device(locks, _):
+    os.close(locks[0])
+    locks[0] = None
+
+
+def partitions_filter(states, step, part_power, next_part_power,
+                      datadir_path, partitions):
+    # Remove all non partitions first (eg: auditor_status_ALL.json)
+    partitions = [p for p in partitions if p.isdigit()]
+
+    if not (step == STEP_CLEANUP and part_power == next_part_power):
+        # This is not a cleanup after cancel, partitions in the upper half are
+        # new partitions, there is nothing to relink/cleanup from there
+        partitions = [p for p in partitions
+                      if int(p) < 2 ** next_part_power / 2]
+
+    # Format: { 'part': [relinked, cleaned] }
+    if states:
+        missing = list(set(partitions) - set(states.keys()))
+        if missing:
+            # All missing partitions was created after the first run of
+            # relink, so after the new ring was distribued, so they already
+            # are hardlinked in both partitions, but they will need to
+            # cleaned.. Just update the state file.
+            for part in missing:
+                states[part] = [True, False]
+        if step == STEP_RELINK:
+            partitions = [str(p) for p, (r, c) in states.items() if not r]
+        elif step == STEP_CLEANUP:
+            partitions = [str(p) for p, (r, c) in states.items() if not c]
+    else:
+        states.update({str(p): [False, False] for p in partitions})
+
+    # Always scan the partitions in reverse order to minimize the amount of IO
+    # (it actually only matters for relink, not for cleanup).
+    #
+    # Initial situation:
+    #  objects/0/000/00000000000000000000000000000000/12345.data
+    #  -> relinked to objects/1/000/10000000000000000000000000000000/12345.data
+    #
+    # If the relinker then scan partition 1, it will listdir that object while
+    # it's unnecessary. By working in reverse order of partitions, this is
+    # avoided.
+    partitions = sorted(partitions, key=lambda x: int(x), reverse=True)
+
+    return partitions
+
+
+# Save states when a partition is done
+def hook_post_partition(states, step,
+                        partition_path):
+    part = os.path.basename(os.path.abspath(partition_path))
+    datadir_path = os.path.dirname(os.path.abspath(partition_path))
+    device_path = os.path.dirname(os.path.abspath(datadir_path))
+    datadir_name = os.path.basename(os.path.abspath(datadir_path))
+    state_tmp_file = os.path.join(device_path,
+                                  STATE_TMP_FILE.format(datadir=datadir_name))
+    state_file = os.path.join(device_path,
+                              STATE_FILE.format(datadir=datadir_name))
+
+    if step == STEP_RELINK:
+        states[part][0] = True
+    elif step == STEP_CLEANUP:
+        states[part][1] = True
+    with open(state_tmp_file, 'wt') as f:
+        json.dump(states, f)
+        os.fsync(f.fileno())
+    os.rename(state_tmp_file, state_file)
+
+
+def hashes_filter(next_part_power, suff_path, hashes):
+    hashes = list(hashes)
+    for hsh in hashes:
+        fname = os.path.join(suff_path, hsh, 'fake-file-name')
+        if replace_partition_in_path(fname, next_part_power) == fname:
+            hashes.remove(hsh)
+    return hashes
+
+
 def relink(swift_dir='/etc/swift',
            devices='/srv/node',
            skip_mount_check=False,
-           logger=logging.getLogger()):
+           logger=logging.getLogger(),
+           device=None):
     mount_check = not skip_mount_check
     run = False
     relinked = errors = 0
@@ -41,10 +161,31 @@ def relink(swift_dir='/etc/swift',
         logging.info('Relinking files for policy %s under %s',
                      policy.name, devices)
         run = True
+        datadir = diskfile.get_data_dir(policy)
+
+        locks = [None]
+        states = {}
+        relink_devices_filter = partial(devices_filter, device)
+        relink_hook_pre_device = partial(hook_pre_device, locks, states,
+                                         datadir)
+        relink_hook_post_device = partial(hook_post_device, locks)
+        relink_partition_filter = partial(partitions_filter,
+                                          states, STEP_RELINK,
+                                          part_power, next_part_power)
+        relink_hook_post_partition = partial(hook_post_partition,
+                                             states, STEP_RELINK)
+        relink_hashes_filter = partial(hashes_filter, next_part_power)
+
         locations = audit_location_generator(
             devices,
-            diskfile.get_data_dir(policy),
-            mount_check=mount_check)
+            datadir,
+            mount_check=mount_check,
+            devices_filter=relink_devices_filter,
+            hook_pre_device=relink_hook_pre_device,
+            hook_post_device=relink_hook_post_device,
+            partitions_filter=relink_partition_filter,
+            hook_post_partition=relink_hook_post_partition,
+            hashes_filter=relink_hashes_filter)
         for fname, _, _ in locations:
             newfname = replace_partition_in_path(fname, next_part_power)
             try:
@@ -67,7 +208,8 @@ def relink(swift_dir='/etc/swift',
 def cleanup(swift_dir='/etc/swift',
             devices='/srv/node',
             skip_mount_check=False,
-            logger=logging.getLogger()):
+            logger=logging.getLogger(),
+            device=None):
     mount_check = not skip_mount_check
     conf = {'devices': devices, 'mount_check': mount_check}
     diskfile_router = diskfile.DiskFileRouter(conf, get_logger(conf))
@@ -83,10 +225,31 @@ def cleanup(swift_dir='/etc/swift',
         logging.info('Cleaning up files for policy %s under %s',
                      policy.name, devices)
         run = True
+        datadir = diskfile.get_data_dir(policy)
+
+        locks = [None]
+        states = {}
+        cleanup_devices_filter = partial(devices_filter, device)
+        cleanup_hook_pre_device = partial(hook_pre_device, locks, states,
+                                          datadir)
+        cleanup_hook_post_device = partial(hook_post_device, locks)
+        cleanup_partition_filter = partial(partitions_filter,
+                                           states, STEP_CLEANUP,
+                                           part_power, next_part_power)
+        cleanup_hook_post_partition = partial(hook_post_partition,
+                                              states, STEP_CLEANUP)
+        cleanup_hashes_filter = partial(hashes_filter, next_part_power)
+
         locations = audit_location_generator(
             devices,
-            diskfile.get_data_dir(policy),
-            mount_check=mount_check)
+            datadir,
+            mount_check=mount_check,
+            devices_filter=cleanup_devices_filter,
+            hook_pre_device=cleanup_hook_pre_device,
+            hook_post_device=cleanup_hook_post_device,
+            partitions_filter=cleanup_partition_filter,
+            hook_post_partition=cleanup_hook_post_partition,
+            hashes_filter=cleanup_hashes_filter)
         for fname, device, partition in locations:
             expected_fname = replace_partition_in_path(fname, part_power)
             if fname == expected_fname:
@@ -152,8 +315,10 @@ def main(args):
 
     if args.action == 'relink':
         return relink(
-            args.swift_dir, args.devices, args.skip_mount_check, logger)
+            args.swift_dir, args.devices, args.skip_mount_check, logger,
+            device=args.device)
 
     if args.action == 'cleanup':
         return cleanup(
-            args.swift_dir, args.devices, args.skip_mount_check, logger)
+            args.swift_dir, args.devices, args.skip_mount_check, logger,
+            device=args.device)
diff -pruN 2.25.0-2/swift/cli/ringbuilder.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/cli/ringbuilder.py
--- 2.25.0-2/swift/cli/ringbuilder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/cli/ringbuilder.py	2020-07-06 17:03:50.000000000 +0000
@@ -1658,7 +1658,7 @@ def main(arguments=None):
         print(msg)
         exit(EXIT_ERROR)
     except (exceptions.FileNotFoundError, exceptions.PermissionError) as e:
-        if len(argv) < 3 or argv[2] not in('create', 'write_builder'):
+        if len(argv) < 3 or argv[2] not in ('create', 'write_builder'):
             print(e)
             exit(EXIT_ERROR)
     except Exception as e:
diff -pruN 2.25.0-2/swift/common/db.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/db.py
--- 2.25.0-2/swift/common/db.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/db.py	2020-07-06 17:03:50.000000000 +0000
@@ -53,6 +53,9 @@ PICKLE_PROTOCOL = 2
 # records will be merged.
 PENDING_CAP = 131072
 
+SQLITE_ARG_LIMIT = 999
+RECLAIM_PAGE_SIZE = 10000
+
 
 def utf8encode(*args):
     return [(s.encode('utf8') if isinstance(s, six.text_type) else s)
@@ -981,16 +984,48 @@ class DatabaseBroker(object):
             with lock_parent_directory(self.pending_file,
                                        self.pending_timeout):
                 self._commit_puts()
-        with self.get() as conn:
-            self._reclaim(conn, age_timestamp, sync_timestamp)
-            self._reclaim_metadata(conn, age_timestamp)
-            conn.commit()
+        marker = ''
+        finished = False
+        while not finished:
+            with self.get() as conn:
+                marker = self._reclaim(conn, age_timestamp, marker)
+                if not marker:
+                    finished = True
+                    self._reclaim_other_stuff(
+                        conn, age_timestamp, sync_timestamp)
+                conn.commit()
+
+    def _reclaim_other_stuff(self, conn, age_timestamp, sync_timestamp):
+        """
+        This is only called once at the end of reclaim after _reclaim has been
+        called for each page.
+        """
+        self._reclaim_sync(conn, sync_timestamp)
+        self._reclaim_metadata(conn, age_timestamp)
+
+    def _reclaim(self, conn, age_timestamp, marker):
+        clean_batch_qry = '''
+            DELETE FROM %s WHERE deleted = 1
+            AND name > ? AND %s < ?
+        ''' % (self.db_contains_type, self.db_reclaim_timestamp)
+        curs = conn.execute('''
+            SELECT name FROM %s WHERE deleted = 1
+            AND name > ?
+            ORDER BY NAME LIMIT 1 OFFSET ?
+        ''' % (self.db_contains_type,), (marker, RECLAIM_PAGE_SIZE))
+        row = curs.fetchone()
+        if row:
+            # do a single book-ended DELETE and bounce out
+            end_marker = row[0]
+            conn.execute(clean_batch_qry + ' AND name <= ?', (
+                marker, age_timestamp, end_marker))
+        else:
+            # delete off the end and reset marker to indicate we're done
+            end_marker = ''
+            conn.execute(clean_batch_qry, (marker, age_timestamp))
+        return end_marker
 
-    def _reclaim(self, conn, age_timestamp, sync_timestamp):
-        conn.execute('''
-            DELETE FROM %s WHERE deleted = 1 AND %s < ?
-        ''' % (self.db_contains_type, self.db_reclaim_timestamp),
-            (age_timestamp,))
+    def _reclaim_sync(self, conn, sync_timestamp):
         try:
             conn.execute('''
                 DELETE FROM outgoing_sync WHERE updated_at < ?
diff -pruN 2.25.0-2/swift/common/db_replicator.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/db_replicator.py
--- 2.25.0-2/swift/common/db_replicator.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/db_replicator.py	2020-07-06 17:03:50.000000000 +0000
@@ -205,7 +205,7 @@ class Replicator(Daemon):
                                 ' to use option %(type)s-replicator/'
                                 'interval.'
                                 % {'type': self.server_type})
-        self.databases_per_second = int(
+        self.databases_per_second = float(
             conf.get('databases_per_second', 50))
         self.node_timeout = float(conf.get('node_timeout', 10))
         self.conn_timeout = float(conf.get('conn_timeout', 0.5))
diff -pruN 2.25.0-2/swift/common/memcached.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/memcached.py
--- 2.25.0-2/swift/common/memcached.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/memcached.py	2020-07-06 17:03:50.000000000 +0000
@@ -160,7 +160,7 @@ class MemcacheRing(object):
     def __init__(self, servers, connect_timeout=CONN_TIMEOUT,
                  io_timeout=IO_TIMEOUT, pool_timeout=POOL_TIMEOUT,
                  tries=TRY_COUNT, allow_pickle=False, allow_unpickle=False,
-                 max_conns=2):
+                 max_conns=2, logger=None):
         self._ring = {}
         self._errors = dict(((serv, []) for serv in servers))
         self._error_limited = dict(((serv, 0) for serv in servers))
@@ -178,18 +178,23 @@ class MemcacheRing(object):
         self._pool_timeout = pool_timeout
         self._allow_pickle = allow_pickle
         self._allow_unpickle = allow_unpickle or allow_pickle
+        if logger is None:
+            self.logger = logging.getLogger()
+        else:
+            self.logger = logger
 
     def _exception_occurred(self, server, e, action='talking',
                             sock=None, fp=None, got_connection=True):
         if isinstance(e, Timeout):
-            logging.error("Timeout %(action)s to memcached: %(server)s",
-                          {'action': action, 'server': server})
+            self.logger.error("Timeout %(action)s to memcached: %(server)s",
+                              {'action': action, 'server': server})
         elif isinstance(e, (socket.error, MemcacheConnectionError)):
-            logging.error("Error %(action)s to memcached: %(server)s: %(err)s",
-                          {'action': action, 'server': server, 'err': e})
+            self.logger.error(
+                "Error %(action)s to memcached: %(server)s: %(err)s",
+                {'action': action, 'server': server, 'err': e})
         else:
-            logging.exception("Error %(action)s to memcached: %(server)s",
-                              {'action': action, 'server': server})
+            self.logger.exception("Error %(action)s to memcached: %(server)s",
+                                  {'action': action, 'server': server})
         try:
             if fp:
                 fp.close()
@@ -213,7 +218,7 @@ class MemcacheRing(object):
                                     if err > now - ERROR_LIMIT_TIME]
             if len(self._errors[server]) > ERROR_LIMIT_COUNT:
                 self._error_limited[server] = now + ERROR_LIMIT_DURATION
-                logging.error('Error limiting server %s', server)
+                self.logger.error('Error limiting server %s', server)
 
     def _get_conns(self, key):
         """
diff -pruN 2.25.0-2/swift/common/middleware/etag_quoter.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/etag_quoter.py
--- 2.25.0-2/swift/common/middleware/etag_quoter.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/etag_quoter.py	2020-07-06 17:03:50.000000000 +0000
@@ -105,11 +105,11 @@ class EtagQuoterMiddleware(object):
 
         status, headers, resp_iter = req.call_application(self.app)
 
-        for i, (header, value) in enumerate(headers):
-            if header.lower() == 'etag':
-                if not value.startswith(('"', 'W/"')) or \
-                        not value.endswith('"'):
-                    headers[i] = (header, '"%s"' % value)
+        headers = [
+            (header, value) if header.lower() != 'etag' or (
+                value.startswith(('"', 'W/"')) and value.endswith('"'))
+            else (header, '"%s"' % value)
+            for header, value in headers]
 
         start_response(status, headers)
         return resp_iter
diff -pruN 2.25.0-2/swift/common/middleware/memcache.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/memcache.py
--- 2.25.0-2/swift/common/middleware/memcache.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/memcache.py	2020-07-06 17:03:50.000000000 +0000
@@ -19,6 +19,7 @@ from six.moves.configparser import Confi
 
 from swift.common.memcached import (MemcacheRing, CONN_TIMEOUT, POOL_TIMEOUT,
                                     IO_TIMEOUT, TRY_COUNT)
+from swift.common.utils import get_logger
 
 
 class MemcacheMiddleware(object):
@@ -28,6 +29,7 @@ class MemcacheMiddleware(object):
 
     def __init__(self, app, conf):
         self.app = app
+        self.logger = get_logger(conf, log_route='memcache')
         self.memcache_servers = conf.get('memcache_servers')
         serialization_format = conf.get('memcache_serialization_support')
         try:
@@ -102,7 +104,8 @@ class MemcacheMiddleware(object):
             io_timeout=io_timeout,
             allow_pickle=(serialization_format == 0),
             allow_unpickle=(serialization_format <= 1),
-            max_conns=max_conns)
+            max_conns=max_conns,
+            logger=self.logger)
 
     def __call__(self, env, start_response):
         env['swift.cache'] = self.memcache
diff -pruN 2.25.0-2/swift/common/middleware/ratelimit.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/ratelimit.py
--- 2.25.0-2/swift/common/middleware/ratelimit.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/ratelimit.py	2020-07-06 17:03:50.000000000 +0000
@@ -242,6 +242,10 @@ class RateLimitMiddleware(object):
         if not self.memcache_client:
             return None
 
+        if req.environ.get('swift.ratelimit.handled'):
+            return None
+        req.environ['swift.ratelimit.handled'] = True
+
         try:
             account_info = get_account_info(req.environ, self.app,
                                             swift_source='RL')
diff -pruN 2.25.0-2/swift/common/middleware/s3api/controllers/__init__.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/controllers/__init__.py
--- 2.25.0-2/swift/common/middleware/s3api/controllers/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/controllers/__init__.py	2020-07-06 17:03:50.000000000 +0000
@@ -31,6 +31,8 @@ from swift.common.middleware.s3api.contr
     LoggingStatusController
 from swift.common.middleware.s3api.controllers.versioning import \
     VersioningController
+from swift.common.middleware.s3api.controllers.tagging import \
+    TaggingController
 
 __all__ = [
     'Controller',
@@ -47,6 +49,7 @@ __all__ = [
     'LocationController',
     'LoggingStatusController',
     'VersioningController',
+    'TaggingController',
 
     'UnsupportedController',
 ]
diff -pruN 2.25.0-2/swift/common/middleware/s3api/controllers/multi_upload.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/controllers/multi_upload.py
--- 2.25.0-2/swift/common/middleware/s3api/controllers/multi_upload.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/controllers/multi_upload.py	2020-07-06 17:03:50.000000000 +0000
@@ -108,6 +108,13 @@ def _get_upload_info(req, app, upload_id
     try:
         return req.get_response(app, 'HEAD', container=container, obj=obj)
     except NoSuchKey:
+        try:
+            resp = req.get_response(app, 'HEAD')
+            if resp.sysmeta_headers.get(sysmeta_header(
+                    'object', 'upload-id')) == upload_id:
+                return resp
+        except NoSuchKey:
+            pass
         raise NoSuchUpload(upload_id=upload_id)
     finally:
         # ...making sure to restore any copy-source before returning
@@ -115,9 +122,34 @@ def _get_upload_info(req, app, upload_id
             req.headers['X-Amz-Copy-Source'] = copy_source
 
 
-def _check_upload_info(req, app, upload_id):
+def _make_complete_body(req, s3_etag, yielded_anything):
+    result_elem = Element('CompleteMultipartUploadResult')
 
-    _get_upload_info(req, app, upload_id)
+    # NOTE: boto with sig v4 appends port to HTTP_HOST value at
+    # the request header when the port is non default value and it
+    # makes req.host_url like as http://localhost:8080:8080/path
+    # that obviously invalid. Probably it should be resolved at
+    # swift.common.swob though, tentatively we are parsing and
+    # reconstructing the correct host_url info here.
+    # in detail, https://github.com/boto/boto/pull/3513
+    parsed_url = urlparse(req.host_url)
+    host_url = '%s://%s' % (parsed_url.scheme, parsed_url.hostname)
+    # Why are we doing our own port parsing? Because py3 decided
+    # to start raising ValueErrors on access after parsing such
+    # an invalid port
+    netloc = parsed_url.netloc.split('@')[-1].split(']')[-1]
+    if ':' in netloc:
+        port = netloc.split(':', 2)[1]
+        host_url += ':%s' % port
+
+    SubElement(result_elem, 'Location').text = host_url + req.path
+    SubElement(result_elem, 'Bucket').text = req.container_name
+    SubElement(result_elem, 'Key').text = req.object_name
+    SubElement(result_elem, 'ETag').text = '"%s"' % s3_etag
+    body = tostring(result_elem, xml_declaration=not yielded_anything)
+    if yielded_anything:
+        return b'\n' + body
+    return body
 
 
 class PartController(Controller):
@@ -152,7 +184,7 @@ class PartController(Controller):
                                   err_msg)
 
         upload_id = req.params['uploadId']
-        _check_upload_info(req, self.app, upload_id)
+        _get_upload_info(req, self.app, upload_id)
 
         req.container_name += MULTIUPLOAD_SUFFIX
         req.object_name = '%s/%s/%d' % (req.object_name, upload_id,
@@ -449,7 +481,7 @@ class UploadController(Controller):
             raise InvalidArgument('encoding-type', encoding_type, err_msg)
 
         upload_id = req.params['uploadId']
-        _check_upload_info(req, self.app, upload_id)
+        _get_upload_info(req, self.app, upload_id)
 
         maxparts = req.get_validated_param(
             'max-parts', DEFAULT_MAX_PARTS_LISTING,
@@ -536,7 +568,7 @@ class UploadController(Controller):
         Handles Abort Multipart Upload.
         """
         upload_id = req.params['uploadId']
-        _check_upload_info(req, self.app, upload_id)
+        _get_upload_info(req, self.app, upload_id)
 
         # First check to see if this multi-part upload was already
         # completed.  Look in the primary container, if the object exists,
@@ -580,7 +612,8 @@ class UploadController(Controller):
         """
         upload_id = req.params['uploadId']
         resp = _get_upload_info(req, self.app, upload_id)
-        headers = {'Accept': 'application/json'}
+        headers = {'Accept': 'application/json',
+                   sysmeta_header('object', 'upload-id'): upload_id}
         for key, val in resp.headers.items():
             _key = key.lower()
             if _key.startswith('x-amz-meta-'):
@@ -650,7 +683,15 @@ class UploadController(Controller):
             raise
 
         s3_etag = '%s-%d' % (s3_etag_hasher.hexdigest(), len(manifest))
-        headers[sysmeta_header('object', 'etag')] = s3_etag
+        s3_etag_header = sysmeta_header('object', 'etag')
+        if resp.sysmeta_headers.get(s3_etag_header) == s3_etag:
+            # This header should only already be present if the upload marker
+            # has been cleaned up and the current target uses the same
+            # upload-id; assuming the segments to use haven't changed, the work
+            # is already done
+            return HTTPOk(body=_make_complete_body(req, s3_etag, False),
+                          content_type='application/xml')
+        headers[s3_etag_header] = s3_etag
         # Leave base header value blank; SLO will populate
         c_etag = '; s3_etag=%s' % s3_etag
         headers[get_container_update_override_key('etag')] = c_etag
@@ -730,37 +771,13 @@ class UploadController(Controller):
                 try:
                     req.get_response(self.app, 'DELETE', container, obj)
                 except NoSuchKey:
-                    # We know that this existed long enough for us to HEAD
+                    # The important thing is that we wrote out a tombstone to
+                    # make sure the marker got cleaned up. If it's already
+                    # gone (e.g., because of concurrent completes or a retried
+                    # complete), so much the better.
                     pass
 
-                result_elem = Element('CompleteMultipartUploadResult')
-
-                # NOTE: boto with sig v4 appends port to HTTP_HOST value at
-                # the request header when the port is non default value and it
-                # makes req.host_url like as http://localhost:8080:8080/path
-                # that obviously invalid. Probably it should be resolved at
-                # swift.common.swob though, tentatively we are parsing and
-                # reconstructing the correct host_url info here.
-                # in detail, https://github.com/boto/boto/pull/3513
-                parsed_url = urlparse(req.host_url)
-                host_url = '%s://%s' % (parsed_url.scheme, parsed_url.hostname)
-                # Why are we doing our own port parsing? Because py3 decided
-                # to start raising ValueErrors on access after parsing such
-                # an invalid port
-                netloc = parsed_url.netloc.split('@')[-1].split(']')[-1]
-                if ':' in netloc:
-                    port = netloc.split(':', 2)[1]
-                    host_url += ':%s' % port
-
-                SubElement(result_elem, 'Location').text = host_url + req.path
-                SubElement(result_elem, 'Bucket').text = req.container_name
-                SubElement(result_elem, 'Key').text = req.object_name
-                SubElement(result_elem, 'ETag').text = '"%s"' % s3_etag
-                resp.headers.pop('ETag', None)
-                if yielded_anything:
-                    yield b'\n'
-                yield tostring(result_elem,
-                               xml_declaration=not yielded_anything)
+                yield _make_complete_body(req, s3_etag, yielded_anything)
             except ErrorResponse as err_resp:
                 if yielded_anything:
                     err_resp.xml_declaration = False
diff -pruN 2.25.0-2/swift/common/middleware/s3api/controllers/obj.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/controllers/obj.py
--- 2.25.0-2/swift/common/middleware/s3api/controllers/obj.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/controllers/obj.py	2020-07-06 17:03:50.000000000 +0000
@@ -26,7 +26,7 @@ from swift.common.middleware.versioned_w
 from swift.common.middleware.s3api.utils import S3Timestamp, sysmeta_header
 from swift.common.middleware.s3api.controllers.base import Controller
 from swift.common.middleware.s3api.s3response import S3NotImplemented, \
-    InvalidRange, NoSuchKey, InvalidArgument, HTTPNoContent, \
+    InvalidRange, NoSuchKey, NoSuchVersion, InvalidArgument, HTTPNoContent, \
     PreconditionFailed
 
 
@@ -88,7 +88,15 @@ class ObjectController(Controller):
         if version_id not in ('null', None) and \
                 'object_versioning' not in get_swift_info():
             raise S3NotImplemented()
+
         query = {} if version_id is None else {'version-id': version_id}
+        if version_id not in ('null', None):
+            container_info = req.get_container_info(self.app)
+            if not container_info.get(
+                    'sysmeta', {}).get('versions-container', ''):
+                # Versioning has never been enabled
+                raise NoSuchVersion(object_name, version_id)
+
         resp = req.get_response(self.app, query=query)
 
         if req.method == 'HEAD':
@@ -193,17 +201,25 @@ class ObjectController(Controller):
                 'object_versioning' not in get_swift_info():
             raise S3NotImplemented()
 
+        version_id = req.params.get('versionId')
+        if version_id not in ('null', None):
+            container_info = req.get_container_info(self.app)
+            if not container_info.get(
+                    'sysmeta', {}).get('versions-container', ''):
+                # Versioning has never been enabled
+                return HTTPNoContent(headers={'x-amz-version-id': version_id})
+
         try:
             try:
                 query = req.gen_multipart_manifest_delete_query(
-                    self.app, version=req.params.get('versionId'))
+                    self.app, version=version_id)
             except NoSuchKey:
                 query = {}
 
             req.headers['Content-Type'] = None  # Ignore client content-type
 
-            if 'versionId' in req.params:
-                query['version-id'] = req.params['versionId']
+            if version_id is not None:
+                query['version-id'] = version_id
                 query['symlink'] = 'get'
 
             resp = req.get_response(self.app, query=query)
diff -pruN 2.25.0-2/swift/common/middleware/s3api/controllers/tagging.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/controllers/tagging.py
--- 2.25.0-2/swift/common/middleware/s3api/controllers/tagging.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/controllers/tagging.py	2020-07-06 17:03:50.000000000 +0000
@@ -0,0 +1,57 @@
+# Copyright (c) 2014 OpenStack Foundation.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+# implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+from swift.common.utils import public
+
+from swift.common.middleware.s3api.controllers.base import Controller, \
+    S3NotImplemented
+from swift.common.middleware.s3api.s3response import HTTPOk
+from swift.common.middleware.s3api.etree import Element, tostring, \
+    SubElement
+
+
+class TaggingController(Controller):
+    """
+    Handles the following APIs:
+
+    * GET Bucket and Object tagging
+    * PUT Bucket and Object tagging
+    * DELETE Bucket and Object tagging
+
+    """
+    @public
+    def GET(self, req):
+        """
+        Handles GET Bucket and Object tagging.
+        """
+        elem = Element('Tagging')
+        SubElement(elem, 'TagSet')
+        body = tostring(elem)
+
+        return HTTPOk(body=body, content_type=None)
+
+    @public
+    def PUT(self, req):
+        """
+        Handles PUT Bucket and Object tagging.
+        """
+        raise S3NotImplemented('The requested resource is not implemented')
+
+    @public
+    def DELETE(self, req):
+        """
+        Handles DELETE Bucket and Object tagging.
+        """
+        raise S3NotImplemented('The requested resource is not implemented')
diff -pruN 2.25.0-2/swift/common/middleware/s3api/etree.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/etree.py
--- 2.25.0-2/swift/common/middleware/s3api/etree.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/etree.py	2020-07-06 17:03:50.000000000 +0000
@@ -92,7 +92,7 @@ def tostring(tree, use_s3ns=True, xml_de
 
         root = Element(tree.tag, attrib=tree.attrib, nsmap=nsmap)
         root.text = tree.text
-        root.extend(deepcopy(tree.getchildren()))
+        root.extend(deepcopy(list(tree)))
         tree = root
 
     return lxml.etree.tostring(tree, xml_declaration=xml_declaration,
diff -pruN 2.25.0-2/swift/common/middleware/s3api/s3request.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/s3request.py
--- 2.25.0-2/swift/common/middleware/s3api/s3request.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/s3request.py	2020-07-06 17:03:50.000000000 +0000
@@ -37,15 +37,15 @@ from swift.common.http import HTTP_OK, H
     HTTP_TOO_MANY_REQUESTS, HTTP_RATE_LIMITED, is_success
 
 from swift.common.constraints import check_utf8
-from swift.proxy.controllers.base import get_container_info, \
-    headers_to_container_info
+from swift.proxy.controllers.base import get_container_info
 from swift.common.request_helpers import check_path_header
 
 from swift.common.middleware.s3api.controllers import ServiceController, \
     ObjectController, AclController, MultiObjectDeleteController, \
     LocationController, LoggingStatusController, PartController, \
     UploadController, UploadsController, VersioningController, \
-    UnsupportedController, S3AclController, BucketController
+    UnsupportedController, S3AclController, BucketController, \
+    TaggingController
 from swift.common.middleware.s3api.s3response import AccessDenied, \
     InvalidArgument, InvalidDigest, BucketAlreadyOwnedByYou, \
     RequestTimeTooSkewed, S3Response, SignatureDoesNotMatch, \
@@ -1026,9 +1026,11 @@ class S3Request(swob.Request):
             return UploadsController
         if 'versioning' in self.params:
             return VersioningController
+        if 'tagging' in self.params:
+            return TaggingController
 
         unsupported = ('notification', 'policy', 'requestPayment', 'torrent',
-                       'website', 'cors', 'tagging', 'restore')
+                       'website', 'cors', 'restore')
         if set(unsupported) & set(self.params):
             return UnsupportedController
 
@@ -1436,25 +1438,28 @@ class S3Request(swob.Request):
         :raises: NoSuchBucket when the container doesn't exist
         :raises: InternalError when the request failed without 404
         """
-        if self.is_authenticated:
-            # if we have already authenticated, yes we can use the account
-            # name like as AUTH_xxx for performance efficiency
-            sw_req = self.to_swift_req(app, self.container_name, None)
-            info = get_container_info(sw_req.environ, app, swift_source='S3')
-            if is_success(info['status']):
-                return info
-            elif info['status'] == 404:
-                raise NoSuchBucket(self.container_name)
-            else:
-                raise InternalError(
-                    'unexpected status code %d' % info['status'])
+        if not self.is_authenticated:
+            sw_req = self.to_swift_req('TEST', None, None, body='')
+            # don't show log message of this request
+            sw_req.environ['swift.proxy_access_log_made'] = True
+
+            sw_resp = sw_req.get_response(app)
+
+            if not sw_req.remote_user:
+                raise SignatureDoesNotMatch(
+                    **self.signature_does_not_match_kwargs())
+
+            _, self.account, _ = split_path(sw_resp.environ['PATH_INFO'],
+                                            2, 3, True)
+        sw_req = self.to_swift_req(app, self.container_name, None)
+        info = get_container_info(sw_req.environ, app, swift_source='S3')
+        if is_success(info['status']):
+            return info
+        elif info['status'] == 404:
+            raise NoSuchBucket(self.container_name)
         else:
-            # otherwise we do naive HEAD request with the authentication
-            resp = self.get_response(app, 'HEAD', self.container_name, '')
-            headers = resp.sw_headers.copy()
-            headers.update(resp.sysmeta_headers)
-            return headers_to_container_info(
-                headers, resp.status_int)  # pylint: disable-msg=E1101
+            raise InternalError(
+                'unexpected status code %d' % info['status'])
 
     def gen_multipart_manifest_delete_query(self, app, obj=None, version=None):
         if not self.allow_multipart_uploads:
diff -pruN 2.25.0-2/swift/common/middleware/s3api/utils.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/utils.py
--- 2.25.0-2/swift/common/middleware/s3api/utils.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/s3api/utils.py	2020-07-06 17:03:50.000000000 +0000
@@ -120,10 +120,6 @@ class S3Timestamp(utils.Timestamp):
         return self.isoformat.replace(
             '-', '').replace(':', '')[:-7] + 'Z'
 
-    @classmethod
-    def now(cls):
-        return cls(time.time())
-
 
 def mktime(timestamp_str, time_format='%Y-%m-%dT%H:%M:%S'):
     """
diff -pruN 2.25.0-2/swift/common/middleware/symlink.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/symlink.py
--- 2.25.0-2/swift/common/middleware/symlink.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/symlink.py	2020-07-06 17:03:50.000000000 +0000
@@ -205,7 +205,8 @@ from swift.common.utils import get_logge
     MD5_OF_EMPTY_STRING, close_if_possible, closing_if_possible, \
     config_true_value, drain_and_close
 from swift.common.constraints import check_account_format
-from swift.common.wsgi import WSGIContext, make_subrequest
+from swift.common.wsgi import WSGIContext, make_subrequest, \
+    make_pre_authed_request
 from swift.common.request_helpers import get_sys_meta_prefix, \
     check_path_header, get_container_update_override_key, \
     update_ignore_range_header
@@ -442,7 +443,9 @@ class SymlinkObjectContext(WSGIContext):
                                content_type='text/plain')
 
     def _recursive_get_head(self, req, target_etag=None,
-                            follow_softlinks=True):
+                            follow_softlinks=True, orig_req=None):
+        if not orig_req:
+            orig_req = req
         resp = self._app_call(req.environ)
 
         def build_traversal_req(symlink_target):
@@ -457,9 +460,20 @@ class SymlinkObjectContext(WSGIContext):
                 '/', version, account,
                 symlink_target.lstrip('/'))
             self._last_target_path = target_path
-            new_req = make_subrequest(
-                req.environ, path=target_path, method=req.method,
-                headers=req.headers, swift_source='SYM')
+
+            subreq_headers = dict(req.headers)
+            if self._response_header_value(ALLOW_RESERVED_NAMES):
+                # this symlink's sysmeta says it can point to reserved names,
+                # we're infering that some piece of middleware had previously
+                # authorized this request because users can't access reserved
+                # names directly
+                subreq_meth = make_pre_authed_request
+                subreq_headers['X-Backend-Allow-Reserved-Names'] = 'true'
+            else:
+                subreq_meth = make_subrequest
+            new_req = subreq_meth(orig_req.environ, path=target_path,
+                                  method=req.method, headers=subreq_headers,
+                                  swift_source='SYM')
             new_req.headers.pop('X-Backend-Storage-Policy-Index', None)
             return new_req
 
@@ -484,11 +498,8 @@ class SymlinkObjectContext(WSGIContext):
             if not config_true_value(
                     self._response_header_value(SYMLOOP_EXTEND)):
                 self._loop_count += 1
-            if config_true_value(
-                    self._response_header_value(ALLOW_RESERVED_NAMES)):
-                new_req.headers['X-Backend-Allow-Reserved-Names'] = 'true'
-
-            return self._recursive_get_head(new_req, target_etag=resp_etag)
+            return self._recursive_get_head(new_req, target_etag=resp_etag,
+                                            orig_req=req)
         else:
             final_etag = self._response_header_value('etag')
             if final_etag and target_etag and target_etag != final_etag:
diff -pruN 2.25.0-2/swift/common/middleware/versioned_writes/object_versioning.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/versioned_writes/object_versioning.py
--- 2.25.0-2/swift/common/middleware/versioned_writes/object_versioning.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/middleware/versioned_writes/object_versioning.py	2020-07-06 17:03:50.000000000 +0000
@@ -152,7 +152,7 @@ from cgi import parse_header
 from six.moves.urllib.parse import unquote
 
 from swift.common.constraints import MAX_FILE_SIZE, valid_api_version, \
-    ACCOUNT_LISTING_LIMIT
+    ACCOUNT_LISTING_LIMIT, CONTAINER_LISTING_LIMIT
 from swift.common.http import is_success, is_client_error, HTTP_NOT_FOUND, \
     HTTP_CONFLICT
 from swift.common.request_helpers import get_sys_meta_prefix, \
@@ -1191,7 +1191,7 @@ class ContainerContext(ObjectVersioningC
                     'hash': item['hash'],
                     'last_modified': item['last_modified'],
                 })
-            limit = constrain_req_limit(req, ACCOUNT_LISTING_LIMIT)
+            limit = constrain_req_limit(req, CONTAINER_LISTING_LIMIT)
             body = build_listing(
                 null_listing, subdir_listing, broken_listing,
                 reverse=config_true_value(params.get('reverse', 'no')),
@@ -1256,7 +1256,7 @@ class ContainerContext(ObjectVersioningC
                         'last_modified': item['last_modified'],
                     })
 
-                limit = constrain_req_limit(req, ACCOUNT_LISTING_LIMIT)
+                limit = constrain_req_limit(req, CONTAINER_LISTING_LIMIT)
                 body = build_listing(
                     null_listing, versions_listing,
                     subdir_listing, broken_listing,
diff -pruN 2.25.0-2/swift/common/swob.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/swob.py
--- 2.25.0-2/swift/common/swob.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/swob.py	2020-07-06 17:03:50.000000000 +0000
@@ -43,7 +43,6 @@ from email.utils import parsedate
 import re
 import random
 import functools
-import inspect
 from io import BytesIO
 
 import six
@@ -1563,23 +1562,15 @@ def wsgify(func):
     return a Response object into WSGI callables.  Also catches any raised
     HTTPExceptions and treats them as a returned Response.
     """
-    argspec = inspect.getargspec(func)
-    if argspec.args and argspec.args[0] == 'self':
-        @functools.wraps(func)
-        def _wsgify_self(self, env, start_response):
-            try:
-                return func(self, Request(env))(env, start_response)
-            except HTTPException as err_resp:
-                return err_resp(env, start_response)
-        return _wsgify_self
-    else:
-        @functools.wraps(func)
-        def _wsgify_bare(env, start_response):
-            try:
-                return func(Request(env))(env, start_response)
-            except HTTPException as err_resp:
-                return err_resp(env, start_response)
-        return _wsgify_bare
+    @functools.wraps(func)
+    def _wsgify(*args):
+        env, start_response = args[-2:]
+        new_args = args[:-2] + (Request(env), )
+        try:
+            return func(*new_args)(env, start_response)
+        except HTTPException as err_resp:
+            return err_resp(env, start_response)
+    return _wsgify
 
 
 class StatusMap(object):
diff -pruN 2.25.0-2/swift/common/utils.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/utils.py
--- 2.25.0-2/swift/common/utils.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/utils.py	2020-07-06 17:03:50.000000000 +0000
@@ -48,6 +48,7 @@ import ctypes.util
 from copy import deepcopy
 from optparse import OptionParser
 import traceback
+import warnings
 
 from tempfile import gettempdir, mkstemp, NamedTemporaryFile
 import glob
@@ -75,6 +76,7 @@ if not six.PY2:
     utf16_decoder = codecs.getdecoder('utf-16')
     utf16_encoder = codecs.getencoder('utf-16')
 from six.moves import cPickle as pickle
+from six.moves import configparser
 from six.moves.configparser import (ConfigParser, NoSectionError,
                                     NoOptionError, RawConfigParser)
 from six.moves import range, http_client
@@ -2984,6 +2986,17 @@ def read_conf_dir(parser, conf_dir):
     return parser.read(sorted(conf_files))
 
 
+if six.PY2:
+    NicerInterpolation = None  # just don't cause ImportErrors over in wsgi.py
+else:
+    class NicerInterpolation(configparser.BasicInterpolation):
+        def before_get(self, parser, section, option, value, defaults):
+            if '%(' not in value:
+                return value
+            return super(NicerInterpolation, self).before_get(
+                parser, section, option, value, defaults)
+
+
 def readconf(conf_path, section_name=None, log_name=None, defaults=None,
              raw=False):
     """
@@ -3005,7 +3018,19 @@ def readconf(conf_path, section_name=Non
     if raw:
         c = RawConfigParser(defaults)
     else:
-        c = ConfigParser(defaults)
+        if six.PY2:
+            c = ConfigParser(defaults)
+        else:
+            # In general, we haven't really thought much about interpolation
+            # in configs. Python's default ConfigParser has always supported
+            # it, though, so *we* got it "for free". Unfortunatley, since we
+            # "supported" interpolation, we have to assume there are
+            # deployments in the wild that use it, and try not to break them.
+            # So, do what we can to mimic the py2 behavior of passing through
+            # values like "1%" (which we want to support for
+            # fallocate_reserve).
+            c = ConfigParser(defaults, interpolation=NicerInterpolation())
+
     if hasattr(conf_path, 'readline'):
         if hasattr(conf_path, 'seek'):
             conf_path.seek(0)
@@ -3151,11 +3176,26 @@ def remove_directory(path):
 
 
 def audit_location_generator(devices, datadir, suffix='',
-                             mount_check=True, logger=None):
+                             mount_check=True, logger=None,
+                             devices_filter=None, partitions_filter=None,
+                             suffixes_filter=None, hashes_filter=None,
+                             hook_pre_device=None, hook_post_device=None,
+                             hook_pre_partition=None, hook_post_partition=None,
+                             hook_pre_suffix=None, hook_post_suffix=None,
+                             hook_pre_hash=None, hook_post_hash=None):
     """
     Given a devices path and a data directory, yield (path, device,
     partition) for all files in that directory
 
+    (devices|partitions|suffixes|hashes)_filter are meant to modify the list of
+    elements that will be iterated. eg: they can be used to exclude some
+    elements based on a custom condition defined by the caller.
+
+    hook_pre_(device|partition|suffix|hash) are called before yielding the
+    element, hook_pos_(device|partition|suffix|hash) are called after the
+    element was yielded. They are meant to do some pre/post processing.
+    eg: saving a progress status.
+
     :param devices: parent directory of the devices to be audited
     :param datadir: a directory located under self.devices. This should be
                     one of the DATADIR constants defined in the account,
@@ -3164,11 +3204,31 @@ def audit_location_generator(devices, da
     :param mount_check: Flag to check if a mount check should be performed
                     on devices
     :param logger: a logger object
+    :devices_filter: a callable taking (devices, [list of devices]) as
+                     parameters and returning a [list of devices]
+    :partitions_filter: a callable taking (datadir_path, [list of parts]) as
+                        parameters and returning a [list of parts]
+    :suffixes_filter: a callable taking (part_path, [list of suffixes]) as
+                      parameters and returning a [list of suffixes]
+    :hashes_filter: a callable taking (suff_path, [list of hashes]) as
+                    parameters and returning a [list of hashes]
+    :hook_pre_device: a callable taking device_path as parameter
+    :hook_post_device: a callable taking device_path as parameter
+    :hook_pre_partition: a callable taking part_path as parameter
+    :hook_post_partition: a callable taking part_path as parameter
+    :hook_pre_suffix: a callable taking suff_path as parameter
+    :hook_post_suffix: a callable taking suff_path as parameter
+    :hook_pre_hash: a callable taking hash_path as parameter
+    :hook_post_hash: a callable taking hash_path as parameter
     """
     device_dir = listdir(devices)
     # randomize devices in case of process restart before sweep completed
     shuffle(device_dir)
+    if devices_filter:
+        device_dir = devices_filter(devices, device_dir)
     for device in device_dir:
+        if hook_pre_device:
+            hook_pre_device(os.path.join(devices, device))
         if mount_check and not ismount(os.path.join(devices, device)):
             if logger:
                 logger.warning(
@@ -3182,24 +3242,36 @@ def audit_location_generator(devices, da
                 logger.warning(_('Skipping %(datadir)s because %(err)s'),
                                {'datadir': datadir_path, 'err': e})
             continue
+        if partitions_filter:
+            partitions = partitions_filter(datadir_path, partitions)
         for partition in partitions:
             part_path = os.path.join(datadir_path, partition)
+            if hook_pre_partition:
+                hook_pre_partition(part_path)
             try:
                 suffixes = listdir(part_path)
             except OSError as e:
                 if e.errno != errno.ENOTDIR:
                     raise
                 continue
+            if suffixes_filter:
+                suffixes = suffixes_filter(part_path, suffixes)
             for asuffix in suffixes:
                 suff_path = os.path.join(part_path, asuffix)
+                if hook_pre_suffix:
+                    hook_pre_suffix(suff_path)
                 try:
                     hashes = listdir(suff_path)
                 except OSError as e:
                     if e.errno != errno.ENOTDIR:
                         raise
                     continue
+                if hashes_filter:
+                    hashes = hashes_filter(suff_path, hashes)
                 for hsh in hashes:
                     hash_path = os.path.join(suff_path, hsh)
+                    if hook_pre_hash:
+                        hook_pre_hash(hash_path)
                     try:
                         files = sorted(listdir(hash_path), reverse=True)
                     except OSError as e:
@@ -3211,6 +3283,14 @@ def audit_location_generator(devices, da
                             continue
                         path = os.path.join(hash_path, fname)
                         yield path, device, partition
+                    if hook_post_hash:
+                        hook_post_hash(hash_path)
+                if hook_post_suffix:
+                    hook_post_suffix(suff_path)
+            if hook_post_partition:
+                hook_post_partition(part_path)
+        if hook_post_device:
+            hook_post_device(os.path.join(devices, device))
 
 
 def ratelimit_sleep(running_time, max_rate, incr_by=1, rate_buffer=5):
@@ -4346,7 +4426,7 @@ def get_expirer_container(x_delete_at, e
     """
     shard_int = int(hash_path(acc, cont, obj), 16) % 100
     return normalize_delete_at_timestamp(
-        int(x_delete_at) / expirer_divisor * expirer_divisor - shard_int)
+        int(x_delete_at) // expirer_divisor * expirer_divisor - shard_int)
 
 
 class _MultipartMimeFileLikeObject(object):
@@ -4813,6 +4893,8 @@ class ShardRange(object):
         value.
     :param epoch: optional epoch timestamp which represents the time at which
         sharding was enabled for a container.
+    :param reported: optional indicator that this shard and its stats have
+        been reported to the root container.
     """
     FOUND = 10
     CREATED = 20
@@ -4863,7 +4945,8 @@ class ShardRange(object):
 
     def __init__(self, name, timestamp, lower=MIN, upper=MAX,
                  object_count=0, bytes_used=0, meta_timestamp=None,
-                 deleted=False, state=None, state_timestamp=None, epoch=None):
+                 deleted=False, state=None, state_timestamp=None, epoch=None,
+                 reported=False):
         self.account = self.container = self._timestamp = \
             self._meta_timestamp = self._state_timestamp = self._epoch = None
         self._lower = ShardRange.MIN
@@ -4882,6 +4965,7 @@ class ShardRange(object):
         self.state = self.FOUND if state is None else state
         self.state_timestamp = state_timestamp
         self.epoch = epoch
+        self.reported = reported
 
     @classmethod
     def _encode(cls, value):
@@ -4985,8 +5069,10 @@ class ShardRange(object):
 
     @lower.setter
     def lower(self, value):
-        if value in (None, b'', u''):
-            value = ShardRange.MIN
+        with warnings.catch_warnings():
+            warnings.simplefilter('ignore', UnicodeWarning)
+            if value in (None, b'', u''):
+                value = ShardRange.MIN
         try:
             value = self._encode_bound(value)
         except TypeError as err:
@@ -5011,8 +5097,10 @@ class ShardRange(object):
 
     @upper.setter
     def upper(self, value):
-        if value in (None, b'', u''):
-            value = ShardRange.MAX
+        with warnings.catch_warnings():
+            warnings.simplefilter('ignore', UnicodeWarning)
+            if value in (None, b'', u''):
+                value = ShardRange.MAX
         try:
             value = self._encode_bound(value)
         except TypeError as err:
@@ -5058,8 +5146,14 @@ class ShardRange(object):
             cast to an int, or if meta_timestamp is neither None nor can be
             cast to a :class:`~swift.common.utils.Timestamp`.
         """
-        self.object_count = int(object_count)
-        self.bytes_used = int(bytes_used)
+        if self.object_count != int(object_count):
+            self.object_count = int(object_count)
+            self.reported = False
+
+        if self.bytes_used != int(bytes_used):
+            self.bytes_used = int(bytes_used)
+            self.reported = False
+
         if meta_timestamp is None:
             self.meta_timestamp = Timestamp.now()
         else:
@@ -5140,6 +5234,14 @@ class ShardRange(object):
     def epoch(self, epoch):
         self._epoch = self._to_timestamp(epoch)
 
+    @property
+    def reported(self):
+        return self._reported
+
+    @reported.setter
+    def reported(self, value):
+        self._reported = bool(value)
+
     def update_state(self, state, state_timestamp=None):
         """
         Set state to the given value and optionally update the state_timestamp
@@ -5156,6 +5258,7 @@ class ShardRange(object):
         self.state = state
         if state_timestamp is not None:
             self.state_timestamp = state_timestamp
+        self.reported = False
         return True
 
     @property
@@ -5278,6 +5381,7 @@ class ShardRange(object):
         yield 'state', self.state
         yield 'state_timestamp', self.state_timestamp.internal
         yield 'epoch', self.epoch.internal if self.epoch is not None else None
+        yield 'reported', 1 if self.reported else 0
 
     def copy(self, timestamp=None, **kwargs):
         """
@@ -5309,7 +5413,8 @@ class ShardRange(object):
             params['name'], params['timestamp'], params['lower'],
             params['upper'], params['object_count'], params['bytes_used'],
             params['meta_timestamp'], params['deleted'], params['state'],
-            params['state_timestamp'], params['epoch'])
+            params['state_timestamp'], params['epoch'],
+            params.get('reported', 0))
 
 
 def find_shard_range(item, ranges):
diff -pruN 2.25.0-2/swift/common/wsgi.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/wsgi.py
--- 2.25.0-2/swift/common/wsgi.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/common/wsgi.py	2020-07-06 17:03:50.000000000 +0000
@@ -36,7 +36,6 @@ from io import BytesIO
 
 import six
 from six import StringIO
-from six.moves import configparser
 
 from swift.common import utils, constraints
 from swift.common.storage_policy import BindPortsCache
@@ -45,7 +44,7 @@ from swift.common.swob import Request, w
 from swift.common.utils import capture_stdio, disable_fallocate, \
     drop_privileges, get_logger, NullLogger, config_true_value, \
     validate_configuration, get_hub, config_auto_int_value, \
-    reiterate, clean_up_daemon_hygiene, systemd_notify
+    reiterate, clean_up_daemon_hygiene, systemd_notify, NicerInterpolation
 
 SIGNUM_TO_NAME = {getattr(signal, n): n for n in dir(signal)
                   if n.startswith('SIG') and '_' not in n}
@@ -61,23 +60,6 @@ except (ImportError, NotImplementedError
     CPU_COUNT = 1
 
 
-if not six.PY2:
-    # In general, we haven't really thought much about interpolation in
-    # configs. Python's default ConfigParser has always supported it, though,
-    # so *we* got it "for free". Unfortunatley, since we "supported"
-    # interpolation, we have to assume there are deployments in the wild that
-    # use it, and try not to break them. So, do what we can to mimic the py2
-    # behavior of passing through values like "1%" (which we want to support
-    # for fallocate_reserve).
-    class NicerInterpolation(configparser.BasicInterpolation):
-        def before_get(self, parser, section, option, value, defaults):
-            if '%(' not in value:
-                return value
-            return super(NicerInterpolation, self).before_get(
-                parser, section, option, value, defaults)
-    configparser.ConfigParser._DEFAULT_INTERPOLATION = NicerInterpolation()
-
-
 class NamedConfigLoader(loadwsgi.ConfigLoader):
     """
     Patch paste.deploy's ConfigLoader so each context object will know what
@@ -85,6 +67,8 @@ class NamedConfigLoader(loadwsgi.ConfigL
     """
 
     def get_context(self, object_type, name=None, global_conf=None):
+        if not six.PY2:
+            self.parser._interpolation = NicerInterpolation()
         context = super(NamedConfigLoader, self).get_context(
             object_type, name=name, global_conf=global_conf)
         context.name = name
diff -pruN 2.25.0-2/swift/container/backend.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/container/backend.py
--- 2.25.0-2/swift/container/backend.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/container/backend.py	2020-07-06 17:03:50.000000000 +0000
@@ -34,9 +34,7 @@ from swift.common.utils import Timestamp
     get_db_files, parse_db_filename, make_db_file_path, split_path, \
     RESERVED_BYTE
 from swift.common.db import DatabaseBroker, utf8encode, BROKER_TIMEOUT, \
-    zero_like, DatabaseAlreadyExists
-
-SQLITE_ARG_LIMIT = 999
+    zero_like, DatabaseAlreadyExists, SQLITE_ARG_LIMIT
 
 DATADIR = 'containers'
 
@@ -62,7 +60,7 @@ SHARD_UPDATE_STATES = [ShardRange.CREATE
 # tuples and vice-versa
 SHARD_RANGE_KEYS = ('name', 'timestamp', 'lower', 'upper', 'object_count',
                     'bytes_used', 'meta_timestamp', 'deleted', 'state',
-                    'state_timestamp', 'epoch')
+                    'state_timestamp', 'epoch', 'reported')
 
 POLICY_STAT_TABLE_CREATE = '''
     CREATE TABLE policy_stat (
@@ -269,6 +267,7 @@ def merge_shards(shard_data, existing):
     if existing['timestamp'] < shard_data['timestamp']:
         # note that currently we do not roll forward any meta or state from
         # an item that was created at older time, newer created time trumps
+        shard_data['reported'] = 0  # reset the latch
         return True
     elif existing['timestamp'] > shard_data['timestamp']:
         return False
@@ -285,6 +284,18 @@ def merge_shards(shard_data, existing):
     else:
         new_content = True
 
+    # We can latch the reported flag
+    if existing['reported'] and \
+            existing['object_count'] == shard_data['object_count'] and \
+            existing['bytes_used'] == shard_data['bytes_used'] and \
+            existing['state'] == shard_data['state'] and \
+            existing['epoch'] == shard_data['epoch']:
+        shard_data['reported'] = 1
+    else:
+        shard_data.setdefault('reported', 0)
+        if shard_data['reported'] and not existing['reported']:
+            new_content = True
+
     if (existing['state_timestamp'] == shard_data['state_timestamp']
             and shard_data['state'] > existing['state']):
         new_content = True
@@ -597,7 +608,8 @@ class ContainerBroker(DatabaseBroker):
                 deleted INTEGER DEFAULT 0,
                 state INTEGER,
                 state_timestamp TEXT,
-                epoch TEXT
+                epoch TEXT,
+                reported INTEGER DEFAULT 0
             );
         """ % SHARD_RANGE_TABLE)
 
@@ -1430,10 +1442,13 @@ class ContainerBroker(DatabaseBroker):
                 #   sqlite3.OperationalError: cannot start a transaction
                 #   within a transaction
                 conn.rollback()
-                if ('no such table: %s' % SHARD_RANGE_TABLE) not in str(err):
-                    raise
-                self.create_shard_range_table(conn)
-                return _really_merge_items(conn)
+                if 'no such column: reported' in str(err):
+                    self._migrate_add_shard_range_reported(conn)
+                    return _really_merge_items(conn)
+                if ('no such table: %s' % SHARD_RANGE_TABLE) in str(err):
+                    self.create_shard_range_table(conn)
+                    return _really_merge_items(conn)
+                raise
 
     def get_reconciler_sync(self):
         with self.get() as conn:
@@ -1581,9 +1596,20 @@ class ContainerBroker(DatabaseBroker):
             CONTAINER_STAT_VIEW_SCRIPT +
             'COMMIT;')
 
-    def _reclaim(self, conn, age_timestamp, sync_timestamp):
-        super(ContainerBroker, self)._reclaim(conn, age_timestamp,
-                                              sync_timestamp)
+    def _migrate_add_shard_range_reported(self, conn):
+        """
+        Add the reported column to the 'shard_range' table.
+        """
+        conn.executescript('''
+            BEGIN;
+            ALTER TABLE %s
+            ADD COLUMN reported INTEGER DEFAULT 0;
+            COMMIT;
+        ''' % SHARD_RANGE_TABLE)
+
+    def _reclaim_other_stuff(self, conn, age_timestamp, sync_timestamp):
+        super(ContainerBroker, self)._reclaim_other_stuff(
+            conn, age_timestamp, sync_timestamp)
         # populate instance cache, but use existing conn to avoid deadlock
         # when it has a pending update
         self._populate_instance_cache(conn=conn)
@@ -1630,7 +1656,7 @@ class ContainerBroker(DatabaseBroker):
         elif states is not None:
             included_states.add(states)
 
-        def do_query(conn):
+        def do_query(conn, use_reported_column=True):
             condition = ''
             conditions = []
             params = []
@@ -1648,21 +1674,27 @@ class ContainerBroker(DatabaseBroker):
                 params.append(self.path)
             if conditions:
                 condition = ' WHERE ' + ' AND '.join(conditions)
+            if use_reported_column:
+                columns = SHARD_RANGE_KEYS
+            else:
+                columns = SHARD_RANGE_KEYS[:-1] + ('0 as reported', )
             sql = '''
             SELECT %s
             FROM %s%s;
-            ''' % (', '.join(SHARD_RANGE_KEYS), SHARD_RANGE_TABLE, condition)
+            ''' % (', '.join(columns), SHARD_RANGE_TABLE, condition)
             data = conn.execute(sql, params)
             data.row_factory = None
             return [row for row in data]
 
-        try:
-            with self.maybe_get(connection) as conn:
+        with self.maybe_get(connection) as conn:
+            try:
                 return do_query(conn)
-        except sqlite3.OperationalError as err:
-            if ('no such table: %s' % SHARD_RANGE_TABLE) not in str(err):
+            except sqlite3.OperationalError as err:
+                if ('no such table: %s' % SHARD_RANGE_TABLE) in str(err):
+                    return []
+                if 'no such column: reported' in str(err):
+                    return do_query(conn, use_reported_column=False)
                 raise
-            return []
 
     @classmethod
     def resolve_shard_range_states(cls, states):
diff -pruN 2.25.0-2/swift/container/server.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/container/server.py
--- 2.25.0-2/swift/container/server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/container/server.py	2020-07-06 17:03:50.000000000 +0000
@@ -155,6 +155,8 @@ class ContainerController(BaseStorageSer
                 conf['auto_create_account_prefix']
         else:
             self.auto_create_account_prefix = AUTO_CREATE_ACCOUNT_PREFIX
+        self.shards_account_prefix = (
+            self.auto_create_account_prefix + 'shards_')
         if config_true_value(conf.get('allow_versions', 'f')):
             self.save_headers.append('x-versions-location')
         if 'allow_versions' in conf:
@@ -375,14 +377,12 @@ class ContainerController(BaseStorageSer
         # auto create accounts)
         obj_policy_index = self.get_and_validate_policy_index(req) or 0
         broker = self._get_container_broker(drive, part, account, container)
-        if account.startswith(self.auto_create_account_prefix) and obj and \
-                not os.path.exists(broker.db_file):
-            try:
-                broker.initialize(req_timestamp.internal, obj_policy_index)
-            except DatabaseAlreadyExists:
-                pass
-        if not os.path.exists(broker.db_file):
+        if obj:
+            self._maybe_autocreate(broker, req_timestamp, account,
+                                   obj_policy_index, req)
+        elif not os.path.exists(broker.db_file):
             return HTTPNotFound()
+
         if obj:     # delete object
             # redirect if a shard range exists for the object name
             redirect = self._redirect_to_shard(req, broker, obj)
@@ -449,11 +449,25 @@ class ContainerController(BaseStorageSer
             broker.update_status_changed_at(timestamp)
         return recreated
 
+    def _should_autocreate(self, account, req):
+        auto_create_header = req.headers.get('X-Backend-Auto-Create')
+        if auto_create_header:
+            # If the caller included an explicit X-Backend-Auto-Create header,
+            # assume they know the behavior they want
+            return config_true_value(auto_create_header)
+        if account.startswith(self.shards_account_prefix):
+            # we have to specical case this subset of the
+            # auto_create_account_prefix because we don't want the updater
+            # accidently auto-creating shards; only the sharder creates
+            # shards and it will explicitly tell the server to do so
+            return False
+        return account.startswith(self.auto_create_account_prefix)
+
     def _maybe_autocreate(self, broker, req_timestamp, account,
-                          policy_index):
+                          policy_index, req):
         created = False
-        if account.startswith(self.auto_create_account_prefix) and \
-                not os.path.exists(broker.db_file):
+        should_autocreate = self._should_autocreate(account, req)
+        if should_autocreate and not os.path.exists(broker.db_file):
             if policy_index is None:
                 raise HTTPBadRequest(
                     'X-Backend-Storage-Policy-Index header is required')
@@ -506,8 +520,8 @@ class ContainerController(BaseStorageSer
             # obj put expects the policy_index header, default is for
             # legacy support during upgrade.
             obj_policy_index = requested_policy_index or 0
-            self._maybe_autocreate(broker, req_timestamp, account,
-                                   obj_policy_index)
+            self._maybe_autocreate(
+                broker, req_timestamp, account, obj_policy_index, req)
             # redirect if a shard exists for this object name
             response = self._redirect_to_shard(req, broker, obj)
             if response:
@@ -531,8 +545,8 @@ class ContainerController(BaseStorageSer
                                 for sr in json.loads(req.body)]
             except (ValueError, KeyError, TypeError) as err:
                 return HTTPBadRequest('Invalid body: %r' % err)
-            created = self._maybe_autocreate(broker, req_timestamp, account,
-                                             requested_policy_index)
+            created = self._maybe_autocreate(
+                broker, req_timestamp, account, requested_policy_index, req)
             self._update_metadata(req, broker, req_timestamp, 'PUT')
             if shard_ranges:
                 # TODO: consider writing the shard ranges into the pending
@@ -805,7 +819,7 @@ class ContainerController(BaseStorageSer
         requested_policy_index = self.get_and_validate_policy_index(req)
         broker = self._get_container_broker(drive, part, account, container)
         self._maybe_autocreate(broker, req_timestamp, account,
-                               requested_policy_index)
+                               requested_policy_index, req)
         try:
             objs = json.load(req.environ['wsgi.input'])
         except ValueError as err:
diff -pruN 2.25.0-2/swift/container/sharder.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/container/sharder.py
--- 2.25.0-2/swift/container/sharder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/container/sharder.py	2020-07-06 17:03:50.000000000 +0000
@@ -618,7 +618,8 @@ class ContainerSharder(ContainerReplicat
 
     def _send_shard_ranges(self, account, container, shard_ranges,
                            headers=None):
-        body = json.dumps([dict(sr) for sr in shard_ranges]).encode('ascii')
+        body = json.dumps([dict(sr, reported=0)
+                           for sr in shard_ranges]).encode('ascii')
         part, nodes = self.ring.get_nodes(account, container)
         headers = headers or {}
         headers.update({'X-Backend-Record-Type': RECORD_TYPE_SHARD,
@@ -1148,7 +1149,8 @@ class ContainerSharder(ContainerReplicat
                 'X-Backend-Storage-Policy-Index': broker.storage_policy_index,
                 'X-Container-Sysmeta-Shard-Quoted-Root': quote(
                     broker.root_path),
-                'X-Container-Sysmeta-Sharding': True}
+                'X-Container-Sysmeta-Sharding': 'True',
+                'X-Backend-Auto-Create': 'True'}
             # NB: we *used* to send along
             #    'X-Container-Sysmeta-Shard-Root': broker.root_path
             # but that isn't safe for container names with nulls or newlines
@@ -1468,7 +1470,7 @@ class ContainerSharder(ContainerReplicat
 
     def _update_root_container(self, broker):
         own_shard_range = broker.get_own_shard_range(no_default=True)
-        if not own_shard_range:
+        if not own_shard_range or own_shard_range.reported:
             return
 
         # persist the reported shard metadata
@@ -1478,9 +1480,12 @@ class ContainerSharder(ContainerReplicat
             include_own=True,
             include_deleted=True)
         # send everything
-        self._send_shard_ranges(
-            broker.root_account, broker.root_container,
-            shard_ranges)
+        if self._send_shard_ranges(
+                broker.root_account, broker.root_container, shard_ranges):
+            # on success, mark ourselves as reported so we don't keep
+            # hammering the root
+            own_shard_range.reported = True
+            broker.merge_shard_ranges(own_shard_range)
 
     def _process_broker(self, broker, node, part):
         broker.get_info()  # make sure account/container are populated
diff -pruN 2.25.0-2/swift/locale/de/LC_MESSAGES/swift.po 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/locale/de/LC_MESSAGES/swift.po
--- 2.25.0-2/swift/locale/de/LC_MESSAGES/swift.po	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/locale/de/LC_MESSAGES/swift.po	2020-07-06 17:03:50.000000000 +0000
@@ -8,15 +8,16 @@
 # Jonas John <jonas.john@e-werkzeug.eu>, 2015
 # Andreas Jaeger <jaegerandi@gmail.com>, 2016. #zanata
 # Andreas Jaeger <jaegerandi@gmail.com>, 2019. #zanata
+# Andreas Jaeger <jaegerandi@gmail.com>, 2020. #zanata
 msgid ""
 msgstr ""
 "Project-Id-Version: swift VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2020-04-10 12:00+0000\n"
+"POT-Creation-Date: 2020-04-24 07:01+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"PO-Revision-Date: 2019-10-03 06:49+0000\n"
+"PO-Revision-Date: 2020-04-25 11:39+0000\n"
 "Last-Translator: Andreas Jaeger <jaegerandi@gmail.com>\n"
 "Language: de\n"
 "Plural-Forms: nplurals=2; plural=(n != 1);\n"
@@ -846,6 +847,10 @@ msgstr ""
 "Partitionszeiten: max. %(max).4fs, min. %(min).4fs, durchschnittl. %(med).4fs"
 
 #, python-format
+msgid "Pass completed in %(time)ds; %(objects)d objects expired"
+msgstr "Durchgänge abgeschlossen in %(time)ds; %(objects)d Objekte abgelaufen"
+
+#, python-format
 msgid "Pass so far %(time)ds; %(objects)d objects expired"
 msgstr "Bisherige Durchgänge %(time)ds; %(objects)d Objekte abgelaufen"
 
diff -pruN 2.25.0-2/swift/obj/diskfile.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/obj/diskfile.py
--- 2.25.0-2/swift/obj/diskfile.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/obj/diskfile.py	2020-07-06 17:03:50.000000000 +0000
@@ -3031,7 +3031,8 @@ class ECDiskFileReader(BaseDiskFileReade
 
 class ECDiskFileWriter(BaseDiskFileWriter):
 
-    def _finalize_durable(self, data_file_path, durable_data_file_path):
+    def _finalize_durable(self, data_file_path, durable_data_file_path,
+                          timestamp):
         exc = None
         new_data_file_path = new_durable_data_file_path = None
         if self.next_part_power:
@@ -3055,6 +3056,21 @@ class ECDiskFileWriter(BaseDiskFileWrite
                             exc)
 
             except (OSError, IOError) as err:
+                if err.errno == errno.ENOENT:
+                    files = os.listdir(self._datadir)
+                    results = self.manager.get_ondisk_files(
+                        files, self._datadir,
+                        frag_index=self._diskfile._frag_index,
+                        policy=self._diskfile.policy)
+                    # We "succeeded" if another writer cleaned up our data
+                    ts_info = results.get('ts_info')
+                    durables = results.get('durable_frag_set', [])
+                    if ts_info and ts_info['timestamp'] > timestamp:
+                        return
+                    elif any(frag_set['timestamp'] > timestamp
+                             for frag_set in durables):
+                        return
+
                 if err.errno not in (errno.ENOSPC, errno.EDQUOT):
                     # re-raise to catch all handler
                     raise
@@ -3102,7 +3118,8 @@ class ECDiskFileWriter(BaseDiskFileWrite
             self._datadir, self.manager.make_on_disk_filename(
                 timestamp, '.data', self._diskfile._frag_index, durable=True))
         tpool.execute(
-            self._finalize_durable, data_file_path, durable_data_file_path)
+            self._finalize_durable, data_file_path, durable_data_file_path,
+            timestamp)
 
     def put(self, metadata):
         """
diff -pruN 2.25.0-2/swift/obj/updater.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/obj/updater.py
--- 2.25.0-2/swift/obj/updater.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/obj/updater.py	2020-07-06 17:03:50.000000000 +0000
@@ -14,12 +14,13 @@
 # limitations under the License.
 
 import six.moves.cPickle as pickle
+import errno
 import os
 import signal
 import sys
 import time
 from swift import gettext_ as _
-from random import random
+from random import random, shuffle
 
 from eventlet import spawn, Timeout
 
@@ -230,7 +231,9 @@ class ObjectUpdater(Daemon):
                                       'to a valid policy (%(error)s)') % {
                                     'directory': asyncdir, 'error': e})
                 continue
-            for prefix in self._listdir(async_pending):
+            prefix_dirs = self._listdir(async_pending)
+            shuffle(prefix_dirs)
+            for prefix in prefix_dirs:
                 prefix_path = os.path.join(async_pending, prefix)
                 if not os.path.isdir(prefix_path):
                     continue
@@ -271,7 +274,11 @@ class ObjectUpdater(Daemon):
                     if obj_hash == last_obj_hash:
                         self.stats.unlinks += 1
                         self.logger.increment('unlinks')
-                        os.unlink(update_path)
+                        try:
+                            os.unlink(update_path)
+                        except OSError as e:
+                            if e.errno != errno.ENOENT:
+                                raise
                     else:
                         last_obj_hash = obj_hash
                         yield {'device': device, 'policy': policy,
diff -pruN 2.25.0-2/swift/proxy/controllers/base.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/proxy/controllers/base.py
--- 2.25.0-2/swift/proxy/controllers/base.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/proxy/controllers/base.py	2020-07-06 17:03:50.000000000 +0000
@@ -539,31 +539,30 @@ def set_info_cache(app, env, account, co
     :returns: the info that was placed into the cache, or None if the
               request status was not in (404, 410, 2xx).
     """
+    cache_key = get_cache_key(account, container)
     infocache = env.setdefault('swift.infocache', {})
+    memcache = getattr(app, 'memcache', None) or env.get('swift.cache')
+
+    if resp is None:
+        infocache.pop(cache_key, None)
+        if memcache:
+            memcache.delete(cache_key)
+        return
 
-    cache_time = None
-    if container and resp:
+    if container:
         cache_time = int(resp.headers.get(
             'X-Backend-Recheck-Container-Existence',
             DEFAULT_RECHECK_CONTAINER_EXISTENCE))
-    elif resp:
+    else:
         cache_time = int(resp.headers.get(
             'X-Backend-Recheck-Account-Existence',
             DEFAULT_RECHECK_ACCOUNT_EXISTENCE))
-    cache_key = get_cache_key(account, container)
 
-    if resp:
-        if resp.status_int in (HTTP_NOT_FOUND, HTTP_GONE):
-            cache_time *= 0.1
-        elif not is_success(resp.status_int):
-            cache_time = None
-
-    # Next actually set both memcache and the env cache
-    memcache = getattr(app, 'memcache', None) or env.get('swift.cache')
-    if cache_time is None:
-        infocache.pop(cache_key, None)
-        if memcache:
-            memcache.delete(cache_key)
+    if resp.status_int in (HTTP_NOT_FOUND, HTTP_GONE):
+        cache_time *= 0.1
+    elif not is_success(resp.status_int):
+        # If we got a response, it was unsuccessful, and it wasn't an
+        # "authoritative" failure, bail without touching caches.
         return
 
     if container:
diff -pruN 2.25.0-2/swift/proxy/controllers/obj.py 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/proxy/controllers/obj.py
--- 2.25.0-2/swift/proxy/controllers/obj.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift/proxy/controllers/obj.py	2020-07-06 17:03:50.000000000 +0000
@@ -2441,10 +2441,12 @@ class ECObjectController(BaseObjectContr
             headers = []
             for getter, _parts_iter in bad_bucket.get_responses():
                 if best_bucket and best_bucket.durable:
-                    headers = HeaderKeyDict(getter.last_headers)
-                    t_data_file = headers.get('X-Backend-Data-Timestamp')
-                    t_obj = headers.get('X-Backend-Timestamp',
-                                        headers.get('X-Timestamp'))
+                    bad_resp_headers = HeaderKeyDict(getter.last_headers)
+                    t_data_file = bad_resp_headers.get(
+                        'X-Backend-Data-Timestamp')
+                    t_obj = bad_resp_headers.get(
+                        'X-Backend-Timestamp',
+                        bad_resp_headers.get('X-Timestamp'))
                     bad_ts = Timestamp(t_data_file or t_obj or '0')
                     if bad_ts <= Timestamp(best_bucket.timestamp_str):
                         # We have reason to believe there's still good data
diff -pruN 2.25.0-2/swift.egg-info/dependency_links.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/dependency_links.txt
--- 2.25.0-2/swift.egg-info/dependency_links.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/dependency_links.txt	2020-07-06 17:03:53.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 2.25.0-2/swift.egg-info/entry_points.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/entry_points.txt
--- 2.25.0-2/swift.egg-info/entry_points.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/entry_points.txt	2020-07-06 17:03:53.000000000 +0000
@@ -0,0 +1,53 @@
+[console_scripts]
+swift-container-deleter = swift.cli.container_deleter:main
+swift-manage-shard-ranges = swift.cli.manage_shard_ranges:main
+
+[paste.app_factory]
+account = swift.account.server:app_factory
+container = swift.container.server:app_factory
+mem_object = swift.obj.mem_server:app_factory
+object = swift.obj.server:app_factory
+proxy = swift.proxy.server:app_factory
+
+[paste.filter_factory]
+account_quotas = swift.common.middleware.account_quotas:filter_factory
+bulk = swift.common.middleware.bulk:filter_factory
+catch_errors = swift.common.middleware.catch_errors:filter_factory
+cname_lookup = swift.common.middleware.cname_lookup:filter_factory
+container_quotas = swift.common.middleware.container_quotas:filter_factory
+container_sync = swift.common.middleware.container_sync:filter_factory
+copy = swift.common.middleware.copy:filter_factory
+crossdomain = swift.common.middleware.crossdomain:filter_factory
+dlo = swift.common.middleware.dlo:filter_factory
+domain_remap = swift.common.middleware.domain_remap:filter_factory
+encryption = swift.common.middleware.crypto:filter_factory
+etag_quoter = swift.common.middleware.etag_quoter:filter_factory
+formpost = swift.common.middleware.formpost:filter_factory
+gatekeeper = swift.common.middleware.gatekeeper:filter_factory
+healthcheck = swift.common.middleware.healthcheck:filter_factory
+keymaster = swift.common.middleware.crypto.keymaster:filter_factory
+keystoneauth = swift.common.middleware.keystoneauth:filter_factory
+kmip_keymaster = swift.common.middleware.crypto.kmip_keymaster:filter_factory
+kms_keymaster = swift.common.middleware.crypto.kms_keymaster:filter_factory
+list_endpoints = swift.common.middleware.list_endpoints:filter_factory
+listing_formats = swift.common.middleware.listing_formats:filter_factory
+memcache = swift.common.middleware.memcache:filter_factory
+name_check = swift.common.middleware.name_check:filter_factory
+proxy_logging = swift.common.middleware.proxy_logging:filter_factory
+ratelimit = swift.common.middleware.ratelimit:filter_factory
+read_only = swift.common.middleware.read_only:filter_factory
+recon = swift.common.middleware.recon:filter_factory
+s3api = swift.common.middleware.s3api.s3api:filter_factory
+s3token = swift.common.middleware.s3api.s3token:filter_factory
+slo = swift.common.middleware.slo:filter_factory
+staticweb = swift.common.middleware.staticweb:filter_factory
+symlink = swift.common.middleware.symlink:filter_factory
+tempauth = swift.common.middleware.tempauth:filter_factory
+tempurl = swift.common.middleware.tempurl:filter_factory
+versioned_writes = swift.common.middleware.versioned_writes:filter_factory
+xprofile = swift.common.middleware.xprofile:filter_factory
+
+[swift.diskfile]
+erasure_coding.fs = swift.obj.diskfile:ECDiskFileManager
+replication.fs = swift.obj.diskfile:DiskFileManager
+
diff -pruN 2.25.0-2/swift.egg-info/not-zip-safe 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/not-zip-safe
--- 2.25.0-2/swift.egg-info/not-zip-safe	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/not-zip-safe	2020-07-06 17:03:53.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 2.25.0-2/swift.egg-info/pbr.json 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/pbr.json
--- 2.25.0-2/swift.egg-info/pbr.json	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/pbr.json	2020-07-06 17:03:53.000000000 +0000
@@ -0,0 +1 @@
+{"git_version": "2e001431f", "is_release": false}
\ No newline at end of file
diff -pruN 2.25.0-2/swift.egg-info/PKG-INFO 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/PKG-INFO
--- 2.25.0-2/swift.egg-info/PKG-INFO	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/PKG-INFO	2020-07-06 17:03:53.000000000 +0000
@@ -0,0 +1,188 @@
+Metadata-Version: 2.1
+Name: swift
+Version: 2.26.0.dev120
+Summary: OpenStack Object Storage
+Home-page: https://docs.openstack.org/swift/latest/
+Author: OpenStack
+Author-email: openstack-discuss@lists.openstack.org
+License: UNKNOWN
+Description: ===============
+        OpenStack Swift
+        ===============
+        
+        .. image:: https://governance.openstack.org/tc/badges/swift.svg
+            :target: https://governance.openstack.org/tc/reference/tags/index.html
+        
+        .. Change things from this point on
+        
+        OpenStack Swift is a distributed object storage system designed to scale
+        from a single machine to thousands of servers. Swift is optimized for
+        multi-tenancy and high concurrency. Swift is ideal for backups, web and mobile
+        content, and any other unstructured data that can grow without bound.
+        
+        Swift provides a simple, REST-based API fully documented at
+        https://docs.openstack.org/swift/latest/.
+        
+        Swift was originally developed as the basis for Rackspace's Cloud Files
+        and was open-sourced in 2010 as part of the OpenStack project. It has
+        since grown to include contributions from many companies and has spawned
+        a thriving ecosystem of 3rd party tools. Swift's contributors are listed
+        in the AUTHORS file.
+        
+        Docs
+        ----
+        
+        To build documentation run::
+        
+            pip install -r requirements.txt -r doc/requirements.txt
+            sphinx-build -W -b html doc/source doc/build/html
+        
+        and then browse to doc/build/html/index.html. These docs are auto-generated
+        after every commit and available online at
+        https://docs.openstack.org/swift/latest/.
+        
+        For Developers
+        --------------
+        
+        Getting Started
+        ~~~~~~~~~~~~~~~
+        
+        Swift is part of OpenStack and follows the code contribution, review, and
+        testing processes common to all OpenStack projects.
+        
+        If you would like to start contributing, check out these
+        `notes <CONTRIBUTING.rst>`__ to help you get started.
+        
+        The best place to get started is the
+        `"SAIO - Swift All In One" <https://docs.openstack.org/swift/latest/development_saio.html>`__.
+        This document will walk you through setting up a development cluster of
+        Swift in a VM. The SAIO environment is ideal for running small-scale
+        tests against Swift and trying out new features and bug fixes.
+        
+        Tests
+        ~~~~~
+        
+        There are three types of tests included in Swift's source tree.
+        
+        #. Unit tests
+        #. Functional tests
+        #. Probe tests
+        
+        Unit tests check that small sections of the code behave properly. For example,
+        a unit test may test a single function to ensure that various input gives the
+        expected output. This validates that the code is correct and regressions are
+        not introduced.
+        
+        Functional tests check that the client API is working as expected. These can
+        be run against any endpoint claiming to support the Swift API (although some
+        tests require multiple accounts with different privilege levels). These are
+        "black box" tests that ensure that client apps written against Swift will
+        continue to work.
+        
+        Probe tests are "white box" tests that validate the internal workings of a
+        Swift cluster. They are written to work against the
+        `"SAIO - Swift All In One" <https://docs.openstack.org/swift/latest/development_saio.html>`__
+        dev environment. For example, a probe test may create an object, delete one
+        replica, and ensure that the background consistency processes find and correct
+        the error.
+        
+        You can run unit tests with ``.unittests``, functional tests with
+        ``.functests``, and probe tests with ``.probetests``. There is an
+        additional ``.alltests`` script that wraps the other three.
+        
+        To fully run the tests, the target environment must use a filesystem that
+        supports large xattrs. XFS is strongly recommended. For unit tests and in-
+        process functional tests, either mount ``/tmp`` with XFS or provide another
+        XFS filesystem via the ``TMPDIR`` environment variable. Without this setting,
+        tests should still pass, but a very large number will be skipped.
+        
+        Code Organization
+        ~~~~~~~~~~~~~~~~~
+        
+        -  bin/: Executable scripts that are the processes run by the deployer
+        -  doc/: Documentation
+        -  etc/: Sample config files
+        -  examples/: Config snippets used in the docs
+        -  swift/: Core code
+        
+           -  account/: account server
+           -  cli/: code that backs some of the CLI tools in bin/
+           -  common/: code shared by different modules
+        
+              -  middleware/: "standard", officially-supported middleware
+              -  ring/: code implementing Swift's ring
+        
+           -  container/: container server
+           -  locale/: internationalization (translation) data
+           -  obj/: object server
+           -  proxy/: proxy server
+        
+        -  test/: Unit, functional, and probe tests
+        
+        Data Flow
+        ~~~~~~~~~
+        
+        Swift is a WSGI application and uses eventlet's WSGI server. After the
+        processes are running, the entry point for new requests is the
+        ``Application`` class in ``swift/proxy/server.py``. From there, a
+        controller is chosen, and the request is processed. The proxy may choose
+        to forward the request to a back-end server. For example, the entry
+        point for requests to the object server is the ``ObjectController``
+        class in ``swift/obj/server.py``.
+        
+        For Deployers
+        -------------
+        
+        Deployer docs are also available at
+        https://docs.openstack.org/swift/latest/. A good starting point is at
+        https://docs.openstack.org/swift/latest/deployment_guide.html
+        There is an `ops runbook <https://docs.openstack.org/swift/latest/ops_runbook/index.html>`__
+        that gives information about how to diagnose and troubleshoot common issues
+        when running a Swift cluster.
+        
+        You can run functional tests against a Swift cluster with
+        ``.functests``. These functional tests require ``/etc/swift/test.conf``
+        to run. A sample config file can be found in this source tree in
+        ``test/sample.conf``.
+        
+        For Client Apps
+        ---------------
+        
+        For client applications, official Python language bindings are provided
+        at https://github.com/openstack/python-swiftclient.
+        
+        Complete API documentation at
+        https://docs.openstack.org/api-ref/object-store/
+        
+        There is a large ecosystem of applications and libraries that support and
+        work with OpenStack Swift. Several are listed on the
+        `associated projects <https://docs.openstack.org/swift/latest/associated_projects.html>`__
+        page.
+        
+        --------------
+        
+        For more information come hang out in #openstack-swift on freenode.
+        
+        Thanks,
+        
+        The Swift Development Team
+        
+        
+Platform: UNKNOWN
+Classifier: Development Status :: 5 - Production/Stable
+Classifier: Environment :: OpenStack
+Classifier: Intended Audience :: Information Technology
+Classifier: Intended Audience :: System Administrators
+Classifier: License :: OSI Approved :: Apache Software License
+Classifier: Operating System :: POSIX :: Linux
+Classifier: Programming Language :: Python
+Classifier: Programming Language :: Python :: 2
+Classifier: Programming Language :: Python :: 2.7
+Classifier: Programming Language :: Python :: 3
+Classifier: Programming Language :: Python :: 3.6
+Classifier: Programming Language :: Python :: 3.7
+Classifier: Programming Language :: Python :: 3.8
+Provides-Extra: keystone
+Provides-Extra: kmip_keymaster
+Provides-Extra: kms_keymaster
+Provides-Extra: test
diff -pruN 2.25.0-2/swift.egg-info/requires.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/requires.txt
--- 2.25.0-2/swift.egg-info/requires.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/requires.txt	2020-07-06 17:03:53.000000000 +0000
@@ -0,0 +1,40 @@
+PasteDeploy>=1.3.3
+PyECLib>=1.3.1
+cryptography>=2.0.2
+eventlet>=0.25.0
+greenlet>=0.3.2
+lxml>=3.4.1
+netifaces!=0.10.0,!=0.10.1,>=0.8
+requests>=2.14.2
+six>=1.10.0
+xattr>=0.4
+
+[keystone]
+keystonemiddleware>=4.17.0
+
+[kmip_keymaster]
+pykmip>=0.7.0
+
+[kms_keymaster]
+castellan>=0.13.0
+oslo.config!=4.3.0,!=4.4.0,>=4.0.0
+
+[test]
+bandit>=1.1.0
+boto3>=1.9
+boto>=2.32.1
+botocore>=1.12
+coverage>=3.6
+docutils>=0.11
+fixtures>=3.0.0
+hacking<2.1.0,>=2.0
+keystonemiddleware>=4.17.0
+mock>=2.0
+nose>=1.3.7
+nosehtmloutput>=0.0.3
+nosexcover>=1.0.10
+os-testr>=0.8.0
+python-keystoneclient!=2.1.0,>=2.0.0
+python-openstackclient>=3.12.0
+python-swiftclient>=3.2.0
+requests-mock>=1.2.0
diff -pruN 2.25.0-2/swift.egg-info/SOURCES.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/SOURCES.txt
--- 2.25.0-2/swift.egg-info/SOURCES.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/SOURCES.txt	2020-07-06 17:03:53.000000000 +0000
@@ -0,0 +1,846 @@
+.alltests
+.coveragerc
+.dockerignore
+.functests
+.mailmap
+.manpages
+.probetests
+.testr.conf
+.unittests
+.zuul.yaml
+AUTHORS
+CHANGELOG
+CONTRIBUTING.rst
+Dockerfile
+Dockerfile-py3
+LICENSE
+MANIFEST.in
+README.rst
+REVIEW_GUIDELINES.rst
+babel.cfg
+bandit.yaml
+bindep.txt
+lower-constraints.txt
+py2-constraints.txt
+requirements.txt
+setup.cfg
+setup.py
+test-requirements.txt
+tox.ini
+api-ref/source/conf.py
+api-ref/source/index.rst
+api-ref/source/metadata_header_encoding.inc
+api-ref/source/metadata_header_syntax.inc
+api-ref/source/parameters.yaml
+api-ref/source/storage-account-services.inc
+api-ref/source/storage-container-services.inc
+api-ref/source/storage-object-services.inc
+api-ref/source/storage_endpoints.inc
+api-ref/source/storage_info.inc
+api-ref/source/samples/account-containers-list-http-request-json.txt
+api-ref/source/samples/account-containers-list-http-request-xml.txt
+api-ref/source/samples/account-containers-list-http-response-json.txt
+api-ref/source/samples/account-containers-list-http-response-xml.txt
+api-ref/source/samples/account-containers-list-response.json
+api-ref/source/samples/account-containers-list-response.xml
+api-ref/source/samples/capabilities-list-response.json
+api-ref/source/samples/containers-list-http-request.txt
+api-ref/source/samples/containers-list-http-response.txt
+api-ref/source/samples/endpoints-list-response-headers.json
+api-ref/source/samples/endpoints-list-response.json
+api-ref/source/samples/goodbyeworld.txt
+api-ref/source/samples/helloworld.txt
+api-ref/source/samples/objects-list-http-response-json.txt
+api-ref/source/samples/objects-list-http-response-xml.txt
+api-ref/source/samples/objects-list-response.json
+api-ref/source/samples/objects-list-response.xml
+bin/swift-account-audit
+bin/swift-account-auditor
+bin/swift-account-info
+bin/swift-account-reaper
+bin/swift-account-replicator
+bin/swift-account-server
+bin/swift-config
+bin/swift-container-auditor
+bin/swift-container-info
+bin/swift-container-reconciler
+bin/swift-container-replicator
+bin/swift-container-server
+bin/swift-container-sharder
+bin/swift-container-sync
+bin/swift-container-updater
+bin/swift-dispersion-populate
+bin/swift-dispersion-report
+bin/swift-drive-audit
+bin/swift-form-signature
+bin/swift-get-nodes
+bin/swift-init
+bin/swift-object-auditor
+bin/swift-object-expirer
+bin/swift-object-info
+bin/swift-object-reconstructor
+bin/swift-object-relinker
+bin/swift-object-replicator
+bin/swift-object-server
+bin/swift-object-updater
+bin/swift-oldies
+bin/swift-orphans
+bin/swift-proxy-server
+bin/swift-recon
+bin/swift-recon-cron
+bin/swift-reconciler-enqueue
+bin/swift-ring-builder
+bin/swift-ring-builder-analyzer
+bin/swift-ring-composer
+doc/requirements.txt
+doc/manpages/account-server.conf.5
+doc/manpages/container-reconciler.conf.5
+doc/manpages/container-server.conf.5
+doc/manpages/container-sync-realms.conf.5
+doc/manpages/dispersion.conf.5
+doc/manpages/object-expirer.conf.5
+doc/manpages/object-server.conf.5
+doc/manpages/proxy-server.conf.5
+doc/manpages/swift-account-audit.1
+doc/manpages/swift-account-auditor.1
+doc/manpages/swift-account-info.1
+doc/manpages/swift-account-reaper.1
+doc/manpages/swift-account-replicator.1
+doc/manpages/swift-account-server.1
+doc/manpages/swift-config.1
+doc/manpages/swift-container-auditor.1
+doc/manpages/swift-container-info.1
+doc/manpages/swift-container-reconciler.1
+doc/manpages/swift-container-replicator.1
+doc/manpages/swift-container-server.1
+doc/manpages/swift-container-sync.1
+doc/manpages/swift-container-updater.1
+doc/manpages/swift-dispersion-populate.1
+doc/manpages/swift-dispersion-report.1
+doc/manpages/swift-drive-audit.1
+doc/manpages/swift-form-signature.1
+doc/manpages/swift-get-nodes.1
+doc/manpages/swift-init.1
+doc/manpages/swift-object-auditor.1
+doc/manpages/swift-object-expirer.1
+doc/manpages/swift-object-info.1
+doc/manpages/swift-object-reconstructor.1
+doc/manpages/swift-object-relinker.1
+doc/manpages/swift-object-replicator.1
+doc/manpages/swift-object-server.1
+doc/manpages/swift-object-updater.1
+doc/manpages/swift-oldies.1
+doc/manpages/swift-orphans.1
+doc/manpages/swift-proxy-server.1
+doc/manpages/swift-recon-cron.1
+doc/manpages/swift-recon.1
+doc/manpages/swift-reconciler-enqueue.1
+doc/manpages/swift-ring-builder-analyzer.1
+doc/manpages/swift-ring-builder.1
+doc/manpages/swift-ring-composer.1
+doc/manpages/swift.conf.5
+doc/s3api/conf/ceph-known-failures-keystone.yaml
+doc/s3api/conf/ceph-known-failures-tempauth.yaml
+doc/s3api/rnc/access_control_policy.rnc
+doc/s3api/rnc/bucket_logging_status.rnc
+doc/s3api/rnc/common.rnc
+doc/s3api/rnc/complete_multipart_upload.rnc
+doc/s3api/rnc/complete_multipart_upload_result.rnc
+doc/s3api/rnc/copy_object_result.rnc
+doc/s3api/rnc/copy_part_result.rnc
+doc/s3api/rnc/create_bucket_configuration.rnc
+doc/s3api/rnc/delete.rnc
+doc/s3api/rnc/delete_result.rnc
+doc/s3api/rnc/error.rnc
+doc/s3api/rnc/initiate_multipart_upload_result.rnc
+doc/s3api/rnc/lifecycle_configuration.rnc
+doc/s3api/rnc/list_all_my_buckets_result.rnc
+doc/s3api/rnc/list_bucket_result.rnc
+doc/s3api/rnc/list_multipart_uploads_result.rnc
+doc/s3api/rnc/list_parts_result.rnc
+doc/s3api/rnc/list_versions_result.rnc
+doc/s3api/rnc/location_constraint.rnc
+doc/s3api/rnc/versioning_configuration.rnc
+doc/saio/rsyncd.conf
+doc/saio/bin/remakerings
+doc/saio/bin/resetswift
+doc/saio/bin/startmain
+doc/saio/bin/startrest
+doc/saio/rsyslog.d/10-swift.conf
+doc/saio/swift/container-reconciler.conf
+doc/saio/swift/container-sync-realms.conf
+doc/saio/swift/internal-client.conf
+doc/saio/swift/object-expirer.conf
+doc/saio/swift/proxy-server.conf
+doc/saio/swift/swift.conf
+doc/saio/swift/account-server/1.conf
+doc/saio/swift/account-server/2.conf
+doc/saio/swift/account-server/3.conf
+doc/saio/swift/account-server/4.conf
+doc/saio/swift/container-server/1.conf
+doc/saio/swift/container-server/2.conf
+doc/saio/swift/container-server/3.conf
+doc/saio/swift/container-server/4.conf
+doc/saio/swift/object-server/1.conf
+doc/saio/swift/object-server/2.conf
+doc/saio/swift/object-server/3.conf
+doc/saio/swift/object-server/4.conf
+doc/source/account.rst
+doc/source/admin_guide.rst
+doc/source/apache_deployment_guide.rst
+doc/source/associated_projects.rst
+doc/source/conf.py
+doc/source/container.rst
+doc/source/cors.rst
+doc/source/crossdomain.rst
+doc/source/db.rst
+doc/source/deployment_guide.rst
+doc/source/development_auth.rst
+doc/source/development_guidelines.rst
+doc/source/development_middleware.rst
+doc/source/development_ondisk_backends.rst
+doc/source/development_saio.rst
+doc/source/first_contribution_swift.rst
+doc/source/getting_started.rst
+doc/source/howto_installmultinode.rst
+doc/source/index.rst
+doc/source/logs.rst
+doc/source/middleware.rst
+doc/source/misc.rst
+doc/source/object.rst
+doc/source/overview_acl.rst
+doc/source/overview_architecture.rst
+doc/source/overview_auth.rst
+doc/source/overview_backing_store.rst
+doc/source/overview_container_sharding.rst
+doc/source/overview_container_sync.rst
+doc/source/overview_encryption.rst
+doc/source/overview_erasure_code.rst
+doc/source/overview_expiring_objects.rst
+doc/source/overview_global_cluster.rst
+doc/source/overview_large_objects.rst
+doc/source/overview_policies.rst
+doc/source/overview_reaper.rst
+doc/source/overview_replication.rst
+doc/source/overview_ring.rst
+doc/source/policies_saio.rst
+doc/source/proxy.rst
+doc/source/ratelimit.rst
+doc/source/replication_network.rst
+doc/source/ring.rst
+doc/source/ring_background.rst
+doc/source/ring_partpower.rst
+doc/source/s3_compat.rst
+doc/source/test-cors.html
+doc/source/_extra/.htaccess
+doc/source/admin/index.rst
+doc/source/admin/objectstorage-EC.rst
+doc/source/admin/objectstorage-account-reaper.rst
+doc/source/admin/objectstorage-admin.rst
+doc/source/admin/objectstorage-arch.rst
+doc/source/admin/objectstorage-auditors.rst
+doc/source/admin/objectstorage-characteristics.rst
+doc/source/admin/objectstorage-components.rst
+doc/source/admin/objectstorage-features.rst
+doc/source/admin/objectstorage-intro.rst
+doc/source/admin/objectstorage-large-objects.rst
+doc/source/admin/objectstorage-monitoring.rst
+doc/source/admin/objectstorage-replication.rst
+doc/source/admin/objectstorage-ringbuilder.rst
+doc/source/admin/objectstorage-tenant-specific-image-storage.rst
+doc/source/admin/objectstorage-troubleshoot.rst
+doc/source/admin/figures/objectstorage-accountscontainers.png
+doc/source/admin/figures/objectstorage-arch.png
+doc/source/admin/figures/objectstorage-buildingblocks.png
+doc/source/admin/figures/objectstorage-nodes.png
+doc/source/admin/figures/objectstorage-partitions.png
+doc/source/admin/figures/objectstorage-replication.png
+doc/source/admin/figures/objectstorage-ring.png
+doc/source/admin/figures/objectstorage-usecase.png
+doc/source/admin/figures/objectstorage-zones.png
+doc/source/admin/figures/objectstorage.png
+doc/source/api/authentication.rst
+doc/source/api/bulk-delete.rst
+doc/source/api/container_quotas.rst
+doc/source/api/discoverability.rst
+doc/source/api/form_post_middleware.rst
+doc/source/api/large_objects.rst
+doc/source/api/object-expiration.rst
+doc/source/api/object_api_v1_overview.rst
+doc/source/api/object_versioning.rst
+doc/source/api/pagination.rst
+doc/source/api/pseudo-hierarchical-folders-directories.rst
+doc/source/api/serialized-response-formats.rst
+doc/source/api/static-website.rst
+doc/source/api/temporary_url_middleware.rst
+doc/source/api/use_content-encoding_metadata.rst
+doc/source/api/use_the_content-disposition_metadata.rst
+doc/source/contributor/contributing.rst
+doc/source/contributor/review_guidelines.rst
+doc/source/images/ec_overview.png
+doc/source/images/sharded_GET.svg
+doc/source/images/sharding_GET.svg
+doc/source/images/sharding_cleave1_load.svg
+doc/source/images/sharding_cleave2_load.svg
+doc/source/images/sharding_cleave_basic.svg
+doc/source/images/sharding_db_states.svg
+doc/source/images/sharding_scan_basic.svg
+doc/source/images/sharding_scan_load.svg
+doc/source/images/sharding_sharded_load.svg
+doc/source/images/sharding_unsharded.svg
+doc/source/images/sharding_unsharded_load.svg
+doc/source/install/controller-common_prerequisites.txt
+doc/source/install/controller-include.txt
+doc/source/install/controller-install-debian.rst
+doc/source/install/controller-install-obs.rst
+doc/source/install/controller-install-rdo.rst
+doc/source/install/controller-install-ubuntu.rst
+doc/source/install/controller-install.rst
+doc/source/install/edit_hosts_file.txt
+doc/source/install/environment-networking.rst
+doc/source/install/finalize-installation-obs.rst
+doc/source/install/finalize-installation-rdo.rst
+doc/source/install/finalize-installation-ubuntu-debian.rst
+doc/source/install/finalize-installation.rst
+doc/source/install/get_started.rst
+doc/source/install/index.rst
+doc/source/install/initial-rings.rst
+doc/source/install/next-steps.rst
+doc/source/install/storage-include1.txt
+doc/source/install/storage-include2.txt
+doc/source/install/storage-include3.txt
+doc/source/install/storage-install-obs.rst
+doc/source/install/storage-install-rdo.rst
+doc/source/install/storage-install-ubuntu-debian.rst
+doc/source/install/storage-install.rst
+doc/source/install/verify.rst
+doc/source/ops_runbook/diagnose.rst
+doc/source/ops_runbook/index.rst
+doc/source/ops_runbook/maintenance.rst
+doc/source/ops_runbook/procedures.rst
+doc/source/ops_runbook/troubleshooting.rst
+docker/dockerhub_description.md
+docker/install_scripts/00_swift_needs.sh
+docker/install_scripts/10_apk_install_prereqs.sh
+docker/install_scripts/20_apk_install_py2.sh
+docker/install_scripts/21_apk_install_py3.sh
+docker/install_scripts/50_swift_install.sh
+docker/install_scripts/60_pip_uninstall_dev.sh
+docker/install_scripts/99_apk_uninstall_dev.sh
+docker/install_scripts/python_test_dirs
+docker/rootfs/etc/profile
+docker/rootfs/etc/rsyncd.conf
+docker/rootfs/etc/rsyslog.conf
+docker/rootfs/etc/cont-init.d/01_swift_logs
+docker/rootfs/etc/cont-init.d/02_build_remakerings
+docker/rootfs/etc/fix-attrs.d/logging
+docker/rootfs/etc/fix-attrs.d/srv_node
+docker/rootfs/etc/fix-attrs.d/swift
+docker/rootfs/etc/fix-attrs.d/tmp
+docker/rootfs/etc/rsyslog.d/00-swift.conf
+docker/rootfs/etc/rsyslog.d/50-default.conf
+docker/rootfs/etc/services.d/memcached/run
+docker/rootfs/etc/services.d/swift-account/run
+docker/rootfs/etc/services.d/swift-container/run
+docker/rootfs/etc/services.d/swift-object/run
+docker/rootfs/etc/services.d/swift-proxy/run
+docker/rootfs/etc/socklog.rules/swift_account_server
+docker/rootfs/etc/socklog.rules/swift_all
+docker/rootfs/etc/socklog.rules/swift_container_server
+docker/rootfs/etc/socklog.rules/swift_object_server
+docker/rootfs/etc/socklog.rules/swift_proxy_server
+docker/rootfs/etc/swift/account-server.conf
+docker/rootfs/etc/swift/container-server.conf
+docker/rootfs/etc/swift/object-server.conf
+docker/rootfs/etc/swift/proxy-server.conf
+docker/rootfs/etc/swift/swift.conf
+docker/rootfs/etc/swift_build/build_devices
+docker/rootfs/etc/swift_build/build_remakerings
+docker/rootfs/etc/swift_build/prepare_rings
+etc/account-server.conf-sample
+etc/container-reconciler.conf-sample
+etc/container-server.conf-sample
+etc/container-sync-realms.conf-sample
+etc/dispersion.conf-sample
+etc/drive-audit.conf-sample
+etc/internal-client.conf-sample
+etc/keymaster.conf-sample
+etc/memcache.conf-sample
+etc/mime.types-sample
+etc/object-expirer.conf-sample
+etc/object-server.conf-sample
+etc/proxy-server.conf-sample
+etc/rsyncd.conf-sample
+etc/swift-rsyslog.conf-sample
+etc/swift.conf-sample
+examples/apache2/account-server.template
+examples/apache2/container-server.template
+examples/apache2/object-server.template
+examples/apache2/proxy-server.template
+examples/wsgi/account-server.wsgi.template
+examples/wsgi/container-server.wsgi.template
+examples/wsgi/object-server.wsgi.template
+examples/wsgi/proxy-server.wsgi.template
+releasenotes/notes/2_10_0_release-666a76f4975657a5.yaml
+releasenotes/notes/2_11_0_release-ac1d256e455d347e.yaml
+releasenotes/notes/2_12_0_release-06af226abc7b91ef.yaml
+releasenotes/notes/2_13_0_release-875e1fb1ef59f015.yaml
+releasenotes/notes/2_14_0_release-7c3ef515ebded888.yaml
+releasenotes/notes/2_15_0_release-0a05a011fb85a9c9.yaml
+releasenotes/notes/2_15_1_release-be25e67bfc5e886a.yaml
+releasenotes/notes/2_15_2_release-6996eccabba558b4.yaml
+releasenotes/notes/2_16_0_release-d48cb9b2629df8ab.yaml
+releasenotes/notes/2_17_0_release-bd35f18c41c5ef18.yaml
+releasenotes/notes/2_17_1_release-dd6e6879cbb94f85.yaml
+releasenotes/notes/2_18_0_release-3acf63cfe2475c65.yaml
+releasenotes/notes/2_19_0_release-3e6ee3e6a1fcc6bb.yaml
+releasenotes/notes/2_19_1_release-5072dd72557f5708.yaml
+releasenotes/notes/2_20_0_release-7b090a5f4bd916e4.yaml
+releasenotes/notes/2_21_0_release-d8ae33ef18b7be3a.yaml
+releasenotes/notes/2_22_0_release-f60d29508b3c1283.yaml
+releasenotes/notes/2_23_0_release-2a2d11c1934f0b61.yaml
+releasenotes/notes/2_24_0_release-1ca244cc959922fc.yaml
+releasenotes/notes/2_25_0_release-09410c808881bf21.yaml
+releasenotes/source/conf.py
+releasenotes/source/current.rst
+releasenotes/source/index.rst
+releasenotes/source/newton.rst
+releasenotes/source/ocata.rst
+releasenotes/source/pike.rst
+releasenotes/source/queens.rst
+releasenotes/source/rocky.rst
+releasenotes/source/stein.rst
+releasenotes/source/train.rst
+releasenotes/source/ussuri.rst
+releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po
+releasenotes/source/locale/ja/LC_MESSAGES/releasenotes.po
+roles/additional-keystone-users/tasks/main.yaml
+roles/additional-tempauth-users/tasks/main.yaml
+roles/dsvm-additional-middlewares/tasks/main.yaml
+swift/__init__.py
+swift.egg-info/PKG-INFO
+swift.egg-info/SOURCES.txt
+swift.egg-info/dependency_links.txt
+swift.egg-info/entry_points.txt
+swift.egg-info/not-zip-safe
+swift.egg-info/pbr.json
+swift.egg-info/requires.txt
+swift.egg-info/top_level.txt
+swift/account/__init__.py
+swift/account/auditor.py
+swift/account/backend.py
+swift/account/reaper.py
+swift/account/replicator.py
+swift/account/server.py
+swift/account/utils.py
+swift/cli/__init__.py
+swift/cli/container_deleter.py
+swift/cli/dispersion_report.py
+swift/cli/form_signature.py
+swift/cli/info.py
+swift/cli/manage_shard_ranges.py
+swift/cli/recon.py
+swift/cli/relinker.py
+swift/cli/ring_builder_analyzer.py
+swift/cli/ringbuilder.py
+swift/cli/ringcomposer.py
+swift/cli/shard-info.py
+swift/common/__init__.py
+swift/common/base_storage_server.py
+swift/common/bufferedhttp.py
+swift/common/constraints.py
+swift/common/container_sync_realms.py
+swift/common/daemon.py
+swift/common/db.py
+swift/common/db_replicator.py
+swift/common/direct_client.py
+swift/common/exceptions.py
+swift/common/header_key_dict.py
+swift/common/http.py
+swift/common/internal_client.py
+swift/common/linkat.py
+swift/common/manager.py
+swift/common/memcached.py
+swift/common/request_helpers.py
+swift/common/splice.py
+swift/common/storage_policy.py
+swift/common/swob.py
+swift/common/utils.py
+swift/common/wsgi.py
+swift/common/middleware/__init__.py
+swift/common/middleware/account_quotas.py
+swift/common/middleware/acl.py
+swift/common/middleware/bulk.py
+swift/common/middleware/catch_errors.py
+swift/common/middleware/cname_lookup.py
+swift/common/middleware/container_quotas.py
+swift/common/middleware/container_sync.py
+swift/common/middleware/copy.py
+swift/common/middleware/crossdomain.py
+swift/common/middleware/dlo.py
+swift/common/middleware/domain_remap.py
+swift/common/middleware/etag_quoter.py
+swift/common/middleware/formpost.py
+swift/common/middleware/gatekeeper.py
+swift/common/middleware/healthcheck.py
+swift/common/middleware/keystoneauth.py
+swift/common/middleware/list_endpoints.py
+swift/common/middleware/listing_formats.py
+swift/common/middleware/memcache.py
+swift/common/middleware/name_check.py
+swift/common/middleware/proxy_logging.py
+swift/common/middleware/ratelimit.py
+swift/common/middleware/read_only.py
+swift/common/middleware/recon.py
+swift/common/middleware/slo.py
+swift/common/middleware/staticweb.py
+swift/common/middleware/symlink.py
+swift/common/middleware/tempauth.py
+swift/common/middleware/tempurl.py
+swift/common/middleware/xprofile.py
+swift/common/middleware/crypto/__init__.py
+swift/common/middleware/crypto/crypto_utils.py
+swift/common/middleware/crypto/decrypter.py
+swift/common/middleware/crypto/encrypter.py
+swift/common/middleware/crypto/keymaster.py
+swift/common/middleware/crypto/kmip_keymaster.py
+swift/common/middleware/crypto/kms_keymaster.py
+swift/common/middleware/s3api/__init__.py
+swift/common/middleware/s3api/acl_handlers.py
+swift/common/middleware/s3api/acl_utils.py
+swift/common/middleware/s3api/etree.py
+swift/common/middleware/s3api/exception.py
+swift/common/middleware/s3api/s3api.py
+swift/common/middleware/s3api/s3request.py
+swift/common/middleware/s3api/s3response.py
+swift/common/middleware/s3api/s3token.py
+swift/common/middleware/s3api/subresource.py
+swift/common/middleware/s3api/utils.py
+swift/common/middleware/s3api/controllers/__init__.py
+swift/common/middleware/s3api/controllers/acl.py
+swift/common/middleware/s3api/controllers/base.py
+swift/common/middleware/s3api/controllers/bucket.py
+swift/common/middleware/s3api/controllers/location.py
+swift/common/middleware/s3api/controllers/logging.py
+swift/common/middleware/s3api/controllers/multi_delete.py
+swift/common/middleware/s3api/controllers/multi_upload.py
+swift/common/middleware/s3api/controllers/obj.py
+swift/common/middleware/s3api/controllers/s3_acl.py
+swift/common/middleware/s3api/controllers/service.py
+swift/common/middleware/s3api/controllers/tagging.py
+swift/common/middleware/s3api/controllers/versioning.py
+swift/common/middleware/s3api/schema/access_control_policy.rng
+swift/common/middleware/s3api/schema/bucket_logging_status.rng
+swift/common/middleware/s3api/schema/common.rng
+swift/common/middleware/s3api/schema/complete_multipart_upload.rng
+swift/common/middleware/s3api/schema/complete_multipart_upload_result.rng
+swift/common/middleware/s3api/schema/copy_object_result.rng
+swift/common/middleware/s3api/schema/copy_part_result.rng
+swift/common/middleware/s3api/schema/create_bucket_configuration.rng
+swift/common/middleware/s3api/schema/delete.rng
+swift/common/middleware/s3api/schema/delete_result.rng
+swift/common/middleware/s3api/schema/error.rng
+swift/common/middleware/s3api/schema/initiate_multipart_upload_result.rng
+swift/common/middleware/s3api/schema/lifecycle_configuration.rng
+swift/common/middleware/s3api/schema/list_all_my_buckets_result.rng
+swift/common/middleware/s3api/schema/list_bucket_result.rng
+swift/common/middleware/s3api/schema/list_multipart_uploads_result.rng
+swift/common/middleware/s3api/schema/list_parts_result.rng
+swift/common/middleware/s3api/schema/list_versions_result.rng
+swift/common/middleware/s3api/schema/location_constraint.rng
+swift/common/middleware/s3api/schema/versioning_configuration.rng
+swift/common/middleware/versioned_writes/__init__.py
+swift/common/middleware/versioned_writes/legacy.py
+swift/common/middleware/versioned_writes/object_versioning.py
+swift/common/middleware/x_profile/__init__.py
+swift/common/middleware/x_profile/exceptions.py
+swift/common/middleware/x_profile/html_viewer.py
+swift/common/middleware/x_profile/profile_model.py
+swift/common/ring/__init__.py
+swift/common/ring/builder.py
+swift/common/ring/composite_builder.py
+swift/common/ring/ring.py
+swift/common/ring/utils.py
+swift/container/__init__.py
+swift/container/auditor.py
+swift/container/backend.py
+swift/container/reconciler.py
+swift/container/replicator.py
+swift/container/server.py
+swift/container/sharder.py
+swift/container/sync.py
+swift/container/sync_store.py
+swift/container/updater.py
+swift/locale/de/LC_MESSAGES/swift.po
+swift/locale/en_GB/LC_MESSAGES/swift.po
+swift/locale/es/LC_MESSAGES/swift.po
+swift/locale/fr/LC_MESSAGES/swift.po
+swift/locale/it/LC_MESSAGES/swift.po
+swift/locale/ja/LC_MESSAGES/swift.po
+swift/locale/ko_KR/LC_MESSAGES/swift.po
+swift/locale/pt_BR/LC_MESSAGES/swift.po
+swift/locale/ru/LC_MESSAGES/swift.po
+swift/locale/tr_TR/LC_MESSAGES/swift.po
+swift/locale/zh_CN/LC_MESSAGES/swift.po
+swift/locale/zh_TW/LC_MESSAGES/swift.po
+swift/obj/__init__.py
+swift/obj/auditor.py
+swift/obj/diskfile.py
+swift/obj/expirer.py
+swift/obj/mem_diskfile.py
+swift/obj/mem_server.py
+swift/obj/reconstructor.py
+swift/obj/replicator.py
+swift/obj/server.py
+swift/obj/ssync_receiver.py
+swift/obj/ssync_sender.py
+swift/obj/updater.py
+swift/proxy/__init__.py
+swift/proxy/server.py
+swift/proxy/controllers/__init__.py
+swift/proxy/controllers/account.py
+swift/proxy/controllers/base.py
+swift/proxy/controllers/container.py
+swift/proxy/controllers/info.py
+swift/proxy/controllers/obj.py
+test/__init__.py
+test/sample.conf
+test/functional/__init__.py
+test/functional/mock_swift_key_manager.py
+test/functional/swift_test_client.py
+test/functional/test_access_control.py
+test/functional/test_account.py
+test/functional/test_container.py
+test/functional/test_dlo.py
+test/functional/test_domain_remap.py
+test/functional/test_object.py
+test/functional/test_object_versioning.py
+test/functional/test_slo.py
+test/functional/test_staticweb.py
+test/functional/test_symlink.py
+test/functional/test_tempurl.py
+test/functional/test_versioned_writes.py
+test/functional/tests.py
+test/functional/s3api/__init__.py
+test/functional/s3api/s3_test_client.py
+test/functional/s3api/test_acl.py
+test/functional/s3api/test_bucket.py
+test/functional/s3api/test_multi_delete.py
+test/functional/s3api/test_multi_upload.py
+test/functional/s3api/test_object.py
+test/functional/s3api/test_presigned.py
+test/functional/s3api/test_service.py
+test/functional/s3api/test_versioning.py
+test/functional/s3api/utils.py
+test/probe/__init__.py
+test/probe/brain.py
+test/probe/common.py
+test/probe/test_account_failures.py
+test/probe/test_account_get_fake_responses_match.py
+test/probe/test_account_reaper.py
+test/probe/test_container_failures.py
+test/probe/test_container_merge_policy_index.py
+test/probe/test_container_sync.py
+test/probe/test_db_replicator.py
+test/probe/test_empty_device_handoff.py
+test/probe/test_object_async_update.py
+test/probe/test_object_conditional_requests.py
+test/probe/test_object_expirer.py
+test/probe/test_object_failures.py
+test/probe/test_object_handoff.py
+test/probe/test_object_metadata_replication.py
+test/probe/test_object_partpower_increase.py
+test/probe/test_object_versioning.py
+test/probe/test_reconstructor_rebuild.py
+test/probe/test_reconstructor_revert.py
+test/probe/test_replication_servers_working.py
+test/probe/test_reserved_name.py
+test/probe/test_sharder.py
+test/probe/test_signals.py
+test/s3api/__init__.py
+test/s3api/test_service.py
+test/s3api/test_versioning.py
+test/unit/__init__.py
+test/unit/helpers.py
+test/unit/account/__init__.py
+test/unit/account/test_auditor.py
+test/unit/account/test_backend.py
+test/unit/account/test_reaper.py
+test/unit/account/test_replicator.py
+test/unit/account/test_server.py
+test/unit/account/test_utils.py
+test/unit/cli/__init__.py
+test/unit/cli/test_container_deleter.py
+test/unit/cli/test_default_output.stub
+test/unit/cli/test_default_output_id_assigned.stub
+test/unit/cli/test_default_sorted_output.stub
+test/unit/cli/test_dispersion_report.py
+test/unit/cli/test_form_signature.py
+test/unit/cli/test_info.py
+test/unit/cli/test_ipv6_output.stub
+test/unit/cli/test_manage_shard_ranges.py
+test/unit/cli/test_recon.py
+test/unit/cli/test_relinker.py
+test/unit/cli/test_ring_builder_analyzer.py
+test/unit/cli/test_ringbuilder.py
+test/unit/cli/test_ringcomposer.py
+test/unit/common/__init__.py
+test/unit/common/corrupted_example.db
+test/unit/common/malformed_example.db
+test/unit/common/malformed_schema_example.db
+test/unit/common/missing_container_info.db
+test/unit/common/test_base_storage_server.py
+test/unit/common/test_bufferedhttp.py
+test/unit/common/test_constraints.py
+test/unit/common/test_container_sync_realms.py
+test/unit/common/test_daemon.py
+test/unit/common/test_db.py
+test/unit/common/test_db_replicator.py
+test/unit/common/test_direct_client.py
+test/unit/common/test_exceptions.py
+test/unit/common/test_header_key_dict.py
+test/unit/common/test_internal_client.py
+test/unit/common/test_linkat.py
+test/unit/common/test_manager.py
+test/unit/common/test_memcached.py
+test/unit/common/test_request_helpers.py
+test/unit/common/test_splice.py
+test/unit/common/test_storage_policy.py
+test/unit/common/test_swob.py
+test/unit/common/test_utils.py
+test/unit/common/test_wsgi.py
+test/unit/common/middleware/__init__.py
+test/unit/common/middleware/helpers.py
+test/unit/common/middleware/test_account_quotas.py
+test/unit/common/middleware/test_acl.py
+test/unit/common/middleware/test_bulk.py
+test/unit/common/middleware/test_catch_errors.py
+test/unit/common/middleware/test_cname_lookup.py
+test/unit/common/middleware/test_container_sync.py
+test/unit/common/middleware/test_copy.py
+test/unit/common/middleware/test_crossdomain.py
+test/unit/common/middleware/test_dlo.py
+test/unit/common/middleware/test_domain_remap.py
+test/unit/common/middleware/test_etag_quoter.py
+test/unit/common/middleware/test_formpost.py
+test/unit/common/middleware/test_gatekeeper.py
+test/unit/common/middleware/test_healthcheck.py
+test/unit/common/middleware/test_keystoneauth.py
+test/unit/common/middleware/test_list_endpoints.py
+test/unit/common/middleware/test_listing_formats.py
+test/unit/common/middleware/test_memcache.py
+test/unit/common/middleware/test_name_check.py
+test/unit/common/middleware/test_object_versioning.py
+test/unit/common/middleware/test_proxy_logging.py
+test/unit/common/middleware/test_quotas.py
+test/unit/common/middleware/test_ratelimit.py
+test/unit/common/middleware/test_read_only.py
+test/unit/common/middleware/test_recon.py
+test/unit/common/middleware/test_slo.py
+test/unit/common/middleware/test_staticweb.py
+test/unit/common/middleware/test_subrequest_logging.py
+test/unit/common/middleware/test_symlink.py
+test/unit/common/middleware/test_tempauth.py
+test/unit/common/middleware/test_tempurl.py
+test/unit/common/middleware/test_versioned_writes.py
+test/unit/common/middleware/test_xprofile.py
+test/unit/common/middleware/crypto/__init__.py
+test/unit/common/middleware/crypto/crypto_helpers.py
+test/unit/common/middleware/crypto/test_crypto.py
+test/unit/common/middleware/crypto/test_crypto_utils.py
+test/unit/common/middleware/crypto/test_decrypter.py
+test/unit/common/middleware/crypto/test_encrypter.py
+test/unit/common/middleware/crypto/test_encryption.py
+test/unit/common/middleware/crypto/test_keymaster.py
+test/unit/common/middleware/crypto/test_kmip_keymaster.py
+test/unit/common/middleware/crypto/test_kms_keymaster.py
+test/unit/common/middleware/s3api/__init__.py
+test/unit/common/middleware/s3api/exceptions.py
+test/unit/common/middleware/s3api/helpers.py
+test/unit/common/middleware/s3api/test_acl.py
+test/unit/common/middleware/s3api/test_acl_handlers.py
+test/unit/common/middleware/s3api/test_acl_utils.py
+test/unit/common/middleware/s3api/test_bucket.py
+test/unit/common/middleware/s3api/test_cfg.py
+test/unit/common/middleware/s3api/test_etree.py
+test/unit/common/middleware/s3api/test_helpers.py
+test/unit/common/middleware/s3api/test_location.py
+test/unit/common/middleware/s3api/test_logging.py
+test/unit/common/middleware/s3api/test_multi_delete.py
+test/unit/common/middleware/s3api/test_multi_upload.py
+test/unit/common/middleware/s3api/test_obj.py
+test/unit/common/middleware/s3api/test_s3_acl.py
+test/unit/common/middleware/s3api/test_s3api.py
+test/unit/common/middleware/s3api/test_s3request.py
+test/unit/common/middleware/s3api/test_s3response.py
+test/unit/common/middleware/s3api/test_s3token.py
+test/unit/common/middleware/s3api/test_service.py
+test/unit/common/middleware/s3api/test_subresource.py
+test/unit/common/middleware/s3api/test_utils.py
+test/unit/common/middleware/s3api/test_versioning.py
+test/unit/common/ring/__init__.py
+test/unit/common/ring/test_builder.py
+test/unit/common/ring/test_composite_builder.py
+test/unit/common/ring/test_ring.py
+test/unit/common/ring/test_utils.py
+test/unit/container/__init__.py
+test/unit/container/test_auditor.py
+test/unit/container/test_backend.py
+test/unit/container/test_reconciler.py
+test/unit/container/test_replicator.py
+test/unit/container/test_server.py
+test/unit/container/test_sharder.py
+test/unit/container/test_sync.py
+test/unit/container/test_sync_store.py
+test/unit/container/test_updater.py
+test/unit/obj/__init__.py
+test/unit/obj/common.py
+test/unit/obj/test_auditor.py
+test/unit/obj/test_diskfile.py
+test/unit/obj/test_expirer.py
+test/unit/obj/test_reconstructor.py
+test/unit/obj/test_replicator.py
+test/unit/obj/test_server.py
+test/unit/obj/test_ssync.py
+test/unit/obj/test_ssync_receiver.py
+test/unit/obj/test_ssync_sender.py
+test/unit/obj/test_updater.py
+test/unit/proxy/__init__.py
+test/unit/proxy/test_mem_server.py
+test/unit/proxy/test_server.py
+test/unit/proxy/test_sysmeta.py
+test/unit/proxy/controllers/__init__.py
+test/unit/proxy/controllers/test_account.py
+test/unit/proxy/controllers/test_base.py
+test/unit/proxy/controllers/test_container.py
+test/unit/proxy/controllers/test_info.py
+test/unit/proxy/controllers/test_obj.py
+test/unit/test_locale/README
+test/unit/test_locale/__init__.py
+test/unit/test_locale/eo.po
+test/unit/test_locale/messages.mo
+test/unit/test_locale/test_locale.py
+test/unit/test_locale/eo/LC_MESSAGES/swift.mo
+tools/test-setup.sh
+tools/playbooks/ceph-s3tests/ceph-s3.conf
+tools/playbooks/ceph-s3tests/post.yaml
+tools/playbooks/ceph-s3tests/run.yaml
+tools/playbooks/common/cover-post.yaml
+tools/playbooks/common/install_dependencies.yaml
+tools/playbooks/dsvm/post.yaml
+tools/playbooks/dsvm/pre.yaml
+tools/playbooks/dsvm/run.yaml
+tools/playbooks/multinode_setup/common_config.yaml
+tools/playbooks/multinode_setup/configure_loopback.yaml
+tools/playbooks/multinode_setup/make_rings.yaml
+tools/playbooks/multinode_setup/pre.yaml
+tools/playbooks/multinode_setup/run.yaml
+tools/playbooks/multinode_setup/templates/make_multinode_rings.j2
+tools/playbooks/multinode_setup/templates/rc.local.j2
+tools/playbooks/multinode_setup/templates/test.conf.j2
+tools/playbooks/probetests/post.yaml
+tools/playbooks/probetests/run.yaml
+tools/playbooks/saio_single_node_setup/add_s3api.yaml
+tools/playbooks/saio_single_node_setup/make_rings.yaml
+tools/playbooks/saio_single_node_setup/setup_saio.yaml
+tools/playbooks/saio_single_node_setup/templates/rc.local.j2
\ No newline at end of file
diff -pruN 2.25.0-2/swift.egg-info/top_level.txt 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/top_level.txt
--- 2.25.0-2/swift.egg-info/top_level.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/swift.egg-info/top_level.txt	2020-07-06 17:03:53.000000000 +0000
@@ -0,0 +1 @@
+swift
diff -pruN 2.25.0-2/test/functional/__init__.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/__init__.py
--- 2.25.0-2/test/functional/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/__init__.py	2020-07-06 17:03:50.000000000 +0000
@@ -322,12 +322,16 @@ def _load_encryption(proxy_conf_file, sw
         pipeline = pipeline.replace(
             "proxy-logging proxy-server",
             "keymaster encryption proxy-logging proxy-server")
+        pipeline = pipeline.replace(
+            "cache listing_formats",
+            "cache etag-quoter listing_formats")
         conf.set(section, 'pipeline', pipeline)
         root_secret = base64.b64encode(os.urandom(32))
         if not six.PY2:
             root_secret = root_secret.decode('ascii')
         conf.set('filter:keymaster', 'encryption_root_secret', root_secret)
         conf.set('filter:versioned_writes', 'allow_object_versioning', 'true')
+        conf.set('filter:etag-quoter', 'enable_by_default', 'true')
     except NoSectionError as err:
         msg = 'Error problem with proxy conf file %s: %s' % \
               (proxy_conf_file, err)
@@ -479,8 +483,6 @@ def _load_s3api(proxy_conf_file, swift_c
 conf_loaders = {
     'encryption': _load_encryption,
     'ec': _load_ec_as_default_policy,
-    'domain_remap_staticweb': _load_domain_remap_staticweb,
-    's3api': _load_s3api,
 }
 
 
@@ -518,6 +520,11 @@ def in_process_setup(the_object_server=o
     swift_conf = _in_process_setup_swift_conf(swift_conf_src, _testdir)
     _info('prepared swift.conf: %s' % swift_conf)
 
+    # load s3api and staticweb configs
+    proxy_conf, swift_conf = _load_s3api(proxy_conf, swift_conf)
+    proxy_conf, swift_conf = _load_domain_remap_staticweb(proxy_conf,
+                                                          swift_conf)
+
     # Call the associated method for the value of
     # 'SWIFT_TEST_IN_PROCESS_CONF_LOADER', if one exists
     conf_loader_label = os.environ.get(
@@ -587,6 +594,7 @@ def in_process_setup(the_object_server=o
         # Below are values used by the functional test framework, as well as
         # by the various in-process swift servers
         'auth_uri': 'http://127.0.0.1:%d/auth/v1.0/' % prolis.getsockname()[1],
+        's3_storage_url': 'http://%s:%d/' % prolis.getsockname(),
         # Primary functional test account (needs admin access to the
         # account)
         'account': 'test',
@@ -868,6 +876,8 @@ def setup_package():
                     443 if parsed.scheme == 'https' else 80),
                 'auth_prefix': parsed.path,
             })
+            config.setdefault('s3_storage_url',
+                              urlunsplit(parsed[:2] + ('', None, None)))
         elif 'auth_host' in config:
             scheme = 'http'
             if config_true_value(config.get('auth_ssl', 'no')):
@@ -880,6 +890,8 @@ def setup_package():
                 auth_prefix += 'v1.0'
             config['auth_uri'] = swift_test_auth = urlunsplit(
                 (scheme, netloc, auth_prefix, None, None))
+            config.setdefault('s3_storage_url', urlunsplit(
+                (scheme, netloc, '', None, None)))
         # else, neither auth_uri nor auth_host; swift_test_auth will be unset
         # and we'll skip everything later
 
@@ -1121,10 +1133,15 @@ def get_url_token(user_index, os_options
                     auth_version=swift_test_auth_version,
                     os_options=os_options,
                     insecure=insecure)
-    return get_auth(swift_test_auth,
-                    swift_test_user[user_index],
-                    swift_test_key[user_index],
-                    **authargs)
+    url, token = get_auth(swift_test_auth,
+                          swift_test_user[user_index],
+                          swift_test_key[user_index],
+                          **authargs)
+    if six.PY2 and not isinstance(url, bytes):
+        url = url.encode('utf-8')
+    if six.PY2 and not isinstance(token, bytes):
+        token = token.encode('utf-8')
+    return url, token
 
 
 def retry(func, *args, **kwargs):
diff -pruN 2.25.0-2/test/functional/s3api/__init__.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/__init__.py
--- 2.25.0-2/test/functional/s3api/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/__init__.py	2020-07-06 17:03:50.000000000 +0000
@@ -15,6 +15,8 @@
 
 import unittest
 import traceback
+from contextlib import contextmanager
+import logging
 import test.functional as tf
 from test.functional.s3api.s3_test_client import (
     Connection, get_boto3_conn, tear_down_s3)
@@ -33,11 +35,23 @@ class S3ApiBase(unittest.TestCase):
         super(S3ApiBase, self).__init__(method_name)
         self.method_name = method_name
 
+    @contextmanager
+    def quiet_boto_logging(self):
+        try:
+            logging.getLogger('boto').setLevel(logging.INFO)
+            yield
+        finally:
+            logging.getLogger('boto').setLevel(logging.DEBUG)
+
     def setUp(self):
         if 's3api' not in tf.cluster_info:
             raise tf.SkipTest('s3api middleware is not enabled')
         try:
-            self.conn = Connection()
+            self.conn = Connection(
+                tf.config['s3_access_key'], tf.config['s3_secret_key'],
+                user_id='%s:%s' % (tf.config['account'],
+                                   tf.config['username']))
+
             self.conn.reset()
         except Exception:
             message = '%s got an error during initialize process.\n\n%s' % \
@@ -67,7 +81,8 @@ class S3ApiBaseBoto3(S3ApiBase):
         if 's3api' not in tf.cluster_info:
             raise tf.SkipTest('s3api middleware is not enabled')
         try:
-            self.conn = get_boto3_conn()
+            self.conn = get_boto3_conn(
+                tf.config['s3_access_key'], tf.config['s3_secret_key'])
             self.endpoint_url = self.conn._endpoint.host
             self.access_key = self.conn._request_signer._credentials.access_key
             self.region = self.conn._client_config.region_name
diff -pruN 2.25.0-2/test/functional/s3api/s3_test_client.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/s3_test_client.py
--- 2.25.0-2/test/functional/s3api/s3_test_client.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/s3_test_client.py	2020-07-06 17:03:50.000000000 +0000
@@ -15,6 +15,7 @@
 
 import logging
 import os
+from six.moves.urllib.parse import urlparse
 import test.functional as tf
 import boto3
 from botocore.exceptions import ClientError
@@ -46,9 +47,9 @@ class Connection(object):
     """
     Connection class used for S3 functional testing.
     """
-    def __init__(self, aws_access_key='test:tester',
-                 aws_secret_key='testing',
-                 user_id='test:tester'):
+    def __init__(self, aws_access_key,
+                 aws_secret_key,
+                 user_id=None):
         """
         Initialize method.
 
@@ -64,15 +65,16 @@ class Connection(object):
         """
         self.aws_access_key = aws_access_key
         self.aws_secret_key = aws_secret_key
-        self.user_id = user_id
-        # NOTE: auth_host and auth_port can be different from storage location
-        self.host = tf.config['auth_host']
-        self.port = int(tf.config['auth_port'])
+        self.user_id = user_id or aws_access_key
+        parsed = urlparse(tf.config['s3_storage_url'])
+        self.host = parsed.hostname
+        self.port = parsed.port
         self.conn = \
-            S3Connection(aws_access_key, aws_secret_key, is_secure=False,
+            S3Connection(aws_access_key, aws_secret_key,
+                         is_secure=(parsed.scheme == 'https'),
                          host=self.host, port=self.port,
                          calling_format=OrdinaryCallingFormat())
-        self.conn.auth_region_name = 'us-east-1'
+        self.conn.auth_region_name = tf.config.get('s3_region', 'us-east-1')
 
     def reset(self):
         """
@@ -140,22 +142,26 @@ class Connection(object):
         url = self.conn.generate_url(expires_in, method, bucket, obj)
         if os.environ.get('S3_USE_SIGV4') == "True":
             # V4 signatures are known-broken in boto, but we can work around it
-            if url.startswith('https://'):
+            if url.startswith('https://') and not tf.config[
+                    's3_storage_url'].startswith('https://'):
                 url = 'http://' + url[8:]
-            return url, {'Host': '%(host)s:%(port)d:%(port)d' % {
-                'host': self.host, 'port': self.port}}
+            if self.port is None:
+                return url, {}
+            else:
+                return url, {'Host': '%(host)s:%(port)d:%(port)d' % {
+                    'host': self.host, 'port': self.port}}
         return url, {}
 
 
-def get_boto3_conn(aws_access_key='test:tester', aws_secret_key='testing'):
-    host = tf.config['auth_host']
-    port = int(tf.config['auth_port'])
+def get_boto3_conn(aws_access_key, aws_secret_key):
+    endpoint_url = tf.config['s3_storage_url']
     config = boto3.session.Config(s3={'addressing_style': 'path'})
     return boto3.client(
         's3', aws_access_key_id=aws_access_key,
         aws_secret_access_key=aws_secret_key,
-        config=config, region_name='us-east-1', use_ssl=False,
-        endpoint_url='http://{}:{}'.format(host, port))
+        config=config, region_name=tf.config.get('s3_region', 'us-east-1'),
+        use_ssl=endpoint_url.startswith('https:'),
+        endpoint_url=endpoint_url)
 
 
 def tear_down_s3(conn):
diff -pruN 2.25.0-2/test/functional/s3api/test_acl.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_acl.py
--- 2.25.0-2/test/functional/s3api/test_acl.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_acl.py	2020-07-06 17:03:50.000000000 +0000
@@ -93,7 +93,7 @@ class TestS3Acl(S3ApiBase):
 
     def test_put_bucket_acl_error(self):
         req_headers = {'x-amz-acl': 'public-read'}
-        aws_error_conn = Connection(aws_secret_key='invalid')
+        aws_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             aws_error_conn.make_request('PUT', self.bucket,
                                         headers=req_headers, query='acl')
@@ -110,7 +110,7 @@ class TestS3Acl(S3ApiBase):
         self.assertEqual(get_error_code(body), 'AccessDenied')
 
     def test_get_bucket_acl_error(self):
-        aws_error_conn = Connection(aws_secret_key='invalid')
+        aws_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             aws_error_conn.make_request('GET', self.bucket, query='acl')
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -126,7 +126,7 @@ class TestS3Acl(S3ApiBase):
     def test_get_object_acl_error(self):
         self.conn.make_request('PUT', self.bucket, self.obj)
 
-        aws_error_conn = Connection(aws_secret_key='invalid')
+        aws_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             aws_error_conn.make_request('GET', self.bucket, self.obj,
                                         query='acl')
diff -pruN 2.25.0-2/test/functional/s3api/test_bucket.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_bucket.py
--- 2.25.0-2/test/functional/s3api/test_bucket.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_bucket.py	2020-07-06 17:03:50.000000000 +0000
@@ -42,11 +42,15 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
             self.assertIn('ETag', obj)
             self.assertIn('Size', obj)
             self.assertEqual(obj['StorageClass'], 'STANDARD')
-            if expect_owner:
+            if not expect_owner:
+                self.assertNotIn('Owner', obj)
+            elif tf.cluster_info['s3api'].get('s3_acl'):
                 self.assertEqual(obj['Owner']['ID'], self.access_key)
                 self.assertEqual(obj['Owner']['DisplayName'], self.access_key)
             else:
-                self.assertNotIn('Owner', obj)
+                self.assertIn('Owner', obj)
+                self.assertIn('ID', obj['Owner'])
+                self.assertIn('DisplayName', obj['Owner'])
 
     def test_bucket(self):
         bucket = 'bucket'
@@ -128,7 +132,7 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
         self.assertEqual(
             ctx.exception.response['Error']['Code'], 'InvalidBucketName')
 
-        auth_error_conn = get_boto3_conn(aws_secret_key='invalid')
+        auth_error_conn = get_boto3_conn(tf.config['s3_access_key'], 'invalid')
         with self.assertRaises(botocore.exceptions.ClientError) as ctx:
             auth_error_conn.create_bucket(Bucket='bucket')
         self.assertEqual(
@@ -201,7 +205,7 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
         self.assertEqual(
             ctx.exception.response['Error']['Code'], 'InvalidBucketName')
 
-        auth_error_conn = get_boto3_conn(aws_secret_key='invalid')
+        auth_error_conn = get_boto3_conn(tf.config['s3_access_key'], 'invalid')
         with self.assertRaises(botocore.exceptions.ClientError) as ctx:
             auth_error_conn.list_objects(Bucket='bucket')
         self.assertEqual(
@@ -388,7 +392,7 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
             ctx.exception.response[
                 'ResponseMetadata']['HTTPHeaders']['content-length'], '0')
 
-        auth_error_conn = get_boto3_conn(aws_secret_key='invalid')
+        auth_error_conn = get_boto3_conn(tf.config['s3_access_key'], 'invalid')
         with self.assertRaises(botocore.exceptions.ClientError) as ctx:
             auth_error_conn.head_bucket(Bucket='bucket')
         self.assertEqual(
@@ -419,7 +423,7 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
         self.assertEqual(
             ctx.exception.response['Error']['Code'], 'InvalidBucketName')
 
-        auth_error_conn = get_boto3_conn(aws_secret_key='invalid')
+        auth_error_conn = get_boto3_conn(tf.config['s3_access_key'], 'invalid')
         with self.assertRaises(botocore.exceptions.ClientError) as ctx:
             auth_error_conn.delete_bucket(Bucket='bucket')
         self.assertEqual(
diff -pruN 2.25.0-2/test/functional/s3api/test_multi_delete.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_multi_delete.py
--- 2.25.0-2/test/functional/s3api/test_multi_delete.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_multi_delete.py	2020-07-06 17:03:50.000000000 +0000
@@ -134,7 +134,7 @@ class TestS3ApiMultiDelete(S3ApiBase):
         content_md5 = calculate_md5(xml)
         query = 'delete'
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('POST', bucket, body=xml,
                                          headers={
diff -pruN 2.25.0-2/test/functional/s3api/test_multi_upload.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_multi_upload.py
--- 2.25.0-2/test/functional/s3api/test_multi_upload.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_multi_upload.py	2020-07-06 17:03:50.000000000 +0000
@@ -78,9 +78,9 @@ class TestS3ApiMultiUpload(S3ApiBase):
     def _upload_part(self, bucket, key, upload_id, content=None, part_num=1):
         query = 'partNumber=%s&uploadId=%s' % (part_num, upload_id)
         content = content if content else b'a' * self.min_segment_size
-        status, headers, body = \
-            self.conn.make_request('PUT', bucket, key, body=content,
-                                   query=query)
+        with self.quiet_boto_logging():
+            status, headers, body = self.conn.make_request(
+                'PUT', bucket, key, body=content, query=query)
         return status, headers, body
 
     def _upload_part_copy(self, src_bucket, src_obj, dst_bucket, dst_key,
@@ -113,7 +113,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         bucket = 'bucket'
         keys = ['obj1', 'obj2', 'obj3']
         bad_content_md5 = base64.b64encode(b'a' * 16).strip().decode('ascii')
-        headers = [None,
+        headers = [{'Content-Type': 'foo/bar', 'x-amz-meta-baz': 'quux'},
                    {'Content-MD5': bad_content_md5},
                    {'Etag': 'nonsense'}]
         uploads = []
@@ -293,7 +293,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
             self._complete_multi_upload(bucket, key, upload_id, xml)
         self.assertEqual(status, 200)
         self.assertCommonResponseHeaders(headers)
-        self.assertTrue('content-type' in headers)
+        self.assertIn('content-type', headers)
         self.assertEqual(headers['content-type'], 'application/xml')
         if 'content-length' in headers:
             self.assertEqual(headers['content-length'], str(len(body)))
@@ -304,9 +304,8 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.assertTrue(lines[0].startswith(b'<?xml'), body)
         self.assertTrue(lines[0].endswith(b'?>'), body)
         elem = fromstring(body, 'CompleteMultipartUploadResult')
-        # TODO: use tf.config value
         self.assertEqual(
-            'http://%s:%s/bucket/obj1' % (self.conn.host, self.conn.port),
+            '%s/bucket/obj1' % tf.config['s3_storage_url'].rstrip('/'),
             elem.find('Location').text)
         self.assertEqual(elem.find('Bucket').text, bucket)
         self.assertEqual(elem.find('Key').text, key)
@@ -318,9 +317,46 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.assertEqual(etag, exp_etag)
 
         exp_size = self.min_segment_size * len(etags)
+        status, headers, body = \
+            self.conn.make_request('HEAD', bucket, key)
+        self.assertEqual(status, 200)
+        self.assertEqual(headers['content-length'], str(exp_size))
+        self.assertEqual(headers['content-type'], 'foo/bar')
+        self.assertEqual(headers['x-amz-meta-baz'], 'quux')
+
         swift_etag = '"%s"' % md5(concatted_etags).hexdigest()
         # TODO: GET via swift api, check against swift_etag
 
+        # Should be safe to retry
+        status, headers, body = \
+            self._complete_multi_upload(bucket, key, upload_id, xml)
+        self.assertEqual(status, 200)
+        self.assertCommonResponseHeaders(headers)
+        self.assertIn('content-type', headers)
+        self.assertEqual(headers['content-type'], 'application/xml')
+        if 'content-length' in headers:
+            self.assertEqual(headers['content-length'], str(len(body)))
+        else:
+            self.assertIn('transfer-encoding', headers)
+            self.assertEqual(headers['transfer-encoding'], 'chunked')
+        lines = body.split(b'\n')
+        self.assertTrue(lines[0].startswith(b'<?xml'), body)
+        self.assertTrue(lines[0].endswith(b'?>'), body)
+        elem = fromstring(body, 'CompleteMultipartUploadResult')
+        self.assertEqual(
+            '%s/bucket/obj1' % tf.config['s3_storage_url'].rstrip('/'),
+            elem.find('Location').text)
+        self.assertEqual(elem.find('Bucket').text, bucket)
+        self.assertEqual(elem.find('Key').text, key)
+        self.assertEqual(elem.find('ETag').text, exp_etag)
+
+        status, headers, body = \
+            self.conn.make_request('HEAD', bucket, key)
+        self.assertEqual(status, 200)
+        self.assertEqual(headers['content-length'], str(exp_size))
+        self.assertEqual(headers['content-type'], 'foo/bar')
+        self.assertEqual(headers['x-amz-meta-baz'], 'quux')
+
         # Upload Part Copy -- MU as source
         key, upload_id = uploads[1]
         status, headers, body, resp_etag = \
@@ -428,7 +464,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.conn.make_request('PUT', bucket)
         query = 'uploads'
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('POST', bucket, key, query=query)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -442,7 +478,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.conn.make_request('PUT', bucket)
         query = 'uploads'
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('GET', bucket, query=query)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -462,7 +498,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         upload_id = elem.find('UploadId').text
 
         query = 'partNumber=%s&uploadId=%s' % (1, upload_id)
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('PUT', bucket, key, query=query)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -500,7 +536,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         upload_id = elem.find('UploadId').text
 
         query = 'partNumber=%s&uploadId=%s' % (1, upload_id)
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('PUT', bucket, key,
                                          headers={
@@ -541,7 +577,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         upload_id = elem.find('UploadId').text
 
         query = 'uploadId=%s' % upload_id
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
 
         status, headers, body = \
             auth_error_conn.make_request('GET', bucket, key, query=query)
@@ -568,7 +604,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self._upload_part(bucket, key, upload_id)
 
         query = 'uploadId=%s' % upload_id
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('DELETE', bucket, key, query=query)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -612,7 +648,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.assertEqual(get_error_code(body), 'EntityTooSmall')
 
         # invalid credentials
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('POST', bucket, keys[0], body=xml,
                                          query=query)
@@ -881,6 +917,8 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.assertEqual(headers['content-length'], '0')
 
     def test_object_multi_upload_part_copy_version(self):
+        if 'object_versioning' not in tf.cluster_info:
+            self.skipTest('Object Versioning not enabled')
         bucket = 'bucket'
         keys = ['obj1']
         uploads = []
diff -pruN 2.25.0-2/test/functional/s3api/test_object.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_object.py
--- 2.25.0-2/test/functional/s3api/test_object.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_object.py	2020-07-06 17:03:50.000000000 +0000
@@ -147,7 +147,7 @@ class TestS3ApiObject(S3ApiBase):
         self.assertCommonResponseHeaders(headers)
 
     def test_put_object_error(self):
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('PUT', self.bucket, 'object')
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -166,7 +166,7 @@ class TestS3ApiObject(S3ApiBase):
         dst_obj = 'dst_object'
 
         headers = {'x-amz-copy-source': '/%s/%s' % (self.bucket, obj)}
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('PUT', dst_bucket, dst_obj, headers)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -197,7 +197,7 @@ class TestS3ApiObject(S3ApiBase):
         obj = 'object'
         self.conn.make_request('PUT', self.bucket, obj)
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('GET', self.bucket, obj)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -216,7 +216,7 @@ class TestS3ApiObject(S3ApiBase):
         obj = 'object'
         self.conn.make_request('PUT', self.bucket, obj)
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('HEAD', self.bucket, obj)
         self.assertEqual(status, 403)
@@ -239,7 +239,7 @@ class TestS3ApiObject(S3ApiBase):
         obj = 'object'
         self.conn.make_request('PUT', self.bucket, obj)
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('DELETE', self.bucket, obj)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
diff -pruN 2.25.0-2/test/functional/s3api/test_service.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_service.py
--- 2.25.0-2/test/functional/s3api/test_service.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_service.py	2020-07-06 17:03:50.000000000 +0000
@@ -69,7 +69,7 @@ class TestS3ApiService(S3ApiBase):
             self.assertTrue(b.find('CreationDate') is not None)
 
     def test_service_error_signature_not_match(self):
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = auth_error_conn.make_request('GET')
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
         self.assertEqual(headers['content-type'], 'application/xml')
diff -pruN 2.25.0-2/test/functional/s3api/test_versioning.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_versioning.py
--- 2.25.0-2/test/functional/s3api/test_versioning.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/s3api/test_versioning.py	2020-07-06 17:03:50.000000000 +0000
@@ -58,7 +58,7 @@ class TestS3ApiVersioning(S3ApiBase):
             'GET', 'bucket', query='versioning')
         self.assertEqual(status, 200)
         elem = fromstring(body)
-        self.assertEqual(elem.getchildren(), [])
+        self.assertEqual(list(elem), [])
 
         # Enable versioning
         elem = Element('VersioningConfiguration')
@@ -108,7 +108,7 @@ class TestS3ApiVersioning(S3ApiBase):
             'GET', 'bucket', query='versioning')
         self.assertEqual(status, 200)
         elem = fromstring(body)
-        self.assertEqual(elem.getchildren(), [])
+        self.assertEqual(list(elem), [])
 
         # Suspend versioning
         elem = Element('VersioningConfiguration')
diff -pruN 2.25.0-2/test/functional/swift_test_client.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/swift_test_client.py
--- 2.25.0-2/test/functional/swift_test_client.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/swift_test_client.py	2020-07-06 17:03:50.000000000 +0000
@@ -225,6 +225,9 @@ class Connection(object):
 
     @storage_url.setter
     def storage_url(self, value):
+        if six.PY2 and not isinstance(value, bytes):
+            value = value.encode('utf-8')
+
         url = urllib.parse.urlparse(value)
 
         if url.scheme == 'http':
diff -pruN 2.25.0-2/test/functional/test_object.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_object.py
--- 2.25.0-2/test/functional/test_object.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_object.py	2020-07-06 17:03:50.000000000 +0000
@@ -1726,7 +1726,7 @@ class TestObject(unittest.TestCase):
         if 'etag_quoter' not in tf.cluster_info:
             raise SkipTest("etag-quoter middleware is not enabled")
 
-        def do_head(expect_quoted=False):
+        def do_head(expect_quoted=None):
             def head(url, token, parsed, conn):
                 conn.request('HEAD', '%s/%s/%s' % (
                     parsed.path, self.container, self.obj), '',
@@ -1736,6 +1736,11 @@ class TestObject(unittest.TestCase):
             resp = retry(head)
             resp.read()
             self.assertEqual(resp.status, 200)
+
+            if expect_quoted is None:
+                expect_quoted = tf.cluster_info.get('etag_quoter', {}).get(
+                    'enable_by_default', False)
+
             expected_etag = hashlib.md5(b'test').hexdigest()
             if expect_quoted:
                 expected_etag = '"%s"' % expected_etag
@@ -1766,11 +1771,15 @@ class TestObject(unittest.TestCase):
         do_head()
         post_container('t')
         do_head(expect_quoted=True)
-        post_account('t')
-        post_container('')
-        do_head(expect_quoted=True)
-        post_container('f')
-        do_head()
+        try:
+            post_account('t')
+            post_container('')
+            do_head(expect_quoted=True)
+            post_container('f')
+            do_head(expect_quoted=False)
+        finally:
+            # Don't leave a dirty account
+            post_account('')
 
 
 if __name__ == '__main__':
diff -pruN 2.25.0-2/test/functional/test_object_versioning.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_object_versioning.py
--- 2.25.0-2/test/functional/test_object_versioning.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_object_versioning.py	2020-07-06 17:03:50.000000000 +0000
@@ -26,6 +26,7 @@ from six.moves.urllib.parse import quote
 
 import test.functional as tf
 
+from swift.common.swob import normalize_etag
 from swift.common.utils import MD5_OF_EMPTY_STRING, config_true_value
 from swift.common.middleware.versioned_writes.object_versioning import \
     DELETE_MARKER_CONTENT_TYPE
@@ -293,7 +294,7 @@ class TestObjectVersioning(TestObjectVer
 
         # swift_test_client's File API doesn't really allow for POSTing
         # arbitrary headers, so...
-        def put(url, token, parsed, conn):
+        def post(url, token, parsed, conn):
             conn.request('POST', '%s/%s/%s' % (parsed.path, container,
                                                versioned_obj2.name),
                          '', {'X-Auth-Token': token,
@@ -301,7 +302,7 @@ class TestObjectVersioning(TestObjectVer
                               'X-Object-Meta-Color': 'red',
                               'X-Delete-After': '1'})
             return tf.check_response(conn)
-        resp = tf.retry(put)
+        resp = tf.retry(post)
         resp.read()
         self.assertEqual(resp.status, 202)
 
@@ -331,6 +332,80 @@ class TestObjectVersioning(TestObjectVer
         # listing, though, we'll only ever have the two entries.
         self.assertTotalVersions(container, 2)
 
+    def test_get_if_match(self):
+        body = b'data'
+        oname = Utils.create_name()
+        obj = self.env.unversioned_container.file(oname)
+        resp = obj.write(body, return_resp=True)
+        etag = resp.getheader('etag')
+        self.assertEqual(md5(body).hexdigest(), normalize_etag(etag))
+
+        # un-versioned object is cool with with if-match
+        self.assertEqual(body, obj.read(hdrs={'if-match': etag}))
+        with self.assertRaises(ResponseError) as cm:
+            obj.read(hdrs={'if-match': 'not-the-etag'})
+        self.assertEqual(412, cm.exception.status)
+
+        v_obj = self.env.container.file(oname)
+        resp = v_obj.write(body, return_resp=True)
+        self.assertEqual(resp.getheader('etag'), etag)
+
+        # versioned object is too with with if-match
+        self.assertEqual(body, v_obj.read(hdrs={
+            'if-match': normalize_etag(etag)}))
+        # works quoted, too
+        self.assertEqual(body, v_obj.read(hdrs={
+            'if-match': '"%s"' % normalize_etag(etag)}))
+        with self.assertRaises(ResponseError) as cm:
+            v_obj.read(hdrs={'if-match': 'not-the-etag'})
+        self.assertEqual(412, cm.exception.status)
+
+    def test_container_acls(self):
+        if tf.skip3:
+            raise SkipTest('Username3 not set')
+
+        obj = self.env.container.file(Utils.create_name())
+        resp = obj.write(b"data", return_resp=True)
+        version_id = resp.getheader('x-object-version-id')
+        self.assertIsNotNone(version_id)
+
+        with self.assertRaises(ResponseError) as cm:
+            obj.read(hdrs={'X-Auth-Token': self.env.conn3.storage_token})
+        self.assertEqual(403, cm.exception.status)
+
+        # Container ACLs work more or less like they always have
+        self.env.container.update_metadata(
+            hdrs={'X-Container-Read': self.env.conn3.user_acl})
+        self.assertEqual(b"data", obj.read(hdrs={
+            'X-Auth-Token': self.env.conn3.storage_token}))
+
+        # But the version-specifc GET still requires a swift owner
+        with self.assertRaises(ResponseError) as cm:
+            obj.read(hdrs={'X-Auth-Token': self.env.conn3.storage_token},
+                     parms={'version-id': version_id})
+        self.assertEqual(403, cm.exception.status)
+
+        # If it's pointing to a symlink that points elsewhere, that still needs
+        # to be authed
+        tgt_name = Utils.create_name()
+        self.env.unversioned_container.file(tgt_name).write(b'link')
+        sym_tgt_header = quote(unquote('%s/%s' % (
+            self.env.unversioned_container.name, tgt_name)))
+        obj.write(hdrs={'X-Symlink-Target': sym_tgt_header})
+
+        # So, user1's good...
+        self.assertEqual(b'link', obj.read())
+        # ...but user3 can't
+        with self.assertRaises(ResponseError) as cm:
+            obj.read(hdrs={'X-Auth-Token': self.env.conn3.storage_token})
+        self.assertEqual(403, cm.exception.status)
+
+        # unless we add the acl to the unversioned_container
+        self.env.unversioned_container.update_metadata(
+            hdrs={'X-Container-Read': self.env.conn3.user_acl})
+        self.assertEqual(b'link', obj.read(
+            hdrs={'X-Auth-Token': self.env.conn3.storage_token}))
+
     def _test_overwriting_setup(self, obj_name=None):
         # sanity
         container = self.env.container
@@ -919,13 +994,13 @@ class TestObjectVersioning(TestObjectVer
             'Content-Type': 'text/jibberish32'
         }, return_resp=True)
         v1_version_id = resp.getheader('x-object-version-id')
-        v1_etag = resp.getheader('etag')
+        v1_etag = normalize_etag(resp.getheader('etag'))
 
         resp = obj.write(b'version2', hdrs={
             'Content-Type': 'text/jibberish33'
         }, return_resp=True)
         v2_version_id = resp.getheader('x-object-version-id')
-        v2_etag = resp.getheader('etag')
+        v2_etag = normalize_etag(resp.getheader('etag'))
 
         # sanity
         self.assertEqual(b'version2', obj.read())
@@ -992,7 +1067,7 @@ class TestObjectVersioning(TestObjectVer
         self.assertEqual(b'version1', obj.read())
         obj_info = obj.info()
         self.assertEqual('text/jibberish32', obj_info['content_type'])
-        self.assertEqual(v1_etag, obj_info['etag'])
+        self.assertEqual(v1_etag, normalize_etag(obj_info['etag']))
 
     def test_delete_with_version_api_old_object(self):
         versioned_obj_name = Utils.create_name()
@@ -2308,7 +2383,7 @@ class TestSloWithVersioning(TestObjectVe
         expected = {
             'bytes': file_info['content_length'],
             'content_type': 'application/octet-stream',
-            'hash': manifest_info['etag'],
+            'hash': normalize_etag(manifest_info['etag']),
             'name': 'my-slo-manifest',
             'slo_etag': file_info['etag'],
             'version_symlink': True,
@@ -2340,7 +2415,7 @@ class TestSloWithVersioning(TestObjectVe
         expected = {
             'bytes': file_info['content_length'],
             'content_type': 'application/octet-stream',
-            'hash': manifest_info['etag'],
+            'hash': normalize_etag(manifest_info['etag']),
             'name': 'my-slo-manifest',
             'slo_etag': file_info['etag'],
             'version_symlink': True,
@@ -2688,16 +2763,11 @@ class TestVersioningContainerTempurl(Tes
         obj.write(b"version2")
 
         # get v2 object (reading from versions container)
-        # cross container tempurl does not work for container tempurl key
-        try:
-            obj.read(parms=get_parms, cfg={'no_auth_token': True})
-        except ResponseError as e:
-            self.assertEqual(e.status, 401)
-        else:
-            self.fail('request did not error')
-        try:
-            obj.info(parms=get_parms, cfg={'no_auth_token': True})
-        except ResponseError as e:
-            self.assertEqual(e.status, 401)
-        else:
-            self.fail('request did not error')
+        # versioning symlink allows us to bypass the normal
+        # container-tempurl-key scoping
+        contents = obj.read(parms=get_parms, cfg={'no_auth_token': True})
+        self.assert_status([200])
+        self.assertEqual(contents, b"version2")
+        # HEAD works, too
+        obj.info(parms=get_parms, cfg={'no_auth_token': True})
+        self.assert_status([200])
diff -pruN 2.25.0-2/test/functional/test_slo.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_slo.py
--- 2.25.0-2/test/functional/test_slo.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_slo.py	2020-07-06 17:03:50.000000000 +0000
@@ -23,6 +23,8 @@ from copy import deepcopy
 
 import six
 
+from swift.common.swob import normalize_etag
+
 import test.functional as tf
 from test.functional import cluster_info, SkipTest
 from test.functional.tests import Utils, Base, Base2, BaseEnv
@@ -299,8 +301,14 @@ class TestSlo(Base):
         # a POST.
         file_item.initialize(parms={'multipart-manifest': 'get'})
         manifest_etag = file_item.etag
-        self.assertFalse(manifest_etag.startswith('"'))
-        self.assertFalse(manifest_etag.endswith('"'))
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertTrue(manifest_etag.startswith('"'))
+            self.assertTrue(manifest_etag.endswith('"'))
+            # ...but in the listing, it'll be stripped
+            manifest_etag = manifest_etag[1:-1]
+        else:
+            self.assertFalse(manifest_etag.startswith('"'))
+            self.assertFalse(manifest_etag.endswith('"'))
 
         file_item.initialize()
         slo_etag = file_item.etag
@@ -715,6 +723,8 @@ class TestSlo(Base):
         source_contents = source.read(parms={'multipart-manifest': 'get'})
         source_json = json.loads(source_contents)
         manifest_etag = hashlib.md5(source_contents).hexdigest()
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            manifest_etag = '"%s"' % manifest_etag
         self.assertEqual(manifest_etag, source.etag)
 
         source.initialize()
@@ -752,14 +762,14 @@ class TestSlo(Base):
         actual = names['manifest-abcde']
         self.assertEqual(4 * 1024 * 1024 + 1, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        self.assertEqual(normalize_etag(manifest_etag), actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
         self.assertIn('copied-abcde-manifest-only', names)
         actual = names['copied-abcde-manifest-only']
         self.assertEqual(4 * 1024 * 1024 + 1, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        self.assertEqual(normalize_etag(manifest_etag), actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
         # Test copy manifest including data segments
@@ -789,6 +799,8 @@ class TestSlo(Base):
         source_contents = source.read(parms={'multipart-manifest': 'get'})
         source_json = json.loads(source_contents)
         manifest_etag = hashlib.md5(source_contents).hexdigest()
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            manifest_etag = '"%s"' % manifest_etag
         self.assertEqual(manifest_etag, source.etag)
 
         source.initialize()
@@ -831,14 +843,14 @@ class TestSlo(Base):
         self.assertEqual(4 * 1024 * 1024 + 1, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
         # the container listing should have the etag of the manifest contents
-        self.assertEqual(manifest_etag, actual['hash'])
+        self.assertEqual(normalize_etag(manifest_etag), actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
         self.assertIn('copied-abcde-manifest-only', names)
         actual = names['copied-abcde-manifest-only']
         self.assertEqual(4 * 1024 * 1024 + 1, actual['bytes'])
         self.assertEqual('image/jpeg', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        self.assertEqual(normalize_etag(manifest_etag), actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
     def test_slo_copy_the_manifest_account(self):
@@ -1098,12 +1110,7 @@ class TestSlo(Base):
         manifest = self.env.container.file("manifest-db")
         got_body = manifest.read(parms={'multipart-manifest': 'get',
                                         'format': 'raw'})
-        body_md5 = hashlib.md5(got_body).hexdigest()
-        headers = dict(
-            (h.lower(), v)
-            for h, v in manifest.conn.response.getheaders())
-        self.assertIn('etag', headers)
-        self.assertEqual(headers['etag'], body_md5)
+        self.assert_etag(hashlib.md5(got_body).hexdigest())
 
         # raw format should have the actual manifest object content-type
         self.assertEqual('application/octet-stream', manifest.content_type)
diff -pruN 2.25.0-2/test/functional/tests.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/tests.py
--- 2.25.0-2/test/functional/tests.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/tests.py	2020-07-06 17:03:50.000000000 +0000
@@ -27,6 +27,7 @@ import uuid
 from copy import deepcopy
 import eventlet
 from swift.common.http import is_success, is_client_error
+from swift.common.swob import normalize_etag
 from email.utils import parsedate
 
 if six.PY2:
@@ -131,6 +132,13 @@ class Base(unittest.TestCase):
                 'Expected header name %r not found in response.' % header_name)
         self.assertEqual(expected_value, actual_value)
 
+    def assert_etag(self, unquoted_value):
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            expected = '"%s"' % unquoted_value
+        else:
+            expected = unquoted_value
+        self.assert_header('etag', expected)
+
 
 class Base2(object):
     @classmethod
@@ -874,7 +882,11 @@ class TestContainer(Base):
         for actual in file_list:
             name = actual['name']
             self.assertIn(name, expected)
-            self.assertEqual(expected[name]['etag'], actual['hash'])
+            if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+                self.assertEqual(expected[name]['etag'],
+                                 '"%s"' % actual['hash'])
+            else:
+                self.assertEqual(expected[name]['etag'], actual['hash'])
             self.assertEqual(
                 expected[name]['content_type'], actual['content_type'])
             self.assertEqual(
@@ -1365,6 +1377,8 @@ class TestFile(Base):
                             'x-delete-at': mock.ANY,
                             'x-trans-id': mock.ANY,
                             'x-openstack-request-id': mock.ANY}
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            expected_headers['etag'] = '"%s"' % expected_headers['etag']
         unexpected_headers = ['connection', 'x-delete-after']
         do_test(put_headers, {}, expected_headers, unexpected_headers)
 
@@ -1420,7 +1434,7 @@ class TestFile(Base):
                     self.fail('Failed to find %s in listing' % dest_filename)
 
                 self.assertEqual(file_item.size, obj['bytes'])
-                self.assertEqual(file_item.etag, obj['hash'])
+                self.assertEqual(normalize_etag(file_item.etag), obj['hash'])
                 self.assertEqual(file_item.content_type, obj['content_type'])
 
                 file_copy = cont.file(dest_filename)
@@ -1470,7 +1484,7 @@ class TestFile(Base):
                     self.fail('Failed to find %s in listing' % dest_filename)
 
                 self.assertEqual(file_item.size, obj['bytes'])
-                self.assertEqual(file_item.etag, obj['hash'])
+                self.assertEqual(normalize_etag(file_item.etag), obj['hash'])
                 self.assertEqual(
                     'application/test-changed', obj['content_type'])
 
@@ -1505,7 +1519,7 @@ class TestFile(Base):
                     self.fail('Failed to find %s in listing' % dest_filename)
 
                 self.assertEqual(file_item.size, obj['bytes'])
-                self.assertEqual(file_item.etag, obj['hash'])
+                self.assertEqual(normalize_etag(file_item.etag), obj['hash'])
                 self.assertEqual(
                     'application/test-updated', obj['content_type'])
 
@@ -2088,7 +2102,7 @@ class TestFile(Base):
                 self.assertEqual(file_item.read(hdrs=hdrs), data[-i:])
                 self.assert_header('content-range', 'bytes %d-%d/%d' % (
                     file_length - i, file_length - 1, file_length))
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
 
             range_string = 'bytes=%d-' % (i)
@@ -2102,7 +2116,7 @@ class TestFile(Base):
         self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
         self.assert_status(416)
         self.assert_header('content-range', 'bytes */%d' % file_length)
-        self.assert_header('etag', file_item.md5)
+        self.assert_etag(file_item.md5)
         self.assert_header('accept-ranges', 'bytes')
 
         range_string = 'bytes=%d-%d' % (file_length - 1000, file_length + 2000)
@@ -2416,14 +2430,16 @@ class TestFile(Base):
         file_item.content_type = content_type
         file_item.write_random(self.env.file_size)
 
-        md5 = file_item.md5
+        expected_etag = file_item.md5
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            expected_etag = '"%s"' % expected_etag
 
         file_item = self.env.container.file(file_name)
         info = file_item.info()
 
         self.assert_status(200)
         self.assertEqual(info['content_length'], self.env.file_size)
-        self.assertEqual(info['etag'], md5)
+        self.assertEqual(info['etag'], expected_etag)
         self.assertEqual(info['content_type'], content_type)
         self.assertIn('last_modified', info)
 
@@ -2612,14 +2628,7 @@ class TestFile(Base):
         file_item = self.env.container.file(Utils.create_name())
 
         data = io.BytesIO(file_item.write_random(512))
-        etag = File.compute_md5sum(data)
-
-        headers = dict((h.lower(), v)
-                       for h, v in self.env.conn.response.getheaders())
-        self.assertIn('etag', headers.keys())
-
-        header_etag = headers['etag'].strip('"')
-        self.assertEqual(etag, header_etag)
+        self.assert_etag(File.compute_md5sum(data))
 
     def testChunkedPut(self):
         if (tf.web_front_end == 'apache2'):
@@ -2645,7 +2654,7 @@ class TestFile(Base):
             self.assertEqual(data, file_item.read())
 
             info = file_item.info()
-            self.assertEqual(etag, info['etag'])
+            self.assertEqual(normalize_etag(info['etag']), etag)
 
     def test_POST(self):
         # verify consistency between object and container listing metadata
@@ -2670,7 +2679,10 @@ class TestFile(Base):
             self.fail('Failed to find file %r in listing' % file_name)
         self.assertEqual(1024, f_dict['bytes'])
         self.assertEqual('text/foobar', f_dict['content_type'])
-        self.assertEqual(etag, f_dict['hash'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual(etag, '"%s"' % f_dict['hash'])
+        else:
+            self.assertEqual(etag, f_dict['hash'])
         put_last_modified = f_dict['last_modified']
 
         # now POST updated content-type to each file
@@ -2697,7 +2709,10 @@ class TestFile(Base):
         self.assertEqual(1024, f_dict['bytes'])
         self.assertEqual('image/foobarbaz', f_dict['content_type'])
         self.assertLess(put_last_modified, f_dict['last_modified'])
-        self.assertEqual(etag, f_dict['hash'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual(etag, '"%s"' % f_dict['hash'])
+        else:
+            self.assertEqual(etag, f_dict['hash'])
 
 
 class TestFileUTF8(Base2, TestFile):
@@ -2742,7 +2757,7 @@ class TestFileComparison(Base):
             hdrs = {'If-Match': 'bogus'}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
     def testIfMatchMultipleEtags(self):
         for file_item in self.env.files:
@@ -2752,7 +2767,7 @@ class TestFileComparison(Base):
             hdrs = {'If-Match': '"bogus1", "bogus2", "bogus3"'}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
     def testIfNoneMatch(self):
         for file_item in self.env.files:
@@ -2762,7 +2777,7 @@ class TestFileComparison(Base):
             hdrs = {'If-None-Match': file_item.md5}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(304)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfNoneMatchMultipleEtags(self):
@@ -2774,7 +2789,7 @@ class TestFileComparison(Base):
                     '"bogus1", "bogus2", "%s"' % file_item.md5}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(304)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfModifiedSince(self):
@@ -2786,11 +2801,11 @@ class TestFileComparison(Base):
             hdrs = {'If-Modified-Since': self.env.time_new}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(304)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
             self.assertRaises(ResponseError, file_item.info, hdrs=hdrs)
             self.assert_status(304)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfUnmodifiedSince(self):
@@ -2802,10 +2817,10 @@ class TestFileComparison(Base):
             hdrs = {'If-Unmodified-Since': self.env.time_old_f2}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assertRaises(ResponseError, file_item.info, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
     def testIfMatchAndUnmodified(self):
         for file_item in self.env.files:
@@ -2817,13 +2832,13 @@ class TestFileComparison(Base):
                     'If-Unmodified-Since': self.env.time_new}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
             hdrs = {'If-Match': file_item.md5,
                     'If-Unmodified-Since': self.env.time_old_f3}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
     def testLastModified(self):
         file_name = Utils.create_name()
@@ -2844,7 +2859,7 @@ class TestFileComparison(Base):
         hdrs = {'If-Modified-Since': last_modified}
         self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
         self.assert_status(304)
-        self.assert_header('etag', etag)
+        self.assert_etag(etag)
         self.assert_header('accept-ranges', 'bytes')
 
         hdrs = {'If-Unmodified-Since': last_modified}
diff -pruN 2.25.0-2/test/functional/test_symlink.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_symlink.py
--- 2.25.0-2/test/functional/test_symlink.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_symlink.py	2020-07-06 17:03:50.000000000 +0000
@@ -25,6 +25,7 @@ from six.moves import urllib
 from uuid import uuid4
 
 from swift.common.http import is_success
+from swift.common.swob import normalize_etag
 from swift.common.utils import json, MD5_OF_EMPTY_STRING
 from swift.common.middleware.slo import SloGetContext
 from test.functional import check_response, retry, requires_acls, \
@@ -1135,7 +1136,7 @@ class TestSymlink(Base):
                                          etag=self.env.tgt_etag)
 
         # overwrite tgt object
-        old_tgt_etag = self.env.tgt_etag
+        old_tgt_etag = normalize_etag(self.env.tgt_etag)
         self.env._create_tgt_object(body='updated target body')
 
         # sanity
@@ -1380,7 +1381,7 @@ class TestSymlink(Base):
                          object_list[0]['symlink_path'])
         obj_info = object_list[0]
         self.assertIn('symlink_etag', obj_info)
-        self.assertEqual(self.env.tgt_etag,
+        self.assertEqual(normalize_etag(self.env.tgt_etag),
                          obj_info['symlink_etag'])
         self.assertEqual(int(self.env.tgt_length),
                          obj_info['symlink_bytes'])
@@ -1550,7 +1551,7 @@ class TestSymlinkSlo(Base):
             'symlink_path': '/v1/%s/%s/manifest-abcde' % (
                 self.account_name, self.env.container2.name),
             'symlink_bytes': 4 * 2 ** 20 + 1,
-            'symlink_etag': manifest_etag,
+            'symlink_etag': normalize_etag(manifest_etag),
         })
 
     def test_static_link_target_slo_manifest_wrong_etag(self):
@@ -1740,7 +1741,11 @@ class TestSymlinkToSloSegments(Base):
                 self.assertEqual(1024 * 1024, f_dict['bytes'])
                 self.assertEqual('application/octet-stream',
                                  f_dict['content_type'])
-                self.assertEqual(manifest_etag, f_dict['hash'])
+                if tf.cluster_info.get('etag_quoter', {}).get(
+                        'enable_by_default'):
+                    self.assertEqual(manifest_etag, '"%s"' % f_dict['hash'])
+                else:
+                    self.assertEqual(manifest_etag, f_dict['hash'])
                 self.assertEqual(slo_etag, f_dict['slo_etag'])
                 break
         else:
@@ -1759,7 +1764,11 @@ class TestSymlinkToSloSegments(Base):
                 self.assertEqual(1024 * 1024, f_dict['bytes'])
                 self.assertEqual(file_item.content_type,
                                  f_dict['content_type'])
-                self.assertEqual(manifest_etag, f_dict['hash'])
+                if tf.cluster_info.get('etag_quoter', {}).get(
+                        'enable_by_default'):
+                    self.assertEqual(manifest_etag, '"%s"' % f_dict['hash'])
+                else:
+                    self.assertEqual(manifest_etag, f_dict['hash'])
                 self.assertEqual(slo_etag, f_dict['slo_etag'])
                 break
         else:
@@ -1778,7 +1787,11 @@ class TestSymlinkToSloSegments(Base):
                 self.assertEqual(1024 * 1024, f_dict['bytes'])
                 self.assertEqual(file_item.content_type,
                                  f_dict['content_type'])
-                self.assertEqual(manifest_etag, f_dict['hash'])
+                if tf.cluster_info.get('etag_quoter', {}).get(
+                        'enable_by_default'):
+                    self.assertEqual(manifest_etag, '"%s"' % f_dict['hash'])
+                else:
+                    self.assertEqual(manifest_etag, f_dict['hash'])
                 self.assertEqual(slo_etag, f_dict['slo_etag'])
                 break
         else:
@@ -1811,6 +1824,8 @@ class TestSymlinkToSloSegments(Base):
         source_contents = source.read(parms={'multipart-manifest': 'get'})
         source_json = json.loads(source_contents)
         manifest_etag = hashlib.md5(source_contents).hexdigest()
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            manifest_etag = '"%s"' % manifest_etag
 
         source.initialize()
         slo_etag = source.etag
@@ -1857,14 +1872,20 @@ class TestSymlinkToSloSegments(Base):
         actual = names['manifest-linkto-ab']
         self.assertEqual(2 * 1024 * 1024, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual(manifest_etag, '"%s"' % actual['hash'])
+        else:
+            self.assertEqual(manifest_etag, actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
         self.assertIn('copied-ab-manifest-only', names)
         actual = names['copied-ab-manifest-only']
         self.assertEqual(2 * 1024 * 1024, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual(manifest_etag, '"%s"' % actual['hash'])
+        else:
+            self.assertEqual(manifest_etag, actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
 
@@ -2000,13 +2021,13 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-Match': 'bogus'}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
     def testIfMatchMultipleEtags(self):
         for file_item in self.env.files:
@@ -2022,13 +2043,13 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-Match': '"bogus1", "bogus2", "bogus3"'}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
     def testIfNoneMatch(self):
         for file_item in self.env.files:
@@ -2044,13 +2065,13 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-None-Match': md5}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(304)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfNoneMatchMultipleEtags(self):
@@ -2067,14 +2088,14 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-None-Match':
                     '"bogus1", "bogus2", "%s"' % md5}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(304)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfModifiedSince(self):
@@ -2091,19 +2112,19 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assertTrue(file_symlink.info(hdrs=hdrs, parms=self.env.parms))
 
             hdrs = {'If-Modified-Since': self.env.time_new}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(304)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assert_header('accept-ranges', 'bytes')
             self.assertRaises(ResponseError, file_symlink.info, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(304)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfUnmodifiedSince(self):
@@ -2120,18 +2141,18 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assertTrue(file_symlink.info(hdrs=hdrs, parms=self.env.parms))
 
             hdrs = {'If-Unmodified-Since': self.env.time_old_f2}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assertRaises(ResponseError, file_symlink.info, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
     def testIfMatchAndUnmodified(self):
         for file_item in self.env.files:
@@ -2148,21 +2169,21 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-Match': 'bogus',
                     'If-Unmodified-Since': self.env.time_new}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-Match': md5,
                     'If-Unmodified-Since': self.env.time_old_f3}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
     def testLastModified(self):
         file_item = self.env.container.file(Utils.create_name())
@@ -2186,7 +2207,7 @@ class TestSymlinkTargetObjectComparison(
         hdrs = {'If-Modified-Since': last_modified}
         self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs)
         self.assert_status(304)
-        self.assert_header('etag', md5)
+        self.assert_etag(md5)
         self.assert_header('accept-ranges', 'bytes')
 
         hdrs = {'If-Unmodified-Since': last_modified}
@@ -2227,20 +2248,20 @@ class TestSymlinkComparison(TestSymlinkT
         body = file_symlink.read(hdrs=hdrs, parms=self.env.parms)
         self.assertEqual(b'', body)
         self.assert_status(200)
-        self.assert_header('etag', md5)
+        self.assert_etag(md5)
 
         hdrs = {'If-Modified-Since': last_modified}
         self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                           parms=self.env.parms)
         self.assert_status(304)
-        self.assert_header('etag', md5)
+        self.assert_etag(md5)
         self.assert_header('accept-ranges', 'bytes')
 
         hdrs = {'If-Unmodified-Since': last_modified}
         body = file_symlink.read(hdrs=hdrs, parms=self.env.parms)
         self.assertEqual(b'', body)
         self.assert_status(200)
-        self.assert_header('etag', md5)
+        self.assert_etag(md5)
 
 
 class TestSymlinkAccountTempurl(Base):
diff -pruN 2.25.0-2/test/functional/test_versioned_writes.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_versioned_writes.py
--- 2.25.0-2/test/functional/test_versioned_writes.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/functional/test_versioned_writes.py	2020-07-06 17:03:50.000000000 +0000
@@ -684,7 +684,11 @@ class TestObjectVersioning(Base):
         prev_version = versions_container.file(versioned_obj_name)
         prev_version_info = prev_version.info(parms={'symlink': 'get'})
         self.assertEqual(b"aaaaa", prev_version.read())
-        self.assertEqual(MD5_OF_EMPTY_STRING, prev_version_info['etag'])
+        symlink_etag = prev_version_info['etag']
+        if symlink_etag.startswith('"') and symlink_etag.endswith('"') and \
+                symlink_etag[1:-1]:
+            symlink_etag = symlink_etag[1:-1]
+        self.assertEqual(MD5_OF_EMPTY_STRING, symlink_etag)
         self.assertEqual(sym_tgt_header,
                          prev_version_info['x_symlink_target'])
         return symlink, tgt_a
@@ -698,7 +702,10 @@ class TestObjectVersioning(Base):
         symlink.delete()
         sym_info = symlink.info(parms={'symlink': 'get'})
         self.assertEqual(b"aaaaa", symlink.read())
-        self.assertEqual(MD5_OF_EMPTY_STRING, sym_info['etag'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual('"%s"' % MD5_OF_EMPTY_STRING, sym_info['etag'])
+        else:
+            self.assertEqual(MD5_OF_EMPTY_STRING, sym_info['etag'])
         self.assertEqual(
             quote(unquote('%s/%s' % (self.env.container.name, target.name))),
             sym_info['x_symlink_target'])
diff -pruN 2.25.0-2/test/probe/brain.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/brain.py
--- 2.25.0-2/test/probe/brain.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/brain.py	2020-07-06 17:03:50.000000000 +0000
@@ -31,6 +31,7 @@ from swift.common.http import HTTP_NOT_F
 
 from swiftclient import client, get_auth, ClientException
 
+from test.probe import PROXY_BASE_URL
 from test.probe.common import ENABLED_POLICIES
 
 TIMEOUT = 60
@@ -340,7 +341,7 @@ def main():
         if cmd not in BrainSplitter.__commands__:
             parser.print_help()
             return 'ERROR: unknown command %s' % cmd
-    url, token = get_auth('http://127.0.0.1:8080/auth/v1.0',
+    url, token = get_auth(PROXY_BASE_URL + '/auth/v1.0',
                           'test:tester', 'testing')
     if options.server_type == 'object' and not options.policy_name:
         options.policy_name = POLICIES.default.name
diff -pruN 2.25.0-2/test/probe/common.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/common.py
--- 2.25.0-2/test/probe/common.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/common.py	2020-07-06 17:03:50.000000000 +0000
@@ -39,7 +39,7 @@ from swift.common.manager import Manager
 from swift.common.storage_policy import POLICIES, EC_POLICY, REPL_POLICY
 from swift.obj.diskfile import get_data_dir
 
-from test.probe import CHECK_SERVER_TIMEOUT, VALIDATE_RSYNC
+from test.probe import CHECK_SERVER_TIMEOUT, VALIDATE_RSYNC, PROXY_BASE_URL
 
 
 ENABLED_POLICIES = [p for p in POLICIES if not p.is_deprecated]
@@ -80,8 +80,8 @@ def _check_storage(ipport, path):
     return resp
 
 
-def _check_proxy(ipport, user, key):
-    url, token = get_auth('http://%s:%d/auth/v1.0' % ipport,
+def _check_proxy(user, key):
+    url, token = get_auth(PROXY_BASE_URL + '/auth/v1.0',
                           user, key)
     account = url.split('/')[-1]
     head_account(url, token)
@@ -118,7 +118,7 @@ def check_server(ipport, ipport2server):
         rv = _retry_timeout(_check_storage, args=(ipport, path))
     else:
         rv = _retry_timeout(_check_proxy, args=(
-            ipport, 'test:tester', 'testing'))
+            'test:tester', 'testing'))
     return rv
 
 
@@ -392,7 +392,7 @@ class ProbeTest(unittest.TestCase):
                 'url': self.url, 'token': self.token, 'account': self.account}
 
             rv = _retry_timeout(_check_proxy, args=(
-                proxy_ipport, 'test2:tester2', 'testing2'))
+                'test2:tester2', 'testing2'))
             self.account_2 = {
                 k: v for (k, v) in zip(('url', 'token', 'account'), rv)}
 
diff -pruN 2.25.0-2/test/probe/__init__.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/__init__.py
--- 2.25.0-2/test/probe/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/__init__.py	2020-07-06 17:03:50.000000000 +0000
@@ -14,6 +14,9 @@
 # limitations under the License.
 
 
+import eventlet
+eventlet.monkey_patch()
+
 from test import get_config
 from swift.common.utils import config_true_value
 
@@ -21,3 +24,8 @@ from swift.common.utils import config_tr
 config = get_config('probe_test')
 CHECK_SERVER_TIMEOUT = int(config.get('check_server_timeout', 30))
 VALIDATE_RSYNC = config_true_value(config.get('validate_rsync', False))
+PROXY_BASE_URL = config.get('proxy_base_url')
+if PROXY_BASE_URL is None:
+    # TODO: find and load an "appropriate" proxy-server.conf(.d), piece
+    # something together from bind_ip, bind_port, and cert_file
+    PROXY_BASE_URL = 'http://127.0.0.1:8080'
diff -pruN 2.25.0-2/test/probe/test_account_get_fake_responses_match.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_account_get_fake_responses_match.py
--- 2.25.0-2/test/probe/test_account_get_fake_responses_match.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_account_get_fake_responses_match.py	2020-07-06 17:03:50.000000000 +0000
@@ -20,6 +20,7 @@ import unittest
 from six.moves import http_client
 from six.moves.urllib.parse import urlparse
 from swiftclient import get_auth
+from test.probe import PROXY_BASE_URL
 from test.probe.common import ReplProbeTest
 
 
@@ -28,7 +29,7 @@ class TestAccountGetFakeResponsesMatch(R
     def setUp(self):
         super(TestAccountGetFakeResponsesMatch, self).setUp()
         self.url, self.token = get_auth(
-            'http://127.0.0.1:8080/auth/v1.0', 'admin:admin', 'admin')
+            PROXY_BASE_URL + '/auth/v1.0', 'admin:admin', 'admin')
 
     def _account_path(self, account):
         _, _, path, _, _, _ = urlparse(self.url)
@@ -46,10 +47,15 @@ class TestAccountGetFakeResponsesMatch(R
         headers['X-Auth-Token'] = self.token
 
         scheme, netloc, path, _, _, _ = urlparse(self.url)
-        host, port = netloc.split(':')
+        host, port = netloc.partition(':')[::2]
+        if not port:
+            port = '443' if scheme == 'https' else '80'
         port = int(port)
 
-        conn = http_client.HTTPConnection(host, port)
+        if scheme == 'https':
+            conn = http_client.HTTPSConnection(host, port)
+        else:
+            conn = http_client.HTTPConnection(host, port)
         conn.request(method, self._account_path(account), headers=headers)
         resp = conn.getresponse()
         if resp.status // 100 != 2:
diff -pruN 2.25.0-2/test/probe/test_container_failures.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_container_failures.py
--- 2.25.0-2/test/probe/test_container_failures.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_container_failures.py	2020-07-06 17:03:50.000000000 +0000
@@ -125,6 +125,35 @@ class TestContainerFailures(ReplProbeTes
         self.assertEqual(headers['x-account-object-count'], '0')
         self.assertEqual(headers['x-account-bytes-used'], '0')
 
+    def test_all_nodes_fail(self):
+        # Create container1
+        container1 = 'container-%s' % uuid4()
+        cpart, cnodes = self.container_ring.get_nodes(self.account, container1)
+        client.put_container(self.url, self.token, container1)
+        client.put_object(self.url, self.token, container1, 'obj1', 'data1')
+
+        # All primaries go down
+        for cnode in cnodes:
+            kill_server((cnode['ip'], cnode['port']), self.ipport2server)
+
+        # Can't GET the container
+        with self.assertRaises(client.ClientException) as caught:
+            client.get_container(self.url, self.token, container1)
+        self.assertEqual(caught.exception.http_status, 503)
+
+        # But we can still write objects! The old info is still in memcache
+        client.put_object(self.url, self.token, container1, 'obj2', 'data2')
+
+        # Can't POST the container, either
+        with self.assertRaises(client.ClientException) as caught:
+            client.post_container(self.url, self.token, container1, {})
+        self.assertEqual(caught.exception.http_status, 503)
+
+        # Though it *does* evict the cache
+        with self.assertRaises(client.ClientException) as caught:
+            client.put_object(self.url, self.token, container1, 'obj3', 'x')
+        self.assertEqual(caught.exception.http_status, 503)
+
     def _get_container_db_files(self, container):
         opart, onodes = self.container_ring.get_nodes(self.account, container)
         onode = onodes[0]
diff -pruN 2.25.0-2/test/probe/test_object_async_update.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_object_async_update.py
--- 2.25.0-2/test/probe/test_object_async_update.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_object_async_update.py	2020-07-06 17:03:50.000000000 +0000
@@ -23,6 +23,7 @@ from swiftclient.exceptions import Clien
 
 from swift.common import direct_client
 from swift.common.manager import Manager
+from swift.common.swob import normalize_etag
 from test.probe.common import kill_nonprimary_server, \
     kill_server, ReplProbeTest, start_server, ECProbeTest
 
@@ -210,7 +211,7 @@ class TestUpdateOverridesEC(ECProbeTest)
         self.assertEqual(1, len(listing))
         self.assertEqual('o1', listing[0]['name'])
         self.assertEqual(len(content), listing[0]['bytes'])
-        self.assertEqual(meta['etag'], listing[0]['hash'])
+        self.assertEqual(normalize_etag(meta['etag']), listing[0]['hash'])
         self.assertEqual('test/ctype', listing[0]['content_type'])
 
     def test_update_during_POST_only(self):
@@ -261,7 +262,7 @@ class TestUpdateOverridesEC(ECProbeTest)
         self.assertEqual(1, len(listing))
         self.assertEqual('o1', listing[0]['name'])
         self.assertEqual(len(content), listing[0]['bytes'])
-        self.assertEqual(meta['etag'], listing[0]['hash'])
+        self.assertEqual(normalize_etag(meta['etag']), listing[0]['hash'])
         self.assertEqual('test/ctype', listing[0]['content_type'])
 
         # Run the object-updaters to send the async pending from the PUT
@@ -328,7 +329,7 @@ class TestUpdateOverridesEC(ECProbeTest)
         self.assertEqual(1, len(listing))
         self.assertEqual('o1', listing[0]['name'])
         self.assertEqual(len(content), listing[0]['bytes'])
-        self.assertEqual(meta['etag'], listing[0]['hash'])
+        self.assertEqual(normalize_etag(meta['etag']), listing[0]['hash'])
         self.assertEqual('test/ctype', listing[0]['content_type'])
 
 
diff -pruN 2.25.0-2/test/probe/test_object_metadata_replication.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_object_metadata_replication.py
--- 2.25.0-2/test/probe/test_object_metadata_replication.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_object_metadata_replication.py	2020-07-06 17:03:50.000000000 +0000
@@ -22,6 +22,7 @@ import uuid
 from swift.common.direct_client import direct_get_suffix_hashes
 from swift.common.exceptions import DiskFileDeleted
 from swift.common.internal_client import UnexpectedResponse
+from swift.common.swob import normalize_etag
 from swift.container.backend import ContainerBroker
 from swift.common import utils
 from swiftclient import client
@@ -129,7 +130,7 @@ class Test(ReplProbeTest):
 
     def _assert_object_metadata_matches_listing(self, listing, metadata):
         self.assertEqual(listing['bytes'], int(metadata['content-length']))
-        self.assertEqual(listing['hash'], metadata['etag'])
+        self.assertEqual(listing['hash'], normalize_etag(metadata['etag']))
         self.assertEqual(listing['content_type'], metadata['content-type'])
         modified = Timestamp(metadata['x-timestamp']).isoformat
         self.assertEqual(listing['last_modified'], modified)
diff -pruN 2.25.0-2/test/probe/test_sharder.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_sharder.py
--- 2.25.0-2/test/probe/test_sharder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_sharder.py	2020-07-06 17:03:50.000000000 +0000
@@ -16,6 +16,7 @@ import hashlib
 import json
 import os
 import shutil
+import subprocess
 import uuid
 
 from nose import SkipTest
@@ -34,6 +35,7 @@ from swiftclient import client, get_auth
 from swift.proxy.controllers.base import get_cache_key
 from swift.proxy.controllers.obj import num_container_updates
 from test import annotate_failure
+from test.probe import PROXY_BASE_URL
 from test.probe.brain import BrainSplitter
 from test.probe.common import ReplProbeTest, get_server_number, \
     wait_for_server_to_hangup
@@ -115,7 +117,7 @@ class BaseTestContainerSharding(ReplProb
             client.requests.logging.WARNING)
         super(BaseTestContainerSharding, self).setUp()
         _, self.admin_token = get_auth(
-            'http://127.0.0.1:8080/auth/v1.0', 'admin:admin', 'admin')
+            PROXY_BASE_URL + '/auth/v1.0', 'admin:admin', 'admin')
         self._setup_container_name()
         self.init_brain(self.container_name)
         self.sharders = Manager(['container-sharder'])
@@ -195,12 +197,16 @@ class BaseTestContainerSharding(ReplProb
         return (utils.storage_directory(datadir, part, container_hash),
                 container_hash)
 
-    def get_broker(self, part, node, account=None, container=None):
+    def get_db_file(self, part, node, account=None, container=None):
         container_dir, container_hash = self.get_storage_dir(
             part, node, account=account, container=container)
         db_file = os.path.join(container_dir, container_hash + '.db')
         self.assertTrue(get_db_files(db_file))  # sanity check
-        return ContainerBroker(db_file)
+        return db_file
+
+    def get_broker(self, part, node, account=None, container=None):
+        return ContainerBroker(
+            self.get_db_file(part, node, account, container))
 
     def categorize_container_dir_content(self, account=None, container=None):
         account = account or self.brain.account
@@ -2409,3 +2415,87 @@ class TestContainerShardingMoreUTF8(Test
         self.container_name = cont_name.encode('utf8').ljust(name_length, b'x')
         if not six.PY2:
             self.container_name = self.container_name.decode('utf8')
+
+
+class TestManagedContainerSharding(BaseTestContainerSharding):
+    '''Test sharding using swift-manage-shard-ranges'''
+    def test_manage_shard_ranges(self):
+        obj_names = self._make_object_names(4)
+        self.put_objects(obj_names)
+
+        client.post_container(self.url, self.admin_token, self.container_name,
+                              headers={'X-Container-Sharding': 'on'})
+
+        # run replicators first time to get sync points set
+        self.replicators.once()
+
+        # sanity check: we don't have nearly enough objects for this to shard
+        # automatically
+        self.sharders.once(number=self.brain.node_numbers[0],
+                           additional_args='--partitions=%s' % self.brain.part)
+        self.assert_container_state(self.brain.nodes[0], 'unsharded', 0)
+
+        subprocess.check_output([
+            'swift-manage-shard-ranges',
+            self.get_db_file(self.brain.part, self.brain.nodes[0]),
+            'find_and_replace', '2', '--enable'], stderr=subprocess.STDOUT)
+        self.assert_container_state(self.brain.nodes[0], 'unsharded', 2)
+
+        # "Run container-replicator to replicate them to other nodes."
+        self.replicators.once()
+        # "Run container-sharder on all nodes to shard the container."
+        self.sharders.once(additional_args='--partitions=%s' % self.brain.part)
+
+        # Everybody's settled
+        self.assert_container_state(self.brain.nodes[0], 'sharded', 2)
+        self.assert_container_state(self.brain.nodes[1], 'sharded', 2)
+        self.assert_container_state(self.brain.nodes[2], 'sharded', 2)
+        self.assert_container_listing(obj_names)
+
+    def test_manage_shard_ranges_used_poorly(self):
+        obj_names = self._make_object_names(8)
+        self.put_objects(obj_names)
+
+        client.post_container(self.url, self.admin_token, self.container_name,
+                              headers={'X-Container-Sharding': 'on'})
+
+        # run replicators first time to get sync points set
+        self.replicators.once()
+
+        subprocess.check_output([
+            'swift-manage-shard-ranges',
+            self.get_db_file(self.brain.part, self.brain.nodes[0]),
+            'find_and_replace', '2', '--enable'], stderr=subprocess.STDOUT)
+        self.assert_container_state(self.brain.nodes[0], 'unsharded', 4)
+
+        # *Also* go find shard ranges on *another node*, like a dumb-dumb
+        subprocess.check_output([
+            'swift-manage-shard-ranges',
+            self.get_db_file(self.brain.part, self.brain.nodes[1]),
+            'find_and_replace', '3', '--enable'], stderr=subprocess.STDOUT)
+        self.assert_container_state(self.brain.nodes[1], 'unsharded', 3)
+
+        # Run things out of order (they were likely running as daemons anyway)
+        self.sharders.once(number=self.brain.node_numbers[0],
+                           additional_args='--partitions=%s' % self.brain.part)
+        self.sharders.once(number=self.brain.node_numbers[1],
+                           additional_args='--partitions=%s' % self.brain.part)
+        self.replicators.once()
+
+        # Uh-oh
+        self.assert_container_state(self.brain.nodes[0], 'sharding', 7)
+        self.assert_container_state(self.brain.nodes[1], 'sharding', 7)
+        # There's a race: the third replica may be sharding, may be unsharded
+
+        # Try it again a few times
+        self.sharders.once(additional_args='--partitions=%s' % self.brain.part)
+        self.replicators.once()
+        self.sharders.once(additional_args='--partitions=%s' % self.brain.part)
+
+        # It's not really fixing itself...
+        self.assert_container_state(self.brain.nodes[0], 'sharding', 7)
+        self.assert_container_state(self.brain.nodes[1], 'sharding', 7)
+
+        # But hey, at least listings still work! They're just going to get
+        # horribly out of date as more objects are added
+        self.assert_container_listing(obj_names)
diff -pruN 2.25.0-2/test/probe/test_signals.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_signals.py
--- 2.25.0-2/test/probe/test_signals.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/probe/test_signals.py	2020-07-06 17:03:50.000000000 +0000
@@ -26,10 +26,12 @@ import time
 from uuid import uuid4
 
 from six.moves import http_client as httplib
+from six.moves.urllib.parse import urlparse
 
 from swift.common.ring import Ring
 from swift.common.manager import Manager
 
+from test.probe import PROXY_BASE_URL
 from test.probe.common import resetswift, ReplProbeTest, client
 
 
@@ -109,7 +111,9 @@ class TestWSGIServerProcessHandling(Repl
             self.assertIn('Invalid path: blah', got_body)
 
     def get_conn(self):
-        ip, port = self.get_ip_port()
+        scheme, ip, port = self.get_scheme_ip_port()
+        if scheme == 'https':
+            return httplib.HTTPSConnection('%s:%s' % (ip, port))
         return httplib.HTTPConnection('%s:%s' % (ip, port))
 
     def _check_reload(self):
@@ -228,11 +232,11 @@ class TestObjectServerReloadBase(TestWSG
     SERVER_NAME = 'object'
     PID_TIMEOUT = 35
 
-    def get_ip_port(self):
+    def get_scheme_ip_port(self):
         self.policy.load_ring('/etc/swift')
         self.ring_node = random.choice(
             self.policy.object_ring.get_part_nodes(1))
-        return self.ring_node['ip'], self.ring_node['port']
+        return 'http', self.ring_node['ip'], self.ring_node['port']
 
     def start_write_req(self, conn, suffix):
         putrequest(conn, 'PUT', '/%s/123/%s/%s/blah-%s' % (
@@ -296,8 +300,12 @@ class TestProxyServerReloadBase(TestWSGI
     def swap_configs(self):
         shutil.copy(self.new_swift_conf_path, self.swift_conf_path)
 
-    def get_ip_port(self):
-        return 'localhost', 8080
+    def get_scheme_ip_port(self):
+        parsed = urlparse(PROXY_BASE_URL)
+        host, port = parsed.netloc.partition(':')[::2]
+        if not port:
+            port = '443' if parsed.scheme == 'https' else '80'
+        return parsed.scheme, host, int(port)
 
     def assertMaxHeaderSize(self, resp, exp_max_header_size):
         self.assertEqual(resp.status // 100, 2)
diff -pruN 2.25.0-2/test/sample.conf 2.25.1~git2020070613.2e001431f-0ubuntu1/test/sample.conf
--- 2.25.0-2/test/sample.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/sample.conf	2020-07-06 17:03:50.000000000 +0000
@@ -24,6 +24,10 @@ auth_uri = http://127.0.0.1:8080/auth/v1
 #auth_version = 3
 #auth_uri = http://localhost:5000/v3/
 
+# Used by s3api functional tests, which don't contact auth directly
+#s3_storage_url = http://127.0.0.1:8080/
+#s3_region = us-east-1
+
 # Primary functional test account (needs admin access to the account)
 account = test
 username = tester
@@ -101,6 +105,7 @@ fake_syslog = False
 [probe_test]
 # check_server_timeout = 30
 # validate_rsync = false
+# proxy_base_url = http://localhost:8080
 
 [swift-constraints]
 # The functional test runner will try to use the constraint values provided in
diff -pruN 2.25.0-2/test/unit/account/test_backend.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/account/test_backend.py
--- 2.25.0-2/test/unit/account/test_backend.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/account/test_backend.py	2020-07-06 17:03:50.000000000 +0000
@@ -180,6 +180,72 @@ class TestAccountBroker(unittest.TestCas
         broker.delete_db(Timestamp.now().internal)
         broker.reclaim(Timestamp.now().internal, time())
 
+    def test_batched_reclaim(self):
+        num_of_containers = 60
+        container_specs = []
+        now = time()
+        top_of_the_minute = now - (now % 60)
+        c = itertools.cycle([True, False])
+        for m, is_deleted in six.moves.zip(range(num_of_containers), c):
+            offset = top_of_the_minute - (m * 60)
+            container_specs.append((Timestamp(offset), is_deleted))
+        random.seed(now)
+        random.shuffle(container_specs)
+        policy_indexes = list(p.idx for p in POLICIES)
+        broker = AccountBroker(':memory:', account='test_account')
+        broker.initialize(Timestamp('1').internal)
+        for i, container_spec in enumerate(container_specs):
+            # with container12 before container2 and shuffled ts.internal we
+            # shouldn't be able to accidently rely on any implicit ordering
+            name = 'container%s' % i
+            pidx = random.choice(policy_indexes)
+            ts, is_deleted = container_spec
+            if is_deleted:
+                broker.put_container(name, 0, ts.internal, 0, 0, pidx)
+            else:
+                broker.put_container(name, ts.internal, 0, 0, 0, pidx)
+
+        def count_reclaimable(conn, reclaim_age):
+            return conn.execute(
+                "SELECT count(*) FROM container "
+                "WHERE deleted = 1 AND delete_timestamp < ?", (reclaim_age,)
+            ).fetchone()[0]
+
+        # This is intended to divide the set of timestamps exactly in half
+        # regardless of the value of now
+        reclaim_age = top_of_the_minute + 1 - (num_of_containers / 2 * 60)
+        with broker.get() as conn:
+            self.assertEqual(count_reclaimable(conn, reclaim_age),
+                             num_of_containers / 4)
+
+        orig__reclaim = broker._reclaim
+        trace = []
+
+        def tracing_reclaim(conn, age_timestamp, marker):
+            trace.append((age_timestamp, marker,
+                          count_reclaimable(conn, age_timestamp)))
+            return orig__reclaim(conn, age_timestamp, marker)
+
+        with mock.patch.object(broker, '_reclaim', new=tracing_reclaim), \
+                mock.patch('swift.common.db.RECLAIM_PAGE_SIZE', 10):
+            broker.reclaim(reclaim_age, reclaim_age)
+        with broker.get() as conn:
+            self.assertEqual(count_reclaimable(conn, reclaim_age), 0)
+        self.assertEqual(3, len(trace), trace)
+        self.assertEqual([age for age, marker, reclaimable in trace],
+                         [reclaim_age] * 3)
+        # markers are in-order
+        self.assertLess(trace[0][1], trace[1][1])
+        self.assertLess(trace[1][1], trace[2][1])
+        # reclaimable count gradually decreases
+        # generally, count1 > count2 > count3, but because of the randomness
+        # we may occassionally have count1 == count2 or count2 == count3
+        self.assertGreaterEqual(trace[0][2], trace[1][2])
+        self.assertGreaterEqual(trace[1][2], trace[2][2])
+        # technically, this might happen occasionally, but *really* rarely
+        self.assertTrue(trace[0][2] > trace[1][2] or
+                        trace[1][2] > trace[2][2])
+
     def test_delete_db_status(self):
         start = next(self.ts)
         broker = AccountBroker(':memory:', account='a')
diff -pruN 2.25.0-2/test/unit/cli/test_info.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/cli/test_info.py
--- 2.25.0-2/test/unit/cli/test_info.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/cli/test_info.py	2020-07-06 17:03:50.000000000 +0000
@@ -497,13 +497,10 @@ Shard Ranges (3):
             print_item_locations(None, partition=part, policy_name='zero',
                                  swift_dir=self.testdir)
         exp_part_msg = 'Partition\t%s' % part
-        exp_acct_msg = 'Account  \tNone'
-        exp_cont_msg = 'Container\tNone'
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_part_msg, out.getvalue())
-        self.assertIn(exp_acct_msg, out.getvalue())
-        self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Account', out.getvalue())
+        self.assertNotIn('Container', out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_dashed_ring_name_partition(self):
         out = StringIO()
@@ -513,13 +510,10 @@ Shard Ranges (3):
                                  ring_name='foo-bar', partition=part,
                                  swift_dir=self.testdir)
         exp_part_msg = 'Partition\t%s' % part
-        exp_acct_msg = 'Account  \tNone'
-        exp_cont_msg = 'Container\tNone'
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_part_msg, out.getvalue())
-        self.assertIn(exp_acct_msg, out.getvalue())
-        self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Account', out.getvalue())
+        self.assertNotIn('Container', out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_with_ring(self):
         out = StringIO()
@@ -533,11 +527,9 @@ Shard Ranges (3):
                       'but ring not named "account"'
         self.assertIn(exp_warning, out.getvalue())
         exp_acct_msg = 'Account  \t%s' % account
-        exp_cont_msg = 'Container\tNone'
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_acct_msg, out.getvalue())
-        self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Container', out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_no_ring(self):
         out = StringIO()
@@ -546,11 +538,9 @@ Shard Ranges (3):
             print_item_locations(None, account=account,
                                  swift_dir=self.testdir)
         exp_acct_msg = 'Account  \t%s' % account
-        exp_cont_msg = 'Container\tNone'
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_acct_msg, out.getvalue())
-        self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Container', out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_container_ring(self):
         out = StringIO()
@@ -562,10 +552,9 @@ Shard Ranges (3):
                                  container=container)
         exp_acct_msg = 'Account  \t%s' % account
         exp_cont_msg = 'Container\t%s' % container
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_acct_msg, out.getvalue())
         self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_container_no_ring(self):
         out = StringIO()
@@ -576,10 +565,9 @@ Shard Ranges (3):
                                  container=container, swift_dir=self.testdir)
         exp_acct_msg = 'Account  \t%s' % account
         exp_cont_msg = 'Container\t%s' % container
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_acct_msg, out.getvalue())
         self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_container_object_ring(self):
         out = StringIO()
@@ -691,59 +679,59 @@ Shard Ranges (3):
     def test_parse_get_node_args(self):
         # Capture error messages
         # (without any parameters)
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = ''
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
         # a
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
         # a c
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a c'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
         # a c o
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a c o'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
 
         # a/c
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a/c'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
         # a/c/o
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a/c/o'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
 
         # account container junk/test.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'account container junk/test.ring.gz'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
 
         # account container object junk/test.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'account container object junk/test.ring.gz'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
 
         # object.ring.gz(without any arguments i.e. a c o)
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'object.ring.gz'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Ring file does not exist',
@@ -751,55 +739,55 @@ Shard Ranges (3):
 
         # Valid policy
         # -P zero
-        options = Namespace(policy_name='zero', partition=None)
+        options = Namespace(policy_name='zero', partition=None, quoted=None)
         args = ''
         self.assertRaisesMessage(InfoSystemExit,
                                  'No target specified',
                                  parse_get_node_args, options, args.split())
         # -P one a/c/o
-        options = Namespace(policy_name='one', partition=None)
+        options = Namespace(policy_name='one', partition=None, quoted=None)
         args = 'a/c/o'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['a', 'c', 'o'])
         # -P one account container photos/cat.jpg
-        options = Namespace(policy_name='one', partition=None)
+        options = Namespace(policy_name='one', partition=None, quoted=None)
         args = 'account container photos/cat.jpg'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['account', 'container', 'photos/cat.jpg'])
         # -P one account/container/photos/cat.jpg
-        options = Namespace(policy_name='one', partition=None)
+        options = Namespace(policy_name='one', partition=None, quoted=None)
         args = 'account/container/photos/cat.jpg'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['account', 'container', 'photos/cat.jpg'])
         # -P one account/container/junk/test.ring.gz(object endswith 'ring.gz')
-        options = Namespace(policy_name='one', partition=None)
+        options = Namespace(policy_name='one', partition=None, quoted=None)
         args = 'account/container/junk/test.ring.gz'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['account', 'container', 'junk/test.ring.gz'])
         # -P two a c o hooya
-        options = Namespace(policy_name='two', partition=None)
+        options = Namespace(policy_name='two', partition=None, quoted=None)
         args = 'a c o hooya'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Invalid arguments',
                                  parse_get_node_args, options, args.split())
         # -P zero -p 1
-        options = Namespace(policy_name='zero', partition='1')
+        options = Namespace(policy_name='zero', partition='1', quoted=None)
         args = ''
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertFalse(args)
         # -P one -p 1 a/c/o
-        options = Namespace(policy_name='one', partition='1')
+        options = Namespace(policy_name='one', partition='1', quoted=None)
         args = 'a/c/o'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['a', 'c', 'o'])
         # -P two -p 1 a c o hooya
-        options = Namespace(policy_name='two', partition='1')
+        options = Namespace(policy_name='two', partition='1', quoted=None)
         args = 'a c o hooya'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Invalid arguments',
@@ -853,7 +841,7 @@ Shard Ranges (3):
 
         # Mock tests
         # /etc/swift/object.ring.gz(without any arguments i.e. a c o)
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = '/etc/swift/object.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -863,7 +851,7 @@ Shard Ranges (3):
                 parse_get_node_args, options, args.split())
         # Similar ring_path and arguments
         # /etc/swift/object.ring.gz /etc/swift/object.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = '/etc/swift/object.ring.gz /etc/swift/object.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -871,7 +859,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, '/etc/swift/object.ring.gz')
         self.assertEqual(args, ['etc', 'swift', 'object.ring.gz'])
         # /etc/swift/object.ring.gz a/c/etc/swift/object.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = '/etc/swift/object.ring.gz a/c/etc/swift/object.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -880,7 +868,7 @@ Shard Ranges (3):
         self.assertEqual(args, ['a', 'c', 'etc/swift/object.ring.gz'])
         # Invalid path as mentioned in BUG#1539275
         # /etc/swift/object.tar.gz account container object
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = '/etc/swift/object.tar.gz account container object'
         self.assertRaisesMessage(
             InfoSystemExit,
@@ -888,7 +876,7 @@ Shard Ranges (3):
             parse_get_node_args, options, args.split())
 
         # object.ring.gz a/
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -896,7 +884,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a'])
         # object.ring.gz a/c
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/c'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -904,7 +892,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c'])
         # object.ring.gz a/c/o
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/c/o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -912,7 +900,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz a/c/o/junk/test.ring.gz
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/c/o/junk/test.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -920,7 +908,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o/junk/test.ring.gz'])
         # object.ring.gz a
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -928,7 +916,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a'])
         # object.ring.gz a c
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a c'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -936,7 +924,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c'])
         # object.ring.gz a c o
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a c o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -944,7 +932,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz a c o blah blah
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a c o blah blah'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -953,7 +941,7 @@ Shard Ranges (3):
                 'Invalid arguments',
                 parse_get_node_args, options, args.split())
         # object.ring.gz a/c/o/blah/blah
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/c/o/blah/blah'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -962,7 +950,7 @@ Shard Ranges (3):
         self.assertEqual(args, ['a', 'c', 'o/blah/blah'])
 
         # object.ring.gz -p 1
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -970,7 +958,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertFalse(args)
         # object.ring.gz -p 1 a c o
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a c o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -978,7 +966,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz -p 1 a c o forth_arg
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a c o forth_arg'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -987,7 +975,7 @@ Shard Ranges (3):
                 'Invalid arguments',
                 parse_get_node_args, options, args.split())
         # object.ring.gz -p 1 a/c/o
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a/c/o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -995,7 +983,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz -p 1 a/c/junk/test.ring.gz
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a/c/junk/test.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1003,7 +991,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'junk/test.ring.gz'])
         # object.ring.gz -p 1 a/c/photos/cat.jpg
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a/c/photos/cat.jpg'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1012,7 +1000,7 @@ Shard Ranges (3):
         self.assertEqual(args, ['a', 'c', 'photos/cat.jpg'])
 
         # --all object.ring.gz a
-        options = Namespace(all=True, policy_name=None)
+        options = Namespace(all=True, policy_name=None, quoted=None)
         args = 'object.ring.gz a'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1020,7 +1008,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a'])
         # --all object.ring.gz a c
-        options = Namespace(all=True, policy_name=None)
+        options = Namespace(all=True, policy_name=None, quoted=None)
         args = 'object.ring.gz a c'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1028,7 +1016,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c'])
         # --all object.ring.gz a c o
-        options = Namespace(all=True, policy_name=None)
+        options = Namespace(all=True, policy_name=None, quoted=None)
         args = 'object.ring.gz a c o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1036,7 +1024,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz account container photos/cat.jpg
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'object.ring.gz account container photos/cat.jpg'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1044,7 +1032,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['account', 'container', 'photos/cat.jpg'])
         # object.ring.gz /account/container/photos/cat.jpg
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'object.ring.gz account/container/photos/cat.jpg'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1053,7 +1041,7 @@ Shard Ranges (3):
         self.assertEqual(args, ['account', 'container', 'photos/cat.jpg'])
         # Object name ends with 'ring.gz'
         # object.ring.gz /account/container/junk/test.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'object.ring.gz account/container/junk/test.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1061,6 +1049,32 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['account', 'container', 'junk/test.ring.gz'])
 
+        # Object name has special characters
+        # object.ring.gz /account/container/obj\nwith%0anewline
+        options = Namespace(policy_name=None, partition=None, quoted=None)
+        args = ['object.ring.gz', 'account/container/obj\nwith%0anewline']
+        with mock.patch('swift.cli.info.os.path.exists') as exists:
+            exists.return_value = True
+            ring_path, args = parse_get_node_args(options, args)
+        self.assertEqual(ring_path, 'object.ring.gz')
+        self.assertEqual(args, ['account', 'container', 'obj\nwith%0anewline'])
+
+        options = Namespace(policy_name=None, partition=None, quoted=True)
+        args = ['object.ring.gz', 'account/container/obj\nwith%0anewline']
+        with mock.patch('swift.cli.info.os.path.exists') as exists:
+            exists.return_value = True
+            ring_path, args = parse_get_node_args(options, args)
+        self.assertEqual(ring_path, 'object.ring.gz')
+        self.assertEqual(args, ['account', 'container', 'obj\nwith\nnewline'])
+
+        options = Namespace(policy_name=None, partition=None, quoted=False)
+        args = ['object.ring.gz', 'account/container/obj\nwith%0anewline']
+        with mock.patch('swift.cli.info.os.path.exists') as exists:
+            exists.return_value = True
+            ring_path, args = parse_get_node_args(options, args)
+        self.assertEqual(ring_path, 'object.ring.gz')
+        self.assertEqual(args, ['account', 'container', 'obj\nwith%0anewline'])
+
 
 class TestPrintObj(TestCliInfoBase):
 
@@ -1186,7 +1200,7 @@ class TestPrintObjFullMeta(TestCliInfoBa
             os.chdir(cwd)
 
         exp_curl = (
-            'curl -g -I -XHEAD '
+            'curl --path-as-is -g -I -XHEAD '
             '"http://{host}:{port}/{device}/{part}/AUTH_admin/c/obj" '
             '-H "X-Backend-Storage-Policy-Index: 2"').format(
                 host=node['ip'],
@@ -1227,7 +1241,7 @@ class TestPrintObjFullMeta(TestCliInfoBa
             os.chdir(cwd)
 
         exp_curl = (
-            'curl -g -I -XHEAD '
+            'curl --path-as-is -g -I -XHEAD '
             '"http://[{host}]:{port}'
             '/{device}/{part}/AUTH_admin/c/obj" ').format(
                 host=node['ip'],
diff -pruN 2.25.0-2/test/unit/cli/test_manage_shard_ranges.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/cli/test_manage_shard_ranges.py
--- 2.25.0-2/test/unit/cli/test_manage_shard_ranges.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/cli/test_manage_shard_ranges.py	2020-07-06 17:03:50.000000000 +0000
@@ -189,6 +189,7 @@ class TestManageShardRanges(unittest.Tes
                     '  "meta_timestamp": "%s",' % now.internal,
                     '  "name": "a/c",',
                     '  "object_count": 0,',
+                    '  "reported": 0,',
                     '  "state": "sharding",',
                     '  "state_timestamp": "%s",' % now.internal,
                     '  "timestamp": "%s",' % now.internal,
@@ -230,6 +231,7 @@ class TestManageShardRanges(unittest.Tes
                     '  "meta_timestamp": "%s",' % now.internal,
                     '  "name": "a/c",',
                     '  "object_count": 0,',
+                    '  "reported": 0,',
                     '  "state": "sharding",',
                     '  "state_timestamp": "%s",' % now.internal,
                     '  "timestamp": "%s",' % now.internal,
@@ -358,6 +360,23 @@ class TestManageShardRanges(unittest.Tes
         self.assertEqual(['Loaded db broker for a/c.'],
                          err.getvalue().splitlines())
         self._assert_enabled(broker, now)
+        found_shard_ranges = broker.get_shard_ranges()
         self.assertEqual(
             [(data['lower'], data['upper']) for data in self.shard_data],
-            [(sr.lower_str, sr.upper_str) for sr in broker.get_shard_ranges()])
+            [(sr.lower_str, sr.upper_str) for sr in found_shard_ranges])
+
+        # Do another find & replace but quit when prompted about existing
+        # shard ranges
+        out = StringIO()
+        err = StringIO()
+        to_patch = 'swift.cli.manage_shard_ranges.input'
+        with mock.patch('sys.stdout', out), mock.patch('sys.stderr', err), \
+                mock_timestamp_now() as now, \
+                mock.patch(to_patch, return_value='q'):
+            main([broker.db_file, 'find_and_replace', '10'])
+        # Shard ranges haven't changed at all
+        self.assertEqual(found_shard_ranges, broker.get_shard_ranges())
+        expected = ['This will delete existing 10 shard ranges.']
+        self.assertEqual(expected, out.getvalue().splitlines())
+        self.assertEqual(['Loaded db broker for a/c.'],
+                         err.getvalue().splitlines())
diff -pruN 2.25.0-2/test/unit/cli/test_relinker.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/cli/test_relinker.py
--- 2.25.0-2/test/unit/cli/test_relinker.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/cli/test_relinker.py	2020-07-06 17:03:50.000000000 +0000
@@ -12,6 +12,9 @@
 # limitations under the License.
 
 import binascii
+import errno
+import fcntl
+import json
 import os
 import shutil
 import struct
@@ -30,6 +33,9 @@ from test.unit import FakeLogger, skip_i
     patch_policies
 
 
+PART_POWER = 8
+
+
 class TestRelinker(unittest.TestCase):
     def setUp(self):
         skip_if_no_xattrs()
@@ -40,7 +46,7 @@ class TestRelinker(unittest.TestCase):
         os.mkdir(self.testdir)
         os.mkdir(self.devices)
 
-        self.rb = ring.RingBuilder(8, 6.0, 1)
+        self.rb = ring.RingBuilder(PART_POWER, 6.0, 1)
 
         for i in range(6):
             ip = "127.0.0.%s" % i
@@ -55,10 +61,10 @@ class TestRelinker(unittest.TestCase):
         os.mkdir(self.objects)
         self._hash = utils.hash_path('a/c/o')
         digest = binascii.unhexlify(self._hash)
-        part = struct.unpack_from('>I', digest)[0] >> 24
+        self.part = struct.unpack_from('>I', digest)[0] >> 24
         self.next_part = struct.unpack_from('>I', digest)[0] >> 23
         self.objdir = os.path.join(
-            self.objects, str(part), self._hash[-3:], self._hash)
+            self.objects, str(self.part), self._hash[-3:], self._hash)
         os.makedirs(self.objdir)
         self.object_fname = "1278553064.00000.data"
         self.objname = os.path.join(self.objdir, self.object_fname)
@@ -97,6 +103,27 @@ class TestRelinker(unittest.TestCase):
         stat_new = os.stat(self.expected_file)
         self.assertEqual(stat_old.st_ino, stat_new.st_ino)
 
+    def test_relink_device_filter(self):
+        self.rb.prepare_increase_partition_power()
+        self._save_ring()
+        relinker.relink(self.testdir, self.devices, True,
+                        device=self.existing_device)
+
+        self.assertTrue(os.path.isdir(self.expected_dir))
+        self.assertTrue(os.path.isfile(self.expected_file))
+
+        stat_old = os.stat(os.path.join(self.objdir, self.object_fname))
+        stat_new = os.stat(self.expected_file)
+        self.assertEqual(stat_old.st_ino, stat_new.st_ino)
+
+    def test_relink_device_filter_invalid(self):
+        self.rb.prepare_increase_partition_power()
+        self._save_ring()
+        relinker.relink(self.testdir, self.devices, True, device='none')
+
+        self.assertFalse(os.path.isdir(self.expected_dir))
+        self.assertFalse(os.path.isfile(self.expected_file))
+
     def _common_test_cleanup(self, relink=True):
         # Create a ring that has prev_part_power set
         self.rb.prepare_increase_partition_power()
@@ -121,6 +148,187 @@ class TestRelinker(unittest.TestCase):
         self.assertFalse(os.path.isfile(
             os.path.join(self.objdir, self.object_fname)))
 
+    def test_cleanup_device_filter(self):
+        self._common_test_cleanup()
+        self.assertEqual(0, relinker.cleanup(self.testdir, self.devices, True,
+                                             device=self.existing_device))
+
+        # Old objectname should be removed, new should still exist
+        self.assertTrue(os.path.isdir(self.expected_dir))
+        self.assertTrue(os.path.isfile(self.expected_file))
+        self.assertFalse(os.path.isfile(
+            os.path.join(self.objdir, self.object_fname)))
+
+    def test_cleanup_device_filter_invalid(self):
+        self._common_test_cleanup()
+        self.assertEqual(0, relinker.cleanup(self.testdir, self.devices, True,
+                                             device='none'))
+
+        # Old objectname should still exist, new should still exist
+        self.assertTrue(os.path.isdir(self.expected_dir))
+        self.assertTrue(os.path.isfile(self.expected_file))
+        self.assertTrue(os.path.isfile(
+            os.path.join(self.objdir, self.object_fname)))
+
+    def test_relink_cleanup(self):
+        state_file = os.path.join(self.devices, self.existing_device,
+                                  'relink.objects.json')
+
+        self.rb.prepare_increase_partition_power()
+        self._save_ring()
+        relinker.relink(self.testdir, self.devices, True)
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {str(self.part): [True, False]})
+
+        self.rb.increase_partition_power()
+        self.rb._ring = None  # Force builder to reload ring
+        self._save_ring()
+        relinker.cleanup(self.testdir, self.devices, True)
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f),
+                             {str(self.part): [True, True],
+                              str(self.next_part): [True, True]})
+
+    def test_devices_filter_filtering(self):
+        # With no filtering, returns all devices
+        devices = relinker.devices_filter(None, "", [self.existing_device])
+        self.assertEqual(set([self.existing_device]), devices)
+
+        # With a matching filter, returns what is matching
+        devices = relinker.devices_filter(self.existing_device, "",
+                                          [self.existing_device, 'sda2'])
+        self.assertEqual(set([self.existing_device]), devices)
+
+        # With a non matching filter, returns nothing
+        devices = relinker.devices_filter('none', "", [self.existing_device])
+        self.assertEqual(set(), devices)
+
+    def test_hook_pre_post_device_locking(self):
+        locks = [None]
+        device_path = os.path.join(self.devices, self.existing_device)
+        datadir = 'object'
+        lock_file = os.path.join(device_path, '.relink.%s.lock' % datadir)
+
+        # The first run gets the lock
+        relinker.hook_pre_device(locks, {}, datadir, device_path)
+        self.assertNotEqual([None], locks)
+
+        # A following run would block
+        with self.assertRaises(IOError) as raised:
+            with open(lock_file, 'a') as f:
+                fcntl.flock(f.fileno(), fcntl.LOCK_EX | fcntl.LOCK_NB)
+        self.assertEqual(errno.EAGAIN, raised.exception.errno)
+
+        # Another must not get the lock, so it must return an empty list
+        relinker.hook_post_device(locks, "")
+        self.assertEqual([None], locks)
+
+        with open(lock_file, 'a') as f:
+            fcntl.flock(f.fileno(), fcntl.LOCK_EX | fcntl.LOCK_NB)
+
+    def test_state_file(self):
+        device_path = os.path.join(self.devices, self.existing_device)
+        datadir = 'objects'
+        datadir_path = os.path.join(device_path, datadir)
+        state_file = os.path.join(device_path, 'relink.%s.json' % datadir)
+
+        def call_partition_filter(step, parts):
+            # Partition 312 will be ignored because it must have been created
+            # by the relinker
+            return relinker.partitions_filter(states, step,
+                                              PART_POWER, PART_POWER + 1,
+                                              datadir_path, parts)
+
+        # Start relinking
+        states = {}
+
+        # Load the states: As it starts, it must be empty
+        locks = [None]
+        relinker.hook_pre_device(locks, states, datadir, device_path)
+        self.assertEqual({}, states)
+        os.close(locks[0])  # Release the lock
+
+        # Partition 312 is ignored because it must have been created with the
+        # next_part_power, so it does not need to be relinked
+        # 96 and 227 are reverse ordered
+        # auditor_status_ALL.json is ignored because it's not a partition
+        self.assertEqual(['227', '96'],
+                         call_partition_filter(relinker.STEP_RELINK,
+                                               ['96', '227', '312',
+                                                'auditor_status.json']))
+        self.assertEqual(states, {'96': [False, False], '227': [False, False]})
+
+        # Ack partition 96
+        relinker.hook_post_partition(states, relinker.STEP_RELINK,
+                                     os.path.join(datadir_path, '96'))
+        self.assertEqual(states, {'96': [True, False], '227': [False, False]})
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {'96': [True, False],
+                                            '227': [False, False]})
+
+        # Restart relinking after only part 96 was done
+        self.assertEqual(['227'],
+                         call_partition_filter(relinker.STEP_RELINK,
+                                               ['96', '227', '312']))
+        self.assertEqual(states, {'96': [True, False], '227': [False, False]})
+
+        # Ack partition 227
+        relinker.hook_post_partition(states, relinker.STEP_RELINK,
+                                     os.path.join(datadir_path, '227'))
+        self.assertEqual(states, {'96': [True, False], '227': [True, False]})
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {'96': [True, False],
+                                            '227': [True, False]})
+
+        # If the process restarts, it reload the state
+        locks = [None]
+        states = {}
+        relinker.hook_pre_device(locks, states, datadir, device_path)
+        self.assertEqual(states, {'96': [True, False], '227': [True, False]})
+        os.close(locks[0])  # Release the lock
+
+        # Start cleanup
+        self.assertEqual(['227', '96'],
+                         call_partition_filter(relinker.STEP_CLEANUP,
+                                               ['96', '227', '312']))
+        # Ack partition 227
+        relinker.hook_post_partition(states, relinker.STEP_CLEANUP,
+                                     os.path.join(datadir_path, '227'))
+        self.assertEqual(states, {'96': [True, False], '227': [True, True]})
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {'96': [True, False],
+                                            '227': [True, True]})
+
+        # Restart cleanup after only part 227 was done
+        self.assertEqual(['96'],
+                         call_partition_filter(relinker.STEP_CLEANUP,
+                                               ['96', '227', '312']))
+        self.assertEqual(states, {'96': [True, False], '227': [True, True]})
+
+        # Ack partition 96
+        relinker.hook_post_partition(states, relinker.STEP_CLEANUP,
+                                     os.path.join(datadir_path, '96'))
+        self.assertEqual(states, {'96': [True, True], '227': [True, True]})
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {'96': [True, True],
+                                            '227': [True, True]})
+
+        # At the end, the state is still accurate
+        locks = [None]
+        states = {}
+        relinker.hook_pre_device(locks, states, datadir, device_path)
+        self.assertEqual(states, {'96': [True, True], '227': [True, True]})
+        os.close(locks[0])  # Release the lock
+
+        # If the file gets corrupted, restart from scratch
+        with open(state_file, 'wt') as f:
+            f.write('NOT JSON')
+        locks = [None]
+        states = {}
+        relinker.hook_pre_device(locks, states, datadir, device_path)
+        self.assertEqual(states, {})
+        os.close(locks[0])  # Release the lock
+
     def test_cleanup_not_yet_relinked(self):
         self._common_test_cleanup(relink=False)
         self.assertEqual(1, relinker.cleanup(self.testdir, self.devices, True))
@@ -176,3 +384,7 @@ class TestRelinker(unittest.TestCase):
 
         self.assertIn('failed audit and was quarantined',
                       self.logger.get_lines_for_level('warning')[0])
+
+
+if __name__ == '__main__':
+    unittest.main()
diff -pruN 2.25.0-2/test/unit/common/middleware/s3api/__init__.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/__init__.py
--- 2.25.0-2/test/unit/common/middleware/s3api/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/__init__.py	2020-07-06 17:03:50.000000000 +0000
@@ -50,6 +50,18 @@ class FakeApp(object):
         if 's3api.auth_details' in env:
             self._update_s3_path_info(env)
 
+        if env['REQUEST_METHOD'] == 'TEST':
+
+            def authorize_cb(req):
+                # Assume swift owner, if not yet set
+                req.environ.setdefault('REMOTE_USER', 'authorized')
+                req.environ.setdefault('swift_owner', True)
+                # But then default to blocking authz, to ensure we've replaced
+                # the default auth system
+                return swob.HTTPForbidden(request=req)
+
+            env['swift.authorize'] = authorize_cb
+
         return self.swift(env, start_response)
 
 
diff -pruN 2.25.0-2/test/unit/common/middleware/s3api/test_multi_upload.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_multi_upload.py
--- 2.25.0-2/test/unit/common/middleware/s3api/test_multi_upload.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_multi_upload.py	2020-07-06 17:03:50.000000000 +0000
@@ -137,6 +137,22 @@ class TestS3ApiMultiUpload(S3ApiTestCase
                                      'Date': self.get_date_header()})
         status, headers, body = self.call_s3api(req)
         self.assertEqual(self._get_error_code(body), 'InvalidRequest')
+        self.assertEqual([], self.swift.calls)
+
+    def test_bucket_upload_part_success(self):
+        req = Request.blank('/bucket/object?partNumber=1&uploadId=X',
+                            method='PUT',
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info',
+                   lambda env, app, swift_source: {'status': 204}):
+            status, headers, body = self.call_s3api(req)
+        self.assertEqual(status, '200 OK')
+        self.assertEqual([
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('PUT', '/v1/AUTH_test/bucket+segments/object/X/1'),
+        ], self.swift.calls)
 
     @s3acl
     def test_object_multipart_uploads_list(self):
@@ -577,12 +593,10 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertNotIn('Content-MD5', req_headers)
         if bucket_exists:
             self.assertEqual([
-                ('HEAD', '/v1/AUTH_test/bucket'),
                 ('PUT', '/v1/AUTH_test/bucket+segments/object/X'),
             ], self.swift.calls)
         else:
             self.assertEqual([
-                ('HEAD', '/v1/AUTH_test/bucket'),
                 ('PUT', '/v1/AUTH_test/bucket+segments'),
                 ('PUT', '/v1/AUTH_test/bucket+segments/object/X'),
             ], self.swift.calls)
@@ -596,6 +610,8 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         fake_memcache = FakeMemcache()
         fake_memcache.store[get_cache_key(
             'AUTH_test', 'bucket+segments')] = {'status': 204}
+        fake_memcache.store[get_cache_key(
+            'AUTH_test', 'bucket')] = {'status': 204}
         self._test_object_multipart_upload_initiate({}, fake_memcache)
         self._test_object_multipart_upload_initiate({'Etag': 'blahblahblah'},
                                                     fake_memcache)
@@ -826,8 +842,9 @@ class TestS3ApiMultiUpload(S3ApiTestCase
 
         self.assertEqual(self.swift.calls, [
             # Bucket exists
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
-            # Segment container exists
+            # Upload marker exists
             ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
             # Create the SLO
             ('PUT', '/v1/AUTH_test/bucket/object'
@@ -843,6 +860,126 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         override_etag = '; s3_etag=%s' % S3_ETAG.strip('"')
         h = 'X-Object-Sysmeta-Container-Update-Override-Etag'
         self.assertEqual(headers.get(h), override_etag)
+        self.assertEqual(headers.get('X-Object-Sysmeta-S3Api-Upload-Id'), 'X')
+
+    def test_object_multipart_upload_retry_complete(self):
+        content_md5 = base64.b64encode(hashlib.md5(
+            XML.encode('ascii')).digest())
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket+segments/object/X',
+                            swob.HTTPNotFound, {}, None)
+        recent_ts = S3Timestamp.now(delta=-1000000).internal  # 10s ago
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket/object',
+                            swob.HTTPOk,
+                            {'x-object-meta-foo': 'bar',
+                             'content-type': 'baz/quux',
+                             'x-object-sysmeta-s3api-upload-id': 'X',
+                             'x-object-sysmeta-s3api-etag': S3_ETAG.strip('"'),
+                             'x-timestamp': recent_ts}, None)
+        req = Request.blank('/bucket/object?uploadId=X',
+                            environ={'REQUEST_METHOD': 'POST'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header(),
+                                     'Content-MD5': content_md5, },
+                            body=XML)
+        status, headers, body = self.call_s3api(req)
+        elem = fromstring(body, 'CompleteMultipartUploadResult')
+        self.assertNotIn('Etag', headers)
+        self.assertEqual(elem.find('ETag').text, S3_ETAG)
+        self.assertEqual(status.split()[0], '200')
+
+        self.assertEqual(self.swift.calls, [
+            # Bucket exists
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            # Upload marker does not exist
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            # But the object does, and with the same upload ID
+            ('HEAD', '/v1/AUTH_test/bucket/object'),
+            # So no PUT necessary
+        ])
+
+    def test_object_multipart_upload_retry_complete_etag_mismatch(self):
+        content_md5 = base64.b64encode(hashlib.md5(
+            XML.encode('ascii')).digest())
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket+segments/object/X',
+                            swob.HTTPNotFound, {}, None)
+        recent_ts = S3Timestamp.now(delta=-1000000).internal
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket/object',
+                            swob.HTTPOk,
+                            {'x-object-meta-foo': 'bar',
+                             'content-type': 'baz/quux',
+                             'x-object-sysmeta-s3api-upload-id': 'X',
+                             'x-object-sysmeta-s3api-etag': 'not-the-etag',
+                             'x-timestamp': recent_ts}, None)
+        req = Request.blank('/bucket/object?uploadId=X',
+                            environ={'REQUEST_METHOD': 'POST'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header(),
+                                     'Content-MD5': content_md5, },
+                            body=XML)
+        status, headers, body = self.call_s3api(req)
+        elem = fromstring(body, 'CompleteMultipartUploadResult')
+        self.assertNotIn('Etag', headers)
+        self.assertEqual(elem.find('ETag').text, S3_ETAG)
+        self.assertEqual(status.split()[0], '200')
+
+        self.assertEqual(self.swift.calls, [
+            # Bucket exists
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            # Upload marker does not exist
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            # But the object does, and with the same upload ID
+            ('HEAD', '/v1/AUTH_test/bucket/object'),
+            # Create the SLO
+            ('PUT', '/v1/AUTH_test/bucket/object'
+                    '?heartbeat=on&multipart-manifest=put'),
+            # Retry deleting the marker for the sake of completeness
+            ('DELETE', '/v1/AUTH_test/bucket+segments/object/X')
+        ])
+
+        _, _, headers = self.swift.calls_with_headers[-2]
+        self.assertEqual(headers.get('X-Object-Meta-Foo'), 'bar')
+        self.assertEqual(headers.get('Content-Type'), 'baz/quux')
+        # SLO will provide a base value
+        override_etag = '; s3_etag=%s' % S3_ETAG.strip('"')
+        h = 'X-Object-Sysmeta-Container-Update-Override-Etag'
+        self.assertEqual(headers.get(h), override_etag)
+        self.assertEqual(headers.get('X-Object-Sysmeta-S3Api-Upload-Id'), 'X')
+
+    def test_object_multipart_upload_retry_complete_upload_id_mismatch(self):
+        content_md5 = base64.b64encode(hashlib.md5(
+            XML.encode('ascii')).digest())
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket+segments/object/X',
+                            swob.HTTPNotFound, {}, None)
+        recent_ts = S3Timestamp.now(delta=-1000000).internal
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket/object',
+                            swob.HTTPOk,
+                            {'x-object-meta-foo': 'bar',
+                             'content-type': 'baz/quux',
+                             'x-object-sysmeta-s3api-upload-id': 'Y',
+                             'x-object-sysmeta-s3api-etag': S3_ETAG.strip('"'),
+                             'x-timestamp': recent_ts}, None)
+        req = Request.blank('/bucket/object?uploadId=X',
+                            environ={'REQUEST_METHOD': 'POST'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header(),
+                                     'Content-MD5': content_md5, },
+                            body=XML)
+        status, headers, body = self.call_s3api(req)
+        elem = fromstring(body, 'Error')
+        self.assertEqual(elem.find('Code').text, 'NoSuchUpload')
+        self.assertEqual(status.split()[0], '404')
+
+        self.assertEqual(self.swift.calls, [
+            # Bucket exists
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            # Upload marker does not exist
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            # But the object does, and with the same upload ID
+            ('HEAD', '/v1/AUTH_test/bucket/object'),
+        ])
 
     def test_object_multipart_upload_invalid_md5(self):
         bad_md5 = base64.b64encode(hashlib.md5(
@@ -902,6 +1039,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         # NB: S3_ETAG includes quotes
         self.assertIn(('<ETag>%s</ETag>' % S3_ETAG).encode('ascii'), body)
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/heartbeat-ok/X'),
             ('PUT', '/v1/AUTH_test/bucket/heartbeat-ok?'
@@ -952,6 +1090,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(self._get_error_message(body),
                          'some/object: 403 Forbidden')
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/heartbeat-fail/X'),
             ('PUT', '/v1/AUTH_test/bucket/heartbeat-fail?'
@@ -1001,6 +1140,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertIn('One or more of the specified parts could not be found',
                       self._get_error_message(body))
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/heartbeat-fail/X'),
             ('PUT', '/v1/AUTH_test/bucket/heartbeat-fail?'
@@ -1091,8 +1231,13 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(self._get_error_code(body), 'EntityTooSmall')
         self.assertEqual(self._get_error_message(body), msg)
         # We punt to SLO to do the validation
-        self.assertEqual([method for method, _ in self.swift.calls],
-                         ['HEAD', 'HEAD', 'PUT'])
+        self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('PUT', '/v1/AUTH_test/bucket/object'
+             '?heartbeat=on&multipart-manifest=put'),
+        ])
 
         self.swift.clear_calls()
         self.s3api.conf.min_segment_size = 5242880
@@ -1112,8 +1257,13 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(self._get_error_code(body), 'EntityTooSmall')
         self.assertEqual(self._get_error_message(body), msg)
         # Again, we punt to SLO to do the validation
-        self.assertEqual([method for method, _ in self.swift.calls],
-                         ['HEAD', 'HEAD', 'PUT'])
+        self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('PUT', '/v1/AUTH_test/bucket/object'
+             '?heartbeat=on&multipart-manifest=put'),
+        ])
 
     def test_object_multipart_upload_complete_zero_segments(self):
         segment_bucket = '/v1/AUTH_test/empty-bucket+segments'
@@ -1151,6 +1301,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         fromstring(body, 'Error')
 
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/empty-bucket'),
             ('HEAD', '/v1/AUTH_test/empty-bucket+segments/object/X'),
         ])
@@ -1197,6 +1348,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(status.split()[0], '200')
 
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/empty-bucket'),
             ('HEAD', '/v1/AUTH_test/empty-bucket+segments/object/X'),
             ('PUT', '/v1/AUTH_test/empty-bucket/object?'
@@ -1266,6 +1418,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(elem.find('ETag').text, expected_etag)
 
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
             ('PUT', '/v1/AUTH_test/bucket/object?'
@@ -1906,7 +2059,13 @@ class TestS3ApiMultiUpload(S3ApiTestCase
 
         self.assertEqual(status.split()[0], '200')
 
-        self.assertEqual(len(self.swift.calls_with_headers), 4)
+        self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('HEAD', '/v1/AUTH_test/src_bucket/src_obj'),
+            ('PUT', '/v1/AUTH_test/bucket+segments/object/X/1'),
+        ])
         _, _, headers = self.swift.calls_with_headers[-2]
         self.assertEqual(headers['If-Match'], etag)
         self.assertEqual(headers['If-Modified-Since'], last_modified_since)
@@ -1957,7 +2116,13 @@ class TestS3ApiMultiUpload(S3ApiTestCase
             self._test_copy_for_s3acl(account, put_header=header)
 
         self.assertEqual(status.split()[0], '200')
-        self.assertEqual(len(self.swift.calls_with_headers), 4)
+        self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('HEAD', '/v1/AUTH_test/src_bucket/src_obj'),
+            ('PUT', '/v1/AUTH_test/bucket+segments/object/X/1'),
+        ])
         _, _, headers = self.swift.calls_with_headers[-2]
         self.assertEqual(headers['If-None-Match'], etag)
         self.assertEqual(headers['If-Unmodified-Since'], last_modified_since)
@@ -2009,6 +2174,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
                       b'source object of size: 10', body)
 
         self.assertEqual([
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
             ('HEAD', '/v1/AUTH_test/src_bucket/src_obj'),
@@ -2039,6 +2205,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(status.split()[0], '200', body)
 
         self.assertEqual([
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
             ('HEAD', '/v1/AUTH_test/src_bucket/src_obj'),
diff -pruN 2.25.0-2/test/unit/common/middleware/s3api/test_obj.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_obj.py
--- 2.25.0-2/test/unit/common/middleware/s3api/test_obj.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_obj.py	2020-07-06 17:03:50.000000000 +0000
@@ -452,6 +452,26 @@ class TestS3ApiObj(S3ApiTestCase):
         status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '404')
 
+    @s3acl(versioning_enabled=False)
+    def test_object_GET_with_version_id_but_not_enabled(self):
+        # Version not found
+        self.swift.register(
+            'HEAD', '/v1/AUTH_test/bucket',
+            swob.HTTPNoContent, {}, None)
+        req = Request.blank('/bucket/object?versionId=A',
+                            environ={'REQUEST_METHOD': 'GET'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(status.split()[0], '404')
+        elem = fromstring(body, 'Error')
+        self.assertEqual(elem.find('Code').text, 'NoSuchVersion')
+        self.assertEqual(elem.find('Key').text, 'object')
+        self.assertEqual(elem.find('VersionId').text, 'A')
+        expected_calls = []
+        # NB: No actual backend GET!
+        self.assertEqual(expected_calls, self.swift.calls)
+
     @s3acl
     def test_object_PUT_error(self):
         code = self._test_method_error('PUT', '/bucket/object',
@@ -1108,7 +1128,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1139,7 +1167,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1152,6 +1188,20 @@ class TestS3ApiObj(S3ApiTestCase):
              '?version-id=1574341899.21751'),
         ], self.swift.calls)
 
+    @s3acl(versioning_enabled=False)
+    def test_object_DELETE_with_version_id_but_not_enabled(self):
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket',
+                            swob.HTTPNoContent, {}, None)
+        req = Request.blank('/bucket/object?versionId=1574358170.12293',
+                            method='DELETE', headers={
+                                'Authorization': 'AWS test:tester:hmac',
+                                'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(status.split()[0], '204')
+        expected_calls = []
+        # NB: No actual backend DELETE!
+        self.assertEqual(expected_calls, self.swift.calls)
+
     def test_object_DELETE_version_id_not_implemented(self):
         req = Request.blank('/bucket/object?versionId=1574358170.12293',
                             method='DELETE', headers={
@@ -1181,7 +1231,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1220,7 +1278,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1248,7 +1314,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '500')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1280,7 +1354,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '500')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1325,23 +1407,25 @@ class TestS3ApiObj(S3ApiTestCase):
             'X-Object-Version-Id': '1574701081.61553'}
         self.swift.register('DELETE', '/v1/AUTH_test/bucket/object',
                             swob.HTTPNoContent, resp_headers, None)
-        self.swift.register('HEAD', '/v1/AUTH_test/bucket',
-                            swob.HTTPNoContent, {
-                                'X-Container-Sysmeta-Versions-Enabled': True},
-                            None)
         self.swift.register('HEAD', '/v1/AUTH_test/bucket/object',
                             swob.HTTPNotFound, self.response_headers, None)
         req = Request.blank('/bucket/object?versionId=1574701081.61553',
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
              '?symlink=get&version-id=1574701081.61553'),
-            ('HEAD', '/v1/AUTH_test'),
-            ('HEAD', '/v1/AUTH_test/bucket'),
             ('DELETE', '/v1/AUTH_test/bucket/object'
              '?symlink=get&version-id=1574701081.61553'),
         ], self.swift.calls)
diff -pruN 2.25.0-2/test/unit/common/middleware/s3api/test_s3_acl.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_s3_acl.py
--- 2.25.0-2/test/unit/common/middleware/s3api/test_s3_acl.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_s3_acl.py	2020-07-06 17:03:50.000000000 +0000
@@ -34,13 +34,16 @@ from test.unit.common.middleware.s3api i
 XMLNS_XSI = 'http://www.w3.org/2001/XMLSchema-instance'
 
 
-def s3acl(func=None, s3acl_only=False):
+def s3acl(func=None, s3acl_only=False, versioning_enabled=True):
     """
     NOTE: s3acl decorator needs an instance of s3api testing framework.
           (i.e. An instance for first argument is necessary)
     """
     if func is None:
-        return functools.partial(s3acl, s3acl_only=s3acl_only)
+        return functools.partial(
+            s3acl,
+            s3acl_only=s3acl_only,
+            versioning_enabled=versioning_enabled)
 
     @functools.wraps(func)
     def s3acl_decorator(*args, **kwargs):
@@ -57,9 +60,14 @@ def s3acl(func=None, s3acl_only=False):
                 #  @patch(xxx)
                 #  def test_xxxx(self)
 
+                fake_info = {'status': 204}
+                if versioning_enabled:
+                    fake_info['sysmeta'] = {
+                        'versions-container': '\x00versions\x00bucket',
+                    }
+
                 with patch('swift.common.middleware.s3api.s3request.'
-                           'get_container_info',
-                           return_value={'status': 204}):
+                           'get_container_info', return_value=fake_info):
                     func(*args, **kwargs)
             except AssertionError:
                 # Make traceback message to clarify the assertion
diff -pruN 2.25.0-2/test/unit/common/middleware/s3api/test_s3api.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_s3api.py
--- 2.25.0-2/test/unit/common/middleware/s3api/test_s3api.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_s3api.py	2020-07-06 17:03:50.000000000 +0000
@@ -500,8 +500,9 @@ class TestS3ApiMiddleware(S3ApiTestCase)
                         'S3Request.check_signature') as mock_cs:
             status, headers, body = self.call_s3api(req)
             self.assertIn('swift.backend_path', req.environ)
-            self.assertEqual('/v1/AUTH_test/bucket',
-                             req.environ['swift.backend_path'])
+            self.assertEqual(
+                '/v1/AUTH_test/bucket+segments/object/123456789abcdef',
+                req.environ['swift.backend_path'])
 
         _, _, headers = self.swift.calls_with_headers[-1]
         self.assertEqual(req.environ['s3api.auth_details'], {
@@ -530,8 +531,9 @@ class TestS3ApiMiddleware(S3ApiTestCase)
                         'S3Request.check_signature') as mock_cs:
             status, headers, body = self.call_s3api(req)
             self.assertIn('swift.backend_path', req.environ)
-            self.assertEqual('/v1/AUTH_test/bucket',
-                             req.environ['swift.backend_path'])
+            self.assertEqual(
+                '/v1/AUTH_test/bucket+segments/object/123456789abcdef',
+                req.environ['swift.backend_path'])
 
         _, _, headers = self.swift.calls_with_headers[-1]
         self.assertEqual(req.environ['s3api.auth_details'], {
@@ -705,7 +707,24 @@ class TestS3ApiMiddleware(S3ApiTestCase)
         self._test_unsupported_resource('cors')
 
     def test_tagging(self):
-        self._test_unsupported_resource('tagging')
+        req = Request.blank('/bucket?tagging',
+                            environ={'REQUEST_METHOD': 'GET'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(status.split()[0], '200')
+        req = Request.blank('/bucket?tagging',
+                            environ={'REQUEST_METHOD': 'PUT'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(self._get_error_code(body), 'NotImplemented')
+        req = Request.blank('/bucket?tagging',
+                            environ={'REQUEST_METHOD': 'DELETE'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(self._get_error_code(body), 'NotImplemented')
 
     def test_restore(self):
         self._test_unsupported_resource('restore')
diff -pruN 2.25.0-2/test/unit/common/middleware/s3api/test_s3request.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_s3request.py
--- 2.25.0-2/test/unit/common/middleware/s3api/test_s3request.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_s3request.py	2020-07-06 17:03:50.000000000 +0000
@@ -312,7 +312,7 @@ class TestRequest(S3ApiTestCase):
             '[{"Grantee":"owner","Permission":"FULL_CONTROL"}]}'
         self.swift.register('HEAD', '/v1/AUTH_test/bucket', HTTPNoContent,
                             {'x-container-read': 'foo',
-                             'X-container-object-count': 5,
+                             'X-container-object-count': '5',
                              'x-container-sysmeta-versions-location':
                                 'bucket2',
                              'x-container-sysmeta-s3api-acl': s3api_acl,
@@ -326,7 +326,7 @@ class TestRequest(S3ApiTestCase):
         self.assertTrue('status' in info)  # sanity
         self.assertEqual(204, info['status'])  # sanity
         self.assertEqual('foo', info['read_acl'])  # sanity
-        self.assertEqual('5', info['object_count'])  # sanity
+        self.assertEqual(5, info['object_count'])  # sanity
         self.assertEqual(
             'bucket2', info['sysmeta']['versions-location'])  # sanity
         self.assertEqual(s3api_acl, info['sysmeta']['s3api-acl'])  # sanity
diff -pruN 2.25.0-2/test/unit/common/middleware/s3api/test_versioning.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_versioning.py
--- 2.25.0-2/test/unit/common/middleware/s3api/test_versioning.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/s3api/test_versioning.py	2020-07-06 17:03:50.000000000 +0000
@@ -42,7 +42,7 @@ class TestS3ApiVersioning(S3ApiTestCase)
         status, headers, body = self._versioning_GET(path)
         self.assertEqual(status.split()[0], '200')
         elem = fromstring(body, 'VersioningConfiguration')
-        self.assertEqual(elem.getchildren(), [])
+        self.assertEqual(list(elem), [])
 
     def _versioning_GET_enabled(self, path):
         self.swift.register('HEAD', '/v1/AUTH_test/bucket', HTTPNoContent, {
diff -pruN 2.25.0-2/test/unit/common/middleware/test_ratelimit.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/test_ratelimit.py
--- 2.25.0-2/test/unit/common/middleware/test_ratelimit.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/test_ratelimit.py	2020-07-06 17:03:50.000000000 +0000
@@ -72,12 +72,20 @@ class FakeMemcache(object):
 
 
 class FakeApp(object):
+    skip_handled_check = False
 
     def __call__(self, env, start_response):
+        assert self.skip_handled_check or env.get('swift.ratelimit.handled')
         start_response('200 OK', [])
         return [b'Some Content']
 
 
+class FakeReq(object):
+    def __init__(self, method, env=None):
+        self.method = method
+        self.environ = env or {}
+
+
 def start_response(*args):
     pass
 
@@ -160,36 +168,29 @@ class TestRateLimit(unittest.TestCase):
             {'object_count': '5'}
         the_app = ratelimit.filter_factory(conf_dict)(FakeApp())
         the_app.memcache_client = fake_memcache
-        req = lambda: None
-        req.environ = {'swift.cache': fake_memcache, 'PATH_INFO': '/v1/a/c/o'}
+        environ = {'swift.cache': fake_memcache, 'PATH_INFO': '/v1/a/c/o'}
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
-            req.method = 'DELETE'
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', None, None)), 0)
-            req.method = 'PUT'
+                FakeReq('DELETE', environ), 'a', None, None)), 0)
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', 'c', None)), 1)
-            req.method = 'DELETE'
+                FakeReq('PUT', environ), 'a', 'c', None)), 1)
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', 'c', None)), 1)
-            req.method = 'GET'
+                FakeReq('DELETE', environ), 'a', 'c', None)), 1)
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', 'c', 'o')), 0)
-            req.method = 'PUT'
+                FakeReq('GET', environ), 'a', 'c', 'o')), 0)
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', 'c', 'o')), 1)
+                FakeReq('PUT', environ), 'a', 'c', 'o')), 1)
 
-        req.method = 'PUT'
         self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-            req, 'a', 'c', None, global_ratelimit=10)), 2)
+            FakeReq('PUT', environ), 'a', 'c', None, global_ratelimit=10)), 2)
         self.assertEqual(the_app.get_ratelimitable_key_tuples(
-            req, 'a', 'c', None, global_ratelimit=10)[1],
+            FakeReq('PUT', environ), 'a', 'c', None, global_ratelimit=10)[1],
             ('ratelimit/global-write/a', 10))
 
-        req.method = 'PUT'
         self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-            req, 'a', 'c', None, global_ratelimit='notafloat')), 1)
+            FakeReq('PUT', environ), 'a', 'c', None,
+            global_ratelimit='notafloat')), 1)
 
     def test_memcached_container_info_dict(self):
         mdict = headers_to_container_info({'x-container-object-count': '45'})
@@ -204,9 +205,8 @@ class TestRateLimit(unittest.TestCase):
             {'container_size': 5}
         the_app = ratelimit.filter_factory(conf_dict)(FakeApp())
         the_app.memcache_client = fake_memcache
-        req = lambda: None
-        req.method = 'PUT'
-        req.environ = {'PATH_INFO': '/v1/a/c/o', 'swift.cache': fake_memcache}
+        req = FakeReq('PUT', {
+            'PATH_INFO': '/v1/a/c/o', 'swift.cache': fake_memcache})
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
             tuples = the_app.get_ratelimitable_key_tuples(req, 'a', 'c', 'o')
@@ -227,8 +227,8 @@ class TestRateLimit(unittest.TestCase):
                     req = Request.blank('/v1/a%s/c' % meth)
                     req.method = meth
                     req.environ['swift.cache'] = FakeMemcache()
-                    make_app_call = lambda: self.test_ratelimit(req.environ,
-                                                                start_response)
+                    make_app_call = lambda: self.test_ratelimit(
+                        req.environ.copy(), start_response)
                     begin = time.time()
                     self._run(make_app_call, num_calls, current_rate,
                               check_time=bool(exp_time))
@@ -244,7 +244,7 @@ class TestRateLimit(unittest.TestCase):
         req.method = 'PUT'
         req.environ['swift.cache'] = FakeMemcache()
         req.environ['swift.cache'].init_incr_return_neg = True
-        make_app_call = lambda: self.test_ratelimit(req.environ,
+        make_app_call = lambda: self.test_ratelimit(req.environ.copy(),
                                                     start_response)
         begin = time.time()
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
@@ -260,15 +260,15 @@ class TestRateLimit(unittest.TestCase):
                      'account_whitelist': 'a',
                      'account_blacklist': 'b'}
         self.test_ratelimit = ratelimit.filter_factory(conf_dict)(FakeApp())
-        req = Request.blank('/')
         with mock.patch.object(self.test_ratelimit,
                                'memcache_client', FakeMemcache()):
             self.assertEqual(
-                self.test_ratelimit.handle_ratelimit(req, 'a', 'c', 'o'),
+                self.test_ratelimit.handle_ratelimit(
+                    Request.blank('/'), 'a', 'c', 'o'),
                 None)
             self.assertEqual(
                 self.test_ratelimit.handle_ratelimit(
-                    req, 'b', 'c', 'o').status_int,
+                    Request.blank('/'), 'b', 'c', 'o').status_int,
                 497)
 
     def test_ratelimit_whitelist_sysmeta(self):
@@ -331,7 +331,7 @@ class TestRateLimit(unittest.TestCase):
                 self.parent = parent
 
             def run(self):
-                self.result = self.parent.test_ratelimit(req.environ,
+                self.result = self.parent.test_ratelimit(req.environ.copy(),
                                                          start_response)
 
         def get_fake_ratelimit(*args, **kwargs):
@@ -370,18 +370,17 @@ class TestRateLimit(unittest.TestCase):
         # simulates 4 requests coming in at same time, then sleeping
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
-            print(repr(r))
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Some Content')
 
     def test_ratelimit_max_rate_double_container(self):
@@ -404,17 +403,17 @@ class TestRateLimit(unittest.TestCase):
         # simulates 4 requests coming in at same time, then sleeping
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Some Content')
 
     def test_ratelimit_max_rate_double_container_listing(self):
@@ -437,17 +436,17 @@ class TestRateLimit(unittest.TestCase):
                         lambda *args, **kwargs: {}):
             time_override = [0, 0, 0, 0, None]
             # simulates 4 requests coming in at same time, then sleeping
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Some Content')
             mc = self.test_ratelimit.memcache_client
             try:
@@ -466,9 +465,6 @@ class TestRateLimit(unittest.TestCase):
 
         the_app = ratelimit.filter_factory(conf_dict)(FakeApp())
         the_app.memcache_client = fake_memcache
-        req = lambda: None
-        req.method = 'PUT'
-        req.environ = {}
 
         class rate_caller(threading.Thread):
 
@@ -478,8 +474,8 @@ class TestRateLimit(unittest.TestCase):
 
             def run(self):
                 for j in range(num_calls):
-                    self.result = the_app.handle_ratelimit(req, self.myname,
-                                                           'c', None)
+                    self.result = the_app.handle_ratelimit(
+                        FakeReq('PUT'), self.myname, 'c', None)
 
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
@@ -541,12 +537,32 @@ class TestRateLimit(unittest.TestCase):
         current_rate = 13
         num_calls = 5
         conf_dict = {'account_ratelimit': current_rate}
-        self.test_ratelimit = ratelimit.filter_factory(conf_dict)(FakeApp())
+        fake_app = FakeApp()
+        fake_app.skip_handled_check = True
+        self.test_ratelimit = ratelimit.filter_factory(conf_dict)(fake_app)
         req = Request.blank('/v1/a')
         req.environ['swift.cache'] = None
         make_app_call = lambda: self.test_ratelimit(req.environ,
                                                     start_response)
         begin = time.time()
+        self._run(make_app_call, num_calls, current_rate, check_time=False)
+        time_took = time.time() - begin
+        self.assertEqual(round(time_took, 1), 0)  # no memcache, no limiting
+
+    def test_already_handled(self):
+        current_rate = 13
+        num_calls = 5
+        conf_dict = {'container_listing_ratelimit_0': current_rate}
+        self.test_ratelimit = ratelimit.filter_factory(conf_dict)(FakeApp())
+        fake_cache = FakeMemcache()
+        fake_cache.set(
+            get_cache_key('a', 'c'),
+            {'object_count': 1})
+        req = Request.blank('/v1/a/c', environ={'swift.cache': fake_cache})
+        req.environ['swift.ratelimit.handled'] = True
+        make_app_call = lambda: self.test_ratelimit(req.environ,
+                                                    start_response)
+        begin = time.time()
         self._run(make_app_call, num_calls, current_rate, check_time=False)
         time_took = time.time() - begin
         self.assertEqual(round(time_took, 1), 0)  # no memcache, no limiting
diff -pruN 2.25.0-2/test/unit/common/middleware/test_symlink.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/test_symlink.py
--- 2.25.0-2/test/unit/common/middleware/test_symlink.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/middleware/test_symlink.py	2020-07-06 17:03:50.000000000 +0000
@@ -24,6 +24,7 @@ from swift.common import swob
 from swift.common.middleware import symlink, copy, versioned_writes, \
     listing_formats
 from swift.common.swob import Request
+from swift.common.request_helpers import get_reserved_name
 from swift.common.utils import MD5_OF_EMPTY_STRING, get_swift_info
 from test.unit.common.middleware.helpers import FakeSwift
 from test.unit.common.middleware.test_versioned_writes import FakeCache
@@ -618,6 +619,55 @@ class TestSymlinkMiddleware(TestSymlinkM
         self.assertEqual(req_headers, calls[1].headers)
         self.assertFalse(calls[2:])
 
+    def test_get_symlink_to_reserved_object(self):
+        cont = get_reserved_name('versioned')
+        obj = get_reserved_name('symlink', '9999998765.99999')
+        symlink_target = "%s/%s" % (cont, obj)
+        version_path = '/v1/a/%s' % symlink_target
+        self.app.register('GET', '/v1/a/versioned/symlink', swob.HTTPOk, {
+            symlink.TGT_OBJ_SYSMETA_SYMLINK_HDR: symlink_target,
+            symlink.ALLOW_RESERVED_NAMES: 'true',
+            'x-object-sysmeta-symlink-target-etag': MD5_OF_EMPTY_STRING,
+            'x-object-sysmeta-symlink-target-bytes': '0',
+        })
+        self.app.register('GET', version_path, swob.HTTPOk, {})
+        req = Request.blank('/v1/a/versioned/symlink', headers={
+            'Range': 'foo', 'If-Match': 'bar'})
+        status, headers, body = self.call_sym(req)
+        self.assertEqual(status, '200 OK')
+        self.assertIn(('Content-Location', version_path), headers)
+        self.assertEqual(len(self.authorized), 1)
+        self.assertNotIn('X-Backend-Allow-Reserved-Names',
+                         self.app.calls_with_headers[0])
+        call_headers = self.app.calls_with_headers[1].headers
+        self.assertEqual('true', call_headers[
+            'X-Backend-Allow-Reserved-Names'])
+        self.assertEqual('foo', call_headers['Range'])
+        self.assertEqual('bar', call_headers['If-Match'])
+
+    def test_get_symlink_to_reserved_symlink(self):
+        cont = get_reserved_name('versioned')
+        obj = get_reserved_name('symlink', '9999998765.99999')
+        symlink_target = "%s/%s" % (cont, obj)
+        version_path = '/v1/a/%s' % symlink_target
+        self.app.register('GET', '/v1/a/versioned/symlink', swob.HTTPOk, {
+            symlink.TGT_OBJ_SYSMETA_SYMLINK_HDR: symlink_target,
+            symlink.ALLOW_RESERVED_NAMES: 'true',
+            'x-object-sysmeta-symlink-target-etag': MD5_OF_EMPTY_STRING,
+            'x-object-sysmeta-symlink-target-bytes': '0',
+        })
+        self.app.register('GET', version_path, swob.HTTPOk, {
+            symlink.TGT_OBJ_SYSMETA_SYMLINK_HDR: 'unversioned/obj',
+            'ETag': MD5_OF_EMPTY_STRING,
+        })
+        self.app.register('GET', '/v1/a/unversioned/obj', swob.HTTPOk, {
+        })
+        req = Request.blank('/v1/a/versioned/symlink')
+        status, headers, body = self.call_sym(req)
+        self.assertEqual(status, '200 OK')
+        self.assertIn(('Content-Location', '/v1/a/unversioned/obj'), headers)
+        self.assertEqual(len(self.authorized), 2)
+
     def test_symlink_too_deep(self):
         self.app.register('GET', '/v1/a/c/symlink', swob.HTTPOk,
                           {'X-Object-Sysmeta-Symlink-Target': 'c/sym1'})
diff -pruN 2.25.0-2/test/unit/common/ring/test_builder.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/ring/test_builder.py
--- 2.25.0-2/test/unit/common/ring/test_builder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/ring/test_builder.py	2020-07-06 17:03:50.000000000 +0000
@@ -2113,7 +2113,7 @@ class TestRingBuilder(unittest.TestCase)
         orig_rb = ring.RingBuilder(8, 3, 1)
         copy_rb = ring.RingBuilder(8, 3, 1)
         copy_rb.copy_from(orig_rb)
-        for rb in(orig_rb, copy_rb):
+        for rb in (orig_rb, copy_rb):
             with self.assertRaises(AttributeError) as cm:
                 rb.id
             self.assertIn('id attribute has not been initialised',
diff -pruN 2.25.0-2/test/unit/common/test_db.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_db.py
--- 2.25.0-2/test/unit/common/test_db.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_db.py	2020-07-06 17:03:50.000000000 +0000
@@ -1154,7 +1154,7 @@ class TestDatabaseBroker(unittest.TestCa
         return broker
 
     # only testing _reclaim_metadata here
-    @patch.object(DatabaseBroker, '_reclaim')
+    @patch.object(DatabaseBroker, '_reclaim', return_value='')
     def test_metadata(self, mock_reclaim):
         # Initializes a good broker for us
         broker = self.get_replication_info_tester(metadata=True)
@@ -1289,7 +1289,7 @@ class TestDatabaseBroker(unittest.TestCa
         for c in range(MAX_META_COUNT):
             key = 'X-Account-Meta-F{0}'.format(c)
             metadata[key] = ('B', normalize_timestamp(1))
-        key = 'X-Account-Meta-Foo'.format(c)
+        key = 'X-Account-Meta-Foo'
         metadata[key] = ('', normalize_timestamp(1))
         self.assertIsNone(DatabaseBroker.validate_metadata(metadata))
 
diff -pruN 2.25.0-2/test/unit/common/test_db_replicator.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_db_replicator.py
--- 2.25.0-2/test/unit/common/test_db_replicator.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_db_replicator.py	2020-07-06 17:03:50.000000000 +0000
@@ -324,7 +324,11 @@ class TestDBReplicator(unittest.TestCase
         # later config should be extended to assert more config options
         replicator = TestReplicator({'node_timeout': '3.5'})
         self.assertEqual(replicator.node_timeout, 3.5)
-        self.assertEqual(replicator.databases_per_second, 50)
+        self.assertEqual(replicator.databases_per_second, 50.0)
+
+        replicator = TestReplicator({'databases_per_second': '0.1'})
+        self.assertEqual(replicator.node_timeout, 10)
+        self.assertEqual(replicator.databases_per_second, 0.1)
 
     def test_repl_connection(self):
         node = {'replication_ip': '127.0.0.1', 'replication_port': 80,
diff -pruN 2.25.0-2/test/unit/common/test_memcached.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_memcached.py
--- 2.25.0-2/test/unit/common/test_memcached.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_memcached.py	2020-07-06 17:03:50.000000000 +0000
@@ -20,6 +20,7 @@ from collections import defaultdict
 import errno
 from hashlib import md5
 import io
+import logging
 import six
 import socket
 import time
@@ -184,9 +185,14 @@ class TestMemcached(unittest.TestCase):
 
     def setUp(self):
         self.logger = debug_logger()
-        patcher = mock.patch('swift.common.memcached.logging', self.logger)
-        self.addCleanup(patcher.stop)
-        patcher.start()
+
+    def test_logger_kwarg(self):
+        server_socket = '%s:%s' % ('[::1]', 11211)
+        client = memcached.MemcacheRing([server_socket])
+        self.assertIs(client.logger, logging.getLogger())
+
+        client = memcached.MemcacheRing([server_socket], logger=self.logger)
+        self.assertIs(client.logger, self.logger)
 
     def test_get_conns(self):
         sock1 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
@@ -202,7 +208,8 @@ class TestMemcached(unittest.TestCase):
             sock2ipport = '%s:%s' % (sock2ip, memcached.DEFAULT_MEMCACHED_PORT)
             # We're deliberately using sock2ip (no port) here to test that the
             # default port is used.
-            memcache_client = memcached.MemcacheRing([sock1ipport, sock2ip])
+            memcache_client = memcached.MemcacheRing([sock1ipport, sock2ip],
+                                                     logger=self.logger)
             one = two = True
             while one or two:  # Run until we match hosts one and two
                 key = uuid4().hex.encode('ascii')
@@ -230,7 +237,8 @@ class TestMemcached(unittest.TestCase):
             sock.listen(1)
             sock_addr = sock.getsockname()
             server_socket = '[%s]:%s' % (sock_addr[0], sock_addr[1])
-            memcache_client = memcached.MemcacheRing([server_socket])
+            memcache_client = memcached.MemcacheRing([server_socket],
+                                                     logger=self.logger)
             key = uuid4().hex.encode('ascii')
             for conn in memcache_client._get_conns(key):
                 peer_sockaddr = conn[2].getpeername()
@@ -251,7 +259,8 @@ class TestMemcached(unittest.TestCase):
             server_socket = '[%s]:%s' % (sock_addr[0], sock_addr[1])
             server_host = '[%s]' % sock_addr[0]
             memcached.DEFAULT_MEMCACHED_PORT = sock_addr[1]
-            memcache_client = memcached.MemcacheRing([server_host])
+            memcache_client = memcached.MemcacheRing([server_host],
+                                                     logger=self.logger)
             key = uuid4().hex.encode('ascii')
             for conn in memcache_client._get_conns(key):
                 peer_sockaddr = conn[2].getpeername()
@@ -265,7 +274,7 @@ class TestMemcached(unittest.TestCase):
         with self.assertRaises(ValueError):
             # IPv6 address with missing [] is invalid
             server_socket = '%s:%s' % ('::1', 11211)
-            memcached.MemcacheRing([server_socket])
+            memcached.MemcacheRing([server_socket], logger=self.logger)
 
     def test_get_conns_hostname(self):
         with patch('swift.common.memcached.socket.getaddrinfo') as addrinfo:
@@ -279,7 +288,8 @@ class TestMemcached(unittest.TestCase):
                 addrinfo.return_value = [(socket.AF_INET,
                                           socket.SOCK_STREAM, 0, '',
                                           ('127.0.0.1', sock_addr[1]))]
-                memcache_client = memcached.MemcacheRing([server_socket])
+                memcache_client = memcached.MemcacheRing([server_socket],
+                                                         logger=self.logger)
                 key = uuid4().hex.encode('ascii')
                 for conn in memcache_client._get_conns(key):
                     peer_sockaddr = conn[2].getpeername()
@@ -304,7 +314,8 @@ class TestMemcached(unittest.TestCase):
                 addrinfo.return_value = [(socket.AF_INET6,
                                           socket.SOCK_STREAM, 0, '',
                                           ('::1', sock_addr[1]))]
-                memcache_client = memcached.MemcacheRing([server_socket])
+                memcache_client = memcached.MemcacheRing([server_socket],
+                                                         logger=self.logger)
                 key = uuid4().hex.encode('ascii')
                 for conn in memcache_client._get_conns(key):
                     peer_sockaddr = conn[2].getpeername()
@@ -317,7 +328,8 @@ class TestMemcached(unittest.TestCase):
                 sock.close()
 
     def test_set_get_json(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -350,7 +362,8 @@ class TestMemcached(unittest.TestCase):
         self.assertAlmostEqual(float(cache_timeout), esttimeout, delta=1)
 
     def test_get_failed_connection_mid_request(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -365,18 +378,17 @@ class TestMemcached(unittest.TestCase):
         # force the logging through the DebugLogger instead of the nose
         # handler. This will use stdout, so we can assert that no stack trace
         # is logged.
-        logger = debug_logger()
-        with patch("sys.stdout", fake_stdout),\
-                patch('swift.common.memcached.logging', logger):
+        with patch("sys.stdout", fake_stdout):
             mock.read_return_empty_str = True
             self.assertIsNone(memcache_client.get('some_key'))
-        log_lines = logger.get_lines_for_level('error')
+        log_lines = self.logger.get_lines_for_level('error')
         self.assertIn('Error talking to memcached', log_lines[0])
         self.assertFalse(log_lines[1:])
         self.assertNotIn("Traceback", fake_stdout.getvalue())
 
     def test_incr(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -396,7 +408,8 @@ class TestMemcached(unittest.TestCase):
         self.assertTrue(mock.close_called)
 
     def test_incr_failed_connection_mid_request(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -411,19 +424,18 @@ class TestMemcached(unittest.TestCase):
         # force the logging through the DebugLogger instead of the nose
         # handler. This will use stdout, so we can assert that no stack trace
         # is logged.
-        logger = debug_logger()
-        with patch("sys.stdout", fake_stdout), \
-                patch('swift.common.memcached.logging', logger):
+        with patch("sys.stdout", fake_stdout):
             mock.read_return_empty_str = True
             self.assertRaises(memcached.MemcacheConnectionError,
                               memcache_client.incr, 'some_key', delta=1)
-        log_lines = logger.get_lines_for_level('error')
+        log_lines = self.logger.get_lines_for_level('error')
         self.assertIn('Error talking to memcached', log_lines[0])
         self.assertFalse(log_lines[1:])
         self.assertNotIn('Traceback', fake_stdout.getvalue())
 
     def test_incr_w_timeout(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -455,7 +467,8 @@ class TestMemcached(unittest.TestCase):
         self.assertEqual(mock.cache, {cache_key: (b'0', b'0', b'10')})
 
     def test_decr(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -473,7 +486,7 @@ class TestMemcached(unittest.TestCase):
 
     def test_retry(self):
         memcache_client = memcached.MemcacheRing(
-            ['1.2.3.4:11211', '1.2.3.5:11211'])
+            ['1.2.3.4:11211', '1.2.3.5:11211'], logger=self.logger)
         mock1 = ExplodingMockMemcached()
         mock2 = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
@@ -500,7 +513,8 @@ class TestMemcached(unittest.TestCase):
                          [])
 
     def test_delete(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -510,7 +524,8 @@ class TestMemcached(unittest.TestCase):
         self.assertIsNone(memcache_client.get('some_key'))
 
     def test_multi(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -560,7 +575,8 @@ class TestMemcached(unittest.TestCase):
 
     def test_multi_delete(self):
         memcache_client = memcached.MemcacheRing(['1.2.3.4:11211',
-                                                  '1.2.3.5:11211'])
+                                                  '1.2.3.5:11211'],
+                                                 logger=self.logger)
         mock1 = MockMemcached()
         mock2 = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
@@ -598,7 +614,8 @@ class TestMemcached(unittest.TestCase):
 
     def test_serialization(self):
         memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
-                                                 allow_pickle=True)
+                                                 allow_pickle=True,
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -643,7 +660,8 @@ class TestMemcached(unittest.TestCase):
             mock_sock.connect = wait_connect
 
             memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
-                                                     connect_timeout=10)
+                                                     connect_timeout=10,
+                                                     logger=self.logger)
             # sanity
             self.assertEqual(1, len(memcache_client._client_cache))
             for server, pool in memcache_client._client_cache.items():
@@ -702,7 +720,8 @@ class TestMemcached(unittest.TestCase):
             memcache_client = memcached.MemcacheRing(['1.2.3.4:11211',
                                                       '1.2.3.5:11211'],
                                                      io_timeout=0.5,
-                                                     pool_timeout=0.1)
+                                                     pool_timeout=0.1,
+                                                     logger=self.logger)
 
             # Hand out a couple slow connections to 1.2.3.5, leaving 1.2.3.4
             # fast. All ten (10) clients should try to talk to .5 first, and
diff -pruN 2.25.0-2/test/unit/common/test_swob.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_swob.py
--- 2.25.0-2/test/unit/common/test_swob.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_swob.py	2020-07-06 17:03:50.000000000 +0000
@@ -914,6 +914,22 @@ class TestRequest(unittest.TestCase):
         self.assertEqual(used_req[0].path, '/hi/there')
         self.assertEqual(resp.status_int, 200)
 
+    def test_wsgify_method(self):
+        class _wsgi_class(object):
+            def __init__(self):
+                self.used_req = []
+
+            @swob.wsgify
+            def __call__(self, req):
+                self.used_req.append(req)
+                return swob.Response(b'200 OK')
+
+        req = swob.Request.blank('/hi/there')
+        handler = _wsgi_class()
+        resp = req.get_response(handler)
+        self.assertIs(handler.used_req[0].environ, req.environ)
+        self.assertEqual(resp.status_int, 200)
+
     def test_wsgify_raise(self):
         used_req = []
 
diff -pruN 2.25.0-2/test/unit/common/test_utils.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_utils.py
--- 2.25.0-2/test/unit/common/test_utils.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/common/test_utils.py	2020-07-06 17:03:50.000000000 +0000
@@ -44,6 +44,7 @@ import sys
 import json
 import math
 import inspect
+import warnings
 
 import six
 from six import StringIO
@@ -6079,6 +6080,136 @@ class TestAuditLocationGenerator(unittes
             self.assertEqual(list(locations),
                              [(obj_path, "drive", "partition2")])
 
+    def test_hooks(self):
+        with temptree([]) as tmpdir:
+            logger = FakeLogger()
+            data = os.path.join(tmpdir, "drive", "data")
+            os.makedirs(data)
+            partition = os.path.join(data, "partition1")
+            os.makedirs(partition)
+            suffix = os.path.join(partition, "suffix1")
+            os.makedirs(suffix)
+            hash_path = os.path.join(suffix, "hash1")
+            os.makedirs(hash_path)
+            obj_path = os.path.join(hash_path, "obj1.dat")
+            with open(obj_path, "w"):
+                pass
+            meta_path = os.path.join(hash_path, "obj1.meta")
+            with open(meta_path, "w"):
+                pass
+            hook_pre_device = MagicMock()
+            hook_post_device = MagicMock()
+            hook_pre_partition = MagicMock()
+            hook_post_partition = MagicMock()
+            hook_pre_suffix = MagicMock()
+            hook_post_suffix = MagicMock()
+            hook_pre_hash = MagicMock()
+            hook_post_hash = MagicMock()
+            locations = utils.audit_location_generator(
+                tmpdir, "data", ".dat", mount_check=False, logger=logger,
+                hook_pre_device=hook_pre_device,
+                hook_post_device=hook_post_device,
+                hook_pre_partition=hook_pre_partition,
+                hook_post_partition=hook_post_partition,
+                hook_pre_suffix=hook_pre_suffix,
+                hook_post_suffix=hook_post_suffix,
+                hook_pre_hash=hook_pre_hash,
+                hook_post_hash=hook_post_hash
+            )
+            list(locations)
+            hook_pre_device.assert_called_once_with(os.path.join(tmpdir,
+                                                                 "drive"))
+            hook_post_device.assert_called_once_with(os.path.join(tmpdir,
+                                                                  "drive"))
+            hook_pre_partition.assert_called_once_with(partition)
+            hook_post_partition.assert_called_once_with(partition)
+            hook_pre_suffix.assert_called_once_with(suffix)
+            hook_post_suffix.assert_called_once_with(suffix)
+            hook_pre_hash.assert_called_once_with(hash_path)
+            hook_post_hash.assert_called_once_with(hash_path)
+
+    def test_filters(self):
+        with temptree([]) as tmpdir:
+            logger = FakeLogger()
+            data = os.path.join(tmpdir, "drive", "data")
+            os.makedirs(data)
+            partition = os.path.join(data, "partition1")
+            os.makedirs(partition)
+            suffix = os.path.join(partition, "suffix1")
+            os.makedirs(suffix)
+            hash_path = os.path.join(suffix, "hash1")
+            os.makedirs(hash_path)
+            obj_path = os.path.join(hash_path, "obj1.dat")
+            with open(obj_path, "w"):
+                pass
+            meta_path = os.path.join(hash_path, "obj1.meta")
+            with open(meta_path, "w"):
+                pass
+
+            def audit_location_generator(**kwargs):
+                return utils.audit_location_generator(
+                    tmpdir, "data", ".dat", mount_check=False, logger=logger,
+                    **kwargs)
+
+            # Return the list of devices
+
+            with patch('os.listdir', side_effect=os.listdir) as m_listdir:
+                # devices_filter
+                m_listdir.reset_mock()
+                devices_filter = MagicMock(return_value=["drive"])
+                list(audit_location_generator(devices_filter=devices_filter))
+                devices_filter.assert_called_once_with(tmpdir, ["drive"])
+                self.assertIn(((data,),), m_listdir.call_args_list)
+
+                m_listdir.reset_mock()
+                devices_filter = MagicMock(return_value=[])
+                list(audit_location_generator(devices_filter=devices_filter))
+                devices_filter.assert_called_once_with(tmpdir, ["drive"])
+                self.assertNotIn(((data,),), m_listdir.call_args_list)
+
+                # partitions_filter
+                m_listdir.reset_mock()
+                partitions_filter = MagicMock(return_value=["partition1"])
+                list(audit_location_generator(
+                    partitions_filter=partitions_filter))
+                partitions_filter.assert_called_once_with(data,
+                                                          ["partition1"])
+                self.assertIn(((partition,),), m_listdir.call_args_list)
+
+                m_listdir.reset_mock()
+                partitions_filter = MagicMock(return_value=[])
+                list(audit_location_generator(
+                    partitions_filter=partitions_filter))
+                partitions_filter.assert_called_once_with(data,
+                                                          ["partition1"])
+                self.assertNotIn(((partition,),), m_listdir.call_args_list)
+
+                # suffixes_filter
+                m_listdir.reset_mock()
+                suffixes_filter = MagicMock(return_value=["suffix1"])
+                list(audit_location_generator(suffixes_filter=suffixes_filter))
+                suffixes_filter.assert_called_once_with(partition, ["suffix1"])
+                self.assertIn(((suffix,),), m_listdir.call_args_list)
+
+                m_listdir.reset_mock()
+                suffixes_filter = MagicMock(return_value=[])
+                list(audit_location_generator(suffixes_filter=suffixes_filter))
+                suffixes_filter.assert_called_once_with(partition, ["suffix1"])
+                self.assertNotIn(((suffix,),), m_listdir.call_args_list)
+
+                # hashes_filter
+                m_listdir.reset_mock()
+                hashes_filter = MagicMock(return_value=["hash1"])
+                list(audit_location_generator(hashes_filter=hashes_filter))
+                hashes_filter.assert_called_once_with(suffix, ["hash1"])
+                self.assertIn(((hash_path,),), m_listdir.call_args_list)
+
+                m_listdir.reset_mock()
+                hashes_filter = MagicMock(return_value=[])
+                list(audit_location_generator(hashes_filter=hashes_filter))
+                hashes_filter.assert_called_once_with(suffix, ["hash1"])
+                self.assertNotIn(((hash_path,),), m_listdir.call_args_list)
+
 
 class TestGreenAsyncPile(unittest.TestCase):
 
@@ -6476,6 +6607,16 @@ class TestParseContentDisposition(unitte
         self.assertEqual(attrs, {'name': 'somefile', 'filename': 'test.html'})
 
 
+class TestGetExpirerContainer(unittest.TestCase):
+
+    @mock.patch.object(utils, 'hash_path', return_value=hex(101)[2:])
+    def test_get_expirer_container(self, mock_hash_path):
+        container = utils.get_expirer_container(1234, 20, 'a', 'c', 'o')
+        self.assertEqual(container, '0000001219')
+        container = utils.get_expirer_container(1234, 200, 'a', 'c', 'o')
+        self.assertEqual(container, '0000001199')
+
+
 class TestIterMultipartMimeDocuments(unittest.TestCase):
 
     def test_bad_start(self):
@@ -7223,7 +7364,8 @@ class TestShardRange(unittest.TestCase):
                       upper='', object_count=0, bytes_used=0,
                       meta_timestamp=ts_1.internal, deleted=0,
                       state=utils.ShardRange.FOUND,
-                      state_timestamp=ts_1.internal, epoch=None)
+                      state_timestamp=ts_1.internal, epoch=None,
+                      reported=0)
         assert_initialisation_ok(dict(empty_run, name='a/c', timestamp=ts_1),
                                  expect)
         assert_initialisation_ok(dict(name='a/c', timestamp=ts_1), expect)
@@ -7232,11 +7374,13 @@ class TestShardRange(unittest.TestCase):
                         upper='u', object_count=2, bytes_used=10,
                         meta_timestamp=ts_2, deleted=0,
                         state=utils.ShardRange.CREATED,
-                        state_timestamp=ts_3.internal, epoch=ts_4)
+                        state_timestamp=ts_3.internal, epoch=ts_4,
+                        reported=0)
         expect.update({'lower': 'l', 'upper': 'u', 'object_count': 2,
                        'bytes_used': 10, 'meta_timestamp': ts_2.internal,
                        'state': utils.ShardRange.CREATED,
-                       'state_timestamp': ts_3.internal, 'epoch': ts_4})
+                       'state_timestamp': ts_3.internal, 'epoch': ts_4,
+                       'reported': 0})
         assert_initialisation_ok(good_run.copy(), expect)
 
         # obj count and bytes used as int strings
@@ -7254,6 +7398,11 @@ class TestShardRange(unittest.TestCase):
         assert_initialisation_ok(good_deleted,
                                  dict(expect, deleted=1))
 
+        good_reported = good_run.copy()
+        good_reported['reported'] = 1
+        assert_initialisation_ok(good_reported,
+                                 dict(expect, reported=1))
+
         assert_initialisation_fails(dict(good_run, timestamp='water balloon'))
 
         assert_initialisation_fails(
@@ -7292,7 +7441,7 @@ class TestShardRange(unittest.TestCase):
             'upper': upper, 'object_count': 10, 'bytes_used': 100,
             'meta_timestamp': ts_2.internal, 'deleted': 0,
             'state': utils.ShardRange.FOUND, 'state_timestamp': ts_3.internal,
-            'epoch': ts_4}
+            'epoch': ts_4, 'reported': 0}
         self.assertEqual(expected, sr_dict)
         self.assertIsInstance(sr_dict['lower'], six.string_types)
         self.assertIsInstance(sr_dict['upper'], six.string_types)
@@ -7307,6 +7456,14 @@ class TestShardRange(unittest.TestCase):
         for key in sr_dict:
             bad_dict = dict(sr_dict)
             bad_dict.pop(key)
+            if key == 'reported':
+                # This was added after the fact, and we need to be able to eat
+                # data from old servers
+                utils.ShardRange.from_dict(bad_dict)
+                utils.ShardRange(**bad_dict)
+                continue
+
+            # The rest were present from the beginning
             with self.assertRaises(KeyError):
                 utils.ShardRange.from_dict(bad_dict)
             # But __init__ still (generally) works!
@@ -7585,8 +7742,10 @@ class TestShardRange(unittest.TestCase):
         expected = u'\N{SNOWMAN}'
         if six.PY2:
             expected = expected.encode('utf-8')
-        do_test(u'\N{SNOWMAN}', expected)
-        do_test(u'\N{SNOWMAN}'.encode('utf-8'), expected)
+        with warnings.catch_warnings(record=True) as captured_warnings:
+            do_test(u'\N{SNOWMAN}', expected)
+            do_test(u'\N{SNOWMAN}'.encode('utf-8'), expected)
+        self.assertFalse(captured_warnings)
 
         sr = utils.ShardRange('a/c', utils.Timestamp.now(), 'b', 'y')
         sr.lower = ''
@@ -7633,8 +7792,10 @@ class TestShardRange(unittest.TestCase):
         expected = u'\N{SNOWMAN}'
         if six.PY2:
             expected = expected.encode('utf-8')
-        do_test(u'\N{SNOWMAN}', expected)
-        do_test(u'\N{SNOWMAN}'.encode('utf-8'), expected)
+        with warnings.catch_warnings(record=True) as captured_warnings:
+            do_test(u'\N{SNOWMAN}', expected)
+            do_test(u'\N{SNOWMAN}'.encode('utf-8'), expected)
+        self.assertFalse(captured_warnings)
 
         sr = utils.ShardRange('a/c', utils.Timestamp.now(), 'b', 'y')
         sr.upper = ''
diff -pruN 2.25.0-2/test/unit/container/test_backend.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/container/test_backend.py
--- 2.25.0-2/test/unit/container/test_backend.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/container/test_backend.py	2020-07-06 17:03:50.000000000 +0000
@@ -28,6 +28,7 @@ from contextlib import contextmanager
 import sqlite3
 import pickle
 import json
+import itertools
 
 import six
 
@@ -558,6 +559,98 @@ class TestContainerBroker(unittest.TestC
         broker.reclaim(Timestamp.now().internal, time())
         broker.delete_db(Timestamp.now().internal)
 
+    def test_batch_reclaim(self):
+        num_of_objects = 60
+        obj_specs = []
+        now = time()
+        top_of_the_minute = now - (now % 60)
+        c = itertools.cycle([True, False])
+        for m, is_deleted in six.moves.zip(range(num_of_objects), c):
+            offset = top_of_the_minute - (m * 60)
+            obj_specs.append((Timestamp(offset), is_deleted))
+        random.seed(now)
+        random.shuffle(obj_specs)
+        policy_indexes = list(p.idx for p in POLICIES)
+        broker = ContainerBroker(':memory:', account='test_account',
+                                 container='test_container')
+        broker.initialize(Timestamp('1').internal, 0)
+        for i, obj_spec in enumerate(obj_specs):
+            # with object12 before object2 and shuffled ts.internal we
+            # shouldn't be able to accidently rely on any implicit ordering
+            obj_name = 'object%s' % i
+            pidx = random.choice(policy_indexes)
+            ts, is_deleted = obj_spec
+            if is_deleted:
+                broker.delete_object(obj_name, ts.internal, pidx)
+            else:
+                broker.put_object(obj_name, ts.internal, 0, 'text/plain',
+                                  'etag', storage_policy_index=pidx)
+
+        def count_reclaimable(conn, reclaim_age):
+            return conn.execute(
+                "SELECT count(*) FROM object "
+                "WHERE deleted = 1 AND created_at < ?", (reclaim_age,)
+            ).fetchone()[0]
+
+        # This is intended to divide the set of timestamps exactly in half
+        # regardless of the value of now
+        reclaim_age = top_of_the_minute + 1 - (num_of_objects / 2 * 60)
+        with broker.get() as conn:
+            self.assertEqual(count_reclaimable(conn, reclaim_age),
+                             num_of_objects / 4)
+
+        orig__reclaim = broker._reclaim
+        trace = []
+
+        def tracing_reclaim(conn, age_timestamp, marker):
+            trace.append((age_timestamp, marker,
+                          count_reclaimable(conn, age_timestamp)))
+            return orig__reclaim(conn, age_timestamp, marker)
+
+        with mock.patch.object(broker, '_reclaim', new=tracing_reclaim), \
+                mock.patch('swift.common.db.RECLAIM_PAGE_SIZE', 10):
+            broker.reclaim(reclaim_age, reclaim_age)
+
+        with broker.get() as conn:
+            self.assertEqual(count_reclaimable(conn, reclaim_age), 0)
+        self.assertEqual(3, len(trace), trace)
+        self.assertEqual([age for age, marker, reclaimable in trace],
+                         [reclaim_age] * 3)
+        # markers are in-order
+        self.assertLess(trace[0][1], trace[1][1])
+        self.assertLess(trace[1][1], trace[2][1])
+        # reclaimable count gradually decreases
+        # generally, count1 > count2 > count3, but because of the randomness
+        # we may occassionally have count1 == count2 or count2 == count3
+        self.assertGreaterEqual(trace[0][2], trace[1][2])
+        self.assertGreaterEqual(trace[1][2], trace[2][2])
+        # technically, this might happen occasionally, but *really* rarely
+        self.assertTrue(trace[0][2] > trace[1][2] or
+                        trace[1][2] > trace[2][2])
+
+    def test_reclaim_with_duplicate_names(self):
+        broker = ContainerBroker(':memory:', account='test_account',
+                                 container='test_container')
+        broker.initialize(Timestamp('1').internal, 0)
+        now = time()
+        ages_ago = Timestamp(now - (3 * 7 * 24 * 60 * 60))
+        for i in range(10):
+            for spidx in range(10):
+                obj_name = 'object%s' % i
+                broker.delete_object(obj_name, ages_ago.internal, spidx)
+        reclaim_age = now - (2 * 7 * 24 * 60 * 60)
+        with broker.get() as conn:
+            self.assertEqual(conn.execute(
+                "SELECT count(*) FROM object "
+                "WHERE created_at < ?", (reclaim_age,)
+            ).fetchone()[0], 100)
+        with mock.patch('swift.common.db.RECLAIM_PAGE_SIZE', 10):
+            broker.reclaim(reclaim_age, reclaim_age)
+        with broker.get() as conn:
+            self.assertEqual(conn.execute(
+                "SELECT count(*) FROM object "
+            ).fetchone()[0], 0)
+
     @with_tempdir
     def test_reclaim_deadlock(self, tempdir):
         db_path = os.path.join(
@@ -642,10 +735,12 @@ class TestContainerBroker(unittest.TestC
         self.assertEqual(info['put_timestamp'], start.internal)
         self.assertTrue(Timestamp(info['created_at']) >= start)
         self.assertEqual(info['delete_timestamp'], '0')
-        if self.__class__ in (TestContainerBrokerBeforeMetadata,
-                              TestContainerBrokerBeforeXSync,
-                              TestContainerBrokerBeforeSPI,
-                              TestContainerBrokerBeforeShardRanges):
+        if self.__class__ in (
+                TestContainerBrokerBeforeMetadata,
+                TestContainerBrokerBeforeXSync,
+                TestContainerBrokerBeforeSPI,
+                TestContainerBrokerBeforeShardRanges,
+                TestContainerBrokerBeforeShardRangeReportedColumn):
             self.assertEqual(info['status_changed_at'], '0')
         else:
             self.assertEqual(info['status_changed_at'],
@@ -932,6 +1027,8 @@ class TestContainerBroker(unittest.TestC
                 "SELECT object_count FROM shard_range").fetchone()[0], 0)
             self.assertEqual(conn.execute(
                 "SELECT bytes_used FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 0)
 
         # Reput same event
         broker.merge_shard_ranges(
@@ -957,6 +1054,64 @@ class TestContainerBroker(unittest.TestC
                 "SELECT object_count FROM shard_range").fetchone()[0], 0)
             self.assertEqual(conn.execute(
                 "SELECT bytes_used FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 0)
+
+        # Mark it as reported
+        broker.merge_shard_ranges(
+            ShardRange('"a/{<shardrange \'&\' name>}"', timestamp,
+                       'low', 'up', meta_timestamp=meta_timestamp,
+                       reported=True))
+        with broker.get() as conn:
+            self.assertEqual(conn.execute(
+                "SELECT name FROM shard_range").fetchone()[0],
+                '"a/{<shardrange \'&\' name>}"')
+            self.assertEqual(conn.execute(
+                "SELECT timestamp FROM shard_range").fetchone()[0],
+                timestamp)
+            self.assertEqual(conn.execute(
+                "SELECT meta_timestamp FROM shard_range").fetchone()[0],
+                meta_timestamp)
+            self.assertEqual(conn.execute(
+                "SELECT lower FROM shard_range").fetchone()[0], 'low')
+            self.assertEqual(conn.execute(
+                "SELECT upper FROM shard_range").fetchone()[0], 'up')
+            self.assertEqual(conn.execute(
+                "SELECT deleted FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT object_count FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT bytes_used FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 1)
+
+        # Reporting latches it
+        broker.merge_shard_ranges(
+            ShardRange('"a/{<shardrange \'&\' name>}"', timestamp,
+                       'low', 'up', meta_timestamp=meta_timestamp,
+                       reported=False))
+        with broker.get() as conn:
+            self.assertEqual(conn.execute(
+                "SELECT name FROM shard_range").fetchone()[0],
+                '"a/{<shardrange \'&\' name>}"')
+            self.assertEqual(conn.execute(
+                "SELECT timestamp FROM shard_range").fetchone()[0],
+                timestamp)
+            self.assertEqual(conn.execute(
+                "SELECT meta_timestamp FROM shard_range").fetchone()[0],
+                meta_timestamp)
+            self.assertEqual(conn.execute(
+                "SELECT lower FROM shard_range").fetchone()[0], 'low')
+            self.assertEqual(conn.execute(
+                "SELECT upper FROM shard_range").fetchone()[0], 'up')
+            self.assertEqual(conn.execute(
+                "SELECT deleted FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT object_count FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT bytes_used FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 1)
 
         # Put new event
         timestamp = next(self.ts).internal
@@ -984,11 +1139,14 @@ class TestContainerBroker(unittest.TestC
                 "SELECT object_count FROM shard_range").fetchone()[0], 1)
             self.assertEqual(conn.execute(
                 "SELECT bytes_used FROM shard_range").fetchone()[0], 2)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 0)
 
         # Put old event
         broker.merge_shard_ranges(
             ShardRange('"a/{<shardrange \'&\' name>}"', old_put_timestamp,
-                       'lower', 'upper', 1, 2, meta_timestamp=meta_timestamp))
+                       'lower', 'upper', 1, 2, meta_timestamp=meta_timestamp,
+                       reported=True))
         with broker.get() as conn:
             self.assertEqual(conn.execute(
                 "SELECT name FROM shard_range").fetchone()[0],
@@ -1009,6 +1167,8 @@ class TestContainerBroker(unittest.TestC
                 "SELECT object_count FROM shard_range").fetchone()[0], 1)
             self.assertEqual(conn.execute(
                 "SELECT bytes_used FROM shard_range").fetchone()[0], 2)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 0)
 
         # Put old delete event
         broker.merge_shard_ranges(
@@ -1885,10 +2045,12 @@ class TestContainerBroker(unittest.TestC
         self.assertEqual(info['hash'], '00000000000000000000000000000000')
         self.assertEqual(info['put_timestamp'], Timestamp(1).internal)
         self.assertEqual(info['delete_timestamp'], '0')
-        if self.__class__ in (TestContainerBrokerBeforeMetadata,
-                              TestContainerBrokerBeforeXSync,
-                              TestContainerBrokerBeforeSPI,
-                              TestContainerBrokerBeforeShardRanges):
+        if self.__class__ in (
+                TestContainerBrokerBeforeMetadata,
+                TestContainerBrokerBeforeXSync,
+                TestContainerBrokerBeforeSPI,
+                TestContainerBrokerBeforeShardRanges,
+                TestContainerBrokerBeforeShardRangeReportedColumn):
             self.assertEqual(info['status_changed_at'], '0')
         else:
             self.assertEqual(info['status_changed_at'],
@@ -3182,10 +3344,12 @@ class TestContainerBroker(unittest.TestC
         self.assertEqual(0, info['storage_policy_index'])  # sanity check
         self.assertEqual(0, info['object_count'])
         self.assertEqual(0, info['bytes_used'])
-        if self.__class__ in (TestContainerBrokerBeforeMetadata,
-                              TestContainerBrokerBeforeXSync,
-                              TestContainerBrokerBeforeSPI,
-                              TestContainerBrokerBeforeShardRanges):
+        if self.__class__ in (
+                TestContainerBrokerBeforeMetadata,
+                TestContainerBrokerBeforeXSync,
+                TestContainerBrokerBeforeSPI,
+                TestContainerBrokerBeforeShardRanges,
+                TestContainerBrokerBeforeShardRangeReportedColumn):
             self.assertEqual(info['status_changed_at'], '0')
         else:
             self.assertEqual(timestamp.internal, info['status_changed_at'])
@@ -5222,6 +5386,75 @@ class TestContainerBrokerBeforeShardRang
                             FROM shard_range''')
 
 
+def pre_reported_create_shard_range_table(self, conn):
+    """
+    Copied from ContainerBroker before the
+    reported column was added; used for testing with
+    TestContainerBrokerBeforeShardRangeReportedColumn.
+
+    Create a shard_range table with no 'reported' column.
+
+    :param conn: DB connection object
+    """
+    conn.execute("""
+        CREATE TABLE shard_range (
+            ROWID INTEGER PRIMARY KEY AUTOINCREMENT,
+            name TEXT,
+            timestamp TEXT,
+            lower TEXT,
+            upper TEXT,
+            object_count INTEGER DEFAULT 0,
+            bytes_used INTEGER DEFAULT 0,
+            meta_timestamp TEXT,
+            deleted INTEGER DEFAULT 0,
+            state INTEGER,
+            state_timestamp TEXT,
+            epoch TEXT
+        );
+    """)
+
+    conn.execute("""
+        CREATE TRIGGER shard_range_update BEFORE UPDATE ON shard_range
+        BEGIN
+            SELECT RAISE(FAIL, 'UPDATE not allowed; DELETE and INSERT');
+        END;
+    """)
+
+
+class TestContainerBrokerBeforeShardRangeReportedColumn(
+        ContainerBrokerMigrationMixin, TestContainerBroker):
+    """
+    Tests for ContainerBroker against databases created
+    before the shard_ranges table was added.
+    """
+    # *grumble grumble* This should include container_info/policy_stat :-/
+    expected_db_tables = {'outgoing_sync', 'incoming_sync', 'object',
+                          'sqlite_sequence', 'container_stat', 'shard_range'}
+
+    def setUp(self):
+        super(TestContainerBrokerBeforeShardRangeReportedColumn,
+              self).setUp()
+        ContainerBroker.create_shard_range_table = \
+            pre_reported_create_shard_range_table
+
+        broker = ContainerBroker(':memory:', account='a', container='c')
+        broker.initialize(Timestamp('1').internal, 0)
+        with self.assertRaises(sqlite3.DatabaseError) as raised, \
+                broker.get() as conn:
+            conn.execute('''SELECT reported
+                            FROM shard_range''')
+        self.assertIn('no such column: reported', str(raised.exception))
+
+    def tearDown(self):
+        super(TestContainerBrokerBeforeShardRangeReportedColumn,
+              self).tearDown()
+        broker = ContainerBroker(':memory:', account='a', container='c')
+        broker.initialize(Timestamp('1').internal, 0)
+        with broker.get() as conn:
+            conn.execute('''SELECT reported
+                            FROM shard_range''')
+
+
 class TestUpdateNewItemFromExisting(unittest.TestCase):
     # TODO: add test scenarios that have swift_bytes in content_type
     t0 = '1234567890.00000'
diff -pruN 2.25.0-2/test/unit/container/test_server.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/container/test_server.py
--- 2.25.0-2/test/unit/container/test_server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/container/test_server.py	2020-07-06 17:03:50.000000000 +0000
@@ -2380,15 +2380,17 @@ class TestContainerController(unittest.T
                    'X-Container-Sysmeta-Test': 'set',
                    'X-Container-Meta-Test': 'persisted'}
 
-        # PUT shard range to non-existent container with non-autocreate prefix
-        req = Request.blank('/sda1/p/a/c', method='PUT', headers=headers,
-                            body=json.dumps([dict(shard_range)]))
+        # PUT shard range to non-existent container without autocreate flag
+        req = Request.blank(
+            '/sda1/p/.shards_a/shard_c', method='PUT', headers=headers,
+            body=json.dumps([dict(shard_range)]))
         resp = req.get_response(self.controller)
         self.assertEqual(404, resp.status_int)
 
-        # PUT shard range to non-existent container with autocreate prefix,
+        # PUT shard range to non-existent container with autocreate flag,
         # missing storage policy
         headers['X-Timestamp'] = next(ts_iter).internal
+        headers['X-Backend-Auto-Create'] = 't'
         req = Request.blank(
             '/sda1/p/.shards_a/shard_c', method='PUT', headers=headers,
             body=json.dumps([dict(shard_range)]))
@@ -2397,7 +2399,7 @@ class TestContainerController(unittest.T
         self.assertIn(b'X-Backend-Storage-Policy-Index header is required',
                       resp.body)
 
-        # PUT shard range to non-existent container with autocreate prefix
+        # PUT shard range to non-existent container with autocreate flag
         headers['X-Timestamp'] = next(ts_iter).internal
         policy_index = random.choice(POLICIES).idx
         headers['X-Backend-Storage-Policy-Index'] = str(policy_index)
@@ -2407,7 +2409,7 @@ class TestContainerController(unittest.T
         resp = req.get_response(self.controller)
         self.assertEqual(201, resp.status_int)
 
-        # repeat PUT of shard range to autocreated container - 204 response
+        # repeat PUT of shard range to autocreated container - 202 response
         headers['X-Timestamp'] = next(ts_iter).internal
         headers.pop('X-Backend-Storage-Policy-Index')  # no longer required
         req = Request.blank(
@@ -2416,7 +2418,7 @@ class TestContainerController(unittest.T
         resp = req.get_response(self.controller)
         self.assertEqual(202, resp.status_int)
 
-        # regular PUT to autocreated container - 204 response
+        # regular PUT to autocreated container - 202 response
         headers['X-Timestamp'] = next(ts_iter).internal
         req = Request.blank(
             '/sda1/p/.shards_a/shard_c', method='PUT',
@@ -4649,61 +4651,53 @@ class TestContainerController(unittest.T
                              "%d on param %s" % (resp.status_int, param))
 
     def test_put_auto_create(self):
-        headers = {'x-timestamp': Timestamp(1).internal,
-                   'x-size': '0',
-                   'x-content-type': 'text/plain',
-                   'x-etag': 'd41d8cd98f00b204e9800998ecf8427e'}
-
-        req = Request.blank('/sda1/p/a/c/o',
-                            environ={'REQUEST_METHOD': 'PUT'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
-
-        req = Request.blank('/sda1/p/.a/c/o',
-                            environ={'REQUEST_METHOD': 'PUT'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 201)
-
-        req = Request.blank('/sda1/p/a/.c/o',
-                            environ={'REQUEST_METHOD': 'PUT'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
+        def do_test(expected_status, path, extra_headers=None, body=None):
+            headers = {'x-timestamp': Timestamp(1).internal,
+                       'x-size': '0',
+                       'x-content-type': 'text/plain',
+                       'x-etag': 'd41d8cd98f00b204e9800998ecf8427e'}
+            if extra_headers:
+                headers.update(extra_headers)
+            req = Request.blank('/sda1/p/' + path,
+                                environ={'REQUEST_METHOD': 'PUT'},
+                                headers=headers, body=body)
+            resp = req.get_response(self.controller)
+            self.assertEqual(resp.status_int, expected_status)
 
-        req = Request.blank('/sda1/p/a/c/.o',
-                            environ={'REQUEST_METHOD': 'PUT'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
+        do_test(404, 'a/c/o')
+        do_test(404, '.a/c/o', {'X-Backend-Auto-Create': 'no'})
+        do_test(201, '.a/c/o')
+        do_test(404, 'a/.c/o')
+        do_test(404, 'a/c/.o')
+        do_test(201, 'a/c/o', {'X-Backend-Auto-Create': 'yes'})
+
+        do_test(404, '.shards_a/c/o')
+        create_shard_headers = {
+            'X-Backend-Record-Type': 'shard',
+            'X-Backend-Storage-Policy-Index': '0'}
+        do_test(404, '.shards_a/c', create_shard_headers, '[]')
+        create_shard_headers['X-Backend-Auto-Create'] = 't'
+        do_test(201, '.shards_a/c', create_shard_headers, '[]')
 
     def test_delete_auto_create(self):
-        headers = {'x-timestamp': Timestamp(1).internal}
-
-        req = Request.blank('/sda1/p/a/c/o',
-                            environ={'REQUEST_METHOD': 'DELETE'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
-
-        req = Request.blank('/sda1/p/.a/c/o',
-                            environ={'REQUEST_METHOD': 'DELETE'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 204)
-
-        req = Request.blank('/sda1/p/a/.c/o',
-                            environ={'REQUEST_METHOD': 'DELETE'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
+        def do_test(expected_status, path, extra_headers=None):
+            headers = {'x-timestamp': Timestamp(1).internal}
+            if extra_headers:
+                headers.update(extra_headers)
+            req = Request.blank('/sda1/p/' + path,
+                                environ={'REQUEST_METHOD': 'DELETE'},
+                                headers=headers)
+            resp = req.get_response(self.controller)
+            self.assertEqual(resp.status_int, expected_status)
 
-        req = Request.blank('/sda1/p/a/.c/.o',
-                            environ={'REQUEST_METHOD': 'DELETE'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
+        do_test(404, 'a/c/o')
+        do_test(404, '.a/c/o', {'X-Backend-Auto-Create': 'false'})
+        do_test(204, '.a/c/o')
+        do_test(404, 'a/.c/o')
+        do_test(404, 'a/.c/.o')
+        do_test(404, '.shards_a/c/o')
+        do_test(204, 'a/c/o', {'X-Backend-Auto-Create': 'true'})
+        do_test(204, '.shards_a/c/o', {'X-Backend-Auto-Create': 'true'})
 
     def test_content_type_on_HEAD(self):
         Request.blank('/sda1/p/a/o',
diff -pruN 2.25.0-2/test/unit/container/test_sharder.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/container/test_sharder.py
--- 2.25.0-2/test/unit/container/test_sharder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/container/test_sharder.py	2020-07-06 17:03:50.000000000 +0000
@@ -4189,6 +4189,7 @@ class TestSharder(BaseTestSharder):
         def capture_send(conn, data):
             bodies.append(data)
 
+        self.assertFalse(broker.get_own_shard_range().reported)  # sanity
         with self._mock_sharder() as sharder:
             with mocked_http_conn(204, 204, 204,
                                   give_send=capture_send) as mock_conn:
@@ -4198,6 +4199,7 @@ class TestSharder(BaseTestSharder):
             self.assertEqual('PUT', req['method'])
         self.assertEqual([expected_sent] * 3,
                          [json.loads(b) for b in bodies])
+        self.assertTrue(broker.get_own_shard_range().reported)
 
     def test_update_root_container_own_range(self):
         broker = self._make_broker()
@@ -4230,6 +4232,32 @@ class TestSharder(BaseTestSharder):
             with annotate_failure(state):
                 check_only_own_shard_range_sent(state)
 
+    def test_update_root_container_already_reported(self):
+        broker = self._make_broker()
+
+        def check_already_reported_not_sent(state):
+            own_shard_range = broker.get_own_shard_range()
+
+            own_shard_range.reported = True
+            self.assertTrue(own_shard_range.update_state(
+                state, state_timestamp=next(self.ts_iter)))
+            # Check that updating state clears the flag
+            self.assertFalse(own_shard_range.reported)
+
+            # If we claim to have already updated...
+            own_shard_range.reported = True
+            broker.merge_shard_ranges([own_shard_range])
+
+            # ... then there's nothing to send
+            with self._mock_sharder() as sharder:
+                with mocked_http_conn() as mock_conn:
+                    sharder._update_root_container(broker)
+            self.assertFalse(mock_conn.requests)
+
+        for state in ShardRange.STATES:
+            with annotate_failure(state):
+                check_already_reported_not_sent(state)
+
     def test_update_root_container_all_ranges(self):
         broker = self._make_broker()
         other_shard_ranges = self._make_shard_ranges((('', 'h'), ('h', '')))
diff -pruN 2.25.0-2/test/unit/obj/test_diskfile.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/obj/test_diskfile.py
--- 2.25.0-2/test/unit/obj/test_diskfile.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/obj/test_diskfile.py	2020-07-06 17:03:50.000000000 +0000
@@ -24,6 +24,7 @@ import mock
 import unittest
 import email
 import tempfile
+import threading
 import uuid
 import xattr
 import re
@@ -3705,6 +3706,91 @@ class DiskFileMixin(BaseDiskFileTestMixi
             # can close again
             writer.close()
 
+    def test_disk_file_concurrent_writes(self):
+        def threadA(df, events, errors):
+            try:
+                ts = self.ts()
+                with df.create() as writer:
+                    writer.write(b'dataA')
+                    writer.put({
+                        'X-Timestamp': ts.internal,
+                        'Content-Length': 5,
+                    })
+                    events[0].set()
+                    events[1].wait()
+                    writer.commit(ts)
+            except Exception as e:
+                errors.append(e)
+                raise
+
+        def threadB(df, events, errors):
+            try:
+                events[0].wait()
+                ts = self.ts()
+                with df.create() as writer:
+                    writer.write(b'dataB')
+                    writer.put({
+                        'X-Timestamp': ts.internal,
+                        'Content-Length': 5,
+                    })
+                    writer.commit(ts)
+                events[1].set()
+            except Exception as e:
+                errors.append(e)
+                raise
+
+        df = self._simple_get_diskfile()
+        events = [threading.Event(), threading.Event()]
+        errors = []
+
+        threads = [threading.Thread(target=tgt, args=(df, events, errors))
+                   for tgt in (threadA, threadB)]
+        for thread in threads:
+            thread.start()
+        for thread in threads:
+            thread.join()
+        self.assertFalse(errors)
+
+        with df.open(), open(df._data_file, 'rb') as fp:
+            self.assertEqual(b'dataB', fp.read())
+
+    def test_disk_file_concurrent_delete(self):
+        def threadA(df, events, errors):
+            try:
+                ts = self.ts()
+                with df.create() as writer:
+                    writer.write(b'dataA')
+                    writer.put({'X-Timestamp': ts.internal})
+                    events[0].set()
+                    events[1].wait()
+                    writer.commit(ts)
+            except Exception as e:
+                errors.append(e)
+                raise
+
+        def threadB(df, events, errors):
+            try:
+                events[0].wait()
+                df.delete(self.ts())
+                events[1].set()
+            except Exception as e:
+                errors.append(e)
+                raise
+
+        df = self._simple_get_diskfile()
+        events = [threading.Event(), threading.Event()]
+        errors = []
+
+        threads = [threading.Thread(target=tgt, args=(df, events, errors))
+                   for tgt in (threadA, threadB)]
+        for thread in threads:
+            thread.start()
+        for thread in threads:
+            thread.join()
+        self.assertFalse(errors)
+
+        self.assertRaises(DiskFileDeleted, df.open)
+
     def _get_open_disk_file(self, invalid_type=None, obj_name='o', fsize=1024,
                             csize=8, mark_deleted=False, prealloc=False,
                             ts=None, mount_check=False, extra_metadata=None,
diff -pruN 2.25.0-2/test/unit/proxy/controllers/test_account.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/controllers/test_account.py
--- 2.25.0-2/test/unit/proxy/controllers/test_account.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/controllers/test_account.py	2020-07-06 17:03:50.000000000 +0000
@@ -21,7 +21,8 @@ from swift.common.middleware.acl import
 from swift.proxy import server as proxy_server
 from swift.proxy.controllers.base import headers_to_account_info
 from swift.common import constraints
-from test.unit import fake_http_connect, FakeRing, FakeMemcache
+from test.unit import fake_http_connect, FakeRing, FakeMemcache, \
+    mocked_http_conn
 from swift.common.storage_policy import StoragePolicy
 from swift.common.request_helpers import get_sys_meta_prefix
 import swift.proxy.controllers.base
@@ -32,6 +33,9 @@ from test.unit import patch_policies
 
 @patch_policies([StoragePolicy(0, 'zero', True, object_ring=FakeRing())])
 class TestAccountController(unittest.TestCase):
+
+    ACCOUNT_REPLICAS = 3
+
     def setUp(self):
         self.app = proxy_server.Application(
             None, FakeMemcache(),
@@ -64,15 +68,32 @@ class TestAccountController(unittest.Tes
 
     def test_account_info_in_response_env(self):
         controller = proxy_server.AccountController(self.app, 'AUTH_bob')
-        with mock.patch('swift.proxy.controllers.base.http_connect',
-                        fake_http_connect(200, body='')):
-            req = Request.blank('/v1/AUTH_bob', {'PATH_INFO': '/v1/AUTH_bob'})
+        with mocked_http_conn(200) as mock_conn:
+            req = Request.blank('/v1/AUTH_bob')
             resp = controller.HEAD(req)
         self.assertEqual(2, resp.status_int // 100)
-        self.assertIn('account/AUTH_bob', resp.environ['swift.infocache'])
-        self.assertEqual(
-            headers_to_account_info(resp.headers),
-            resp.environ['swift.infocache']['account/AUTH_bob'])
+        self.assertEqual(['/AUTH_bob'],
+                         # requests are like /sdX/0/..
+                         [r['path'][6:] for r in mock_conn.requests])
+        info_cache = resp.environ['swift.infocache']
+        self.assertIn('account/AUTH_bob', info_cache)
+        header_info = headers_to_account_info(resp.headers)
+        self.assertEqual(header_info, info_cache['account/AUTH_bob'])
+
+        # The failure doesn't lead to cache eviction
+        errors = [500] * self.ACCOUNT_REPLICAS
+        with mocked_http_conn(*errors) as mock_conn:
+            req = Request.blank('/v1/AUTH_bob', {
+                'PATH_INFO': '/v1/AUTH_bob', 'swift.infocache': info_cache})
+            resp = controller.HEAD(req)
+        self.assertEqual(5, resp.status_int // 100)
+        self.assertEqual(['/AUTH_bob'] * self.ACCOUNT_REPLICAS,
+                         # requests are like /sdX/0/..
+                         [r['path'][6:] for r in mock_conn.requests])
+        self.assertIs(info_cache, resp.environ['swift.infocache'])
+        # The *old* header info is all still there
+        self.assertIn('account/AUTH_bob', info_cache)
+        self.assertEqual(header_info, info_cache['account/AUTH_bob'])
 
     def test_swift_owner(self):
         owner_headers = {
@@ -317,6 +338,9 @@ class TestAccountController(unittest.Tes
 @patch_policies(
     [StoragePolicy(0, 'zero', True, object_ring=FakeRing(replicas=4))])
 class TestAccountController4Replicas(TestAccountController):
+
+    ACCOUNT_REPLICAS = 4
+
     def setUp(self):
         self.app = proxy_server.Application(
             None,
diff -pruN 2.25.0-2/test/unit/proxy/controllers/test_base.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/controllers/test_base.py
--- 2.25.0-2/test/unit/proxy/controllers/test_base.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/controllers/test_base.py	2020-07-06 17:03:50.000000000 +0000
@@ -24,7 +24,8 @@ import six
 from swift.proxy.controllers.base import headers_to_container_info, \
     headers_to_account_info, headers_to_object_info, get_container_info, \
     get_cache_key, get_account_info, get_info, get_object_info, \
-    Controller, GetOrHeadHandler, bytes_to_skip
+    Controller, GetOrHeadHandler, bytes_to_skip, clear_info_cache, \
+    set_info_cache
 from swift.common.swob import Request, HTTPException, RESPONSE_REASONS, \
     bytes_to_wsgi
 from swift.common import exceptions
@@ -470,6 +471,36 @@ class TestFuncs(unittest.TestCase):
         resp = get_container_info(req.environ, 'xxx')
         self.assertEqual(resp['bytes'], 3867)
 
+    def test_info_clearing(self):
+        def check_in_cache(req, cache_key):
+            self.assertIn(cache_key, req.environ['swift.infocache'])
+            self.assertIn(cache_key, req.environ['swift.cache'].store)
+
+        def check_not_in_cache(req, cache_key):
+            self.assertNotIn(cache_key, req.environ['swift.infocache'])
+            self.assertNotIn(cache_key, req.environ['swift.cache'].store)
+
+        app = FakeApp(statuses=[200, 200])
+        acct_cache_key = get_cache_key("account")
+        cont_cache_key = get_cache_key("account", "cont")
+        req = Request.blank(
+            "/v1/account/cont", environ={"swift.cache": FakeCache()})
+        # populate caches
+        info = get_container_info(req.environ, app)
+        self.assertEqual(info['status'], 200)
+
+        check_in_cache(req, acct_cache_key)
+        check_in_cache(req, cont_cache_key)
+
+        clear_info_cache('app-is-unused', req.environ, 'account', 'cont')
+        check_in_cache(req, acct_cache_key)
+        check_not_in_cache(req, cont_cache_key)
+
+        # Can also use set_info_cache interface
+        set_info_cache('app-is-unused', req.environ, 'account', None, None)
+        check_not_in_cache(req, acct_cache_key)
+        check_not_in_cache(req, cont_cache_key)
+
     def test_get_account_info_swift_source(self):
         app = FakeApp()
         req = Request.blank("/v1/a", environ={'swift.cache': FakeCache()})
@@ -684,9 +715,11 @@ class TestFuncs(unittest.TestCase):
         base.account_name = 'a'
         base.container_name = 'c'
 
-        container_info = \
-            base.container_info(base.account_name,
-                                base.container_name)
+        with mock.patch('swift.proxy.controllers.base.'
+                        'http_connect', fake_http_connect(200)):
+            container_info = \
+                base.container_info(base.account_name,
+                                    base.container_name)
         self.assertEqual(container_info['status'], 0)
 
     def test_headers_to_account_info_missing(self):
diff -pruN 2.25.0-2/test/unit/proxy/controllers/test_container.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/controllers/test_container.py
--- 2.25.0-2/test/unit/proxy/controllers/test_container.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/controllers/test_container.py	2020-07-06 17:03:50.000000000 +0000
@@ -107,18 +107,34 @@ class TestContainerController(TestRingBa
 
     def test_container_info_got_cached(self):
         controller = proxy_server.ContainerController(self.app, 'a', 'c')
-        with mock.patch('swift.proxy.controllers.base.http_connect',
-                        fake_http_connect(200, 200, body='')):
-            req = Request.blank('/v1/a/c', {'PATH_INFO': '/v1/a/c'})
+        with mocked_http_conn(200, 200) as mock_conn:
+            req = Request.blank('/v1/a/c')
             resp = controller.HEAD(req)
         self.assertEqual(2, resp.status_int // 100)
+        self.assertEqual(['/a', '/a/c'],
+                         # requests are like /sdX/0/..
+                         [r['path'][6:] for r in mock_conn.requests])
         # Make sure it's in both swift.infocache and memcache
+        header_info = headers_to_container_info(resp.headers)
+        info_cache = resp.environ['swift.infocache']
         self.assertIn("container/a/c", resp.environ['swift.infocache'])
-        self.assertEqual(
-            headers_to_container_info(resp.headers),
-            resp.environ['swift.infocache']['container/a/c'])
-        from_memcache = self.app.memcache.get('container/a/c')
-        self.assertTrue(from_memcache)
+        self.assertEqual(header_info, info_cache['container/a/c'])
+        self.assertEqual(header_info, self.app.memcache.get('container/a/c'))
+
+        # The failure doesn't lead to cache eviction
+        errors = [500] * self.CONTAINER_REPLICAS * 2
+        with mocked_http_conn(*errors) as mock_conn:
+            req = Request.blank('/v1/a/c', {'swift.infocache': info_cache})
+            resp = controller.HEAD(req)
+        self.assertEqual(5, resp.status_int // 100)
+        self.assertEqual(['/a/c'] * self.CONTAINER_REPLICAS * 2,
+                         # requests are like /sdX/0/..
+                         [r['path'][6:] for r in mock_conn.requests])
+        self.assertIs(info_cache, resp.environ['swift.infocache'])
+        self.assertIn("container/a/c", resp.environ['swift.infocache'])
+        # NB: this is the *old* header_info, from the good req
+        self.assertEqual(header_info, info_cache['container/a/c'])
+        self.assertEqual(header_info, self.app.memcache.get('container/a/c'))
 
     @mock.patch('swift.proxy.controllers.container.clear_info_cache')
     @mock.patch.object(Controller, 'make_requests')
diff -pruN 2.25.0-2/test/unit/proxy/controllers/test_obj.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/controllers/test_obj.py
--- 2.25.0-2/test/unit/proxy/controllers/test_obj.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/controllers/test_obj.py	2020-07-06 17:03:50.000000000 +0000
@@ -51,7 +51,8 @@ from swift.common.storage_policy import
 from test.unit import FakeRing, FakeMemcache, fake_http_connect, \
     debug_logger, patch_policies, SlowBody, FakeStatus, \
     DEFAULT_TEST_EC_TYPE, encode_frag_archive_bodies, make_ec_object_stub, \
-    fake_ec_node_response, StubResponse, mocked_http_conn
+    fake_ec_node_response, StubResponse, mocked_http_conn, \
+    quiet_eventlet_exceptions
 from test.unit.proxy.test_server import node_error_count
 
 
@@ -1617,7 +1618,8 @@ class TestReplicatedObjController(Common
         # to the next node rather than hang the request
         headers = [{'X-Backend-Timestamp': 'not-a-timestamp'}, {}]
         codes = [200, 200]
-        with set_http_connect(*codes, headers=headers):
+        with quiet_eventlet_exceptions(), set_http_connect(
+                *codes, headers=headers):
             resp = req.get_response(self.app)
         self.assertEqual(resp.status_int, 200)
 
@@ -2280,6 +2282,18 @@ class TestECObjController(ECObjectContro
         self.assertIn('Accept-Ranges', resp.headers)
         self.assertNotIn('Connection', resp.headers)
 
+    def test_GET_not_found_when_404_newer(self):
+        # if proxy receives a 404, it keeps waiting for other connections until
+        # max number of nodes in hopes of finding an object, but if 404 is
+        # more recent than a 200, then it should ignore 200 and return 404
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+        rest = 2 * self.policy.object_ring.replica_count - 2
+        codes = [200, 404] + [200] * rest
+        ts_iter = iter([1, 2] + [1] * rest)
+        with set_http_connect(*codes, timestamps=ts_iter):
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 404)
+
     def _test_if_match(self, method):
         num_responses = self.policy.ec_ndata if method == 'GET' else 1
 
diff -pruN 2.25.0-2/test/unit/proxy/test_server.py 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/test_server.py
--- 2.25.0-2/test/unit/proxy/test_server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/test/unit/proxy/test_server.py	2020-07-06 17:03:50.000000000 +0000
@@ -7982,7 +7982,7 @@ class TestObjectDisconnectCleanup(unitte
                 continue
             device_path = os.path.join(_testdir, dev)
             for datadir in os.listdir(device_path):
-                if 'object' not in datadir:
+                if any(p in datadir for p in ('account', 'container')):
                     continue
                 data_path = os.path.join(device_path, datadir)
                 rmtree(data_path, ignore_errors=True)
diff -pruN 2.25.0-2/tools/playbooks/common/install_dependencies.yaml 2.25.1~git2020070613.2e001431f-0ubuntu1/tools/playbooks/common/install_dependencies.yaml
--- 2.25.0-2/tools/playbooks/common/install_dependencies.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/tools/playbooks/common/install_dependencies.yaml	2020-07-06 17:03:50.000000000 +0000
@@ -14,12 +14,13 @@
 # limitations under the License.
 - hosts: all
   become: true
+  roles:
+    - ensure-pip
   tasks:
     - name: installing dependencies
       yum: name={{ item }} state=present
       with_items:
         - python-pyeclib
-        - python-pip
         - python-nose
         - python-swiftclient
 
diff -pruN 2.25.0-2/tools/playbooks/dsvm/pre.yaml 2.25.1~git2020070613.2e001431f-0ubuntu1/tools/playbooks/dsvm/pre.yaml
--- 2.25.0-2/tools/playbooks/dsvm/pre.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/tools/playbooks/dsvm/pre.yaml	2020-07-06 17:03:50.000000000 +0000
@@ -7,3 +7,6 @@
       bindep_dir: "{{ zuul_work_dir }}"
     - test-setup
     - ensure-tox
+    - additional-tempauth-users
+    - additional-keystone-users
+    - dsvm-additional-middlewares
diff -pruN 2.25.0-2/tools/playbooks/multinode_setup/configure_loopback.yaml 2.25.1~git2020070613.2e001431f-0ubuntu1/tools/playbooks/multinode_setup/configure_loopback.yaml
--- 2.25.0-2/tools/playbooks/multinode_setup/configure_loopback.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/tools/playbooks/multinode_setup/configure_loopback.yaml	2020-07-06 17:03:50.000000000 +0000
@@ -31,7 +31,7 @@
         state: directory
 
     - name: mount /mnt/sdb1
-      mount: name=/mnt/sdb1 src=/srv/swift-disk fstype=xfs opts="loop,noatime,nodiratime,logbufs=8" dump=0 passno=0 state=mounted
+      mount: name=/mnt/sdb1 src=/srv/swift-disk fstype=xfs opts="loop,noatime" dump=0 passno=0 state=mounted
 
     - name: create sub-partitions
       file:
diff -pruN 2.25.0-2/tools/playbooks/saio_single_node_setup/setup_saio.yaml 2.25.1~git2020070613.2e001431f-0ubuntu1/tools/playbooks/saio_single_node_setup/setup_saio.yaml
--- 2.25.0-2/tools/playbooks/saio_single_node_setup/setup_saio.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/tools/playbooks/saio_single_node_setup/setup_saio.yaml	2020-07-06 17:03:50.000000000 +0000
@@ -29,7 +29,7 @@
       file: path=/mnt/sdb1 state=directory
 
     - name: mount /mnt/sdb1
-      mount: name=/mnt/sdb1 src=/srv/swift-disk fstype=xfs opts="loop,noatime,nodiratime,logbufs=8" dump=0 passno=0 state=mounted
+      mount: name=/mnt/sdb1 src=/srv/swift-disk fstype=xfs opts="loop,noatime" dump=0 passno=0 state=mounted
 
     - name: create sub-partitions
       file: >
@@ -153,10 +153,12 @@
       with_items: "{{ find_result.files }}"
 
     - name: set the options in the proxy config file
-      shell:
-        cmd: |
-          crudini --set /etc/swift/proxy-server.conf app:proxy-server node_timeout 20
-        executable: /bin/bash
+      ini_file:
+        path: /etc/swift/proxy-server.conf
+        section: app:proxy-server
+        option: node_timeout
+        value: 20
+        create: no
 
     - name: copy the SAIO scripts for resetting the environment
       command: cp -r {{ zuul.project.src_dir }}/doc/saio/bin /home/{{ ansible_ssh_user }}/bin creates=/home/{{ ansible_ssh_user }}/bin
diff -pruN 2.25.0-2/tox.ini 2.25.1~git2020070613.2e001431f-0ubuntu1/tox.ini
--- 2.25.0-2/tox.ini	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/tox.ini	2020-07-06 17:03:50.000000000 +0000
@@ -21,6 +21,12 @@ whitelist_externals = find
                       rm
 passenv = SWIFT_* *_proxy
 
+[testenv:py27]
+deps =
+  -c{toxinidir}/py2-constraints.txt
+  -r{toxinidir}/requirements.txt
+  -r{toxinidir}/test-requirements.txt
+
 [testenv:cover]
 setenv = VIRTUAL_ENV={envdir}
          NOSE_WITH_COVERAGE=1
@@ -30,6 +36,7 @@ setenv = VIRTUAL_ENV={envdir}
 
 [testenv:pep8]
 basepython = python2.7
+deps = {[testenv:py27]deps}
 commands =
   flake8 {posargs:swift test doc setup.py}
   flake8 --filename=swift* bin
@@ -51,52 +58,31 @@ commands = ./.functests {posargs}
 setenv = SWIFT_TEST_IN_PROCESS=1
          SWIFT_TEST_IN_PROCESS_CONF_LOADER=ec
 
-[testenv:func-s3api-py3]
-basepython = python3
-commands = ./.functests {posargs}
-setenv = SWIFT_TEST_IN_PROCESS=1
-         SWIFT_TEST_IN_PROCESS_CONF_LOADER=s3api
-
 [testenv:func-encryption-py3]
 basepython = python3
 commands = ./.functests {posargs}
 setenv = SWIFT_TEST_IN_PROCESS=1
          SWIFT_TEST_IN_PROCESS_CONF_LOADER=encryption
 
-[testenv:func-domain-remap-staticweb-py3]
-basepython = python3
-commands = ./.functests {posargs}
-setenv = SWIFT_TEST_IN_PROCESS=1
-         SWIFT_TEST_IN_PROCESS_CONF_LOADER=domain_remap_staticweb
-
 [testenv:func]
 basepython = python2.7
+deps = {[testenv:py27]deps}
 commands = ./.functests {posargs}
 
 [testenv:func-encryption]
 basepython = python2.7
+deps = {[testenv:py27]deps}
 commands = ./.functests {posargs}
 setenv = SWIFT_TEST_IN_PROCESS=1
          SWIFT_TEST_IN_PROCESS_CONF_LOADER=encryption
 
-[testenv:func-domain-remap-staticweb]
-basepython = python2.7
-commands = ./.functests {posargs}
-setenv = SWIFT_TEST_IN_PROCESS=1
-         SWIFT_TEST_IN_PROCESS_CONF_LOADER=domain_remap_staticweb
-
 [testenv:func-ec]
 basepython = python2.7
+deps = {[testenv:py27]deps}
 commands = ./.functests {posargs}
 setenv = SWIFT_TEST_IN_PROCESS=1
          SWIFT_TEST_IN_PROCESS_CONF_LOADER=ec
 
-[testenv:func-s3api]
-basepython = python2.7
-commands = ./.functests {posargs}
-setenv = SWIFT_TEST_IN_PROCESS=1
-         SWIFT_TEST_IN_PROCESS_CONF_LOADER=s3api
-
 [testenv:venv]
 commands = {posargs}
 
@@ -131,10 +117,11 @@ commands = bandit -c bandit.yaml -r swif
 # changes to enable:
 # E402: module level import not at top of file
 # E731 do not assign a lambda expression, use a def
+# E741 ambiguous variable name
 # Swift team needs to decide if they want to enable either of these:
 # W503: line break before binary operator
 # W504: line break after binary operator
-ignore = H101,H202,H301,H306,H404,H405,H501,W503,W504,E402,E731
+ignore = H101,H202,H301,H306,H404,H405,H501,W503,W504,E402,E731,E741
 exclude = .venv,.tox,dist,*egg
 filename = *.py,bin/*
 show-source = True
diff -pruN 2.25.0-2/.zuul.yaml 2.25.1~git2020070613.2e001431f-0ubuntu1/.zuul.yaml
--- 2.25.0-2/.zuul.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020070613.2e001431f-0ubuntu1/.zuul.yaml	2020-07-06 17:03:50.000000000 +0000
@@ -6,7 +6,7 @@
 
       It sets TMPDIR to an XFS mount point created via
       tools/test-setup.sh.
-    timeout: 2400
+    timeout: 3600
     vars:
       tox_environment:
         TMPDIR: '{{ ansible_env.HOME }}/xfstmp'
@@ -140,30 +140,6 @@
       tox_envlist: func-ec-py3
 
 - job:
-    name: swift-tox-func-domain-remap-staticweb-py37
-    parent: swift-tox-func-py37
-    description: |
-      Run functional tests for swift under cPython version 3.7.
-
-      Uses tox with the ``func-domain-remap-staticweb-py3`` environment.
-      It sets TMPDIR to an XFS mount point created via
-      tools/test-setup.sh.
-    vars:
-      tox_envlist: func-domain-remap-staticweb-py3
-
-- job:
-    name: swift-tox-func-s3api-py37
-    parent: swift-tox-func-py37
-    description: |
-      Run functional tests for swift under cPython version 3.7.
-
-      Uses tox with the ``func-s3api`` environment.
-      It sets TMPDIR to an XFS mount point created via
-      tools/test-setup.sh.
-    vars:
-      tox_envlist: func-s3api-py3
-
-- job:
     name: swift-tox-func-py27-centos-7
     parent: swift-tox-func-py27
     nodeset: centos-7
@@ -203,30 +179,6 @@
     nodeset: centos-7
 
 - job:
-    name: swift-tox-func-domain-remap-staticweb-py27
-    parent: swift-tox-base
-    description: |
-      Run functional tests for swift under cPython version 2.7.
-
-      Uses tox with the ``func-domain-remap-staticweb`` environment.
-      It sets TMPDIR to an XFS mount point created via
-      tools/test-setup.sh.
-    vars:
-      tox_envlist: func-domain-remap-staticweb
-
-- job:
-    name: swift-tox-func-s3api-py27
-    parent: swift-tox-base
-    description: |
-      Run functional tests for swift under cPython version 2.7.
-
-      Uses tox with the ``func-s3api`` environment.
-      It sets TMPDIR to an XFS mount point created via
-      tools/test-setup.sh.
-    vars:
-      tox_envlist: func-s3api
-
-- job:
     name: swift-dsvm-functional
     parent: devstack-minimal
     description: |
@@ -235,16 +187,12 @@
       - opendev.org/openstack/requirements
       - opendev.org/openstack/swift
       - opendev.org/openstack/keystone
-    timeout: 2700
+    timeout: 3600
     vars:
       tox_constraints_file: '{{ ansible_user_dir }}/src/opendev.org/openstack/requirements/upper-constraints.txt'
       # This tox env get run twice; once for Keystone and once for tempauth
       tox_envlist: func
       devstack_localrc:
-        # Other services are fine to run py3
-        USE_PYTHON3: true
-        # explicitly state that we want to test swift under py2
-        DISABLED_PYTHON3_PACKAGES: 'swift'
         SWIFT_HASH: changeme
         # We don't need multiple replicas to run purely functional tests.
         # In fact, devstack special cases some things when there's only
@@ -258,26 +206,13 @@
       devstack_services:
         keystone: true
         swift: true
+        s3api: true
       zuul_work_dir: src/opendev.org/openstack/swift
     pre-run: tools/playbooks/dsvm/pre.yaml
     run: tools/playbooks/dsvm/run.yaml
     post-run: tools/playbooks/dsvm/post.yaml
 
 - job:
-    name: swift-dsvm-functional-py3
-    parent: swift-dsvm-functional
-    description: |
-      Setup a Swift/Keystone environment under py3 and run Swift's func tests
-      (also under py3).
-    vars:
-      # This tox env get run twice; once for Keystone and once for tempauth
-      tox_envlist: func-py3
-      devstack_localrc:
-        USE_PYTHON3: true
-        # explicitly clear swift's default-disabled status
-        DISABLED_PYTHON3_PACKAGES: ''
-
-- job:
     name: swift-dsvm-functional-ipv6
     parent: swift-dsvm-functional
     vars:
@@ -292,7 +227,7 @@
     nodeset: centos-7
     description: |
       Setup a SAIO dev environment and run ceph-s3tests
-    timeout: 2400
+    timeout: 3600
     pre-run:
       - tools/playbooks/common/install_dependencies.yaml
       - tools/playbooks/saio_single_node_setup/setup_saio.yaml
@@ -309,7 +244,7 @@
     nodeset: centos-7
     description: |
       Setup a SAIO dev environment and run Swift's probe tests
-    timeout: 3600
+    timeout: 5400
     pre-run:
       - tools/playbooks/common/install_dependencies.yaml
       - tools/playbooks/saio_single_node_setup/setup_saio.yaml
@@ -393,6 +328,18 @@
       previous_swift_version: origin/stable/train
 
 - job:
+    name: swift-multinode-rolling-upgrade-ussuri
+    parent: swift-multinode-rolling-upgrade
+    vars:
+      previous_swift_version: origin/stable/ussuri
+
+- job:
+    name: swift-multinode-rolling-upgrade-master
+    parent: swift-multinode-rolling-upgrade
+    vars:
+      previous_swift_version: origin/master
+
+- job:
     name: swift-tox-lower-constraints
     parent: openstack-tox-lower-constraints
     vars:
@@ -526,54 +473,34 @@
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-func-encryption-py27:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-tox-func-domain-remap-staticweb-py27:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-func-ec-py27:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-tox-func-s3api-py27:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
 
         # py3 functional tests
         - swift-tox-func-py37:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-func-encryption-py37:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-tox-func-domain-remap-staticweb-py37:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-func-ec-py37:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-tox-func-s3api-py37:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
 
         # Other tests
         - swift-tox-func-s3api-ceph-s3tests-tempauth:
@@ -583,29 +510,24 @@
               # Also keep doc/s3api -- it holds known failures for these tests
               - ^doc/(requirements.txt|(manpages|source)/.*)$
               - ^test/(unit|probe)/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-probetests-centos-7:
             irrelevant-files:
               - ^(api-ref|releasenotes)/.*$
               # Keep doc/saio -- we use those sample configs in the saio playbooks
               - ^doc/(requirements.txt|(manpages|s3api|source)/.*)$
               - ^test/(unit|functional)/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-dsvm-functional:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-dsvm-functional-py3:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-dsvm-functional-ipv6:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-lower-constraints:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
@@ -619,22 +541,24 @@
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
+            # 2.25.0 had a test issue; see https://review.opendev.org/#/c/721518/
+            voting: false
         - tempest-integrated-object-storage:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - tempest-ipv6-only:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - grenade-py3:
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
+        - grenade:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
     gate:
       jobs:
         # For gate jobs, err towards running more jobs (so, generally avoid
@@ -649,36 +573,27 @@
         - swift-tox-py38
         - swift-tox-func-py27
         - swift-tox-func-encryption-py27
-        - swift-tox-func-domain-remap-staticweb-py27
         - swift-tox-func-ec-py27
-        - swift-tox-func-s3api-py27
         - swift-tox-func-py37
         - swift-tox-func-encryption
-        - swift-tox-func-domain-remap-staticweb-py37
         - swift-tox-func-ec-py37
-        - swift-tox-func-s3api-py37
         - swift-probetests-centos-7:
             irrelevant-files:
               - ^(api-ref|releasenotes)/.*$
               # Keep doc/saio -- we use those sample configs in the saio playbooks
               - ^doc/(requirements.txt|(manpages|s3api|source)/.*)$
               - ^test/(unit|functional)/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-dsvm-functional:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-dsvm-functional-py3:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-dsvm-functional-ipv6:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-lower-constraints:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
@@ -692,17 +607,17 @@
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - tempest-ipv6-only:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - grenade-py3:
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
+        - grenade:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
     experimental:
       jobs:
         - swift-tox-py27-centos-7
@@ -712,6 +627,9 @@
         - swift-multinode-rolling-upgrade-rocky
         - swift-multinode-rolling-upgrade-stein
         - swift-multinode-rolling-upgrade-train
+        - swift-multinode-rolling-upgrade-ussuri
+        - swift-multinode-rolling-upgrade-master:
+            branches: master
 
     post:
       jobs:
